
#include "libraries.h"
/*   */

#ifndef OKO_U2
  /*  HW  */
  const char HW_Version_Text[] @ "FLASH" =  "OKO-PRO"; // !!!
  /*    */
  const char SW_Version_Text[] @ "FLASH"  = "1.2.3"; // !!!
#else
  /*  HW  */
  const char HW_Version_Text[] @ "FLASH" =  "OKO-U2"; // !!!
  /*    */
  const char SW_Version_Text[] @ "FLASH"  = "2.2.3"; // !!!
#endif

xQueueHandle 			Queue_Print_Debug, Queue_Event, Queue_GPRS_Event, Queue_Delay_Event, Queue_TRX_Command;
xSemaphoreHandle                Mutex_Flash_Access, Mutex_Copy_Delay_Event, Mutex_Save_Event,xSemaphore_GSM_UART_Handler;
xTaskHandle                     pxTask_I_O_TIMERS;
xTaskHandle                     pxTask_ADC;
xTaskHandle                     pxTask_1WIRE_1;
xTaskHandle                     pxTask_1WIRE_2;
xTaskHandle                     pxTask_SPI;
xTaskHandle                     pxTask_RS485;
xTaskHandle                     pxTask_PRINT_DEBUG;
xTaskHandle                     pxTask_GSM, pxTask_GSM_Data_Analize;
xTaskHandle                     pxTask_CORE_IDLE;


volatile unsigned short int     Task_1WIRE_1_Alive=0;
volatile unsigned short int     Task_1WIRE_2_Alive=0;
volatile unsigned short int     Task_ADC_Alive=0;
volatile unsigned short int     Task_SPI_Alive=0;
volatile unsigned short int     Task_GSM_Alive=0;
volatile unsigned short int     Task_RS485_Alive=0;

volatile uint32_t               Counters[MAX_WIRE_SENSOR]={NO_PULSE,NO_PULSE,NO_PULSE,NO_PULSE,NO_PULSE,NO_PULSE,NO_PULSE,NO_PULSE};
/*   ADC*/ 
unsigned short int              ADC_value[ADC_CH]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

/*         */
volatile unsigned short int     Inputs_State=0;
/*           */
volatile unsigned short int     KZ_Obriv_State=0;

/*    */
volatile unsigned short int     Outputs_State=0;

/*      GSM-, *100 msec*/
volatile unsigned short int     GSM_Answer_Wait=0 ;

/*     DTMF-, *100 msec*/
volatile unsigned short int     DTMF_Command_Wait=0 ;

/*     GSM-, *100 msec*/
volatile unsigned short int     Check_GSM =200 ;

/*     ""  , *100 msec*/
volatile unsigned short int     Check_Tasks = CHECK_TASKS_LEN ;

/* -       , *100 msec */
volatile char			RF_Data_Timeout=0;

/* -    RS485-, *10 msec */
volatile char			RS485_Rx_Timeout=0;

/* -      1, *100 msec */
volatile char                   Key_Board_1_Command_Timeout=0;
volatile char                   Key_Board_1_Alive_Timeout=0;

/* -      2, *100 msec */
volatile char                   Key_Board_2_Command_Timeout=0;
volatile char                   Key_Board_2_Alive_Timeout=0;

/* -    1, *100 msec */
volatile char                   Piezo_KB1_Timeout=0;

/* -    2, *100 msec */
volatile char                   Piezo_KB2_Timeout=0;

/*    , * sec */
volatile char                   Arm_Delay=0;

/*  , * sec */
volatile char                   Alarm_Delay=0;

/*      */
volatile char                   Alarm_Voice=0;
char*                           Alarm_File;

/*      */
volatile char                   Delay_arm_group=0;
/*        */
volatile char                   Delay_who=NOT_OWNER;

/* -     , * sec */
volatile char                   GPRS_Fault_Timeout=0;

/* -   , * sec */
volatile char			Load_Data_Timeout=0;

/*  GSM-  RSSI */
volatile char                   GSM_Level = 0;

/*   "" */
volatile char                   Working_Flag[MAX_FLAG]={0};

/*  ""   */
volatile char                   Mode_Flag[MAX_MODE_FLAGS]={0};

/* -  , 1sec */
volatile char			Program_Mode_Timeout=0;

/* -  , 1sec */
volatile char			Test_Mode_Timeout=0;

volatile char                   LED_test_timeout=0;

/*   (100)   */
volatile char			LED_Short_Flash=12; // 6       

/*   (100)   */
volatile char			SIRENA_Short_Beep=0;

/*   (1)   */
volatile char			LED_Long_Flash=0;

/*   USB-*/
volatile TypeDef_USB_Mode       USB_Mode=UsbIdleMode; //DebugMode;UsbIdleMode

/*    */
volatile TypeDef_RADIO_SENSOR   RF_Sensor;

/*    */
volatile TypeDef_WIRE_SENSOR    Wire_Sensor;

/*   */
volatile TypeDef_OWNER          Owner;

/*  IButton */
volatile TypeDef_IBUTTON        IButton;

/*   DS1820*/
volatile TypeDef_DS1820_SENSOR  DS1820_Sensor;

/*    */
volatile TypeDef_POWER          Power;

/*    */
volatile TypeDef_TAMPER         Tamper;

/*      OKO_RF_PRO*/
volatile char                   oko_rf_pro_version=0;

/*      */
volatile char                   pin_timeout=0;

/*-       */
volatile char                   reset_pin_error_timeout=0;

uint32_t Device_Serial_0, Device_Serial_1, Device_Serial_2;

/*    ""   ,    FLASH- ,   
   DEFAULT_CONFIG_BASE_ADDRESS    DEFAULT_CONFIG_END_ADDRESS
           DEFAULT_CONFIG   MASTER_CONFIG, 
         
*/
// SMS 
const char IN1_Low_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + LOW_INPUT_1_EVENT * INPUT_EVENT_TEXT_LEN =            "z1 NORMA\x0A";
const char IN1_High_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + HIGH_INPUT_1_EVENT * INPUT_EVENT_TEXT_LEN =          "z1 TREVOGA\x0A";
const char IN2_Low_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + LOW_INPUT_2_EVENT * INPUT_EVENT_TEXT_LEN =            "z2 NORMA\x0A";
const char IN2_High_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + HIGH_INPUT_2_EVENT * INPUT_EVENT_TEXT_LEN=           "z2 TREVOGA\x0A";
const char IN3_Low_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + LOW_INPUT_3_EVENT * INPUT_EVENT_TEXT_LEN =            "z3 NORMA\x0A";
const char IN3_High_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + HIGH_INPUT_3_EVENT * INPUT_EVENT_TEXT_LEN=           "z3 TREVOGA\x0A";
const char IN4_Low_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + LOW_INPUT_4_EVENT * INPUT_EVENT_TEXT_LEN =            "z4 NORMA\x0A";
const char IN4_High_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + HIGH_INPUT_4_EVENT * INPUT_EVENT_TEXT_LEN=           "z4 TREVOGA\x0A";
const char IN5_Low_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + LOW_INPUT_5_EVENT * INPUT_EVENT_TEXT_LEN =            "z5 NORMA\x0A";
const char IN5_High_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + HIGH_INPUT_5_EVENT * INPUT_EVENT_TEXT_LEN=           "z5 TREVOGA\x0A";
const char IN6_Low_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + LOW_INPUT_6_EVENT * INPUT_EVENT_TEXT_LEN =            "z6 NORMA\x0A";
const char IN6_High_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + HIGH_INPUT_6_EVENT * INPUT_EVENT_TEXT_LEN=           "z6 TREVOGA\x0A";
const char IN7_Low_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + LOW_INPUT_7_EVENT * INPUT_EVENT_TEXT_LEN =            "z7 NORMA\x0A";
const char IN7_High_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + HIGH_INPUT_7_EVENT * INPUT_EVENT_TEXT_LEN=           "z7 TREVOGA\x0A";
const char IN8_Low_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + LOW_INPUT_8_EVENT * INPUT_EVENT_TEXT_LEN =            "z8 NORMA\x0A";
const char IN8_High_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + HIGH_INPUT_8_EVENT * INPUT_EVENT_TEXT_LEN=           "z8 TREVOGA\x0A";


const char Tamper_KB1_Alarm_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + TAMPER_KB1_ALARM_EVENT*INPUT_EVENT_TEXT_LEN="TAMPER KB1 TREVOGA\x0A";
const char Tamper_KB1_Norma_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + TAMPER_KB1_NORMA_EVENT*INPUT_EVENT_TEXT_LEN="TAMPER KB1 NORMA\x0A";
const char Tamper_KB2_Alarm_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + TAMPER_KB2_ALARM_EVENT*INPUT_EVENT_TEXT_LEN="TAMPER KB2 TREVOGA\x0A";
const char Tamper_KB2_Norma_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + TAMPER_KB2_NORMA_EVENT*INPUT_EVENT_TEXT_LEN="TAMPER KB2 NORMA\x0A";
const char Arm_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + ARMED_EVENT * INPUT_EVENT_TEXT_LEN=                       "OHRANA ON\x0A";
const char Disarm_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + DISARMED_EVENT * INPUT_EVENT_TEXT_LEN=                 "OHRANA OFF\x0A";
const char _220V_On_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + _220_POWER_ON_EVENT * INPUT_EVENT_TEXT_LEN=          "220V ON\x0A";
const char _220V_Off_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + _220_POWER_OFF_EVENT * INPUT_EVENT_TEXT_LEN=        "220V OFF\x0A";
const char Low_Acc_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + BACKUP_POWER_LOW_EVENT * INPUT_EVENT_TEXT_LEN=        "RAZRYAD AKKUM\x0A";
const char Tamper_Alarm_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + TAMPER_ALARM_EVENT * INPUT_EVENT_TEXT_LEN=       "TAMPER TREVOGA\x0A";
const char Tamper_Norma_Text[] @ DEFAULT_CONFIGURATOR_BASE_ADDRESS + TAMPER_NORMA_EVENT * INPUT_EVENT_TEXT_LEN=       "TAMPER NORMA\x0A";


//    DS1820
const char Termo_DS1820_Name_1[] @ TERMO_NAME_START + TERMO_DS1820_NAME_LEN*0=                          "Termo-1";
const char Termo_DS1820_Name_2[] @ TERMO_NAME_START + TERMO_DS1820_NAME_LEN*1=                          "Termo-2";
const char Termo_DS1820_Name_3[] @ TERMO_NAME_START + TERMO_DS1820_NAME_LEN*2=                          "Termo-3";
const char Termo_DS1820_Name_4[] @ TERMO_NAME_START + TERMO_DS1820_NAME_LEN*3=                          "Termo-4";
const char Termo_DS1820_Name_5[] @ TERMO_NAME_START + TERMO_DS1820_NAME_LEN*4=                          "Termo-5";
const char Termo_DS1820_Name_6[] @ TERMO_NAME_START + TERMO_DS1820_NAME_LEN*5=                          "Termo-6";
const char Termo_DS1820_Name_7[] @ TERMO_NAME_START + TERMO_DS1820_NAME_LEN*6=                          "Termo-7";
const char Termo_DS1820_Name_8[] @ TERMO_NAME_START + TERMO_DS1820_NAME_LEN*7=                          "Termo-8";

//   
const char Radio_Sensor_Name_1[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*0=                          "Radio-1";
const char Radio_Sensor_Name_2[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*1=                          "Radio-2";
const char Radio_Sensor_Name_3[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*2=                          "Radio-3";
const char Radio_Sensor_Name_4[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*3=                          "Radio-4";
const char Radio_Sensor_Name_5[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*4=                          "Radio-5";
const char Radio_Sensor_Name_6[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*5=                          "Radio-6";
const char Radio_Sensor_Name_7[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*6=                          "Radio-7";
const char Radio_Sensor_Name_8[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*7=                          "Radio-8";
const char Radio_Sensor_Name_9[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*8=                          "Radio-9";
const char Radio_Sensor_Name_10[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*9=                         "Radio-10";
const char Radio_Sensor_Name_11[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*10=                        "Radio-11";
const char Radio_Sensor_Name_12[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*11=                        "Radio-12";
const char Radio_Sensor_Name_13[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*12=                        "Radio-13";
const char Radio_Sensor_Name_14[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*13=                        "Radio-14";
const char Radio_Sensor_Name_15[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*14=                        "Radio-15";
const char Radio_Sensor_Name_16[] @ RADIO_NAME_START + RADIO_SENSOR_NAME_LEN*15=                        "Radio-16";
const char Alarm_SMS_input @ DEFAULT_CONFIGURATOR_END_ADDRESS-1984 =   				        0xff;
const char Alarm_Ring_input @ DEFAULT_CONFIGURATOR_END_ADDRESS-1983 =   				        0xff;
const uint16_t Alarm_SMS_RF @ DEFAULT_CONFIGURATOR_END_ADDRESS-1982 =   				        0xffff;
const uint16_t Alarm_Ring_RF @ DEFAULT_CONFIGURATOR_END_ADDRESS-1980 =   				        0xffff;
const char KB_Group @ DEFAULT_CONFIGURATOR_END_ADDRESS-1978 =      				                0xff; //     / 
const char KB_OKO_Group @ DEFAULT_CONFIGURATOR_END_ADDRESS-1977 =      				        0xff; //    -
const char RF_Brelok_Arm_Button[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-1976 =       				{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff}; //     " "  
const char RF_Brelok_Disarm_Button[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-1960 =       				{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff}; //     " "  
const char RF_Brelok_Home_Button[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-1944 =       				{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2}; //     ""  
const char _24h @ DEFAULT_CONFIGURATOR_END_ADDRESS-1928 =   				                        0xff;
const char _sms @ DEFAULT_CONFIGURATOR_END_ADDRESS-1927 =   				                        0xff;
//const char ttt @ DEFAULT_CONFIGURATOR_END_ADDRESS-1926 =   				                        0x00;
//const char ttt @ DEFAULT_CONFIGURATOR_END_ADDRESS-1925 =   				                        0x00;
const char kz_obriv_24h @ DEFAULT_CONFIGURATOR_END_ADDRESS-1924 =   				                0xff; //     


const uint16_t test_var[776] @ DEFAULT_CONFIGURATOR_END_ADDRESS-(210+1712);
const char nn_pp @ DEFAULT_CONFIGURATOR_END_ADDRESS-370 =   				                        0; //next parameter
const char socket_code @ DEFAULT_CONFIGURATOR_END_ADDRESS-369 =   				                0; //5-   
const char vxod_mode[8] @ DEFAULT_CONFIGURATOR_END_ADDRESS-368 =      				                {0,0,0,0,0,0,0,0}; //  
const char vxod_type[8] @ DEFAULT_CONFIGURATOR_END_ADDRESS-360 =      				                {0,0,0,0,0,0,0,0}; //   
const char oxr_input_type @ DEFAULT_CONFIGURATOR_END_ADDRESS-352 =   				                0x00; //     ,    
const char _ring @ DEFAULT_CONFIGURATOR_END_ADDRESS-351 =   				                        0x00;
const char Play_End[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-350 =                                                  ".amr\",0,100\r";
const char Record_End[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-336 =                                                ".amr\",0,3,0,0\r";
const char Device_ID[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-318 =       				                {'0','0','0','1'};//     SurGARD, ContactID
const char Server_2[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-314 =      				                {0}; // 2
const char Port_2[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-282 =      				                {0}; // 2
const char ArmDisarm_PIN[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-266 =       				        {'4','3','2','1'};//    / 
const char GPRS_protocol @ DEFAULT_CONFIGURATOR_END_ADDRESS-262 =   				                0; // GPRS-
const char Force_PIN[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-261 =       				                {'1','1','1','1'};//      " "
const char Fraud_SMS @ DEFAULT_CONFIGURATOR_END_ADDRESS-257 =            				        0; //-     
const char RF_Termo_Hyst[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-256 =       				        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2}; //           
const char DS1820_Hyst[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-240 =       				        {2,2,2,2,2,2,2,2}; //   DS1820         
const char Input_Obriv @ DEFAULT_CONFIGURATOR_END_ADDRESS-232 =      				                0; //     
const char Input_KZ @ DEFAULT_CONFIGURATOR_END_ADDRESS-231 =      				                0; //   ( )   
const char No_timeout @ DEFAULT_CONFIGURATOR_END_ADDRESS-230 =      				                0; //  -         
const char Output_by_Call @ DEFAULT_CONFIGURATOR_END_ADDRESS-229 =      				        0; //       (  )
const char Output_Invert @ DEFAULT_CONFIGURATOR_END_ADDRESS-228 =      				                0; //  ""  
const char Arm_Callback @ DEFAULT_CONFIGURATOR_END_ADDRESS-227 =   				                0; //          (  )
const uint16_t External_BBP @ DEFAULT_CONFIGURATOR_END_ADDRESS-226 =   				                0; //  220     
const char GSM_Jamming_SMS @ DEFAULT_CONFIGURATOR_END_ADDRESS-224 =   				                0; //-    
const char Jamming_Beep @ DEFAULT_CONFIGURATOR_END_ADDRESS-223 =   				                0; //      GSM-
const char Output_Mode[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-222 =       				        {0,0,0,0,0,0,0,0}; // 
const char SMS_not_owner_denied @ DEFAULT_CONFIGURATOR_END_ADDRESS-214 =   				        0;
const char DTMF_not_owner_denied @ DEFAULT_CONFIGURATOR_END_ADDRESS-213 =   				        0;
const char SMS_owner_denied @ DEFAULT_CONFIGURATOR_END_ADDRESS-212 =   				                0;
const char DTMF_owner_denied @ DEFAULT_CONFIGURATOR_END_ADDRESS-211 =   				        0;
const char Balance_USSD[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-210 =       				        "*111#"; //USSD-  -
const uint16_t Balance_Level @ DEFAULT_CONFIGURATOR_END_ADDRESS-190 =   				        0; //     -, 0 - 
const char Output_Group[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-188 =       				        {0,0,0,0,0,0,0,0}; // ,     
const uint16_t Output_Time_Out_Len[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-180 =   				{0,0,0,0,0,0,0,0}; //  , *100
const uint16_t Input_Main_Power_Filtr_Len @ DEFAULT_CONFIGURATOR_END_ADDRESS-164 =      		        6000; //   MAIN_POWER -   12 , *10 mc
const uint16_t Input_Ext_Power_Filtr_Len @ DEFAULT_CONFIGURATOR_END_ADDRESS-162 =      		                1000; //   EXT_POWER -   220, *10 mc
const uint16_t Input_Filtr_Len[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-160 =      				        {10,10,10,10,10,10,10,10}; //    -1..-8, *10
const char Wire_Time_Out_Len[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-128 =      				        {30,30,30,30,30,30,30,30}; //-        , *
const char RF_Time_Out_Len[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-112 =      				        {30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30}; //-      , *
const char APN_User[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-96 =      				                "\0";  //APN  ,  
const char Server_1[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-64 =      				                "77.120.122.83"; // 
const char Port_1[] @ DEFAULT_CONFIGURATOR_END_ADDRESS-32 =      				                "80"; //
const uint16_t GPRS_Period_Len @ DEFAULT_CONFIGURATOR_END_ADDRESS-16 =   				        0; //    , *
const uint16_t Sirena_Time_Out_Len @ DEFAULT_CONFIGURATOR_END_ADDRESS-14 =   				        60; //   , *
const char Tamper_Time_Out_Len @ DEFAULT_CONFIGURATOR_END_ADDRESS-12 =      				        30; //-        , *
const char Termo_24h @ DEFAULT_CONFIGURATOR_END_ADDRESS-11 =      				                0xFF; //  ""  8-  
const uint16_t Input_Tamper_Filtr_Len @ DEFAULT_CONFIGURATOR_END_ADDRESS-10 =      		                10; //   , *10 mc
const char Termo_silent @ DEFAULT_CONFIGURATOR_END_ADDRESS-8 =      				                0xFF; //  ""  8-  
const char Input_Invert @ DEFAULT_CONFIGURATOR_END_ADDRESS-7 =      				                0xFF; //  "" (   )  
const char Input_Norma_Event @ DEFAULT_CONFIGURATOR_END_ADDRESS-6 =      				        0; //    

const  uint32_t flash_valid @ DEFAULT_CONFIGURATOR_END_ADDRESS-4=                                             FLASH_VALID; //  

//const char End_Flash @ END_OF_FLASH_ADDRESS='1';
/*************************************/ 


/*        
Virtual address defined by the user: 0xFFFF value is prohibited */

const uint16_t                  VirtAddVarTab[NumbOfVar] @ "FLASH" = 
{
  OWNER1_PHONE_W1, 
  OWNER1_PHONE_W2,
  OWNER1_PHONE_W3,
  OWNER1_PHONE_W4,
  OWNER1_PHONE_W5,
  OWNER1_PHONE_W6,
  OWNER1_PHONE_W7,
  OWNER1_PHONE_W8,
  OWNER2_PHONE_W1, 
  OWNER2_PHONE_W2,
  OWNER2_PHONE_W3,
  OWNER2_PHONE_W4,
  OWNER2_PHONE_W5,
  OWNER2_PHONE_W6,
  OWNER2_PHONE_W7,
  OWNER2_PHONE_W8,
  OWNER3_PHONE_W1, 
  OWNER3_PHONE_W2,
  OWNER3_PHONE_W3,
  OWNER3_PHONE_W4,
  OWNER3_PHONE_W5,
  OWNER3_PHONE_W6,
  OWNER3_PHONE_W7,
  OWNER3_PHONE_W8,
  OWNER4_PHONE_W1, 
  OWNER4_PHONE_W2,
  OWNER4_PHONE_W3,
  OWNER4_PHONE_W4,
  OWNER4_PHONE_W5,
  OWNER4_PHONE_W6,
  OWNER4_PHONE_W7,
  OWNER4_PHONE_W8,
  OWNER5_PHONE_W1, 
  OWNER5_PHONE_W2,
  OWNER5_PHONE_W3,
  OWNER5_PHONE_W4,
  OWNER5_PHONE_W5,
  OWNER5_PHONE_W6,
  OWNER5_PHONE_W7,
  OWNER5_PHONE_W8,
  OWNER6_PHONE_W1, 
  OWNER6_PHONE_W2,
  OWNER6_PHONE_W3,
  OWNER6_PHONE_W4,
  OWNER6_PHONE_W5,
  OWNER6_PHONE_W6,
  OWNER6_PHONE_W7,
  OWNER6_PHONE_W8,
  OWNER7_PHONE_W1, 
  OWNER7_PHONE_W2,
  OWNER7_PHONE_W3,
  OWNER7_PHONE_W4,
  OWNER7_PHONE_W5,
  OWNER7_PHONE_W6,
  OWNER7_PHONE_W7,
  OWNER7_PHONE_W8,
  OWNER8_PHONE_W1, 
  OWNER8_PHONE_W2,
  OWNER8_PHONE_W3,
  OWNER8_PHONE_W4,
  OWNER8_PHONE_W5,
  OWNER8_PHONE_W6,
  OWNER8_PHONE_W7,
  OWNER8_PHONE_W8,

  PIN_CODE_W1,
  PIN_CODE_W2,
  MODE_FLAGS_W,
  OUTPUT_STATE_W,

  RADIO_1_MIN_MAX_W,
  RADIO_2_MIN_MAX_W,
  RADIO_3_MIN_MAX_W,
  RADIO_4_MIN_MAX_W,
  RADIO_5_MIN_MAX_W,
  RADIO_6_MIN_MAX_W,
  RADIO_7_MIN_MAX_W,
  RADIO_8_MIN_MAX_W,
  RADIO_9_MIN_MAX_W,
  RADIO_10_MIN_MAX_W,
  RADIO_11_MIN_MAX_W,
  RADIO_12_MIN_MAX_W,
  RADIO_13_MIN_MAX_W,
  RADIO_14_MIN_MAX_W,
  RADIO_15_MIN_MAX_W,
  RADIO_16_MIN_MAX_W,
  
  OWNER_1_2_GROUP_W,
  OWNER_3_4_GROUP_W,
  OWNER_5_6_GROUP_W,
  OWNER_7_8_GROUP_W,  
  
  RADIO_LOOP,
  DS1820_LOOP,
  IBUTTON_LOOP,

  DS1820_1_MIN_MAX_W,
  DS1820_2_MIN_MAX_W,
  DS1820_3_MIN_MAX_W,
  DS1820_4_MIN_MAX_W,
  DS1820_5_MIN_MAX_W,
  DS1820_6_MIN_MAX_W,
  DS1820_7_MIN_MAX_W,
  DS1820_8_MIN_MAX_W,
  DS1820_1_W1,
  DS1820_1_W2,
  DS1820_1_W3,
  DS1820_1_W4,
  DS1820_2_W1,
  DS1820_2_W2,
  DS1820_2_W3,
  DS1820_2_W4,
  DS1820_3_W1,
  DS1820_3_W2,
  DS1820_3_W3,
  DS1820_3_W4,
  DS1820_4_W1,
  DS1820_4_W2,
  DS1820_4_W3,
  DS1820_4_W4,
  DS1820_5_W1,
  DS1820_5_W2,
  DS1820_5_W3,
  DS1820_5_W4,
  DS1820_6_W1,
  DS1820_6_W2,
  DS1820_6_W3,
  DS1820_6_W4,
  DS1820_7_W1,
  DS1820_7_W2,
  DS1820_7_W3,
  DS1820_7_W4,
  DS1820_8_W1,
  DS1820_8_W2,
  DS1820_8_W3,
  DS1820_8_W4,


  IBUTTON_1_W1,
  IBUTTON_1_W2,
  IBUTTON_1_W3,
  IBUTTON_2_W1,
  IBUTTON_2_W2,
  IBUTTON_2_W3,
  IBUTTON_3_W1,
  IBUTTON_3_W2,
  IBUTTON_3_W3,
  IBUTTON_4_W1,
  IBUTTON_4_W2,
  IBUTTON_4_W3,
  IBUTTON_5_W1,
  IBUTTON_5_W2,
  IBUTTON_5_W3,
  IBUTTON_6_W1,
  IBUTTON_6_W2,
  IBUTTON_6_W3,
  IBUTTON_7_W1,
  IBUTTON_7_W2,
  IBUTTON_7_W3,
  IBUTTON_8_W1,
  IBUTTON_8_W2,
  IBUTTON_8_W3,
  IBUTTON_9_W1,
  IBUTTON_9_W2,
  IBUTTON_9_W3,
  IBUTTON_10_W1,
  IBUTTON_10_W2,
  IBUTTON_10_W3,  
  IBUTTON_11_W1,
  IBUTTON_11_W2,
  IBUTTON_11_W3,
  IBUTTON_12_W1,
  IBUTTON_12_W2,
  IBUTTON_12_W3,
  
  IBUTTON_1_2_GROUP_W,
  IBUTTON_3_4_GROUP_W,
  IBUTTON_5_6_GROUP_W,
  IBUTTON_7_8_GROUP_W,
  IBUTTON_9_10_GROUP_W,
  IBUTTON_11_12_GROUP_W,
  
  DS1820_1_2_GROUP_W,
  DS1820_3_4_GROUP_W,
  DS1820_5_6_GROUP_W,
  DS1820_7_8_GROUP_W,
  TAMPER_220_GROUP_W,
  SMS_ARM_DISARM_W,
  SMS_RING_W,
  ANSWER_ARM_PARAMETER_W,
  
  RADIO_1_2_GROUP_W,
  RADIO_3_4_GROUP_W,
  RADIO_5_6_GROUP_W,
  RADIO_7_8_GROUP_W,
  RADIO_9_10_GROUP_W,
  RADIO_11_12_GROUP_W,
  RADIO_13_14_GROUP_W,
  RADIO_15_16_GROUP_W,
  GPRS_PERIOD_W,

  RADIO_1_W1,
  RADIO_1_W2,
  RADIO_2_W1,
  RADIO_2_W2,
  RADIO_3_W1,
  RADIO_3_W2,
  RADIO_4_W1,
  RADIO_4_W2,
  RADIO_5_W1,
  RADIO_5_W2,
  RADIO_6_W1,
  RADIO_6_W2,
  RADIO_7_W1,
  RADIO_7_W2,
  RADIO_8_W1,
  RADIO_8_W2,
  RADIO_9_W1,
  RADIO_9_W2,
  RADIO_10_W1,
  RADIO_10_W2,
  RADIO_11_W1,
  RADIO_11_W2,
  RADIO_12_W1,
  RADIO_12_W2,
  RADIO_13_W1,
  RADIO_13_W2,
  RADIO_14_W1,
  RADIO_14_W2,
  RADIO_15_W1,
  RADIO_15_W2,
  RADIO_16_W1,
  RADIO_16_W2,
 
  DS1820_1_2_T_NAGREV_W,
  DS1820_3_4_T_NAGREV_W,
  DS1820_5_6_T_NAGREV_W,
  DS1820_7_8_T_NAGREV_W,

  RADIO_1_2_T_NAGREV_W, 
  RADIO_3_4_T_NAGREV_W,
  RADIO_5_6_T_NAGREV_W,
  RADIO_7_8_T_NAGREV_W,
  RADIO_9_10_T_NAGREV_W,
  RADIO_11_12_T_NAGREV_W,
  RADIO_13_14_T_NAGREV_W,
  RADIO_15_16_T_NAGREV_W,

  IN_1_2_PARAMETER_W,
  IN_3_4_PARAMETER_W,
  IN_5_6_PARAMETER_W,
  IN_7_8_PARAMETER_W,
  RADIO_1_2_PARAMETER_W,
  RADIO_3_4_PARAMETER_W,
  RADIO_5_6_PARAMETER_W,
  RADIO_7_8_PARAMETER_W,
  RADIO_9_10_PARAMETER_W,
  RADIO_11_12_PARAMETER_W,
  RADIO_13_14_PARAMETER_W,
  RADIO_15_16_PARAMETER_W,
 
  IN_1_2_GROUP_W,
  IN_3_4_GROUP_W,
  IN_5_6_GROUP_W,
  IN_7_8_GROUP_W

   
};


/*******************************************************************************
* Function Name  : Virtual_EEPROM
* Description    :    ""      ,  - 
* Input          : VirtAddress -      
*                 Data -     /
*                 Operation -     (, , , )
* Output         : 
* Return         : 0 -     
*******************************************************************************/

uint16_t Virtual_EEPROM (uint16_t VirtAddress, uint16_t* Data, char Operation )
{

uint16_t i=1;


/* ,    .
       ,      
     ,    .   xSemaphoreTake() 
      ,    . */
xSemaphoreTake( Mutex_Flash_Access, portMAX_DELAY );

{
        switch (Operation)
        {
          
        case SAVE_DATA_EEPROM:
          /* Unlock the Flash Program Erase controller */
          FLASH_Unlock();
          i= EE_WriteVariable(VirtAddress, *Data);
          /* Lock the Flash Program Erase controller */
          FLASH_Lock();  
          
          break;
          
        case READ_DATA_EEPROM:
          i= EE_ReadVariable(VirtAddress, Data);
          
          break;

        case FORMAT_EEPROM:
 
          /* Unlock the Flash Program Erase controller */
          FLASH_Unlock(); 
          /*    */
          EEPROM_Format();
          /* EEPROM Init */
          EE_Init();
          /* Lock the Flash Program Erase controller */
          FLASH_Lock();  
          
          break;

        case UPLOAD_CONFIG:
          
          break; 
        
        default:
      
          break;
        }
}

/*     ! */
xSemaphoreGive( Mutex_Flash_Access );


return i;
}
         
uint16_t calc_flags(char * f, char len)
{
  uint16_t res=0;
  char i;
  for (i=0; i<len; i++)
  {
    if (*f) {res = res + (0x0001<<i);}
    f++;
  }
  return res;
}

//    -  !!!
char test(void)
{
  
  return (
          IN1_Low_Text[0]+
          IN1_High_Text[0]+
          IN2_Low_Text[0]+
          IN2_High_Text[0]+            
          IN3_Low_Text[0]+
          IN3_High_Text[0]+            
          IN4_Low_Text[0]+
          IN4_High_Text[0]+            
          IN5_Low_Text[0]+
          IN5_High_Text[0]+            
          IN6_Low_Text[0]+
          IN6_High_Text[0]+            
          IN7_Low_Text[0]+
          IN7_High_Text[0]+            
          IN8_Low_Text[0])+
          IN8_High_Text[0]+    
    
          Tamper_KB1_Alarm_Text[0]+
          Tamper_KB1_Norma_Text[0]+
          Tamper_KB2_Alarm_Text[0]+
          Tamper_KB2_Norma_Text[0]+
          Arm_Text[0]+
          Disarm_Text[0]+
          _220V_On_Text[0]+
          _220V_Off_Text[0]+
          Low_Acc_Text[0]+
          Tamper_Alarm_Text[0]+  
          Tamper_Norma_Text[0]+
            
  
          Termo_DS1820_Name_1[0]+
          Termo_DS1820_Name_2[0]+
          Termo_DS1820_Name_3[0]+
          Termo_DS1820_Name_4[0]+
          Termo_DS1820_Name_5[0]+
          Termo_DS1820_Name_6[0]+
          Termo_DS1820_Name_7[0]+
          Termo_DS1820_Name_8[0]+
            
          Radio_Sensor_Name_1[0]+
          Radio_Sensor_Name_2[0]+
          Radio_Sensor_Name_3[0]+
          Radio_Sensor_Name_4[0]+
          Radio_Sensor_Name_5[0]+
          Radio_Sensor_Name_6[0]+
          Radio_Sensor_Name_7[0]+
          Radio_Sensor_Name_8[0]+
          Radio_Sensor_Name_9[0]+
          Radio_Sensor_Name_10[0]+
          Radio_Sensor_Name_11[0]+
          Radio_Sensor_Name_12[0]+
          Radio_Sensor_Name_13[0]+
          Radio_Sensor_Name_14[0]+
          Radio_Sensor_Name_15[0]+
          Radio_Sensor_Name_16[0]+
          Alarm_SMS_input+
          Alarm_Ring_input+  
          Alarm_SMS_RF+
          Alarm_Ring_RF+
          KB_Group+
          KB_OKO_Group+ 
          RF_Brelok_Arm_Button[0]+
          RF_Brelok_Disarm_Button[0]+ 
          RF_Brelok_Home_Button[0]+ 
          _24h+
          _sms+
          kz_obriv_24h+
          //tttt+
            
          test_var[0]+
            nn_pp+
          socket_code+
          vxod_type[0]+
          vxod_mode[0]+
          oxr_input_type+
          _ring+
          Play_End[0]+
          Record_End[0]+
          Device_ID[0]+
          Server_2[0]+
          Port_2[0]+    
          ArmDisarm_PIN[0]+
          GPRS_protocol+
          Force_PIN[0]+
          Fraud_SMS+
          RF_Termo_Hyst[0]+
          DS1820_Hyst[0]+
          Input_Obriv+
          Input_KZ+
          No_timeout+
          Output_by_Call+
          Output_Invert+
          Arm_Callback+
          External_BBP+
          GSM_Jamming_SMS+
          Jamming_Beep+  
          Output_Mode[0]+
          SMS_not_owner_denied+
          DTMF_not_owner_denied+             
          SMS_owner_denied+
          DTMF_owner_denied+             
          Balance_USSD[0]+
          Balance_Level+
          Output_Group[0]+
          Output_Time_Out_Len[0]+
          Input_Main_Power_Filtr_Len+ 
          Input_Ext_Power_Filtr_Len+  
          Input_Filtr_Len[0]+
          Wire_Time_Out_Len[0]+
          RF_Time_Out_Len[0]+  
          APN_User[0]+
          Server_1[0]+
          Port_1[0]+
          GPRS_Period_Len+
          Sirena_Time_Out_Len+
          Tamper_Time_Out_Len+  
          Termo_24h+
          Input_Tamper_Filtr_Len+
          Termo_silent+
          Input_Norma_Event+
          Input_Invert+
            
          //End_Flash+  
          flash_valid;
  
}
