
#ifndef _USER_TYPES_
#define _USER_TYPES_


/*   USB-*/
typedef enum
{
  DebugMode=0, //    
  SWConfigMode, //  
  UploadConfigMode, //   
  DownloadConfigMode, //   
  StateMode, // 
  UsbIdleMode, //
  HandshakeMode, // "" - HW-
  IMEIMode, //  IMEI
  SaveConfigMode, //   
  ModemMode, // 
} TypeDef_USB_Mode;

/*  APN */
typedef enum
{
  User_APN=0, //APN  
  Default_APN, //APN  
  KYIVSTAR_APN_contract, //
  KYIVSTAR_APN_prepaid, //
  UTEL_APN, //
  MTS_APN_contract, //
  MTS_APN_prepaid, //
  
} TypeDef_APN;

/*     DEBUG,    
    .*/
typedef struct
{
  char                  Debug_Data_type; //   :2hex,hex,ASCII,Long
  char                  Debug_Source_ID; //     
  char                 *Debug_Char_Data; //    
  unsigned short int   *Debug_u16_Data;  //    
  unsigned short int    Debug_Data_Len;  //   
  unsigned long int     Debug_Long_Data; //    ul
    
} TypeDef_PRINT_DEBUG;


/*   ,      */
typedef struct
{
  unsigned short int    Code_Event; //   
  char                  Sirena_Event; //  
  char                  Group; //  
  char                  Sensor; //  
  char                  Restore; // 
} TypeDef_DELAY_EVENT;

/*   ,    */
typedef struct
{
  unsigned short int    Code_Event; // 
  char                  Group; // 
  char                  Sensor; // 
  char                  Restore; // 
  char                  KZ_Obriv; //  (,  )
  char                  Who; // ,  / 
} TypeDef_EVENT;

/*   ,     */
typedef struct
{
  unsigned short int    Code_Event; // 
  char                  Group; //
  char                  Sensor; // 
  char                  DS1820_Data_Current[MAX_DS1820];  //    DS1820
  unsigned short int    RF_Data_Current[MAX_RADIO_SENSOR];  //      
  unsigned short int    Mode_Flags; //  
  unsigned short int    Inputs_State; //  ,  , 220 ...
  unsigned short int    KZ_Obriv_State; //      
  unsigned short int    Outputs_State; //  
  char                  GSM_Level; //  GSM- 
  unsigned short int	ADC_Value[ADC_CH]; //   
  char                  Who; // ,  / 
} TypeDef_GPRS_EVENT;

/*   ,      */
typedef struct
{
  char                  Group; //
} TypeDef_POWER;

/*   ,     */
typedef struct
{
  char                  Time_Out; // -   
  char                  Group; //
} TypeDef_TAMPER;

/*   ,     */
typedef struct
{
  unsigned short int    Data_Current[MAX_RADIO_SENSOR];  //   
  unsigned short int    Data_Before[MAX_RADIO_SENSOR];  //   
  char                  Time_Out[MAX_RADIO_SENSOR]; // -  -    
  char                  Same_Data_Time_Out[MAX_RADIO_SENSOR]; // -      
  unsigned short int    Termo_Sensor_Range_State; // 16  -  16  : 0 -     , 1 -     
  char                  Parameter[MAX_RADIO_SENSOR]; //   ( , , )
  char                  Group[MAX_RADIO_SENSOR]; //  
  char    		Tn[MAX_RADIO_SENSOR]; //   ()
  char    		Time_out_Tn[MAX_RADIO_SENSOR]; //-  
  char    		T_Before[MAX_RADIO_SENSOR]; //   
} TypeDef_RADIO_SENSOR;

/*   ,     */
typedef struct
{
  char                  Time_Out[MAX_WIRE_SENSOR]; //  -    
  char                  Parameter[MAX_WIRE_SENSOR]; //    (,  , , )
  char                  Group[MAX_WIRE_SENSOR];//  
} TypeDef_WIRE_SENSOR;

/*   ,    */
typedef struct
{
  char                  Group[MAX_OWNER];// 
} TypeDef_OWNER;

/*   ,   Ibutton */
typedef struct
{
  char                  Group[MAX_IBUTTON];// 
} TypeDef_IBUTTON;


/*   ,     DS1820 */
typedef struct
{
  char    Data_Current[MAX_DS1820];  //   
  char    Data_Before[MAX_DS1820];  //   
  char    Range_State; // 8  -  8  : 0 -     , 1 -     
  char    Group[MAX_DS1820]; //
  char    Tn[MAX_DS1820]; //   ()
  char    Time_out_Tn[MAX_DS1820]; //-  
} TypeDef_DS1820_SENSOR;

#endif