
#include "libraries.h"

u8 RxBuffer[SERIAL_MAX_DATA_LEN];
extern u8 DeviceAddress;
extern TypeDef_InputPackage IncomingPackage;

extern xQueueHandle Queue_basic_commands;



/*******************************************************************************
* Function Name  : protothread
* Description    :        
* Input          : 
* Output         : 
* Return         : PT_THREAD
*******************************************************************************/

PT_THREAD(protothread(u8 *pData, u16 *pDataLenght,  TypeDef_InputPackage *Package))
{ 
  u8 tmp;
  static unsigned char InputPackage_CRC16H, InputPackage_CRC16L;

  //     
  #define INC_INPUT_BUFFER {pData++;(*pDataLenght)--;PT_WAIT_WHILE(&Package->pt_parser,*pDataLenght == 0);}
  PT_BEGIN(&Package->pt_parser);
  while(1)
  {
  #define UNSTAFFING  {                                             \
                        if(*pData == FESC)                          \
                        { INC_INPUT_BUFFER;                         \
                          if(*pData == TFBGN) tmp = PACK_HEADER;    \
                          if(*pData == TFESC) tmp = FESC;           \
                        }                                           \
                        else tmp=*pData;                            \
                      }
    
  
    //   
    while( *pData != PACK_HEADER) 
    {
      INC_INPUT_BUFFER;
    }
    //   RC
    init_crc(&InputPackage_CRC16H,&InputPackage_CRC16L);
    //  PackageHead
    Package->Header=*pData;
    crc16_update(&InputPackage_CRC16H,&InputPackage_CRC16L, Package->Header);
    //  Addr 
    INC_INPUT_BUFFER;
    UNSTAFFING;
    Package->Addr=tmp;
    
    /*
    if((Package->Addr&0xC0)==0)
    {
      if(DeviceAddress!=Package->Addr)
        PT_RESTART(&Package->pt_parser); 
    }
    */
    
    crc16_update(&InputPackage_CRC16H,&InputPackage_CRC16L, tmp);
    //  PackageNum 
    INC_INPUT_BUFFER;
    UNSTAFFING;
    Package->NumberPresent=tmp;
    crc16_update(&InputPackage_CRC16H,&InputPackage_CRC16L, tmp);
    //  PackageCode 
    INC_INPUT_BUFFER;
    UNSTAFFING;
    Package->Code=tmp;
    crc16_update(&InputPackage_CRC16H,&InputPackage_CRC16L, tmp);
    //  PackageSize 
    INC_INPUT_BUFFER;
    UNSTAFFING;
    Package->Size=tmp;
    crc16_update(&InputPackage_CRC16H,&InputPackage_CRC16L, tmp);
    
    /*
    if(Package->Addr==SERIAL_NUMBER_TYPE_1 || Package->Addr==SERIAL_NUMBER_TYPE_2)
    {
      Package->Size-=sizeof(Device.Properties.SerialNum);
      for (serial_number_index=0; serial_number_index<sizeof(Device.Properties.SerialNum); serial_number_index++)
      {
        INC_INPUT_BUFFER;
        UNSTAFFING;
        if(tmp == Device.Properties.SerialNum[serial_number_index])
          crc16_update(&InputPackage_CRC16H,&InputPackage_CRC16L, tmp);
        else
         PT_RESTART(&Package->pt_parser);
      }
    }
    */
    
    //   
    Package->pData=&RxBuffer[0];
    Package->p_data=Package->pData;
    while (Package->Size--)
    {
      INC_INPUT_BUFFER;
      UNSTAFFING;
      *Package->p_data=tmp;
      crc16_update(&InputPackage_CRC16H,&InputPackage_CRC16L, tmp);
       Package->p_data++;
    }
    //    CRC
    INC_INPUT_BUFFER;
    UNSTAFFING;
    Package->CRC_[0]=tmp;  // CRC16L
    //    CRC
    INC_INPUT_BUFFER;
    UNSTAFFING;
    Package->CRC_[1]=tmp;  // CRC16H
    //     
    Package->Size=Package->p_data-Package->pData;
    //        
    if(crc(&InputPackage_CRC16H,&InputPackage_CRC16L) ==(Package->CRC_[0])+((Package->CRC_[1])<<8)) 
      break;
    else {_DBG(LOW, "CRC input package ERROR %s, %i\n",__FILE__, __LINE__);}
  }
  //         Package
  PT_END(&Package->pt_parser);
}

/*******************************************************************************
* Function Name  : 
* Description    : 
* Input          : 
* Output         : 
* Return         : 
*******************************************************************************/
void FillingIncomingDataStruct(TypeDef_InputPackage *Input_Package, TypeDef_Data *Input_Data)
{
  Input_Data->Command=Input_Package->Code;
  Input_Data->Size=Input_Package->Size;
  Input_Data->pData=Input_Package->pData;
}

