
#include "libraries.h"
extern   xQueueHandle                   Queue_Print_Debug;
extern volatile unsigned short int      Task_1WIRE_1_Alive;
extern volatile TypeDef_USB_Mode        USB_Mode;
extern volatile char			Program_Mode_Timeout;
extern volatile char			LED_Short_Flash;
extern volatile char			LED_Long_Flash;
extern volatile char                    Working_Flag[];
extern volatile char                    Mode_Flag[];
extern volatile char                    Arm_Delay;
extern  TypeDef_IBUTTON                 IButton;
extern volatile char                    Delay_arm_group;
extern volatile char                    Delay_who;
extern volatile char			Test_Mode_Timeout;
extern volatile char                    LED_test_timeout;

//IWD -   task_1Wire1
#define T_1W1_WD_LEN                    10
volatile char                           T_1w1_wd = T_1W1_WD_LEN;
/*******************************************************************************
* Function Name  : Task_1WIRE_1
* Description    :        1Wire_1
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 

void Task_1WIRE_1 (void *pvParameters) 
{
  
  portBASE_TYPE xStatus;
  const portTickType xTicksToWait = DEBUG_WAIT / portTICK_RATE_MS;
  const char Test_1W1[] = "Test_1W1\r";
  TypeDef_PRINT_DEBUG xMessage;

  char IButton_data[IBUTTON_DATA_LEN];
  char IButton_data_before[IBUTTON_DATA_LEN];
  char i, m, IButton_pos, crc, temp;
  
  vTaskDelay(50/portTICK_RATE_MS);

  /*    . 
   Rx  Tx UART  ,    IButton,   -    */
  FLAG_ARM_BOARD_RESET;
  
  for(i = 0; i < strlen(Test_1W1); i++ ) 
  { 
    USART_ClearFlag_1WIRE_1(USART_FLAG_RXNE);
    USART_SendData_1WIRE_1(Test_1W1[i]);
    temp=255;
    while (USART_GetFlagStatus_1WIRE_1(USART_FLAG_RXNE) == RESET && temp) {temp--;}
    m=USART_RECEIVE_DATA_1WIRE_1;
    
    USART_ClearFlag_1WIRE_1(USART_FLAG_RXNE);
    USART_SendData_1WIRE_1(m);
    temp=255;
    while (USART_GetFlagStatus_1WIRE_1(USART_FLAG_RXNE) == RESET && temp) {temp--;}
    m=USART_RECEIVE_DATA_1WIRE_1;
    
    if (m!= Test_1W1[i]) FLAG_ARM_BOARD_SET;
  }
  
  
     
  /*        . */
  while (1)
  { 
    /*   ""   */
    Task_1WIRE_1_Alive++;

        /*     .    
          vTaskDelay(),     
        Blocked    .     '' */
 
    vTaskDelay(300/portTICK_RATE_MS);

  /*     */	
  if (!FLAG_ARM_BOARD_STATE)
  {
    /*    IButton */
    if ( _1Wire_1_Reset() )
    {
      _1Wire_1_ByteWrite( _1Wire_READ);

      /* i=0 ... 7 */
      for(i = 0; i < 8; i++ )
      {
        IButton_data[i]=_1Wire_1_ByteWrite(_1Wire_READ_BYTE);    
      }
      

      IButton_data[8]=_1W_CRC(IButton_data,7);

      crc=IButton_data[8]-IButton_data[7]; //0 - crc OK
        
      
      m=0;
      //    
      if ( (crc==0) && (IButton_data[0] || IButton_data[1] || IButton_data[2] || IButton_data[3]) )
       {
        for(i = 0; i < 8; i++ )
         {
          if (IButton_data[i]!=IButton_data_before[i]) m=1;
          IButton_data_before[i]=IButton_data[i];
         }
       }


      if (m)
       {
        //   IButton -  
        IButton_pos = Check_IButton (IButton_data);

        /*   IButton*/
        if (FLAG_PROGRAM_MODE_STATE)
         {
	  /*       IButton     ,        */
	  Program_Mode_Timeout=PROGRAM_MODE_TIMEOUT_LEN; //  
	  if (IButton_pos==0) IButton_pos=Save_IButton(IButton_data); //  IButton    ,   
          Sirena(1); //   
          LED_OFF;
          LED_Long_Flash=0;
          LED_Short_Flash=2; //1   
	 }
	 else
	 {
	  // "" IButton,         
	  if (IButton_pos!=0)
	   {
	     if ( 
                 ( MODE_ARM_STATE & IButton.Group[IButton_pos-1] ) ||                //     ,   IButton
                 ( Arm_Delay && (Delay_arm_group & IButton.Group[IButton_pos-1]) ) //       ,   IButton
                 ) 
               Disarm (IButton.Group[IButton_pos-1], IButton_pos + IBUTTON_1 - 1); //   ,   IButton
             else 
               Arm_1Wire(IButton.Group[IButton_pos-1], IButton_pos + IBUTTON_1 - 1); //   ,   IButton
	   }
	 }
        IButton_data[9]=IButton_pos;
       }
    
         
      if ( (USB_Mode==DebugMode) && m)
      {
        /*    Debug-  */    
	xMessage.Debug_Data_Len = IBUTTON_DATA_LEN;
	xMessage.Debug_Source_ID = Receive_1Wire_1_Debug_ID;
        xMessage.Debug_Char_Data = IButton_data;
        xMessage.Debug_Data_type=Debug_Data_type_HEX;
    
        /*   .
          -   .  
          ,     pvParameters.
            - ,    
          Blocked,      ,
            */
        xStatus = xQueueSendToBack(Queue_Print_Debug, &xMessage, xTicksToWait );
        if( xStatus != pdPASS )
        {
         /*    ,    xTicksToWait .
             . */
  
        }
      }    
  
      
      /* -   */ 
      vTaskDelay(800/portTICK_RATE_MS);
     
    }
    else
    {
      //   IButton
      for(i = 0; i < 8; i++ )
      {
        IButton_data_before[i]=0;
      } 
    }

  
   } 
 
  //IWD -   task_1Wire1
  T_1w1_wd = T_1W1_WD_LEN;
  }
  
       /*     ,     (break)  
          ,      
           .  NULL, 
       vTaskDelete(), ,      (, 
       ) . */
    
//    vTaskDelete( NULL );
  
}


/*******************************************************************************
* Function Name  : Check_IButton
* Description    :   IButton      
* Input          : Sensor_Data -      IButton
*                  
* Output         : None
* Return         : !0 -   IButton   , 0 -  IButton   
*******************************************************************************/ 
char Check_IButton (char * Sensor_Data)
{
  
  char i=0;
  uint16_t eeprom_data;
  
  for (i=0; i < MAX_IBUTTON; i++)
  {     
   //  0,      
   if (! Virtual_EEPROM (START_IBUTTON_ADDR + i*3+0, & eeprom_data, READ_DATA_EEPROM)) 
    {
     if ( (Sensor_Data[1]== (char) (eeprom_data>>8)) && (Sensor_Data[2]== (char) (eeprom_data & 0x00FF)))
      {
       //  0,      
       if (! Virtual_EEPROM (START_IBUTTON_ADDR + i*3+1, & eeprom_data, READ_DATA_EEPROM)) 
        {
 	  if ( (Sensor_Data[3]== (char) (eeprom_data>>8)) && (Sensor_Data[4]== (char) (eeprom_data & 0x00FF))) 
          {
           //  0,      
           if (! Virtual_EEPROM (START_IBUTTON_ADDR + i*3+2, & eeprom_data, READ_DATA_EEPROM)) 
            {
	     if ( (Sensor_Data[5]== (char) (eeprom_data>>8)) && (Sensor_Data[6]== (char) (eeprom_data & 0x00FF)) ) return (i+1); //  
	    }
          }    
        }
      }    
    }  

  }

  return 0; // IButton   
} 
/*******************************************************************************
* Function Name  : Save_to_EEPROM_IButton
* Description    :   IButton  EEPROM   
* Input          : Sensor_Data -      IButton
*		   pos -  
* Output         : None
* Return         : None
*******************************************************************************/ 
void Save_to_EEPROM_IButton (char * Sensor_Data, char pos)
{
  uint16_t eeprom_data;

  //    
  eeprom_data =  (( (uint16_t) Sensor_Data[1] & 0x00FF)<<8) |  ((uint16_t) Sensor_Data[2] & 0x00FF);
  Virtual_EEPROM (START_IBUTTON_ADDR + (pos-1)*3+0, & eeprom_data, SAVE_DATA_EEPROM);

  eeprom_data =  (( (uint16_t) Sensor_Data[3] & 0x00FF)<<8) |  ((uint16_t) Sensor_Data[4] & 0x00FF);
  Virtual_EEPROM (START_IBUTTON_ADDR + (pos-1)*3+1, & eeprom_data, SAVE_DATA_EEPROM);

  eeprom_data =  (( (uint16_t) Sensor_Data[5] & 0x00FF)<<8) |  ((uint16_t) Sensor_Data[6] & 0x00FF);
  Virtual_EEPROM (START_IBUTTON_ADDR + (pos-1)*3+2, & eeprom_data, SAVE_DATA_EEPROM);
}

/*******************************************************************************
* Function Name  : Arm_1Wire
* Description    :     ,      1Wire
* Input          : arm_group - ,    , who - 
*		   None
* Output         : Arm_Delay -     
* Return         : None
*******************************************************************************/
void Arm_1Wire(char arm_group, char who)
{
uint16_t eeprom_data;
    /*   EEPROM       1Wire */
   //  0,   
   if (Virtual_EEPROM (ANSWER_ARM_PARAMETER_W, & eeprom_data, READ_DATA_EEPROM)) 
   {
      eeprom_data=ANSWER_ARM_PARAMETER_DEFAULT; //   ,    
      Virtual_EEPROM (ANSWER_ARM_PARAMETER_W, & eeprom_data, SAVE_DATA_EEPROM);
   }
   if ( 0x0007 & (eeprom_data>>ARM_1W1_DELAY_POSITION) )
	{ 
	 Arm_Delay= (char) (10 * ( 0x0007 & (eeprom_data>>ARM_1W1_DELAY_POSITION)));
	 Delay_arm_group |= arm_group;
         Delay_who=who;
	} 
   else 
	Arm(arm_group,0, who);
}

/*******************************************************************************
* Function Name  : Save_IButton
* Description    :   IButton   
* Input          : Sensor_Data -      IButton
* Output         : None
* Return         :    IButton   
*******************************************************************************/ 
char Save_IButton (char * Sensor_Data)
{
  char i=0;
  uint16_t eeprom_data, eeprom_data1, eeprom_data2;

  //     
  for (i=0; i < MAX_IBUTTON; i++)
  {     
   //  !=0,      
   if ( Virtual_EEPROM (START_IBUTTON_ADDR + i*3, & eeprom_data, READ_DATA_EEPROM) ||  
	Virtual_EEPROM (START_IBUTTON_ADDR + i*3+1, & eeprom_data1, READ_DATA_EEPROM) ||  
	Virtual_EEPROM (START_IBUTTON_ADDR + i*3+2, & eeprom_data2, READ_DATA_EEPROM) 
	) 
    {
     Save_to_EEPROM_IButton (Sensor_Data, i+1);
     return (i+1);
    }

   //     ,   
   if ( (eeprom_data==0) && (eeprom_data1==0) && (eeprom_data2==0) )
    {
     Save_to_EEPROM_IButton (Sensor_Data, i+1);
     return (i+1);
    }
  }

  //   -   
  //  0,      
  if (! Virtual_EEPROM (IBUTTON_LOOP, & eeprom_data, READ_DATA_EEPROM))
    {
      eeprom_data++;
      if ( eeprom_data > MAX_IBUTTON ) eeprom_data=1;
      Virtual_EEPROM (IBUTTON_LOOP, & eeprom_data, SAVE_DATA_EEPROM);    
      Save_to_EEPROM_IButton (Sensor_Data,(char) eeprom_data);
      return (char) eeprom_data;

    }
    else
    {
      //    1
      eeprom_data = 1;
      Virtual_EEPROM (IBUTTON_LOOP, & eeprom_data, SAVE_DATA_EEPROM);    
      Save_to_EEPROM_IButton (Sensor_Data,(char) eeprom_data);
      return 1;
    }
  //return 0;
} 

/*******************************************************************************
* Function Name  : _1W_CRC
* Description    :  CRC8  mas  Len 
* Input          : mas -   , Len -  
* Output         : None
* Return         : CRC
*******************************************************************************/ 
char _1W_CRC( char *mas, char Len )
{
  char i,dat,crc=0,fb;
  
  do
  {
    dat=*mas;
    for( i=0; i<8; i++) 
    {  //    
      fb = crc ^ dat;
      fb &= 1;
      crc >>= 1;
      dat >>= 1;
      if( fb == 1 ) crc ^= 0x8c; // 
    }
    mas++;
    Len--;
  } while( Len ); //    
  
  return crc;
}

/*******************************************************************************
* Function Name  : _1Wire_1_UART_config
* Description    :   UART
* Input          : USART_TypeDef* USART
* Output         : None
* Return         : None
*******************************************************************************/ 
void _1Wire_1_UART_config(void)
{
 
  USART_InitTypeDef USART_InitStructure;
  
  USART_InitStructure.USART_BaudRate = 115200;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_Init_1W1(_1WIRE_1_UART, &USART_InitStructure);
 
/*    */
  USART_Cmd(_1WIRE_1_UART, ENABLE);
 
}

/*******************************************************************************
* Function Name  : _1Wire_1_PinConfig
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void _1Wire_1_PinConfig(void) 
{
  GPIO_InitTypeDef  GPIO_InitStruct;
  
  RCC_APB2PeriphClockCmd(_1WIRE_1_APB_PERIPH_PIN_TX, ENABLE);
  RCC_APB2PeriphClockCmd(_1WIRE_1_APB_PERIPH_PIN_RX, ENABLE);
  
  /* !!!    UART*/
  if (_1WIRE_1_UART==USART1)
  {
    RCC_APB2PeriphClockCmd(_1WIRE_1_APB_PERIPH_UART, ENABLE);
  } 
  else
  {
    RCC_APB1PeriphClockCmd(_1WIRE_1_APB_PERIPH_UART, ENABLE); 
  }
   
  GPIO_InitStruct.GPIO_Pin = _1WIRE_1_PIN_TX;
  GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
  /* open drain */
  GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF_OD; //GPIO_Mode_AF_OD; GPIO_Mode_AF_PP
  GPIO_Init(_1WIRE_1_PORT_TX, &GPIO_InitStruct);

  GPIO_InitStruct.GPIO_Pin = _1WIRE_1_PIN_RX;
  GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IPU; //GPIO_Mode_IPU; GPIO_Mode_IN_FLOATING
  GPIO_Init(_1WIRE_1_PORT_RX, &GPIO_InitStruct);

}


/*******************************************************************************
* Function Name  : _1Wire_1_Reset
* Description    :  1Wire_1     
* Input          : None
* Output         : None
* Return         : char: 1 -  -, 0 -  
*******************************************************************************/ 

char _1Wire_1_Reset(void) 
{
        u8 temp, _1wire_slave_answer;
        
        USART_InitTypeDef USART_InitStructure;

        USART_InitStructure.USART_BaudRate = 9600;
        USART_InitStructure.USART_WordLength = USART_WordLength_8b;
        USART_InitStructure.USART_StopBits = USART_StopBits_1;
        USART_InitStructure.USART_Parity = USART_Parity_No;
        USART_InitStructure.USART_HardwareFlowControl =USART_HardwareFlowControl_None;
        USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;

        //taskENTER_CRITICAL();
        USART_Init_1W1(_1WIRE_1_UART, &USART_InitStructure);
        //taskEXIT_CRITICAL();
    
        
        USART_ClearFlag_1WIRE_1(USART_FLAG_RXNE);
        
        USART_SendData_1WIRE_1( 0xf0); // master send RESET

        temp=255;
        while (USART_GetFlagStatus_1WIRE_1(USART_FLAG_RXNE) == RESET && temp) {temp--;}
        //taskYIELD();
        
        _1wire_slave_answer = IBUTTON_DATA_READ 
        
        USART_InitStructure.USART_BaudRate = 115200;
        //USART_InitStructure.USART_WordLength = USART_WordLength_8b;
        //USART_InitStructure.USART_StopBits = USART_StopBits_1;
        //USART_InitStructure.USART_Parity = USART_Parity_No;
        //USART_InitStructure.USART_HardwareFlowControl =USART_HardwareFlowControl_None;
        //USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
        
        //taskENTER_CRITICAL();
        USART_Init_1W1(_1WIRE_1_UART, &USART_InitStructure);
        //taskEXIT_CRITICAL();

        if ( Test_Mode_Timeout && !_1wire_slave_answer)
        {
          LED_ON;
          LED_test_timeout=LED_TEST_TIMEOUT_LEN;
        }
          
        
        //     
        if ((_1wire_slave_answer != 0xf0) && (_1wire_slave_answer != 0x00)) 
        {
          return 1; //slave is on 1Wire_1
        }

        return 0; //nothing on 1Wire_1
}



/*******************************************************************************
* Function Name  : _1Wire_1_BitWrite
* Description    : /    1Wire_1  UART
* Input          : bool ucBit 
* Output         : None
* Return         : boolean: TRUE - received bit 1, FALSE - received bit 0
*******************************************************************************/
bool _1Wire_1_BitWrite (bool ucBit)
{
    u8 temp, ucData = 0;

    if (ucBit)
    {
        temp=0xff;
     }
    else
    {
        temp=0x00;
     }    
    
    /* send bit to 1Wire_1 */

    USART_ClearFlag_1WIRE_1(USART_FLAG_RXNE);
    
    USART_SendData_1WIRE_1(temp);
   
    temp=255;
    while (USART_GetFlagStatus_1WIRE_1(USART_FLAG_RXNE) == RESET && temp) {temp--;}

    /*read bit from 1Wire_1 */
    ucData = IBUTTON_DATA_READ
    
    if (ucData == 0xff) 
    {
      return TRUE;
     }

    return FALSE;
    
}

/*******************************************************************************
* Function Name  : _1Wire_1_ByteWrite
* Description    : /    1Wire_1  UART
* Input          : u8 ucByte
* Output         : None
* Return         : u8:  
*******************************************************************************/
u8 _1Wire_1_ByteWrite( u8 ucByte)
{
    u8 i,ucData=0;
    bool bit;
  
    for(i = 0;i<8 ;i++)
    {
        bit=FALSE;
        if (ucByte & 0x01) bit=TRUE ;
        ucData >>=  1;
        ucData &= 0x7f;
        if (_1Wire_1_BitWrite(bit)) {ucData |= 0x80;}
        ucByte >>=  1;
    }
    
    return ucData;    
}

void _1Wire_1_Config (void)
{
    _1Wire_1_PinConfig();
    _1Wire_1_UART_config();
}


/* Receive Data */
//u8 USART_ReceiveData_1WIRE_1()
//{
//  return (u8)(_1WIRE_1_UART->DR);
//}

/* Transmit Data */
void USART_SendData_1WIRE_1(u8 Data)
{
    USART_ClearFlag_1WIRE_1(USART_FLAG_TC);
    _1WIRE_1_UART->DR = Data;
    while (USART_GetFlagStatus_1WIRE_1(USART_FLAG_TC) == RESET) {}
}


/* Clears the USARTx's pending flags */
void USART_ClearFlag_1WIRE_1(uint16_t USART_FLAG)
{
  _1WIRE_1_UART->SR = (uint16_t)~USART_FLAG;
}


/* Checks whether the specified USART flag is set or not */
FlagStatus USART_GetFlagStatus_1WIRE_1(uint16_t USART_FLAG)
{
  FlagStatus bitstatus = RESET;

  
  if ((_1WIRE_1_UART->SR & USART_FLAG) != (uint16_t)RESET)
  {
    bitstatus = SET;
  }
  else
  {
    bitstatus = RESET;
  }
  return bitstatus;
}

/**
  * @brief  Initializes the USARTx peripheral according to the specified
  *         parameters in the USART_InitStruct .
  * @param  USARTx: Select the USART or the UART peripheral. 
  *   This parameter can be one of the following values:
  *   USART1, USART2, USART3, UART4 or UART5.
  * @param  USART_InitStruct: pointer to a USART_InitTypeDef structure
  *         that contains the configuration information for the specified USART 
  *         peripheral.
  * @retval None
  */
void USART_Init_1W1(USART_TypeDef* USARTx, USART_InitTypeDef* USART_InitStruct)
{
  #define CR2_STOP_CLEAR_Mask       ((uint16_t)0xCFFF)  /*!< USART CR2 STOP Bits Mask */
  #define CR1_CLEAR_Mask            ((uint16_t)0xE9F3)  /*!< USART CR1 Mask */
  #define CR3_CLEAR_Mask            ((uint16_t)0xFCFF)  /*!< USART CR3 Mask */
  #define CR1_OVER8_Set             ((u16)0x8000)  /* USART OVER8 mode Enable Mask */
  
  uint32_t tmpreg = 0x00, apbclock = 0x00;
  uint32_t integerdivider = 0x00;
  uint32_t fractionaldivider = 0x00;
  uint32_t usartxbase = 0;
  RCC_ClocksTypeDef RCC_ClocksStatus;

  /* The hardware flow control is available only for USART1, USART2 and USART3 */
  if (USART_InitStruct->USART_HardwareFlowControl != USART_HardwareFlowControl_None)
  {
    assert_param(IS_USART_123_PERIPH(USARTx));
  }

  usartxbase = (uint32_t)USARTx;

/*---------------------------- USART CR2 Configuration -----------------------*/
  tmpreg = USARTx->CR2;
  /* Clear STOP[13:12] bits */
  tmpreg &= CR2_STOP_CLEAR_Mask;
  /* Configure the USART Stop Bits, Clock, CPOL, CPHA and LastBit ------------*/
  /* Set STOP[13:12] bits according to USART_StopBits value */
  tmpreg |= (uint32_t)USART_InitStruct->USART_StopBits;
  
  /* Write to USART CR2 */
  USARTx->CR2 = (uint16_t)tmpreg;

/*---------------------------- USART CR1 Configuration -----------------------*/
  tmpreg = USARTx->CR1;
  /* Clear M, PCE, PS, TE and RE bits */
  tmpreg &= CR1_CLEAR_Mask;
  /* Configure the USART Word Length, Parity and mode ----------------------- */
  /* Set the M bits according to USART_WordLength value */
  /* Set PCE and PS bits according to USART_Parity value */
  /* Set TE and RE bits according to USART_Mode value */
  tmpreg |= (uint32_t)USART_InitStruct->USART_WordLength | USART_InitStruct->USART_Parity |
            USART_InitStruct->USART_Mode;
  /* Write to USART CR1 */
  USARTx->CR1 = (uint16_t)tmpreg;

/*---------------------------- USART CR3 Configuration -----------------------*/  
  tmpreg = USARTx->CR3;
  /* Clear CTSE and RTSE bits */
  tmpreg &= CR3_CLEAR_Mask;
  /* Configure the USART HFC -------------------------------------------------*/
  /* Set CTSE and RTSE bits according to USART_HardwareFlowControl value */
  tmpreg |= USART_InitStruct->USART_HardwareFlowControl;
  /* Write to USART CR3 */
  USARTx->CR3 = (uint16_t)tmpreg;

/*---------------------------- USART BRR Configuration -----------------------*/
  /* Configure the USART Baud Rate -------------------------------------------*/
  RCC_GetClocksFreq(&RCC_ClocksStatus);
  if (usartxbase == USART1_BASE)
  {
    apbclock = RCC_ClocksStatus.PCLK2_Frequency;
  }
  else
  {
    apbclock = RCC_ClocksStatus.PCLK1_Frequency;
  }
  
  /* Determine the integer part */
  if ((USARTx->CR1 & CR1_OVER8_Set) != 0)
  {
    /* Integer part computing in case Oversampling mode is 8 Samples */
    integerdivider = ((25 * apbclock) / (2 * (USART_InitStruct->USART_BaudRate)));    
  }
  else /* if ((USARTx->CR1 & CR1_OVER8_Set) == 0) */
  {
    /* Integer part computing in case Oversampling mode is 16 Samples */
    integerdivider = ((25 * apbclock) / (4 * (USART_InitStruct->USART_BaudRate)));    
  }
  tmpreg = (integerdivider / 100) << 4;

  /* Determine the fractional part */
  fractionaldivider = integerdivider - (100 * (tmpreg >> 4));

  /* Implement the fractional part in the register */
  if ((USARTx->CR1 & CR1_OVER8_Set) != 0)
  {
    tmpreg |= ((((fractionaldivider * 8) + 50) / 100)) & ((uint8_t)0x07);
  }
  else /* if ((USARTx->CR1 & CR1_OVER8_Set) == 0) */
  {
    tmpreg |= ((((fractionaldivider * 16) + 50) / 100)) & ((uint8_t)0x0F);
  }
  
  /* Write to USART BRR */
  USARTx->BRR = (uint16_t)tmpreg;
}


