
#include "libraries.h"
extern   xQueueHandle 			Queue_Print_Debug;
extern volatile unsigned short int 	Task_1WIRE_2_Alive;
extern volatile TypeDef_USB_Mode 	USB_Mode;
extern volatile char			Program_Mode_Timeout;
extern volatile char			LED_Short_Flash;
extern volatile char			LED_Long_Flash;
extern volatile char                    Working_Flag[];
extern volatile char                    Mode_Flag[];
extern volatile TypeDef_DS1820_SENSOR   DS1820_Sensor;
extern volatile char			Test_Mode_Timeout;
extern volatile char                    LED_test_timeout;

//IWD -   task_1Wire2
#define T_1W2_WD_LEN                    10
volatile char                           T_1w2_wd = T_1W2_WD_LEN;
/*******************************************************************************
* Function Name  : Task_1WIRE_2
* Description    :        1Wire
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 

void Task_1WIRE_2 (void *pvParameters) 
{
  portBASE_TYPE xStatus;
  const portTickType xTicksToWait = DEBUG_WAIT / portTICK_RATE_MS;
  const char Test_1W2[] = "Test_1W2\r";
  char 	DS1820_data[T_DATA_LEN], DS1820_ROM_before[8];
  char m, i, temp, crc, DS1820, print_debug, current_sensor=1, get_temperature=0;
  TypeDef_PRINT_DEBUG 		xMessage;

  //  
  /* i=0 ... MAX_DS1820-1 */
  for(i = 0; i < MAX_DS1820; i++ )
   {
     DS1820_Sensor.Data_Current[i]=NO_TEMPERATURE; //     
   }
  DS1820_Sensor.Range_State=0; //     

  vTaskDelay(600/portTICK_RATE_MS);
  
  /*    Rx  Tx UART        */
  
  for(i = 0; i < strlen(Test_1W2); i++ ) 
  { 
    USART_ClearFlag_1WIRE_2(USART_FLAG_RXNE);
    USART_SendData_1WIRE_2(Test_1W2[i]);
    temp=255;
    while (USART_GetFlagStatus_1WIRE_2(USART_FLAG_RXNE) == RESET && temp) {temp--;}
    m=USART_RECEIVE_DATA_1WIRE_2;
    
    USART_ClearFlag_1WIRE_2(USART_FLAG_RXNE);
    USART_SendData_1WIRE_2(m);
    temp=255;
    while (USART_GetFlagStatus_1WIRE_2(USART_FLAG_RXNE) == RESET && temp) {temp--;}
    m=USART_RECEIVE_DATA_1WIRE_2;
    
    if (m!= Test_1W2[i]) {}
  }  
 

  
  /*        . */
  while (1)
  { 
    /*   ""   */
    Task_1WIRE_2_Alive++;
    
/*     .    
          vTaskDelay(),     
        Blocked    .     '' */
 
    vTaskDelay(500/portTICK_RATE_MS);
 
   /*      */
   if ( _1Wire_2_Reset() )
    {
     print_debug=0;
     
     /*     */
     if (FLAG_PROGRAM_MODE_STATE)
      {
       _1Wire_2_ByteWrite( _1Wire_READ);
        
        /* i=0 ... 7 */
        for(i = 0; i < 8; i++ )
        {
         DS1820_data[i]=_1Wire_2_ByteWrite(_1Wire_READ_BYTE); // here 64bits sensor ROM-code
        }
        
        DS1820_data[8]=_1W_CRC(DS1820_data,7); //calculate CRC for 1&&7 bytes
        
        crc=DS1820_data[8]-DS1820_data[7]; //0 - crc OK
        
        //prepare for Debug
        xMessage.Debug_Data_Len = 9; 
        xMessage.Debug_Source_ID = Receive_1Wire_2_Debug_ID;
        xMessage.Debug_Char_Data = DS1820_data;
        xMessage.Debug_Data_type=Debug_Data_type_HEX; 
        print_debug=1;


        
        /*  CRC=0,     */
        if ( (crc==0) && (DS1820_data[0] || DS1820_data[1] || DS1820_data[2] || DS1820_data[3]) )
         {

           //    
           /* i=0 ... 7 */
           temp=0;
           for(i = 0; i < 8; i++ )
            {
              if (DS1820_ROM_before[i]!=DS1820_data[i]) temp=1; // 
            } 
           
           if (temp)
           {
            /* i=0 ... 7 */
            for(i = 0; i < 8; i++ )
              {
                DS1820_ROM_before[i]=DS1820_data[i]; //  64bits sensor ROM-code
              }
           
            //   DS1820 -  
            DS1820 = Check_DS1820 (DS1820_data);
            // DS1820      -      
            Program_Mode_Timeout=PROGRAM_MODE_TIMEOUT_LEN; //  
            if (DS1820==0) DS1820=Save_DS1820(DS1820_data); //  DS1820    ,   
            DS1820_data[9]=DS1820;
            Sirena(1); //   
            LED_OFF;
            LED_Long_Flash=0;
            LED_Short_Flash=2; //1   
           }
           //prepare for Debug
           xMessage.Debug_Data_Len = 10; 

	 }
                 

      }
	else
      {
        if (current_sensor>MAX_DS1820)
        {
          current_sensor=1;
           //prepare for Debug
          xMessage.Debug_Data_Len = MAX_DS1820; 
          xMessage.Debug_Source_ID = DS1820_Debug_ID;
          xMessage.Debug_Char_Data = (char*)(DS1820_Sensor.Data_Current);
          xMessage.Debug_Data_type=Debug_Data_type_HEX;
          print_debug=1;
        }
        else
        {
         if (get_temperature)
         {
          //prepare for Debug
          xMessage.Debug_Data_Len = T_DATA_LEN; 
          xMessage.Debug_Source_ID = Receive_1Wire_2_Debug_ID;
          xMessage.Debug_Char_Data = DS1820_data;
          xMessage.Debug_Data_type=Debug_Data_type_HEX; 
           
          print_debug=Check_Sensor_ROM_Code(current_sensor);
       
          if (print_debug)
          {
            
            _1Wire_2_ByteWrite( _1Wire_MATCH);
            Send_Sensor_ROM_Code (current_sensor, DS1820_data);          
            _1Wire_2_ByteWrite( _1Wire_READ_SCRATCHPAD);
            DS1820_data[8] = _1Wire_READ_SCRATCHPAD;            
            
            
            /* i=0 ... 8 */
            for(i = 0; i < 9; i++ )
            {
              DS1820_data[9+i]=_1Wire_2_ByteWrite(_1Wire_READ_BYTE); //  9  17  -   
            }
            
            DS1820_data[18]=_1W_CRC(DS1820_data+9,8); //calculate CRC for 1&&8 bytes
            crc=DS1820_data[18] - DS1820_data[17]; //0 - crc OK
            DS1820_data[19]=current_sensor; // 
            
            if ( (crc==0) && (DS1820_data[9] || DS1820_data[10] || DS1820_data[11] || DS1820_data[12] || DS1820_data[13] || DS1820_data[14]) ) 
            {
              /*    ( )*/ 
              switch (DS1820_data[0])
              {
                case 0x28:
                  /* DS18B20 */
                  DS1820_Sensor.Data_Current[current_sensor-1]=(DS1820_data[10]<<4) | (DS1820_data[9]>>4);
                  break;
                  
                case 0x10:
                  /* DS18S20 */
                  DS1820_Sensor.Data_Current[current_sensor-1]=(DS1820_data[10]<<7) | (DS1820_data[9]>>1);
                  break;
                  
                default:
                  DS1820_Sensor.Data_Current[current_sensor-1]=NO_TEMPERATURE; //   
                  break;
              }
            }
            else 
            {
              //print_debug=0;
              DS1820_Sensor.Data_Current[current_sensor-1]=NO_TEMPERATURE; //    
            }
          }
          
          get_temperature=0;
          //      
          current_sensor++;          
        }
         else
         {
          print_debug=Check_Sensor_ROM_Code (current_sensor);
          //    
          if (print_debug)
          {
            _1Wire_2_ByteWrite( _1Wire_MATCH);
            Send_Sensor_ROM_Code (current_sensor, DS1820_data);
            _1Wire_2_ByteWrite( _1Wire_CONVERT);
          }
          if (!print_debug) DS1820_Sensor.Data_Current[current_sensor-1]=NO_TEMPERATURE; //    
          print_debug=0; 
          get_temperature=1;         
         }
        }
      }


      if ( (USB_Mode==DebugMode) && print_debug)
      {
     
         /*    Debug-  */        

     
        /*   .
          -   .  
          ,     pvParameters.
            - ,    
          Blocked,      ,
            */
        xStatus = xQueueSendToBack(Queue_Print_Debug, &xMessage, xTicksToWait );
        if( xStatus != pdPASS )
        {
         /*    ,    xTicksToWait .
             . */
         
        }
     }    
     
 
     /* -*/     
     vTaskDelay(1000/portTICK_RATE_MS);

    }
    else
    {
       //  
      /* i=0 ... MAX_DS1820-1 */
      for(i = 0; i < MAX_DS1820; i++ )
      {
        DS1820_Sensor.Data_Current[i]=NO_TEMPERATURE; //     
      }
      
      /* i=0 ... 7 */
      for(i = 0; i < 8; i++ )
      {
        DS1820_ROM_before[i]=0; //  64bits sensor ROM-code
      }      
      
    }
   
  //IWD -   task_1Wire2
  T_1w2_wd = T_1W2_WD_LEN;
  }
  
  /*     ,     (break)  
          ,      
           .  NULL, 
       vTaskDelete(), ,      (, 
       ) . */
    
//    vTaskDelete( NULL ); 
}

/*******************************************************************************
* Function Name  : Check_Sensor_ROM_Code
* Description    :   ROM-code DS1820   
* Input          : cur_sensor -   
*                 
*                  
* Output         : None
* Return         : 1 -  DS1820   , 0 -  DS1820   
*******************************************************************************/ 
char Check_Sensor_ROM_Code (char cur_sensor)
{
  char i;
  uint16_t eeprom_data;
  
        /* i=0 ... 3 */
        for(i = 0; i < 4; i++ )
        {
         //  0,      
         if (Virtual_EEPROM (START_T_ADDR + (cur_sensor-1)*4 + i, & eeprom_data, READ_DATA_EEPROM)) return 0; // DS1820   
        }
        
        return 1; 
        
}

/*******************************************************************************
* Function Name  : Send_Sensor_ROM_Code
* Description    :    1Wire 64bit ROM-code DS1820
* Input          : cur_sensor -   
*                 Sensor_Data -   ,   ROM-code
*                  
* Output         : None
* Return         : 1 -  DS1820   , 0 -  DS1820   
*******************************************************************************/ 
char Send_Sensor_ROM_Code (char cur_sensor, char * Sensor_data)
{
  char i;
  uint16_t eeprom_data;
  
        /* i=0 ... 3 */
        for(i = 0; i < 4; i++ )
        {
         //  0,      
         if (! Virtual_EEPROM (START_T_ADDR + (cur_sensor-1)*4 + i, & eeprom_data, READ_DATA_EEPROM)) 
          {
            Sensor_data[i*2 + 0] =(char) (eeprom_data>>8);
            Sensor_data[i*2 + 1] =(char) (eeprom_data & 0x00FF);
            _1Wire_2_ByteWrite( Sensor_data[i*2 + 0] );  
            _1Wire_2_ByteWrite( Sensor_data[i*2 + 1] );
          }
          else return 0; // DS1820   
        }
        
        return 1; 
        
}
/*******************************************************************************
* Function Name  : Check_DS1820
* Description    :   DS1820      
* Input          : Sensor_Data -      DS1820
*                  
* Output         : None
* Return         : !0 -   DS1820   , 0 -  DS1820   
*******************************************************************************/ 
char Check_DS1820 (char * Sensor_Data)
{
  
  char i=0;
  uint16_t eeprom_data;
  
  for (i=0; i < MAX_DS1820; i++)
  {     
   //  0,      
   if (! Virtual_EEPROM (START_T_ADDR + i*4 + 0, & eeprom_data, READ_DATA_EEPROM)) 
    {
     if ( (Sensor_Data[0]== (char) (eeprom_data>>8)) && (Sensor_Data[1]== (char) (eeprom_data & 0x00FF)))
      {
       //  0,      
       if (! Virtual_EEPROM (START_T_ADDR + i*4 + 1, & eeprom_data, READ_DATA_EEPROM)) 
        {
 	  if ( (Sensor_Data[2]== (char) (eeprom_data>>8)) && (Sensor_Data[3]== (char) (eeprom_data & 0x00FF))) 
          {
           //  0,      
           if (! Virtual_EEPROM (START_T_ADDR + i*4 + 2, & eeprom_data, READ_DATA_EEPROM)) 
            {
	     if ( (Sensor_Data[4]== (char) (eeprom_data>>8)) && (Sensor_Data[5]== (char) (eeprom_data & 0x00FF)))
	      {	 
               //  0,      
               if (! Virtual_EEPROM (START_T_ADDR + i*4 + 3, & eeprom_data, READ_DATA_EEPROM)) 
                {
	         if ( (Sensor_Data[6]== (char) (eeprom_data>>8)) && (Sensor_Data[7]== (char) (eeprom_data & 0x00FF))) return (i+1); //  
	        }
	      } 
	    }
          }    
        }
      }    
    }  

  }

  return 0; // DS1820   
} 


/*******************************************************************************
* Function Name  : Save_to_EEPROM_DS1820
* Description    :   DS1820  EEPROM   
* Input          : Sensor_Data -      DS1820
*		   pos -  
* Output         : None
* Return         : None
*******************************************************************************/ 
void Save_to_EEPROM_DS1820 (char * Sensor_Data, char pos)
{
  uint16_t eeprom_data;

  //    

  eeprom_data =  (( (uint16_t) Sensor_Data[0] & 0x00FF)<<8) |  ((uint16_t) Sensor_Data[1] & 0x00FF);
  Virtual_EEPROM (START_T_ADDR + (pos-1)*4+0, & eeprom_data, SAVE_DATA_EEPROM);

  eeprom_data =  (( (uint16_t) Sensor_Data[2] & 0x00FF)<<8) |  ((uint16_t) Sensor_Data[3] & 0x00FF);
  Virtual_EEPROM (START_T_ADDR + (pos-1)*4+1, & eeprom_data, SAVE_DATA_EEPROM);

  eeprom_data =  (( (uint16_t) Sensor_Data[4] & 0x00FF)<<8) |  ((uint16_t) Sensor_Data[5] & 0x00FF);
  Virtual_EEPROM (START_T_ADDR + (pos-1)*4+2, & eeprom_data, SAVE_DATA_EEPROM);

  eeprom_data =  (( (uint16_t) Sensor_Data[6] & 0x00FF)<<8) |  ((uint16_t) Sensor_Data[7] & 0x00FF);
  Virtual_EEPROM (START_T_ADDR + (pos-1)*4+3, & eeprom_data, SAVE_DATA_EEPROM);
}


/*******************************************************************************
* Function Name  : Save_DS1820
* Description    :   DS1820   
* Input          : Sensor_Data -      DS1820
* Output         : None
* Return         :       
*******************************************************************************/ 
char Save_DS1820 (char * Sensor_Data)
{
  char i=0;
  uint16_t eeprom_data,eeprom_data1,eeprom_data2,eeprom_data3;

  //     
  for (i=0; i < MAX_DS1820; i++)
  {     
   //  !=0,      
   if ( Virtual_EEPROM (START_T_ADDR + i*4+0, & eeprom_data, READ_DATA_EEPROM) ||  
	Virtual_EEPROM (START_T_ADDR + i*4+1, & eeprom_data1, READ_DATA_EEPROM) ||  
	Virtual_EEPROM (START_T_ADDR + i*4+2, & eeprom_data2, READ_DATA_EEPROM) || 
	Virtual_EEPROM (START_T_ADDR + i*4+3, & eeprom_data3, READ_DATA_EEPROM) 
	) 
    {
      Save_to_EEPROM_DS1820 (Sensor_Data, i+1);
      return (i+1);
    }


   //     ,   
   if ( (eeprom_data==0) && (eeprom_data1==0) && (eeprom_data2==0) && (eeprom_data3==0) )
    {
      Save_to_EEPROM_DS1820 (Sensor_Data, i+1);
      return (i+1);
    }

  }


  //   -   
  //  0,      
  if (! Virtual_EEPROM (DS1820_LOOP, & eeprom_data, READ_DATA_EEPROM))
    {
      eeprom_data++;
      if (eeprom_data>MAX_DS1820) eeprom_data=1;
      Virtual_EEPROM (DS1820_LOOP, & eeprom_data, SAVE_DATA_EEPROM);    
      Save_to_EEPROM_DS1820 (Sensor_Data,(char) eeprom_data);
      return (char) eeprom_data;

    }
    else
    {
      //    1
      eeprom_data = 1;
      Virtual_EEPROM (DS1820_LOOP, & eeprom_data, SAVE_DATA_EEPROM);    
      Save_to_EEPROM_DS1820 (Sensor_Data,(char) eeprom_data);
      return 1;
    }
  //return 0;
} 

/*******************************************************************************
* Function Name  : _1Wire_2_UART_config
* Description    :   UART
* Input          : USART_TypeDef* USART
* Output         : None
* Return         : None
*******************************************************************************/ 
void _1Wire_2_UART_config(void)
{
 
  USART_InitTypeDef USART_InitStructure;
  
  USART_InitStructure.USART_BaudRate = 115200;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_Init_1W2(_1WIRE_2_UART, &USART_InitStructure);
 
/*    */
  USART_Cmd(_1WIRE_2_UART, ENABLE);
 
}

/*******************************************************************************
* Function Name  : _1Wire_2_PinConfig
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void _1Wire_2_PinConfig(void) 
{
  GPIO_InitTypeDef  GPIO_InitStruct;
  
  RCC_APB2PeriphClockCmd(_1WIRE_2_APB_PERIPH_PIN_TX, ENABLE);
  RCC_APB2PeriphClockCmd(_1WIRE_2_APB_PERIPH_PIN_RX, ENABLE);
  
  /*  UART. !!!    UART*/
  if (_1WIRE_2_UART==USART1)
  {
    RCC_APB2PeriphClockCmd(_1WIRE_2_APB_PERIPH_UART, ENABLE);
  } 
  else
  {
    RCC_APB1PeriphClockCmd(_1WIRE_2_APB_PERIPH_UART, ENABLE); 
  }
 
  
  GPIO_InitStruct.GPIO_Pin = _1WIRE_2_PIN_TX;
  GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
  /* open drain */
  GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF_OD;
  GPIO_Init(_1WIRE_2_PORT_TX, &GPIO_InitStruct);

  GPIO_InitStruct.GPIO_Pin = _1WIRE_2_PIN_RX;
  GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IPU; //GPIO_Mode_IPU; GPIO_Mode_IN_FLOATING
  GPIO_Init(_1WIRE_2_PORT_RX, &GPIO_InitStruct);

}

/*******************************************************************************
* Function Name  : _1Wire_2_Reset
* Description    :  1Wire     
* Input          : None
* Output         : None
* Return         : char: 1 -  -, 0 -  
*******************************************************************************/ 

char _1Wire_2_Reset(void) 
{
        u8 temp, _1wire_slave_answer;
        
        USART_InitTypeDef USART_InitStructure;

        USART_InitStructure.USART_BaudRate = 9600;
        USART_InitStructure.USART_WordLength = USART_WordLength_8b;
        USART_InitStructure.USART_StopBits = USART_StopBits_1;
        USART_InitStructure.USART_Parity = USART_Parity_No;
        USART_InitStructure.USART_HardwareFlowControl =USART_HardwareFlowControl_None;
        USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
        
        //taskENTER_CRITICAL();
        USART_Init_1W2(_1WIRE_2_UART, &USART_InitStructure);
        //taskEXIT_CRITICAL();
        
        
        USART_ClearFlag_1WIRE_2(USART_FLAG_TC);
        USART_ClearFlag_1WIRE_2(USART_FLAG_RXNE);
        
        USART_SendData_1WIRE_2(0xf0); // master send RESET
 
        //taskYIELD();
 
        while (USART_GetFlagStatus_1WIRE_2(USART_FLAG_TC) == RESET) {}
        temp=255;
        while (USART_GetFlagStatus_1WIRE_2(USART_FLAG_RXNE) == RESET && temp) {temp--;}
        //taskYIELD();

        _1wire_slave_answer = T_DATA_READ;
        
        USART_InitStructure.USART_BaudRate = 115200;
        //USART_InitStructure.USART_WordLength = USART_WordLength_8b;
        //USART_InitStructure.USART_StopBits = USART_StopBits_1;
        //USART_InitStructure.USART_Parity = USART_Parity_No;
        //USART_InitStructure.USART_HardwareFlowControl =USART_HardwareFlowControl_None;
        //USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
        
        //taskENTER_CRITICAL();
        USART_Init_1W2(_1WIRE_2_UART, &USART_InitStructure);
        //taskEXIT_CRITICAL();
        
        if ( Test_Mode_Timeout && !_1wire_slave_answer)
        {
          LED_ON;
          LED_test_timeout=LED_TEST_TIMEOUT_LEN;
        }           
        
        //     
        if ((_1wire_slave_answer != 0xf0) && (_1wire_slave_answer != 0x00)) 
        {
          return 1; //slave is on 1Wire
        }

        return 0; //nothing on 1Wire
}



/*******************************************************************************
* Function Name  : _1Wire_2_BitWrite
* Description    : /    1Wire  UART
* Input          : bool ucBit 
* Output         : None
* Return         : boolean: TRUE - received bit 1, FALSE - received bit 0
*******************************************************************************/
bool _1Wire_2_BitWrite (bool ucBit)
{
    u8 temp, ucData = 0;

    if (ucBit)
    {
        temp=0xff;
     }
    else
    {
        temp=0x00;
     }
    
    /* send bit to 1Wire */
    USART_ClearFlag_1WIRE_2(USART_FLAG_TC);
    USART_ClearFlag_1WIRE_2(USART_FLAG_RXNE);
    
    USART_SendData_1WIRE_2(temp);

    //taskYIELD();
  
    while (USART_GetFlagStatus_1WIRE_2(USART_FLAG_TC) == RESET) {}
    temp=255;
    while (USART_GetFlagStatus_1WIRE_2(USART_FLAG_RXNE) == RESET && temp) {temp--;}

    //taskYIELD();
    
    /*read bit from 1Wire */
    ucData = T_DATA_READ;
    
    if (ucData == 0xff) 
    {
      return TRUE;
     }

    return FALSE;
    
}

/*******************************************************************************
* Function Name  : _1Wire_2_ByteWrite
* Description    : /    1Wire  UART
* Input          : u8 ucByte
* Output         : None
* Return         : u8:  
*******************************************************************************/
u8 _1Wire_2_ByteWrite( u8 ucByte)
{
    u8 i,ucData=0;
    bool bit;
  
    for(i = 0;i<8 ;i++)
    {
        bit=FALSE;
        if (ucByte & 0x01) bit=TRUE ;
        ucData >>= 1;
        ucData &= 0x7f;
        if (_1Wire_2_BitWrite(bit)) {ucData |= 0x80;}
        ucByte >>= 1;
    }
    
    return ucData;    
}

void _1Wire_2_Config (void)
{
    _1Wire_2_PinConfig();
    _1Wire_2_UART_config();
}

/* Receive Data */
//u8 USART_ReceiveData_1WIRE_2()
//{
//  return (u8)(_1WIRE_2_UART->DR);
//}

/* Transmit Data */
void USART_SendData_1WIRE_2(u8 Data)
{
  _1WIRE_2_UART->DR = Data;
}

/* Clears the USARTx's pending flags */
void USART_ClearFlag_1WIRE_2(uint16_t USART_FLAG)
{
  _1WIRE_2_UART->SR = (uint16_t)~USART_FLAG;
}


/* Checks whether the specified USART flag is set or not */
FlagStatus USART_GetFlagStatus_1WIRE_2(uint16_t USART_FLAG)
{
  FlagStatus bitstatus = RESET;

  
  if ((_1WIRE_2_UART->SR & USART_FLAG) != (uint16_t)RESET)
  {
    bitstatus = SET;
  }
  else
  {
    bitstatus = RESET;
  }
  return bitstatus;
}


/**
  * @brief  Initializes the USARTx peripheral according to the specified
  *         parameters in the USART_InitStruct .
  * @param  USARTx: Select the USART or the UART peripheral. 
  *   This parameter can be one of the following values:
  *   USART1, USART2, USART3, UART4 or UART5.
  * @param  USART_InitStruct: pointer to a USART_InitTypeDef structure
  *         that contains the configuration information for the specified USART 
  *         peripheral.
  * @retval None
  */
void USART_Init_1W2(USART_TypeDef* USARTx, USART_InitTypeDef* USART_InitStruct)
{
  #define CR2_STOP_CLEAR_Mask       ((uint16_t)0xCFFF)  /*!< USART CR2 STOP Bits Mask */
  #define CR1_CLEAR_Mask            ((uint16_t)0xE9F3)  /*!< USART CR1 Mask */
  #define CR3_CLEAR_Mask            ((uint16_t)0xFCFF)  /*!< USART CR3 Mask */
  #define CR1_OVER8_Set             ((u16)0x8000)  /* USART OVER8 mode Enable Mask */
  
  uint32_t tmpreg = 0x00, apbclock = 0x00;
  uint32_t integerdivider = 0x00;
  uint32_t fractionaldivider = 0x00;
  uint32_t usartxbase = 0;
  RCC_ClocksTypeDef RCC_ClocksStatus;

  /* The hardware flow control is available only for USART1, USART2 and USART3 */
  if (USART_InitStruct->USART_HardwareFlowControl != USART_HardwareFlowControl_None)
  {
    assert_param(IS_USART_123_PERIPH(USARTx));
  }

  usartxbase = (uint32_t)USARTx;

/*---------------------------- USART CR2 Configuration -----------------------*/
  tmpreg = USARTx->CR2;
  /* Clear STOP[13:12] bits */
  tmpreg &= CR2_STOP_CLEAR_Mask;
  /* Configure the USART Stop Bits, Clock, CPOL, CPHA and LastBit ------------*/
  /* Set STOP[13:12] bits according to USART_StopBits value */
  tmpreg |= (uint32_t)USART_InitStruct->USART_StopBits;
  
  /* Write to USART CR2 */
  USARTx->CR2 = (uint16_t)tmpreg;

/*---------------------------- USART CR1 Configuration -----------------------*/
  tmpreg = USARTx->CR1;
  /* Clear M, PCE, PS, TE and RE bits */
  tmpreg &= CR1_CLEAR_Mask;
  /* Configure the USART Word Length, Parity and mode ----------------------- */
  /* Set the M bits according to USART_WordLength value */
  /* Set PCE and PS bits according to USART_Parity value */
  /* Set TE and RE bits according to USART_Mode value */
  tmpreg |= (uint32_t)USART_InitStruct->USART_WordLength | USART_InitStruct->USART_Parity |
            USART_InitStruct->USART_Mode;
  /* Write to USART CR1 */
  USARTx->CR1 = (uint16_t)tmpreg;

/*---------------------------- USART CR3 Configuration -----------------------*/  
  tmpreg = USARTx->CR3;
  /* Clear CTSE and RTSE bits */
  tmpreg &= CR3_CLEAR_Mask;
  /* Configure the USART HFC -------------------------------------------------*/
  /* Set CTSE and RTSE bits according to USART_HardwareFlowControl value */
  tmpreg |= USART_InitStruct->USART_HardwareFlowControl;
  /* Write to USART CR3 */
  USARTx->CR3 = (uint16_t)tmpreg;

/*---------------------------- USART BRR Configuration -----------------------*/
  /* Configure the USART Baud Rate -------------------------------------------*/
  RCC_GetClocksFreq(&RCC_ClocksStatus);
  if (usartxbase == USART1_BASE)
  {
    apbclock = RCC_ClocksStatus.PCLK2_Frequency;
  }
  else
  {
    apbclock = RCC_ClocksStatus.PCLK1_Frequency;
  }
  
  /* Determine the integer part */
  if ((USARTx->CR1 & CR1_OVER8_Set) != 0)
  {
    /* Integer part computing in case Oversampling mode is 8 Samples */
    integerdivider = ((25 * apbclock) / (2 * (USART_InitStruct->USART_BaudRate)));    
  }
  else /* if ((USARTx->CR1 & CR1_OVER8_Set) == 0) */
  {
    /* Integer part computing in case Oversampling mode is 16 Samples */
    integerdivider = ((25 * apbclock) / (4 * (USART_InitStruct->USART_BaudRate)));    
  }
  tmpreg = (integerdivider / 100) << 4;

  /* Determine the fractional part */
  fractionaldivider = integerdivider - (100 * (tmpreg >> 4));

  /* Implement the fractional part in the register */
  if ((USARTx->CR1 & CR1_OVER8_Set) != 0)
  {
    tmpreg |= ((((fractionaldivider * 8) + 50) / 100)) & ((uint8_t)0x07);
  }
  else /* if ((USARTx->CR1 & CR1_OVER8_Set) == 0) */
  {
    tmpreg |= ((((fractionaldivider * 16) + 50) / 100)) & ((uint8_t)0x0F);
  }
  
  /* Write to USART BRR */
  USARTx->BRR = (uint16_t)tmpreg;
}



