
#include "libraries.h"
extern   xQueueHandle                   Queue_Print_Debug;
extern volatile unsigned short int      Task_ADC_Alive;
extern volatile TypeDef_USB_Mode USB_Mode;

/*   */ 
extern unsigned short int               ADC_value[];

/* ADC_VAL-   DMA    */
unsigned short int                      ADC_current[ADC_CH]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

//IWD -   task_ADC
#define T_ADC_WD_LEN                    10
volatile char                           T_adc_wd = T_ADC_WD_LEN;

/*******************************************************************************
* Function Name  : Task_ADC
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 

void Task_ADC (void *pvParameters) 
{
  /*  */
  static unsigned short int periodic_print=0; 

  portBASE_TYPE xStatus;
  const portTickType xTicksToWait = 0;
  TypeDef_PRINT_DEBUG xMessage;
  
  unsigned char i;
  
  /* ADC_VG-   */
  static unsigned short int     ADC_AVG[ADC_CH]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
 
  vTaskDelay(10/portTICK_RATE_MS); 
  
  /*        . */
while (1)
 { 
  
   /*   ""   */
   Task_ADC_Alive++;
   
   /*     */  
   for (i=0; i<ADC_CH; i++)
   {
      /*     2 */
      ADC_AVG[i]+=ADC_current[i];
      ADC_AVG[i]>>=1; 
  
      /*      */
      ADC_value[i]=ADC_AVG[i]; 
   }   

   periodic_print++;
   
   if (periodic_print>ADC_PERIODIC_PRINT_LEN)
   {
      periodic_print=0;
      
      if (USB_Mode==DebugMode)
      {
      
        xMessage.Debug_Data_Len = ADC_CH;
        xMessage.Debug_Source_ID = ADC_Debug_ID;
        xMessage.Debug_u16_Data = ADC_value;
        xMessage.Debug_Data_type=Debug_Data_type_2HEX;
   
        /*   .
          -   .  
          ,     pvParameters.
            - ,    
          Blocked,      ,
            */
        xStatus = xQueueSendToBack(Queue_Print_Debug, &xMessage, xTicksToWait );
        if( xStatus != pdPASS )
        {
         /*    ,    xTicksToWait .
             . */
        }
      }   
  
   } 
   
   //IWD -   task_ADC
   T_adc_wd = T_ADC_WD_LEN;      
   /*   ADC_PERIODIC_LEN . */
   vTaskDelay(ADC_PERIODIC_LEN/portTICK_RATE_MS);    
 }
  
  /*     ,     (break)  
          ,      
           .  NULL, 
       vTaskDelete(), ,      (, 
       ) . */
    
//    vTaskDelete( NULL ); 
}


/*******************************************************************************
* Function Name  : ADC_Config
* Description    : 
* Input          : 
* Output         : None
* Return         : None
*******************************************************************************/

/*      DMA    Transfer complete */
void ADC_Config(void)
{
        //==Definitions==
    #define ADC1_DR_Address   ((uint32_t)0x4001244C) // DR_ADDRESS 
  
    DMA_InitTypeDef DMA_InitStructure; //Variable used to setup the DMA

    ADC_InitTypeDef ADC_InitStructure;

        //--Enable DMA1 clock--
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE);

        //==Configure DMA1 - Channel1==
    DMA_DeInit(DMA1_Channel1); //Set DMA registers to default values
    DMA_InitStructure.DMA_PeripheralBaseAddr = ADC1_DR_Address; //Address of peripheral the DMA must map to
    DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t) & ADC_current; //Variable to which ADC values will be stored
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;
    DMA_InitStructure.DMA_BufferSize = ADC_CH; //Buffer size 
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
    DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;
    DMA_InitStructure.DMA_Priority = DMA_Priority_Low;
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;

    DMA_Init(DMA1_Channel1, &DMA_InitStructure); //Initialise the DMA

    //   ADC1 - 
    ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;
    ADC_InitStructure.ADC_ScanConvMode = ENABLE;
    ADC_InitStructure.ADC_ContinuousConvMode = ENABLE;
    ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;
    ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;
    ADC_InitStructure.ADC_NbrOfChannel = ADC_CH; //

    ADC_Init(ADC1, &ADC_InitStructure); //Initialise ADC1

    // 
    #define ADC_SampleTime ADC_SampleTime_239Cycles5
    ADC_RegularChannelConfig(ADC1, ADC_Channel_9, 1, ADC_SampleTime);//Power
    ADC_RegularChannelConfig(ADC1, ADC_Channel_8, 2, ADC_SampleTime);//ACC
    ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 3, ADC_SampleTime); //ADC1 - TAMPER
    ADC_RegularChannelConfig(ADC1, ADC_Channel_14, 4, ADC_SampleTime);//ADC2
    ADC_RegularChannelConfig(ADC1, ADC_Channel_15, 5, ADC_SampleTime);//ADC3
    ADC_RegularChannelConfig(ADC1, ADC_Channel_0, 6, ADC_SampleTime); //knopka
    ADC_RegularChannelConfig(ADC1, ADC_Channel_2, 7, ADC_SampleTime);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_3, 8, ADC_SampleTime);    
    
    ADC_RegularChannelConfig(ADC1, ADC_Channel_12, 9, ADC_SampleTime); //IN1
    ADC_RegularChannelConfig(ADC1, ADC_Channel_11, 10, ADC_SampleTime);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_10, 11, ADC_SampleTime);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_1, 12, ADC_SampleTime);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_5, 13, ADC_SampleTime);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_13, 14, ADC_SampleTime);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_6, 15, ADC_SampleTime);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_7, 16, ADC_SampleTime);//IN8
    
    
   

    
    ADC_DMACmd(ADC1, ENABLE); //Enable ADC1 DMA
    ADC_Cmd(ADC1, ENABLE); //Enable ADC1

    // ADC1

    //Enable ADC1 reset calibaration register
    ADC_ResetCalibration(ADC1);
    while (ADC_GetResetCalibrationStatus(ADC1)); //Check the end of ADC1 reset calibration register

    //Start ADC1 calibaration
    ADC_StartCalibration(ADC1);
    while (ADC_GetCalibrationStatus(ADC1)); //Check the end of ADC1 calibration

   /*     DMA */
   ADC_SoftwareStartConvCmd(ADC1, ENABLE);
   DMA_Cmd(DMA1_Channel1, ENABLE); 
}





