
#include "libraries.h"
extern   xQueueHandle Queue_Print_Debug;
extern volatile TypeDef_USB_Mode USB_Mode;

/*  ,     . */
unsigned long int ulIdleCycleCount = 0;

//IWD -   task_CoreIdle
#define T_CORE_WD_LEN                   10
volatile char                           T_core_wd = T_CORE_WD_LEN;
extern volatile char                    T_adc_wd;
extern volatile char                    T_1w1_wd;
extern volatile char                    T_1w2_wd;
extern volatile uint16_t                T_gsm_wd;
extern volatile char                    T_io_wd;
extern volatile char                    T_debug_wd;
extern volatile char                    T_485_wd;
extern volatile char                    T_spi_wd;
/*******************************************************************************
* Function Name  : CORE_IDLE
* Description    :       
                    IDLE TASK HOOK
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 


/*   Idle   vApplicationIdleHook(),  
   ,   void. 
  !!!
    Idle Task hook vApplicationIdleHook ,   
  FreeRTOSConfig.h    1  configUSE_IDLE_HOOK.*/
void vApplicationIdleHook( void )
{
  /*      ,    
     . */
  ulIdleCycleCount++;
}


/*        */
void Task_CORE_IDLE( void *pvParameters )
{
  
  portBASE_TYPE xStatus;
  const portTickType xTicksToWait = DEBUG_WAIT / portTICK_RATE_MS;

  TypeDef_PRINT_DEBUG xMessage;
  portTickType xLastWakeTime;
  
  vTaskDelay(1000/portTICK_RATE_MS); 
  char period=10;
/*  xLastWakeTime    
       .   ,  
         .  xLastWakeTime  
        vTaskDelayUntil(). */

  xLastWakeTime = xTaskGetTickCount();

  /*        . */
  for( ;; )
  {
      /* Reload IWDG counter */
       if (T_1w1_wd) T_1w1_wd--;
       if (T_1w2_wd) T_1w2_wd--;
       if (T_adc_wd) T_adc_wd--;
       if (T_core_wd) T_core_wd--;
       if (T_gsm_wd) T_gsm_wd--;
       if (T_io_wd) T_io_wd--;
       if (T_debug_wd) T_debug_wd--;
       if (T_485_wd) T_485_wd--;
       if (T_spi_wd) T_spi_wd--;
       
       if (
            #ifndef _1WIRE_1_BLOCKED
            T_1w1_wd && 
            #endif
            #ifndef _1WIRE_2_BLOCKED
            T_1w2_wd && 
            #endif
            #ifndef ADC_BLOCKED              
            T_adc_wd && 
            #endif
            #ifndef SPI_BLOCKED              
            T_spi_wd &&
            #endif              
            T_gsm_wd && 
            T_io_wd && 
            T_debug_wd &&
            #ifndef RS485_BLOCKED              
            T_485_wd &&
            #endif              
            T_core_wd
          ) 
        IWDG_ReloadCounter(); 
       
    
    if (period)
    {
      period--;
      if (!period)
      {
        period=10;
        
        if (USB_Mode==DebugMode)
        {
   
          xMessage.Debug_Source_ID = Core_Idle_Debug_ID;
          xMessage.Debug_Long_Data= ulIdleCycleCount;
          xMessage.Debug_Data_type=Debug_Data_type_LONG; 
  
          /*   .
              -   .  
              ,     pvParameters.
                - ,    
              Blocked,      ,
                */
          xStatus = xQueueSendToBack(Queue_Print_Debug, &xMessage, xTicksToWait );
          if( xStatus != pdPASS )
          {
            /*    ,    xTicksToWait .
             . */
         
          }
    }   
    
        /*    */
        ulIdleCycleCount=0UL;
      }
    }
    

        /*       1000 .  
          vTaskDelay(),    ,  
        portTICK_RATE_MS      .
         xLastWakeTime    
        vTaskDelayUntil(),        xLastWakeTime
         . 
    !!!
      vTaskDelayUntil ,   
    FreeRTOSConfig.h    1 INCLUDE_vTaskDelayUntil.
    */
    
    //IWD -   task_CoreIdle
     T_core_wd = T_CORE_WD_LEN;
     
     vTaskDelayUntil( &xLastWakeTime, ( 1000 / portTICK_RATE_MS ) );
     
  }
  
   /*     ,     (break)  
          ,      
           .  NULL, 
       vTaskDelete(), ,      (, 
       ) . 
    !!!
      vTaskDelete ,   
    FreeRTOSConfig.h    1 INCLUDE_vTaskDelete.
  */
    
//    vTaskDelete( NULL );  
}


