
#ifndef _TASK_MANAGER_
  #define _TASK_MANAGER_



/*      GSM- */    
  #define SIM900_RX_BUFFER_SIZE         512+1024  //for OKO_KBM/RF_FLASH_PAGE_SIZE


/*     */ 
  #define TEMP_BUFFER_SIZE         	PAGE_SIZE*4+1

/*     ,   16  !!! */
  #define PHONE_MAX_LEN                 16 

/*  ( )     */
  #define PHONE_TAIL_LEN                9

/*   IMEI GSM- */
  #define IMEI_MAX_LEN                  15

/*   USSD- */
  #define USSD_QUERY_MAX_LEN            30

/*    */
  #define BALANCE_MAX_LEN               10

/*    GSM-, *100 mc */
  #define GSM_ANSWER_WAIT_1SEC          10

/*   DTMF-, *100 mc */
  #define DTMF_COMMAND_WAIT_30SEC       300

/*   GSM-, *100 mc */
  #define CHECK_GSM_LEN                 600

/* -     ,  */
 #define GPRS_FAULT_TIMEOUT_LEN		30
 #define GPRS_FAULT_TIMEOUT_SHORT_LEN   10

/* -   ,  */
 #define LOAD_DATA_TIMEOUT_LEN		5

/* -   GSM-     GSM-*/
  #define NO_REGISTRATION_LEN           10

/*   GSM-  rssi */
  #define GSM_LEVEL_LOW                 9

/*   GSM-  rssi */
  #define GSM_LEVEL_MEDIUM              17


/*     */
  #define WITH_RING                     1
  #define WITHOUT_RING                  0
/*   sms */
  #define WITH_SMS                     1
  #define WITHOUT_SMS                  0

  #define SAVE_ARM_DELAY                  0
  #define SAVE_ALARM_DELAY                1
  #define SAVE_SENSOR_GROUP               2
  #define SAVE_SENSOR_SILENT              3
  #define SAVE_SENSOR_24H                 4
  #define SAVE_OWNER_GROUP                5
  #define SAVE_IBUTTON_GROUP              6
  #define SAVE_DS1820_GROUP               7
  #define CLEAR_IBUTTON		          8
  #define CLEAR_DS1820	                  9
  #define CLEAR_RADIO	                  10
  #define GET_TERMO                       11

  #define SAVE_T_MIN_SETTING              0
  #define SAVE_T_MAX_SETTING              1
  #define SAVE_T_N_SETTING	          2

  #define SAVE_RING_SETTING               0
  #define SAVE_SMS_SETTING                1
  #define SAVE_ANSWER_SETTING             2
  #define SAVE_SMS_ARM_SETTING            3
  #define SAVE_SMS_DISARM_SETTING         4
  #define SAVE_TAMPER_GROUP		  5
  #define SAVE_220V_GROUP		  6

  #define USART_RECEIVE_DATA_GSM        (uint8_t)(SIM900_UART->DR)

  void SIM900_ON(void);
  void SIM900_Powerkey_Push(void);
  void SIM900_Ini(void);
  char SIM900_Auto_Baud(void);
  void GPRS_Ini(void);
  
  void SIM900_UART_Config(void);

  void Send_Command_To_SIM900( const char *data, uint16_t data_len);
  void Send_Command_To_SIM900_( const char *data, uint16_t data_len); 
  unsigned short int Wait_For_SIM900_Answer (const char *Expected_Answer, unsigned short int gsm_answer_wait);
  char Check_SIM900( void );
  char Check_Ring( void );
  void Connect_for_DTMF ( char owner, char without_timeout );
  void Connect_for_DTMF_ ( char owner, char without_timeout, char alarm, const char * file );
  char Ring_to_Phone (char * Phone_Number, char owner, char short_call, char alarm, const char * file);
  char Check_SMS( void );
  void SIM900_Pin_Config(void);
  char Save_Incoming_Call( unsigned short int i );
  char Save_IMEI( unsigned short int i );

  void SIM900_Config (void);
  void Task_GSM( void *pvParameters );
  void Task_GSM_Data_Analize( void *pvParameters );
  void System_GSM_Debug( const char *data, u8 data_len);
  void USART_SendData_GSM(u8 Data);
  void USART_ClearFlag_GSM(uint16_t USART_FLAG);
  FlagStatus USART_GetFlagStatus_GSM (uint16_t USART_FLAG);
  void EEPROM_Default_Setting (void);
  void Save_Mode_to_EEPROM (void);
  void Save_Output_to_EEPROM (void);
  char Event_Check (void);
  char GPRS_Event_Check (void);
  char GPRS_Send_ContactID (char * buffer);
  char Send_Status_SMS_to_Phone (char * SMS_Phone_Number);
  char Send_Termo_SMS_to_Phone (char * SMS_Phone_Number);
  char Send_Netmon_SMS_to_Phone (char * SMS_Phone_Number);
  char Send_GSM_Location_SMS_to_Phone (char * SMS_Phone_Number);
  char Send_USSD_SMS_to_Phone (char * SMS_Phone_Number);  
  char Send_Android_SMS_to_Phone (char * SMS_Phone_Number);
  char Send_Config_SMS_to_Phone (char * SMS_Phone_Number);
  char Send_Parameter_SMS_to_Phone (char * SMS_Phone_Number);
  char Send_Radio_Code_SMS_to_Phone (char * SMS_Phone_Number);
  void Read_Config_from_EEPROM (void);
  char * Add_String (char * add_to, const char * add_from, char len);
  char Analize_Command (char * Command_List, unsigned short int i, char owner);
  char Phone_Verification(void);
  char Copy_Owner_Phone_from_EEPROM (uint16_t OWNER_PHONE_W);
  void Flash_Init(uint32_t Data);
  char Hex_Ascii (char Hex);
  char Save_Config(void);
  char Load_Data(u8 *Data, uint16_t Data_len, char Start);
  void Set_Default_Settings(void);
  char Check_Command (char *Command_List, const char *_Command, unsigned short int i);
  unsigned short int Check_Answer (const char *Expected_Answer, unsigned short int SIM900_InputDataLength);
  char Connect_to_Server (void);
  void Save_Counters(void);
  void Load_OKO_KBM_FW(void);
  void Load_OKO_TRX_FW(void);
  
//          STM32f10x  
  void USART_ClearITPendingBit_GSM(USART_TypeDef* USARTx, uint16_t USART_IT);

#endif