
#include "libraries.h"
extern   xQueueHandle 			Queue_Print_Debug, Queue_Event, Queue_Delay_Event, Queue_GPRS_Event, Queue_TRX_Command;
extern xSemaphoreHandle                 Mutex_Copy_Delay_Event, Mutex_Save_Event;
extern volatile TypeDef_USB_Mode        USB_Mode;
extern volatile TypeDef_RADIO_SENSOR    RF_Sensor;
extern volatile TypeDef_WIRE_SENSOR     Wire_Sensor;
extern volatile TypeDef_DS1820_SENSOR   DS1820_Sensor;
extern volatile TypeDef_POWER           Power;
extern volatile TypeDef_TAMPER          Tamper;
extern volatile char                    Delay_arm_group;
extern volatile char                    Delay_who;
extern volatile char                    dtmf_command_timeout;
extern volatile char                    GSM_Level;
extern volatile char                    pin_timeout;
extern volatile char                    reset_pin_error_timeout;
extern char *                           File_Wire[];
extern volatile char                    Alarm_Voice; 
extern char*                            Alarm_File;
extern volatile char                    Modem_Mode_Time_Out;
extern volatile uint32_t                Counters[];
extern volatile char                    SMS_Ready_timeout;
extern volatile char                    oko_kbm_broadcast_timeout;

/* -  , 1sec */
extern volatile char			Program_Mode_Timeout;

/* -  , 1sec */
extern volatile char			Test_Mode_Timeout;

/* -     , 1sec */
extern volatile char			GPRS_Fault_Timeout;

/* -   , 1sec */
extern volatile char			Load_Data_Timeout;

/*   (100)   */
extern volatile char			LED_Short_Flash;

/*   (1)   */
extern volatile char			LED_Long_Flash;

/*   (100)   */
extern volatile char			SIRENA_Short_Beep;

/* -       , *100 msec */
extern volatile char			RF_Data_Timeout;

/* -     RS485-, *10 msec */
extern volatile char			RS485_Rx_Timeout;

/* -      1, *100 msec */
extern volatile char                   Key_Board_1_Command_Timeout;
extern volatile char                   Key_Board_1_Alive_Timeout;

/* -      2, *100 msec */
extern volatile char                   Key_Board_2_Command_Timeout;
extern volatile char                   Key_Board_2_Alive_Timeout;

/* -    1, *100 msec */
extern volatile char                   Piezo_KB1_Timeout;

/* -    2, *100 msec */
extern volatile char                   Piezo_KB2_Timeout;

/*    , * sec */
extern volatile char                   Arm_Delay;

/*  , * sec */
extern volatile char                   Alarm_Delay;



/*         */
extern volatile unsigned short int      Inputs_State;
/*           */
extern volatile unsigned short int      KZ_Obriv_State;

/*    */
extern volatile unsigned short int      Outputs_State;

/*      GSM-, *100 msec*/
extern volatile unsigned short int      GSM_Answer_Wait;

/*     GSM-, *100 msec*/
extern volatile unsigned short int      Check_GSM;

/*     DTMF-, *100 msec*/
extern volatile unsigned short int      DTMF_Command_Wait;

/*     ""  , *100 msec*/
extern volatile unsigned short int      Check_Tasks;

/*    */
extern volatile char                    Working_Flag[];

/*  ""   */
extern volatile char                    Mode_Flag[];

/*   */ 
extern unsigned short int               ADC_value[];

extern volatile char                    LED_test_timeout;

/* -    ,   */
uint16_t                                GPRS_Period=0;

//-      
char                                    Save_Counters_Timeout=0;
#define SAVE_COUNTERS_TIMEOUT_LEN       60 // max 255

volatile char                           start_disarm=0; //    (      )

//IWD -   task_IO
#define T_IO_WD_LEN                     60
volatile char                           T_io_wd = T_IO_WD_LEN;
volatile uint16_t                       Check_Balance_Period=24*60; // 24 hour

/*  -  ,  */
volatile uint16_t Output_Time_Out[]=
  {
    0x00, // -  1
    0x00, // -  2
    0x00, // -  3
    0x00, // -  4
    0x00, // -  5
    0x00, // -  6
    0x00, // -  7
    0x00, // -  8
    0x00  // - 

  };
  
  /*     Debug-  */
  static unsigned short int periodic_print=0;

/*******************************************************************************
* Function Name  : Task_I_O_TIMERS
* Description    :     ,  ,  
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 

void Task_I_O_TIMERS (void *pvParameters) 
{
  
  portBASE_TYPE xStatus;
  const portTickType xTicksToWait = 0;
  portTickType xLastWakeTime;
  TypeDef_PRINT_DEBUG xMessage;
  static char _100msec=100/I_O_TIMERS_PERIODIC_LEN;
  static char _0_2sec=2;
  static char _1sec=10;
  static char _1min=60;
  static char _5min=5;
  static char _1hour=60;
  static char erase_eeprom=0;
  static char dt1820_startup_timeout=60 ;
  char i_s_d[4];
  char i,k,temp, temperature, tmin, tmax, tn, Button_Pulse=0, Button_Timeout=0, Button_Low_Level_Timeout=0; 
  uint16_t eeprom_data;
  TypeDef_EVENT Event;

/*  xLastWakeTime    
       .   ,  
         .  xLastWakeTime  
        vTaskDelayUntil(). */
  xLastWakeTime = xTaskGetTickCount();   
  
  vTaskDelay(500/portTICK_RATE_MS);
  
  /*    */
  Update_current_state (IN1_STATE,INPUT_1);
  Update_current_state (IN2_STATE,INPUT_2);
  Update_current_state (IN3_STATE,INPUT_3);
  Update_current_state (IN4_STATE,INPUT_4);
  Update_current_state (IN5_STATE,INPUT_5);
  Update_current_state (IN6_STATE,INPUT_6);
  Update_current_state (IN7_STATE,INPUT_7);
  Update_current_state (IN8_STATE,INPUT_8);
  
  if (ARM_STATE) Inputs_State|=(1<<INPUT_ARM); else Inputs_State&=~(1<<INPUT_ARM);
  if (BUTTON_STATE) Inputs_State|=(1<<INPUT_BUTTON); else Inputs_State&=~(1<<INPUT_BUTTON);
  
  //220V
  if (*(uint16_t*)EXTERNAL_BBP)
  {
    //    
    if (ADC_value[ADC_EXT_POWER]>(*(uint16_t*)EXTERNAL_BBP)) Inputs_State|=(1<<INPUT_EXT_POWER); else Inputs_State&=~(1<<INPUT_EXT_POWER);
  }
  else
  {
    //    
    if (ADC_value[ADC_EXT_POWER]>ADC_EXT_POWER_LEVEL) Inputs_State|=(1<<INPUT_EXT_POWER); else Inputs_State&=~(1<<INPUT_EXT_POWER);
  }
  
  if (ADC_value[ADC_MAIN_POWER]>ADC_MAIN_POWER_LEVEL) Inputs_State|=(1<<INPUT_MAIN_POWER); else Inputs_State&=~(1<<INPUT_MAIN_POWER);
  if (ADC_value[ADC_TAMPER]>ADC_TAMPER_LEVEL) Inputs_State|=(1<<INPUT_TAMPER); else Inputs_State&=~(1<<INPUT_TAMPER);
  Inputs_State|=(1<<INPUT_INT_POWER); //   
  

  
  //  / 
   //if (MODE_FLAG_GPRS_STATE) 
  //{
    if (FLAG_WATCH_DOG_STATE) 
	Event.Code_Event=DEVICE_RESTART_EVENT; 
     else
	Event.Code_Event=DEVICE_START_EVENT;

    Save_Event_to_Buffer(Event);
  //}

    //,     220    
    if ( (0x01 & (Inputs_State>>INPUT_EXT_POWER)) && !MODE_FLAG_220_STATE )
    {
      /*      */
      if ( (0x01 & ( (*(char*)(_24H))>>_POWER)) || (Power.Group & MODE_ARM_STATE) )
      {
        Event.Code_Event=_220_POWER_ON_EVENT; 
        Event.Group=Power.Group ; 
        Save_Event_to_Buffer(Event);
        MODE_FLAG_220_SET; FLAG_SAVE_MODE_SET;
      }
    }
  
  
  /*        . */
  while (1)
  { 
    
    T_io_wd = T_IO_WD_LEN;
    
    while (FLAG_SAVE_CONFIG_COMMAND_STATE) {}
    
    /*    100, 1, 1, 1 */
    if (_100msec)
     {
      _100msec--;
      if (_100msec==0)
      {
       _100msec=100/I_O_TIMERS_PERIODIC_LEN;
       /*  100   */
       
        /*-      -*/      
       if (oko_kbm_broadcast_timeout) oko_kbm_broadcast_timeout--;
       
       /*-     dtmf-*/
       if (dtmf_command_timeout) dtmf_command_timeout--;
       
       /* -      1, *100 msec */
       if (Key_Board_1_Command_Timeout) Key_Board_1_Command_Timeout--; 
       if (Key_Board_1_Alive_Timeout) 
       {
         Key_Board_1_Alive_Timeout--;
         if (!Key_Board_1_Alive_Timeout)
         {
            Event.Code_Event=KB1_NO_EVENT;
            Event.Group=Tamper.Group ; 
            Save_Event_to_Buffer(Event);
         }
       }

       /* -      2, *100 msec */
       if (Key_Board_2_Command_Timeout) Key_Board_2_Command_Timeout--;
       if (Key_Board_2_Alive_Timeout) 
       {
         Key_Board_2_Alive_Timeout--;
         if (!Key_Board_2_Alive_Timeout)
         {
            Event.Code_Event=KB2_NO_EVENT;
            Event.Group=Tamper.Group ; 
            Save_Event_to_Buffer(Event);
         }
       }
       
       /* ,          */
       if (erase_eeprom) 
       {
         erase_eeprom--; 
         if (erase_eeprom==0) 
         {
           FLAG_DEFAULT_SETTING_SET;
           //Set_Default_Settings();
         }
       }

       /*     GSM-*/
       if (GSM_Answer_Wait) GSM_Answer_Wait--;

       /*  -   GSM-*/
       if (Check_GSM) Check_GSM--;

       /*    DTMF-*/
       if (DTMF_Command_Wait) DTMF_Command_Wait--;   
    
       /*  -   "" */
       if (Check_Tasks) Check_Tasks--;
   
       /*  -        */
       if (RF_Data_Timeout) RF_Data_Timeout--;

       /*  -  */       
       if (Button_Low_Level_Timeout) Button_Low_Level_Timeout--;
       
       /*   -     */	
       if (Button_Timeout) 
       {
	 Button_Timeout--;
	 if (!Button_Timeout) 
	 {
           
            /*   ,    */
            if (Button_Pulse==3)
            { 
              if (Test_Mode_Timeout)
              {
                Test_Mode_Timeout=0;
                LED_OFF;
                LED_Long_Flash=0;
                LED_Short_Flash=10; //5    
                SIRENA_OFF;
                OUT1_OFF;
                OUT2_OFF;
                OUT3_OFF;
                OUT4_OFF;
                #ifndef OKO_U2
                OUT5_OFF;
                OUT6_OFF;
                OUT7_OFF;
                OUT8_OFF;
                #endif
              }
              else
              {
                Test_Mode_Timeout=TEST_MODE_TIMEOUT_LEN;
                LED_OFF;
                LED_Long_Flash=0;
                LED_Short_Flash=8; //4                    
              }
            }           
           
            /*   ,  /  */
            if (Button_Pulse==2)
            {
              Program_Mode();
            }
            /*   ,   */
            if (Button_Pulse==1)
            {
              NVIC_SystemReset();
              //T_io_wd=0;
              //while (1) {}
            }	  
            Button_Pulse=0;
	 }
	}

	/*     ,      */
       {
       if (Output_Time_Out[OUTPUT_1]) 
	 {
	  Output_Time_Out[OUTPUT_1]--;
	  if (!Output_Time_Out[OUTPUT_1]) OUT1_OFF;
	 }

	if (Output_Time_Out[OUTPUT_2]) 
	 {
	  Output_Time_Out[OUTPUT_2]--;
	  if (!Output_Time_Out[OUTPUT_2]) OUT2_OFF;
	 }

	if (Output_Time_Out[OUTPUT_3]) 
	 {
	  Output_Time_Out[OUTPUT_3]--;
	  if (!Output_Time_Out[OUTPUT_3]) OUT3_OFF;
	 }

	if (Output_Time_Out[OUTPUT_4]) 
	 {
	  Output_Time_Out[OUTPUT_4]--;
	  if (!Output_Time_Out[OUTPUT_4]) OUT4_OFF;
	 }

        #ifndef OKO_U2
	if (Output_Time_Out[OUTPUT_5]) 
	 {
	  Output_Time_Out[OUTPUT_5]--;
	  if (!Output_Time_Out[OUTPUT_5]) OUT5_OFF;
	 }

	if (Output_Time_Out[OUTPUT_6]) 
	 {
	  Output_Time_Out[OUTPUT_6]--;
	  if (!Output_Time_Out[OUTPUT_6]) OUT6_OFF;
	 }

	if (Output_Time_Out[OUTPUT_7]) 
	 {
	  Output_Time_Out[OUTPUT_7]--;
	  if (!Output_Time_Out[OUTPUT_7]) OUT7_OFF;
	 }

	if (Output_Time_Out[OUTPUT_8]) 
	 {
	  Output_Time_Out[OUTPUT_8]--;
	  if (!Output_Time_Out[OUTPUT_8]) OUT8_OFF;
	 }
        #endif
       }
       
        //   -    
       {
        if (( * (char *) (OUTPUT_MODE + 0))==ARMED_GROUP_MODE) 
        {
          if (MODE_ARM_STATE & ( * (char *) (OUTPUT_GROUP + 0))) OUT1_ON else OUT1_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 1))==ARMED_GROUP_MODE) 
        {
          if (MODE_ARM_STATE & ( * (char *) (OUTPUT_GROUP + 1))) OUT2_ON else OUT2_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 2))==ARMED_GROUP_MODE) 
        {
          if (MODE_ARM_STATE & ( * (char *) (OUTPUT_GROUP + 2))) OUT3_ON else OUT3_OFF
        }        
        if (( * (char *) (OUTPUT_MODE + 3))==ARMED_GROUP_MODE) 
        {
          if (MODE_ARM_STATE & ( * (char *) (OUTPUT_GROUP + 3))) OUT4_ON else OUT4_OFF
        }        
        #ifndef OKO_U2
        if (( * (char *) (OUTPUT_MODE + 4))==ARMED_GROUP_MODE) 
        {
          if (MODE_ARM_STATE & ( * (char *) (OUTPUT_GROUP + 4))) OUT5_ON else OUT5_OFF
        }        
        if (( * (char *) (OUTPUT_MODE + 5))==ARMED_GROUP_MODE) 
        {
          if (MODE_ARM_STATE & ( * (char *) (OUTPUT_GROUP + 5))) OUT6_ON else OUT6_OFF
        }        
        if (( * (char *) (OUTPUT_MODE + 6))==ARMED_GROUP_MODE) 
        {
          if (MODE_ARM_STATE & ( * (char *) (OUTPUT_GROUP + 6))) OUT7_ON else OUT7_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 7))==ARMED_GROUP_MODE) 
        {
          if (MODE_ARM_STATE & ( * (char *) (OUTPUT_GROUP + 7))) OUT8_ON else OUT8_OFF
        }
        #endif
       }




       /*   100  */


       if (_0_2sec)
       {
	_0_2sec--;
	if (_0_2sec==0)
	{
	 _0_2sec=2;
	/*  0.2   */
       
        //  "     -1..-8"
       {
        #ifndef OKO_U2
        temp=(char) (0x00FF & Inputs_State);
        #else
        temp=(char) (0x000F & Inputs_State);
        #endif 
         
        if (( * (char *) (OUTPUT_MODE + 0))==INPUTS_STATE_MODE) 
        {
          if (temp & ( * (char *) (OUTPUT_GROUP + 0))) OUT1_ON else OUT1_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 1))==INPUTS_STATE_MODE) 
        {
          if (temp & ( * (char *) (OUTPUT_GROUP + 1))) OUT2_ON else OUT2_OFF
        }        
        if (( * (char *) (OUTPUT_MODE + 2))==INPUTS_STATE_MODE) 
        {
          if (temp & ( * (char *) (OUTPUT_GROUP + 2))) OUT3_ON else OUT3_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 3))==INPUTS_STATE_MODE) 
        {
          if (temp & ( * (char *) (OUTPUT_GROUP + 3))) OUT4_ON else OUT4_OFF
        }
        #ifndef OKO_U2
        if (( * (char *) (OUTPUT_MODE + 4))==INPUTS_STATE_MODE) 
        {
          if (temp & ( * (char *) (OUTPUT_GROUP + 4))) OUT5_ON else OUT5_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 5))==INPUTS_STATE_MODE) 
        {
          if (temp & ( * (char *) (OUTPUT_GROUP + 5))) OUT6_ON else OUT6_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 6))==INPUTS_STATE_MODE) 
        {
          if (temp & ( * (char *) (OUTPUT_GROUP + 6))) OUT7_ON else OUT7_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 7))==INPUTS_STATE_MODE) 
        {
          if (temp & ( * (char *) (OUTPUT_GROUP + 7))) OUT8_ON else OUT8_OFF
        }        
        #endif
       }
         
         
         
      	/*    */
      	if (SIRENA_Short_Beep) 
	{
	 SIRENA_Short_Beep--; 
	 /* Toggle SIRENA */
         if (SIRENA_STATE!=RESET){SIRENA_OFF;}else{SIRENA_ON;} 
	}

         //   ""
       {
        temp=SIRENA_STATE;
        if (( * (char *) (OUTPUT_MODE + 0))==SIRENA_STATE_MODE) 
        {
          if (temp) OUT1_ON else OUT1_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 1))==SIRENA_STATE_MODE) 
        {
          if (temp) OUT2_ON else OUT2_OFF
        }        
        if (( * (char *) (OUTPUT_MODE + 2))==SIRENA_STATE_MODE) 
        {
          if (temp) OUT3_ON else OUT3_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 3))==SIRENA_STATE_MODE) 
        {
          if (temp) OUT4_ON else OUT4_OFF
        }
        #ifndef OKO_U2
        if (( * (char *) (OUTPUT_MODE + 4))==SIRENA_STATE_MODE) 
        {
          if (temp) OUT5_ON else OUT5_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 5))==SIRENA_STATE_MODE) 
        {
          if (temp) OUT6_ON else OUT6_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 6))==SIRENA_STATE_MODE) 
        {
          if (temp) OUT7_ON else OUT7_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 7))==SIRENA_STATE_MODE) 
        {
          if (temp) OUT8_ON else OUT8_OFF
        }        
        #endif
       }       
        
      	
      	/*     */
      	if (LED_Short_Flash || Alarm_Delay) 
	{
	 /* Toggle LED */
         if (LED_STATE!=RESET) LED_OFF else LED_ON

	 if (LED_Short_Flash) LED_Short_Flash--;
	}

         //    "" 
       {
        temp=LED_STATE;
        if (( * (char *) (OUTPUT_MODE + 0))==LED_STATE_MODE) 
        {
          if (temp) OUT1_ON else OUT1_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 1))==LED_STATE_MODE) 
        {
          if (temp) OUT2_ON else OUT2_OFF
        }        
        if (( * (char *) (OUTPUT_MODE + 2))==LED_STATE_MODE) 
        {
          if (temp) OUT3_ON else OUT3_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 3))==LED_STATE_MODE) 
        {
          if (temp) OUT4_ON else OUT4_OFF
        }
        #ifndef OKO_U2
        if (( * (char *) (OUTPUT_MODE + 4))==LED_STATE_MODE) 
        {
          if (temp) OUT5_ON else OUT5_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 5))==LED_STATE_MODE) 
        {
          if (temp) OUT6_ON else OUT6_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 6))==LED_STATE_MODE) 
        {
          if (temp) OUT7_ON else OUT7_OFF
        }
        if (( * (char *) (OUTPUT_MODE + 7))==LED_STATE_MODE) 
        {
          if (temp) OUT8_ON else OUT8_OFF
        }        
        #endif
       }  
        

       /*  0.2   */
	}
       }


       if (_1sec)
       {
	_1sec--;
	if (_1sec==0)
	{
	 _1sec=10;
	/*  1   */
         
        //-  SIM-    SMS 
        if (SMS_Ready_timeout) SMS_Ready_timeout--;
         
        //-  
        if (Save_Counters_Timeout)
        {
          Save_Counters_Timeout--;
          if (!Save_Counters_Timeout)
          {
            FLAG_SAVE_COUNTERS_SET;
            Event.Code_Event=PULSE_EVENT;
            Save_Event_to_Buffer(Event);
          }
        }
        
         /*-  */
        if (Modem_Mode_Time_Out)
        {
          Modem_Mode_Time_Out--;
          if(!Modem_Mode_Time_Out) USB_Mode=UsbIdleMode;
        } 
         
        /*     */
        if (pin_timeout) pin_timeout--;
        
        /* -   */
        if (Test_Mode_Timeout) 
        {
          Test_Mode_Timeout--;
          if (!Test_Mode_Timeout)
          {
            LED_OFF;
            LED_Long_Flash=0;
            LED_Short_Flash=10; //5    
            
                SIRENA_OFF;
                OUT1_OFF;
                OUT2_OFF;
                OUT3_OFF;
                OUT4_OFF;
                #ifndef OKO_U2
                OUT5_OFF;
                OUT6_OFF;
                OUT7_OFF;
                OUT8_OFF;
                #endif            
          }
        } 
        
	/* -   */
	if (Load_Data_Timeout) { Load_Data_Timeout--; if (!Load_Data_Timeout) USB_Mode=UsbIdleMode;}
	

	/* -     */
	if (GPRS_Fault_Timeout) GPRS_Fault_Timeout--;
         
        /*         DS1820*/ 
        if (dt1820_startup_timeout) 
        {
          dt1820_startup_timeout--;
          if (dt1820_startup_timeout==0)
          {
           for (temp=0; temp<MAX_DS1820;  temp++) 
           {
             DS1820_Sensor.Data_Before[temp]=DS1820_Sensor.Data_Current[temp];
           }            
          }
        }

        /*      - */
        if (Program_Mode_Timeout) 
         {
          Program_Mode_Timeout--; 
          if (!Program_Mode_Timeout) 
          {
            FLAG_PROGRAM_MODE_RESET;
            LED_OFF;
            LED_Long_Flash=0;
            LED_Short_Flash=6; //3    
          }
         }
         
         
         
        /*     */
        if (LED_Long_Flash || Arm_Delay) 
	 {
	   
	  /* Toggle LED */
          if (LED_STATE!=RESET) LED_OFF else LED_ON

	  if (LED_Long_Flash) LED_Long_Flash--;
	
	  /*       */
	  if (Arm_Delay) 
          {
            Arm_Delay--; 
            if (!Arm_Delay) 
            {
              i=Delay_who;
              Arm(Delay_arm_group, 0, i);
            }
          }
	 }

	 /*   */
	 if (Alarm_Delay)
	 {
	   Alarm_Delay--;
	   if (!Alarm_Delay)  {Copy_from_Delay_Buffer (); start_disarm=0;}
 	 }        

        /*  -   */
  	for (temp=0; temp<MAX_WIRE_SENSOR;  temp++) 
  	{
	 if (Wire_Sensor.Time_Out[temp]) Wire_Sensor.Time_Out[temp]--;
	}
        
        /*  -   */
        if (Tamper.Time_Out) Tamper.Time_Out--;

	/*    ,      */
	if (Output_Time_Out[OUTPUT_SIRENA]) 
	 {
	  Output_Time_Out[OUTPUT_SIRENA]--;
	  if (!Output_Time_Out[OUTPUT_SIRENA]) SIRENA_OFF;
	 }        

        /*  -       */
        for (temp=0; temp<MAX_RADIO_SENSOR;  temp++) 
        {
         if(RF_Sensor.Same_Data_Time_Out[temp]) RF_Sensor.Same_Data_Time_Out[temp]--;
        }


	/*  1   */

	 if(_1min)
	 {
	  _1min--;
	  if (_1min==0)
	  {
	   _1min=60;
	   /*  1   */
           
           /*-       */
           if (reset_pin_error_timeout) reset_pin_error_timeout--;
           
           //    
            if (GPRS_Period)
            {
              GPRS_Period--;
              if (!GPRS_Period)
              {
                GPRS_Period=*(uint16_t *) GPRS_PERIOD_LEN;
                Event.Code_Event=PERIODIC_EVENT;
                Save_Event_to_Buffer(Event);
              }
            }
            
            
             //     USSD-  ,      0
             if (Check_Balance_Period)
             {
               Check_Balance_Period--;
               if (Check_Balance_Period==0)
               {
                 Check_Balance_Period=24*60; // 24 hour
                 if ( * (uint16_t *) BALANCE_LEVEL ) FLAG_USSD_BALANCE_SEND_SET;   
               } 
             }           
           
           
           /*    DS1820       
            /    Tn */
           for (temp=0; temp<MAX_DS1820;  temp++) 
           {
              
              /*      DS1820 */
              if (DS1820_Sensor.Time_out_Tn[temp])
              {
                DS1820_Sensor.Time_out_Tn[temp]--;
                if (DS1820_Sensor.Time_out_Tn[temp]==0)
                {
                  // 
                  if (temp==0) OUT1_OFF;
                  if (temp==1) OUT2_OFF;
                  if (temp==2) OUT3_OFF;
                  if (temp==3) OUT4_OFF;
                  #ifndef OKO_U2
                    if (temp==4) OUT5_OFF;
                    if (temp==5) OUT6_OFF;
                    if (temp==6) OUT7_OFF;
                    if (temp==7) OUT8_OFF; 
                  #endif
                } 
              }         
              
              temperature = DS1820_Sensor.Data_Current[temp]; //  
              
              if (temperature!=NO_TEMPERATURE) // ,     
               {
                  //   ,   128 = 0   
                  if (temperature<128) temperature+=128; else temperature-=128; 
                  
                  /*   ,   DS1820  EEPROM */
                  //  0,   
                  if (Virtual_EEPROM (DS1820_1_MIN_MAX_W + temp, & eeprom_data, READ_DATA_EEPROM)==0) 
                  { 
                    tmin = eeprom_data>>8;
                    tmax =0x00FF & eeprom_data;

                    if (tmin<128) tmin+=128; else tmin-=128;
                    if (tmax<128) tmax+=128; else tmax-=128;
                    if ( 0x01 & (DS1820_Sensor.Range_State>>temp) )
                     {
                      //  ""       
                      if ( (temperature<tmax) && (temperature>tmin) ) 
                      {
                        //           
                        if ( 
                              (MODE_ARM_STATE & DS1820_Sensor.Group[temp]) ||
                              ( 0x01 & ( (*(char *)TERMO_24H)>>temp ) ) 
                            )
                        {
                          Event.Code_Event=TERMO_DS1820_1_EVENT + temp;
                          Event.Group=DS1820_Sensor.Group[temp];
                          Event.Sensor=temp+1;
                          Save_Event_to_Buffer(Event);
                        }
                        DS1820_Sensor.Range_State &= ~(1<<temp); //    0
                      }
                     }
                     else
                     {
                      //  ""       
                      if ( (temperature>tmax) || (temperature<tmin) ) 
                      {
                        //           
                        if ( ( 0x01 & ( (*(char *)TERMO_24H)>>temp ) )  || (MODE_ARM_STATE & DS1820_Sensor.Group[temp]) )
                        {
                          Event.Code_Event=TERMO_DS1820_1_EVENT + temp;
                          Event.Group=DS1820_Sensor.Group[temp];
                          Event.Sensor=temp+1;
                          Save_Event_to_Buffer(Event);
                          if ( !( 0x01 & ((*(char *)TERMO_SILENT)>>temp)) ) 
                          {
                            Sirena(0); //    "",     
                          }
                          Check_Out_Pulse_Alarm(DS1820_Sensor.Group[temp]); //       
                        }
                        DS1820_Sensor.Range_State |= (1<<temp); //    1
                      }
                     }
                  }
                  else 
                  {
                    eeprom_data=(((uint16_t)(T_MIN)) << 8) | ((uint16_t)(T_MAX)); //=+5, =+40
                    Virtual_EEPROM (DS1820_1_MIN_MAX_W + temp, & eeprom_data, SAVE_DATA_EEPROM);                     
                  }

		  //  
		  if (DS1820_Sensor.Tn[temp]!=NO_TEMPERATURE)
		    {
                        tn=DS1820_Sensor.Tn[temp];
                        if (tn<128) tn+=128; else tn-=128;
			if (tn>temperature)
			 {
			   DS1820_Sensor.Time_out_Tn[temp]=TIME_OUT_TN_LEN;
			   // 
                           if (temp==0) OUT1_ON;
                           if (temp==1) OUT2_ON;
                           if (temp==2) OUT3_ON;
                           if (temp==3) OUT4_ON;
                           #ifndef OKO_U2
                            if (temp==4) OUT5_ON;
                            if (temp==5) OUT6_ON;
                            if (temp==6) OUT7_ON;
                            if (temp==7) OUT8_ON;
                           #endif
			 }
		    }                  
                }
           }
           
           
           /*  -  -     */
           for (temp=0; temp<MAX_RADIO_SENSOR;  temp++) 
           {
             if(RF_Sensor.Time_Out[temp]) 
             {
               RF_Sensor.Time_Out[temp]--;
               //  -   ,      
               if(RF_Sensor.Time_Out[temp]==0)  
               {
                  //       ,   
                  if (
                      ((RF_Sensor.Data_Current[temp] & 0x000F)!= RADIO_BRELOK) && 
                      ((RF_Sensor.Data_Current[temp] & 0x000F)!= RADIO_BUTTON)
                      )
                   {
                     //        0
                     taskENTER_CRITICAL();  
	             RF_Sensor.Data_Current[temp] &= (unsigned short int)~(1<<RADIO_PERIOD_STATE);
                     RF_Sensor.Data_Before[temp] &= (unsigned short int)~(1<<RADIO_PERIOD_STATE);
                     taskEXIT_CRITICAL();
                     
             		//,     
             	     if ( 
                   	  ((RF_Sensor.Data_Current[temp] & 0x000F)== RADIO_SENSOR_TERMO) ||
                    	  ((RF_Sensor.Data_Current[temp] & 0x000F)== RADIO_SENSOR_TERMO_REPITER)                  
                 	 )
              		{
			  //   
                          taskENTER_CRITICAL();
			  RF_Sensor.Data_Current[temp] = (0x00FF & RF_Sensor.Data_Current[temp]) | (unsigned short int)((0x00FF & NO_TEMPERATURE)<<8);
			  RF_Sensor.Data_Before[temp] = (0x00FF & RF_Sensor.Data_Before[temp]) | (unsigned short int)((0x00FF & NO_TEMPERATURE)<<8);
                          taskEXIT_CRITICAL();
                        }
                     
                     //    
                     //Event.Code_Event=RADIO_SENSOR1_PERIOD_EVENT+EVENTS_PER_RADIO_SENSOR*temp;
                     //Event.Group=RF_Sensor.Group[temp];
                     //Event.Sensor=temp+1;
                     //Save_Event_to_Buffer(Event);                     
                   }                
               }
             }
           }

           
           /*          , 
                Tn */
           for (temp=0; temp<MAX_RADIO_SENSOR;  temp++) 
           {
             //,      
             if (
                 ((RF_Sensor.Data_Current[temp] & 0x000F)== RADIO_SENSOR_TERMO) ||
                 ((RF_Sensor.Data_Current[temp] & 0x000F)== RADIO_SENSOR_TERMO_REPITER) 
                 )
              {
                /*       */
                if (RF_Sensor.Time_out_Tn[temp])
                {
                  RF_Sensor.Time_out_Tn[temp]--;
                  if (RF_Sensor.Time_out_Tn[temp]==0)
                  {
                    // 
                    if (temp==0 || temp==8) OUT1_OFF;
                    if (temp==1 || temp==9) OUT2_OFF;
                    if (temp==2 || temp==10) OUT3_OFF;
                    if (temp==3 || temp==11) OUT4_OFF;
                    #ifndef OKO_U2
                      if (temp==4 || temp==12) OUT5_OFF;
                      if (temp==5 || temp==13) OUT6_OFF;
                      if (temp==6 || temp==14) OUT7_OFF;
                      if (temp==7 || temp==15) OUT8_OFF; 
                    #endif
                  } 
                }                 
                
                temperature = RF_Sensor.Data_Current[temp]>>8; //  
                if (temperature!=NO_TEMPERATURE) // ,     
                {
                  //   ,   128 = 0   
                  if (temperature<128) temperature+=128; else temperature-=128; 
                  
                  /*   ,     EEPROM */
                  //  0,   
                  if (Virtual_EEPROM (RADIO_1_MIN_MAX_W + temp, & eeprom_data, READ_DATA_EEPROM)==0) 
                  { 
                    tmin = eeprom_data>>8;
                    tmax =0x00FF & eeprom_data;

                    if (tmin<128) tmin+=128; else tmin-=128;
                    if (tmax<128) tmax+=128; else tmax-=128;
                    if ( 0x0001 & (RF_Sensor.Termo_Sensor_Range_State>>temp) )
                    {
                      //  ""       
                      if ( (temperature<tmax) && (temperature>tmin) ) 
                      {
                        if (
                              ( MODE_ARM_STATE & RF_Sensor.Group[temp] ) ||
                              ((RF_Sensor.Parameter[temp]>>SENSOR_24H_POSITION) & 0x01)
                            )
                        {
                          Event.Code_Event=RADIO_SENSOR1_NORMA_EVENT+EVENTS_PER_RADIO_SENSOR*temp;
                          Event.Group=RF_Sensor.Group[temp];
                          Event.Sensor=temp+1;
                          Save_Event_to_Buffer(Event);
                        }
                        
                        RF_Sensor.Termo_Sensor_Range_State &= (unsigned short int)~(1<<temp); //    0
                      }
                    }
                    else
                    {
                      
                      //  ""       
                      if ( (temperature>tmax) || (temperature<tmin) ) 
                      {
                        if (
                              ( MODE_ARM_STATE & RF_Sensor.Group[temp] ) ||
                              ((RF_Sensor.Parameter[temp]>>SENSOR_24H_POSITION) & 0x01)
                            )
                        {
                          Event.Code_Event=RADIO_SENSOR1_ALARM_EVENT+EVENTS_PER_RADIO_SENSOR*temp;
                          Event.Group=RF_Sensor.Group[temp];
                          Event.Sensor=temp+1;
                          Save_Event_to_Buffer(Event);
                          //    "",     
                          if ( !((RF_Sensor.Parameter[temp]>>SENSOR_SILENT_POSITION) & 0x01) ) 
                          {
                            Sirena (0);
                          }
                          Check_Out_Pulse_Alarm(RF_Sensor.Group[temp]); //       
                        }
                        
                        RF_Sensor.Termo_Sensor_Range_State |= (unsigned short int)(1<<temp); //    1
                      }
                    }
                  }
                  else
                  {
                    eeprom_data=(((uint16_t)(T_MIN)) << 8) | ((uint16_t)(T_MAX)); //=+5, =+40
                    Virtual_EEPROM (RADIO_1_MIN_MAX_W + temp, & eeprom_data, SAVE_DATA_EEPROM);    
                  }
                  
		  //  
		  if (RF_Sensor.Tn[temp]!=NO_TEMPERATURE)
		    {
                        tn=RF_Sensor.Tn[temp];
                        if (tn<128) tn+=128; else tn-=128;
			if (tn>temperature)
			 {
			   RF_Sensor.Time_out_Tn[temp]=TIME_OUT_TN_LEN;
			   // 
                           if (temp==0 || temp==8) OUT1_ON;
                           if (temp==1 || temp==9) OUT2_ON;
                           if (temp==2 || temp==10) OUT3_ON;
                           if (temp==3 || temp==11) OUT4_ON;
                           #ifndef OKO_U2
                            if (temp==4 || temp==12) OUT5_ON;
                            if (temp==5 || temp==13) OUT6_ON;
                            if (temp==6 || temp==14) OUT7_ON;
                            if (temp==7 || temp==15) OUT8_ON;
                           #endif
			 }
		    }                  
                  
                }
              }  
           }
 



           
           if(_5min)
            {
              _5min--;
              if (_5min==0)
              {
                _5min=5;
                /*  5   */
                
                
                /*    DS1820     */
                for (temp=0; temp<MAX_DS1820;  temp++) 
                {
                  /*     */
                  i=DS1820_Sensor.Data_Current[temp];
                  k=*(char*)(DS1820_HYST + temp);
                  if (k==0) k=2; //  
                  if ( (dt1820_startup_timeout==0) && (Compare_T(DS1820_Sensor.Data_Before[temp],i)>=k) )
                    {
                      DS1820_Sensor.Data_Before[temp]=i;
                      Event.Code_Event= DS1820_T_CHANGE_1_EVENT+temp;
                      Event.Group=DS1820_Sensor.Group[temp];
                      Event.Sensor=temp+1;
                      Save_Event_to_Buffer(Event);
                    }
                }

                /*        */
                for (temp=0; temp<MAX_RADIO_SENSOR;  temp++) 
                {   
                  i=(char) (RF_Sensor.Data_Current[temp]>>8);
                  k=*(char*)(RF_TERMO_HYST + temp);
                  if (k==0) k=2; //  
                  //,         
                  if ( 
                        (Compare_T(RF_Sensor.T_Before[temp],i)>=k) &&
                        ( 
                          ((RF_Sensor.Data_Current[temp] & 0x000F)== RADIO_SENSOR_TERMO) ||
                          ((RF_Sensor.Data_Current[temp] & 0x000F)== RADIO_SENSOR_TERMO_REPITER)
                        )                   
                      )
                    {
                      RF_Sensor.T_Before[temp]=i;
                      Event.Code_Event=RADIO_T_CHANGE_1_EVENT+temp;
                      Event.Group=RF_Sensor.Group[temp];
                      Event.Sensor=temp+1;
                      Save_Event_to_Buffer(Event);              
                    }
                }
                              
                
                /*   5   */
              }
            }
           
	   
                      

	   /*  1   */

	   if(_1hour)
	   {
	    _1hour--;
	    if(_1hour==0)
	    {
	     _1hour=60;
	     /*  1   */


             
             
	     /*  1   */		
	    }
	   }
	  }
	 }
	}
       }
      }
     }
    

/*  I_O_TIMERS_PERIODIC_LEN   */
    
    //    /,    -1  -1 ...  ..
    if (Test_Mode_Timeout)
    {
       if (LED_test_timeout) 
       {
         LED_test_timeout--;
         if (!LED_test_timeout) LED_OFF;
       }
#ifndef OKO_U2      
      if (OUT8_STATE)
      {
        if ( 
              (IN1_STATE) && (IN2_STATE) && (IN3_STATE)&& (IN4_STATE)
              #ifndef OKO_U2
              && (IN5_STATE)&& (IN6_STATE)&& (IN7_STATE)&& (!IN8_STATE)
              #endif                
             ) 
        {
          LED_ON;
          LED_test_timeout=LED_TEST_TIMEOUT_LEN;
        }
        OUT8_OFF;
        //SIRENA_ON;
      }       
      
      if (OUT7_STATE)
      {
        if ( 
              (IN1_STATE) && (IN2_STATE) && (IN3_STATE)&& (IN4_STATE)
              #ifndef OKO_U2
              && (IN5_STATE)&& (IN6_STATE)&& (!IN7_STATE)&& (IN8_STATE)
              #endif                
             ) 
        {
          LED_ON;
          LED_test_timeout=LED_TEST_TIMEOUT_LEN;
        }
        OUT7_OFF;
        OUT8_ON;
      } 
      
      if (OUT6_STATE)
      {
        if ( 
              (IN1_STATE) && (IN2_STATE) && (IN3_STATE)&& (IN4_STATE)
              #ifndef OKO_U2
              && (IN5_STATE)&& (!IN6_STATE)&& (IN7_STATE)&& (IN8_STATE)
              #endif                
             ) 
        {
          LED_ON;
          LED_test_timeout=LED_TEST_TIMEOUT_LEN;
        }
        OUT6_OFF;
        OUT7_ON;
      }  
      
      if (OUT5_STATE)
      {
        if ( 
              (IN1_STATE) && (IN2_STATE) && (IN3_STATE)&& (IN4_STATE)
              #ifndef OKO_U2
              && (!IN5_STATE)&& (IN6_STATE)&& (IN7_STATE)&& (IN8_STATE)
              #endif                
             ) 
        {
          LED_ON;
          LED_test_timeout=LED_TEST_TIMEOUT_LEN;
        }
        OUT5_OFF;
        OUT6_ON;
      }       
#endif
      
      if (OUT4_STATE)
      {
        if ( 
              (IN1_STATE) && (IN2_STATE) && (IN3_STATE)&& (!IN4_STATE)
              #ifndef OKO_U2
              && (IN5_STATE)&& (IN6_STATE)&& (IN7_STATE)&& (IN8_STATE)
              #endif                
             ) 
        {
          LED_ON;
          LED_test_timeout=LED_TEST_TIMEOUT_LEN;
        }
        OUT4_OFF;
        #ifndef OKO_U2
        OUT5_ON;
        #endif
      }  
      
      if (OUT3_STATE)
      {
        if ( 
              (IN1_STATE) && (IN2_STATE) && (!IN3_STATE)&& (IN4_STATE)
              #ifndef OKO_U2
              && (IN5_STATE)&& (IN6_STATE)&& (IN7_STATE)&& (IN8_STATE)
              #endif                
             ) 
        {
          LED_ON;
          LED_test_timeout=LED_TEST_TIMEOUT_LEN;
        }
        OUT3_OFF;
        OUT4_ON;
      } 
      
      if (OUT2_STATE)
      {
        if ( 
              (IN1_STATE) && (!IN2_STATE) && (IN3_STATE)&& (IN4_STATE)
              #ifndef OKO_U2
              && (IN5_STATE)&& (IN6_STATE)&& (IN7_STATE)&& (IN8_STATE)
              #endif                
             ) 
        {
          LED_ON;
          LED_test_timeout=LED_TEST_TIMEOUT_LEN;
        }
        OUT2_OFF;
        OUT3_ON;
      }      
      
      if (OUT1_STATE)
      {
        if ( 
              (!IN1_STATE) && (IN2_STATE) && (IN3_STATE)&& (IN4_STATE)
              #ifndef OKO_U2
              && (IN5_STATE)&& (IN6_STATE)&& (IN7_STATE)&& (IN8_STATE)
              #endif                
             ) 
        {
          LED_ON;
          LED_test_timeout=LED_TEST_TIMEOUT_LEN;
        }
        OUT1_OFF;
        OUT2_ON;
      }

      if (SIRENA_STATE)
      {
        if ( 
              (IN1_STATE) && (IN2_STATE) && (IN3_STATE)
              #ifdef OKO_U2
                && (!IN4_STATE)
              #else
                && (IN4_STATE) && (IN5_STATE)&& (IN6_STATE)&& (IN7_STATE)&& (!IN8_STATE)
              #endif
           ) 
        {
          LED_ON;
          LED_test_timeout=LED_TEST_TIMEOUT_LEN;
        }
        SIRENA_OFF;
        OUT1_ON;
      }        
      
      if ( 
           !(
              (SIRENA_STATE)|| (OUT1_STATE) || (OUT2_STATE) || (OUT3_STATE)|| (OUT4_STATE)
              #ifndef OKO_U2
              || (OUT5_STATE)|| (OUT6_STATE)|| (OUT7_STATE)|| (OUT8_STATE)
              #endif 
            )               
          )
      {
        vTaskDelay(10/portTICK_RATE_MS);
        if ( 
              (IN1_STATE) && (IN2_STATE) && (IN3_STATE)&& (IN4_STATE)
              #ifndef OKO_U2
              && (IN5_STATE)&& (IN6_STATE)&& (IN7_STATE)&& (IN8_STATE)
              #endif                
             ) 
        {
          //LED_OFF;
        }
        else
        {
          LED_ON;
        }
        
        SIRENA_ON;
      }        
      
    }
    
    
    
    
   /* -    1 */
   if (Piezo_KB1_Timeout) Piezo_KB1_Timeout--;

   /* -    2 */
   if (Piezo_KB2_Timeout) Piezo_KB2_Timeout--;
       
    
    /* -    RS485-  */
    if (RS485_Rx_Timeout) RS485_Rx_Timeout--;
    
    /*        Ring */
    if (!SIM900_RING_STATE) FLAG_SIM900_RING_SET;

    
    /*     -1  */
    Event.Code_Event=HIGH_INPUT_1_EVENT;  //  
    Event.Group=Wire_Sensor.Group[INPUT_1];
    Check_Input_Event (INPUT_1, IN1_STATE, Event, LOW_INPUT_1_EVENT, KZ_INPUT_1_EVENT, OBRIV_INPUT_1_EVENT);

    /*     -2  */
    Event.Code_Event=HIGH_INPUT_2_EVENT; //  
    Event.Group=Wire_Sensor.Group[INPUT_2];
    Check_Input_Event (INPUT_2, IN2_STATE, Event, LOW_INPUT_2_EVENT, KZ_INPUT_2_EVENT, OBRIV_INPUT_2_EVENT);

    /*     -3  */
    Event.Code_Event=HIGH_INPUT_3_EVENT; //  
    Event.Group=Wire_Sensor.Group[INPUT_3];
    Check_Input_Event (INPUT_3, IN3_STATE, Event, LOW_INPUT_3_EVENT, KZ_INPUT_3_EVENT, OBRIV_INPUT_3_EVENT);



    /*     -4  */
    Event.Code_Event=HIGH_INPUT_4_EVENT; //  
    Event.Group=Wire_Sensor.Group[INPUT_4];
    Check_Input_Event (INPUT_4, IN4_STATE, Event, LOW_INPUT_4_EVENT, KZ_INPUT_4_EVENT, OBRIV_INPUT_4_EVENT);


  #ifndef OKO_U2
    
    /*     -5  */
    Event.Code_Event=HIGH_INPUT_5_EVENT; //  
    Event.Group=Wire_Sensor.Group[INPUT_5];
    Check_Input_Event (INPUT_5, IN5_STATE, Event, LOW_INPUT_5_EVENT, KZ_INPUT_5_EVENT, OBRIV_INPUT_5_EVENT);



    /*     -6  */
    Event.Code_Event=HIGH_INPUT_6_EVENT; //  
    Event.Group=Wire_Sensor.Group[INPUT_6];
    Check_Input_Event (INPUT_6, IN6_STATE, Event, LOW_INPUT_6_EVENT, KZ_INPUT_6_EVENT, OBRIV_INPUT_6_EVENT);



    /*     -7  */
    Event.Code_Event=HIGH_INPUT_7_EVENT; //  
    Event.Group=Wire_Sensor.Group[INPUT_7];
    Check_Input_Event (INPUT_7, IN7_STATE, Event, LOW_INPUT_7_EVENT, KZ_INPUT_7_EVENT, OBRIV_INPUT_7_EVENT);



    /*     -8  */
    Event.Code_Event=HIGH_INPUT_8_EVENT; //  
    Event.Group=Wire_Sensor.Group[INPUT_8];
    Check_Input_Event (INPUT_8, IN8_STATE, Event, LOW_INPUT_8_EVENT, KZ_INPUT_8_EVENT, OBRIV_INPUT_8_EVENT);
  #endif

    /*      */
    if (Tamper.Time_Out==0)
    {
    if (ADC_value[ADC_TAMPER]>ADC_TAMPER_LEVEL) temp=1; else temp=0;
    temp=Input_Analysis(temp,INPUT_TAMPER);
    /*      */
    //if ( (0x01 & ( (*(char*)(_24H))>>_TAMPER)) || (Tamper.Group & MODE_ARM_STATE) )
    {
     if (temp==LOW_CHANGE) 
      {
       Event.Code_Event=TAMPER_ALARM_EVENT; 
       Event.Group=Tamper.Group; 
       if ( Save_Event_to_Buffer(Event) ) Tamper.Time_Out=*(char *)TAMPER_TIME_OUT_LEN; //-     
       Check_Out_Pulse_Alarm(Tamper.Group); //       
      }
     if (temp==HIGH_CHANGE) 
      {
       Event.Code_Event=TAMPER_NORMA_EVENT; 
       Event.Group=Tamper.Group; 
       Save_Event_to_Buffer(Event); 
      } 
    }
    }
    
    /*   / 220  */
    if (*(uint16_t*)EXTERNAL_BBP) 
    {
      //    
      if (ADC_value[ADC_EXT_POWER]> (*(uint16_t*)EXTERNAL_BBP) ) temp=1; else temp=0;
    }
    else
    {
      //    
      if (ADC_value[ADC_EXT_POWER]>ADC_EXT_POWER_LEVEL) temp=1; else temp=0;
    }
    temp=Input_Analysis(temp,INPUT_EXT_POWER);
    /*      */
    if ( (0x01 & ( (*(char*)(_24H))>>_POWER)) || (Power.Group & MODE_ARM_STATE) )
    {
     if (temp==HIGH_CHANGE) 
      {
        Event.Code_Event=_220_POWER_ON_EVENT; 
        Event.Group=Power.Group ; 
        Save_Event_to_Buffer(Event);
        MODE_FLAG_220_SET; FLAG_SAVE_MODE_SET;
      }
    
     if (temp==LOW_CHANGE) 
      {
        Event.Code_Event=_220_POWER_OFF_EVENT; 
        Event.Group=Power.Group; 
        Save_Event_to_Buffer(Event);
        Check_Out_Pulse_Alarm(Power.Group); //      220
        MODE_FLAG_220_RESET; FLAG_SAVE_MODE_SET;
      }	
    }
     
    /*     12   */
    if (ADC_value[ADC_MAIN_POWER]>ADC_MAIN_POWER_LEVEL) temp=1; else temp=0;
    temp=Input_Analysis(temp,INPUT_MAIN_POWER);
    /*      */
    if (temp==LOW_CHANGE) 
    {
      Event.Code_Event=BACKUP_POWER_LOW_EVENT; 
      Event.Group=Power.Group; 
      Save_Event_to_Buffer(Event);
    }


    /*   */
    temp=Input_Analysis(BUTTON_STATE,INPUT_BUTTON);
    if (temp) 
     {
	/*     Debug-*/
	periodic_print=INPUTS_PERIODIC_PRINT_LEN;
	/*        -,      */
	if (temp==HIGH_CHANGE && Button_Low_Level_Timeout) 
          {
            Button_Low_Level_Timeout=0; 
            Button_Pulse++; 
            if (!Button_Timeout) Button_Timeout=20;
          }
        if (temp==LOW_CHANGE) Button_Low_Level_Timeout=15;
     }    


    /*   /  */
    if (FLAG_ARM_BOARD_STATE)
	{
	temp=Input_Analysis(ARM_STATE,INPUT_ARM);
	if (temp) 
	 {
	  periodic_print=INPUTS_PERIODIC_PRINT_LEN;
          
          switch (*(char*)OXR_INPUT_TYPE)
          {
          case OXR_INPUT_HIGH_TO_ARM:
              if (temp==HIGH_CHANGE) Arm_1Wire(*(char*)KB_GROUP, BY_KEYBOARD); //ALL_GROUP
              if (temp==LOW_CHANGE) Disarm(*(char*)KB_GROUP, BY_KEYBOARD); //ALL_GROUP            
            break;
           
          case OXR_INPUT_PULSE_TO_ARM:
            if (temp==LOW_CHANGE)
            {
                if ( 
                    ( MODE_ARM_STATE & (*(char*)KB_GROUP) ) || 
                    ( Arm_Delay && (Delay_arm_group & (*(char*)KB_GROUP)) )
                   )
                  Disarm(*(char*)KB_GROUP, BY_KEYBOARD);
                else
                  Arm_1Wire(*(char*)KB_GROUP, BY_KEYBOARD);
            }
            break;
            
          case OXR_INPUT_LOW_TO_ARM:  
          default:
              if (temp==LOW_CHANGE) Arm_1Wire(*(char*)KB_GROUP, BY_KEYBOARD); //ALL_GROUP
              if (temp==HIGH_CHANGE) Disarm(*(char*)KB_GROUP, BY_KEYBOARD); //ALL_GROUP           
            break;
            
          }

	 }
	}
 

    /* /          */   
    if (
         MODE_ARM_STATE && 
         !FLAG_PROGRAM_MODE_STATE &&
         !Test_Mode_Timeout &&  
         !Arm_Delay && 
         !Alarm_Delay &&
         !LED_Long_Flash &&
         !LED_Short_Flash
        ) 
     { LED_ON }
    else 
     {if ( (LED_Long_Flash==0) && (LED_Short_Flash==0) && (Arm_Delay==0) && (Alarm_Delay==0) && (Test_Mode_Timeout==0) ) LED_OFF}


    /*   5         */
    if (BUTTON_STATE!= RESET) 
      {
        erase_eeprom=0; 
      }
      else
      {
         if (erase_eeprom==0) erase_eeprom=50;
      }      
  
    /*    */
    if (OUT1_STATE) Outputs_State|=(1<<OUTPUT_1); else Outputs_State&=~(1<<OUTPUT_1);
    if (OUT2_STATE) Outputs_State|=(1<<OUTPUT_2); else Outputs_State&=~(1<<OUTPUT_2);
    if (OUT3_STATE) Outputs_State|=(1<<OUTPUT_3); else Outputs_State&=~(1<<OUTPUT_3);
    if (OUT4_STATE) Outputs_State|=(1<<OUTPUT_4); else Outputs_State&=~(1<<OUTPUT_4);
#ifndef OKO_U2
    if (OUT5_STATE) Outputs_State|=(1<<OUTPUT_5); else Outputs_State&=~(1<<OUTPUT_5);
    if (OUT6_STATE) Outputs_State|=(1<<OUTPUT_6); else Outputs_State&=~(1<<OUTPUT_6);
    if (OUT7_STATE) Outputs_State|=(1<<OUTPUT_7); else Outputs_State&=~(1<<OUTPUT_7);
    if (OUT8_STATE) Outputs_State|=(1<<OUTPUT_8); else Outputs_State&=~(1<<OUTPUT_8);
#endif
      
   periodic_print++;
   
   if (periodic_print>INPUTS_PERIODIC_PRINT_LEN)
   {
    
     
      periodic_print=0;
      
      if (USB_Mode==DebugMode)
      {
        i_s_d[0]=(char) (Inputs_State>>8);
        i_s_d[1]=(char) (Inputs_State&0x00ff);
        i_s_d[2]=(char) (KZ_Obriv_State>>8);
        i_s_d[3]=(char) (KZ_Obriv_State&0x00ff);
        xMessage.Debug_Data_Len = 4;
        xMessage.Debug_Source_ID = Inputs_Debug_ID;
        xMessage.Debug_Char_Data = i_s_d;
        xMessage.Debug_Data_type=Debug_Data_type_BIN;
   
        /*   .
          -   .  
          ,     pvParameters.
            - ,    
          Blocked,      ,
            */
        xStatus = xQueueSendToBack(Queue_Print_Debug, &xMessage, xTicksToWait );
        if( xStatus != pdPASS )
        {
         /*    ,    xTicksToWait .
             . */
        }
      }    
  
   } 
      

   
     /*   I_O_TIMERS_PERIODIC_LEN . */
    /*       I_O_TIMERS_PERIODIC_LEN .  
          vTaskDelay(),    ,  
        portTICK_RATE_MS      .
         xLastWakeTime    
        vTaskDelayUntil(),        xLastWakeTime
         . 
    !!!
      vTaskDelayUntil ,   
    FreeRTOSConfig.h    1 INCLUDE_vTaskDelayUntil.
    */  
   
   vTaskDelayUntil( &xLastWakeTime, ( I_O_TIMERS_PERIODIC_LEN / portTICK_RATE_MS ) );     
      
  
  }
  
    /*     ,     (break)  
          ,      
           .  NULL, 
       vTaskDelete(), ,      (, 
       ) . 
    !!!
      vTaskDelete ,   
    FreeRTOSConfig.h    1 INCLUDE_vTaskDelete.    
         
         */
    
//    vTaskDelete( NULL ); 
}

/*******************************************************************************
* Function Name  : Sirena
* Description    :  
* Input          : beep -  0,    , !0 -   
* Output         : None
* Return         : None
*******************************************************************************/ 
void Sirena (char beep)
{
  char i;
  
  if (beep) 
  {
  SIRENA_OFF;
  Output_Time_Out[OUTPUT_SIRENA]=0; 
  SIRENA_Short_Beep=beep*2;
  }
  else
  {
    if ( (!Output_Time_Out[OUTPUT_SIRENA]) && (* (uint16_t *) SIRENA_TIME_OUT_LEN) )
    {
      SIRENA_ON;
      Output_Time_Out[OUTPUT_SIRENA]= * (uint16_t *) SIRENA_TIME_OUT_LEN;
    }
  }
  
  if ( (beep==0) || (beep==60) )
  {
      i=ALARM_COMMAND;
      xQueueSendToBack(Queue_TRX_Command, & i, 0 ); //         OKO-TRX
  }
}

/*******************************************************************************
* Function Name  : Arm
* Description    :     
* Input          : arm_group - ,    
*               arm_in_any_case -    
*               who -  ,  
* Output         : None
* Return         : None
*******************************************************************************/ 
void Arm (char arm_group, char arm_in_any_case, char who)
{
 char i;
 char j=0;
 TypeDef_EVENT Event;

 //Delay_who=NOT_OWNER;
 
 if (MODE_FLAG_BLOCK_ARM_STATE && !arm_in_any_case)
  {
    //     
   //        ,   
   if (INPUT_1_STATE && (arm_group & Wire_Sensor.Group[INPUT_1]) ) 
   {
     j=1;
     Event.Code_Event=INPUT_1_FAULT_ARMED_EVENT;
   }
   else
   {
    if (INPUT_2_STATE && (arm_group & Wire_Sensor.Group[INPUT_2]) ) 
    {
      j=2;
      Event.Code_Event=INPUT_2_FAULT_ARMED_EVENT;
    }
    else
    {
      if (INPUT_3_STATE && (arm_group & Wire_Sensor.Group[INPUT_3]) ) 
      {
        j=3;
        Event.Code_Event=INPUT_3_FAULT_ARMED_EVENT;
      }
      else
      {
        if (INPUT_4_STATE && (arm_group & Wire_Sensor.Group[INPUT_4]) ) 
        {
          j=4;
          Event.Code_Event=INPUT_4_FAULT_ARMED_EVENT;
        }
        else
        {
          if (INPUT_5_STATE && (arm_group & Wire_Sensor.Group[INPUT_5]) ) 
          {
            j=5;
            Event.Code_Event=INPUT_5_FAULT_ARMED_EVENT;
          }
          else
          {
            if (INPUT_6_STATE && (arm_group & Wire_Sensor.Group[INPUT_6]) ) 
            {
              j=6;
              Event.Code_Event=INPUT_6_FAULT_ARMED_EVENT;
            }
            else
            {
              if (INPUT_7_STATE && (arm_group & Wire_Sensor.Group[INPUT_7]) ) 
              {
                j=7;
                Event.Code_Event=INPUT_7_FAULT_ARMED_EVENT;
              }
              else
              {
                if (INPUT_8_STATE && (arm_group & Wire_Sensor.Group[INPUT_8]) ) 
                {
                  j=8;
                  Event.Code_Event=INPUT_8_FAULT_ARMED_EVENT;
                }
                else
                {
                  //         ,   
                  for (i=0; i<MAX_RADIO_SENSOR;  i++) 
                    {
                    if ( 
                      ( ((RF_Sensor.Data_Current[i] & 0x000F)== RADIO_SENSOR_GERKON) || ((RF_Sensor.Data_Current[i] & 0x000F)==RADIO_SENSOR_GERKON_POTENCIAL) ) && 
                      ( !(0x0001 & (RF_Sensor.Data_Current[i]>>RADIO_SENSOR_STATE)) ) &&
                    (arm_group & RF_Sensor.Group[i])
                        )
                      {
                        j=8+i+1;
                        Event.Code_Event=RADIO_1_FAULT_ARMED_EVENT+i;
                        break;
                      }
                    }
                }
              }
            }
          }
        }
      }
    }
   }
  }

if (!j)
{

 if (Delay_arm_group==arm_group)
  {
    Arm_Delay=0;
    Delay_arm_group=0;
    //Delay_who=NOT_OWNER;
  }
  else
  {
    Delay_arm_group &=~(arm_group);
  }
  
 Check_Out_Pulse_Arm (arm_group);
 
 if (arm_group & (~MODE_ARM_STATE) )
 {
    
   if (0x01 & (arm_group>>0) ) MODE_FLAG_ARM_1_SET; //   -1
   if (0x01 & (arm_group>>1) ) MODE_FLAG_ARM_2_SET; //   -2
   if (0x01 & (arm_group>>2) ) MODE_FLAG_ARM_3_SET; //   -3
   if (0x01 & (arm_group>>3) ) MODE_FLAG_ARM_4_SET; //   -4
   if (0x01 & (arm_group>>4) ) MODE_FLAG_ARM_5_SET; //   -5
   if (0x01 & (arm_group>>5) ) MODE_FLAG_ARM_6_SET; //   -6
   if (0x01 & (arm_group>>6) ) MODE_FLAG_ARM_7_SET; //   -7
   if (0x01 & (arm_group>>7) ) MODE_FLAG_ARM_8_SET; //   -8

  FLAG_SAVE_MODE_SET;
  if (arm_in_any_case) Event.Code_Event=REMOUT_ARMED_EVENT; else Event.Code_Event=ARMED_EVENT;
  Event.Group=arm_group;
  Event.Who=who;
  Save_Event_to_Buffer(Event);

  Check_Balance_Period=2; //    2     
  
  if (MODE_FLAG_CHECK_INPUT_STATE)
  {
   //        ,     
   if (INPUT_1_STATE && (arm_group & Wire_Sensor.Group[INPUT_1]) ) 
    {Event.Code_Event=HIGH_INPUT_1_EVENT; Event.Group=Wire_Sensor.Group[INPUT_1]; Event.Sensor=INPUT_1+1; Save_Event_to_Buffer(Event);}
   else
   {
    if (INPUT_2_STATE && (arm_group & Wire_Sensor.Group[INPUT_2]) ) 
      {Event.Code_Event=HIGH_INPUT_2_EVENT; Event.Group=Wire_Sensor.Group[INPUT_2]; Event.Sensor=INPUT_2+1; Save_Event_to_Buffer(Event);}
      else
      {
        if (INPUT_3_STATE && (arm_group & Wire_Sensor.Group[INPUT_3]) ) 
	{Event.Code_Event=HIGH_INPUT_3_EVENT; Event.Group=Wire_Sensor.Group[INPUT_3]; Event.Sensor=INPUT_3+1; Save_Event_to_Buffer(Event);}
        else
        {
          if (INPUT_4_STATE && (arm_group & Wire_Sensor.Group[INPUT_4]) ) 
          {Event.Code_Event=HIGH_INPUT_4_EVENT; Event.Group=Wire_Sensor.Group[INPUT_4]; Event.Sensor=INPUT_4+1; Save_Event_to_Buffer(Event);}
          else
          {
            #ifndef OKO_U2     
            if (INPUT_5_STATE && (arm_group & Wire_Sensor.Group[INPUT_5]) ) 
              {Event.Code_Event=HIGH_INPUT_5_EVENT; Event.Group=Wire_Sensor.Group[INPUT_5]; Event.Sensor=INPUT_5+1; Save_Event_to_Buffer(Event);}
              else
              {
                if (INPUT_6_STATE && (arm_group & Wire_Sensor.Group[INPUT_6]) ) 
                  {Event.Code_Event=HIGH_INPUT_6_EVENT; Event.Group=Wire_Sensor.Group[INPUT_6]; Event.Sensor=INPUT_6+1; Save_Event_to_Buffer(Event);}
                  else
                  {
                    if (INPUT_7_STATE && (arm_group & Wire_Sensor.Group[INPUT_7]) ) 
                      {Event.Code_Event=HIGH_INPUT_7_EVENT; Event.Group=Wire_Sensor.Group[INPUT_7]; Event.Sensor=INPUT_7+1; Save_Event_to_Buffer(Event);}
                    else
                    {
                      if (INPUT_8_STATE && (arm_group & Wire_Sensor.Group[INPUT_8]) ) 
                        {Event.Code_Event=HIGH_INPUT_8_EVENT; Event.Group=Wire_Sensor.Group[INPUT_8]; Event.Sensor=INPUT_8+1; Save_Event_to_Buffer(Event);}
                    }
                  }
              }
            #endif
          }
        }
      }
   }

   //         ,     
 
  }
  
  if (MODE_FLAG_CHECK_RADIO_STATE)
  {
   //         ,     
   for (i=0; i<MAX_RADIO_SENSOR;  i++) 
    {
     if ( 
       ( ((RF_Sensor.Data_Current[i] & 0x000F)== RADIO_SENSOR_GERKON) || ((RF_Sensor.Data_Current[i] & 0x000F)==RADIO_SENSOR_GERKON_POTENCIAL) ) && 
       ( !(0x0001 & (RF_Sensor.Data_Current[i]>>RADIO_SENSOR_STATE)) ) &&
       (arm_group & RF_Sensor.Group[i])
         )
      {
        Event.Code_Event=RADIO_SENSOR1_ALARM_EVENT+EVENTS_PER_RADIO_SENSOR*i; 
        Event.Group=RF_Sensor.Group[i];
        Event.Sensor=i+1;
        Save_Event_to_Buffer(Event);
        break;
      }
    }
  } 
  
 }
 
 
  SIRENA_OFF;
  Output_Time_Out[OUTPUT_SIRENA]=0;
  //   
  if (!MODE_FLAG_ARM_DISARM_SILENT_STATE) 
  {
    Sirena (1);
    i=ARM_COMMAND;
    xQueueSendToBack(Queue_TRX_Command, & i, 0 ); //           OKO-TRX
  }

 /*  -   */
 for (i=0; i<MAX_WIRE_SENSOR;  i++) 
 {
  Wire_Sensor.Time_Out[i]=0;
 }

 /*  -       */
 for (i=0; i<MAX_RADIO_SENSOR;  i++) 
 {
  RF_Sensor.Same_Data_Time_Out[i]=0;
 }
}
else
{
  //   
  //Event.Code_Event=FAULT_ARMED_EVENT;
  Event.Group=arm_group;
  Event.Who=who;
  if (j<9) Event.Sensor=j; else Event.Sensor=j-8;
  Save_Event_to_Buffer(Event);
 
  SIRENA_OFF;
  //   
  if (!MODE_FLAG_ARM_DISARM_SILENT_STATE) Sirena (3);  
  
}

}


/*******************************************************************************
* Function Name  : Disarm
* Description    :   
* Input          : disarm_group - ,    , who -  ,  
* Output         : None
* Return         : None
*******************************************************************************/ 
void Disarm (char disarm_group, char who)
{
  TypeDef_DELAY_EVENT           Delay_Event; /*    */
  TypeDef_EVENT                 Event;
  char i;
  
  start_disarm=0;
  
  if (Delay_arm_group==disarm_group)
  {
    Arm_Delay=0;
    Delay_arm_group=0;
    //Delay_who=NOT_OWNER;
  }
  else
  {
    Delay_arm_group &=~(disarm_group);
  }
  
  Alarm_Delay=0;
  Alarm_Voice=0;
  
  
  
  Check_Out_Pulse_Disarm (disarm_group);
  
  /*    ""   ,     */
  for (i=0; i < DELAY_EVENT_QUEUE_LEN; i++)
   {
     if( xQueueReceive( Queue_Delay_Event, &Delay_Event, 0 ) == pdPASS )
      {
        if (Delay_Event.Group & (~disarm_group) )
        {
          Delay_Event.Group &= (~disarm_group);
          /*      ""  */
          xQueueSendToBack(Queue_Delay_Event, &Delay_Event, 0 );
        }
   
      }
      else
      {
        i = DELAY_EVENT_QUEUE_LEN;
      }
   } 


  if (!MODE_FLAG_NOT_CLEAR_BUFFER_STATE)
  {
   /*       ,     ,    / */
   for (i=0; i < EVENT_QUEUE_LEN; i++)
    {
     if( xQueueReceive( Queue_Event, &Event, 0 ) == pdPASS )
      {
        if ( (Event.Group & (~disarm_group)) && !( (Event.Code_Event==ARMED_EVENT) || ( (Event.Code_Event>=INPUT_1_FAULT_ARMED_EVENT) && (Event.Code_Event<=RADIO_16_FAULT_ARMED_EVENT) ) || (Event.Code_Event==DISARMED_EVENT) || (Event.Code_Event==FORCE_DISARMED_EVENT) ) )
        {
          Event.Group &= (~disarm_group);
          /*       */
          xQueueSendToBack(Queue_Event, &Event, 0 );
        }
        else
        {
          if ( (Event.Code_Event==ARMED_EVENT) || ((Event.Code_Event>=INPUT_1_FAULT_ARMED_EVENT) && (Event.Code_Event<=RADIO_16_FAULT_ARMED_EVENT)) || (Event.Code_Event==DISARMED_EVENT) || (Event.Code_Event==FORCE_DISARMED_EVENT) )
          {
            /*       */
            xQueueSendToBack(Queue_Event, &Event, 0 );            
          }
        }
   
      }
      else
      {
        i = EVENT_QUEUE_LEN;
      }
    }
  } 

   //     
  if (MODE_ARM_STATE & disarm_group) 
  {
    
   if (0x01 & (disarm_group>>0) ) MODE_FLAG_ARM_1_RESET; //   -1
   if (0x01 & (disarm_group>>1) ) MODE_FLAG_ARM_2_RESET; //   -2
   if (0x01 & (disarm_group>>2) ) MODE_FLAG_ARM_3_RESET; //   -3
   if (0x01 & (disarm_group>>3) ) MODE_FLAG_ARM_4_RESET; //   -4
   if (0x01 & (disarm_group>>4) ) MODE_FLAG_ARM_5_RESET; //   -5
   if (0x01 & (disarm_group>>5) ) MODE_FLAG_ARM_6_RESET; //   -6
   if (0x01 & (disarm_group>>6) ) MODE_FLAG_ARM_7_RESET; //   -7
   if (0x01 & (disarm_group>>7) ) MODE_FLAG_ARM_8_RESET; //   -8
   
   FLAG_SAVE_MODE_SET;
   if (FLAG_FORCE_PIN_STATE) 
    {
      Event.Code_Event=FORCE_DISARMED_EVENT;
      FLAG_FORCE_PIN_RESET;
    }
   else
    {
      Event.Code_Event=DISARMED_EVENT;
    }
   Event.Group=disarm_group;
   Event.Who=who;
   Save_Event_to_Buffer(Event);
  }
  
  SIRENA_OFF;
  Output_Time_Out[OUTPUT_SIRENA]=0;
  //   
  if (!MODE_FLAG_ARM_DISARM_SILENT_STATE) 
  {
    Sirena (2); 
    i=DISARM_COMMAND;
    xQueueSendToBack(Queue_TRX_Command, & i, 0 ); //           OKO-TRX
  }

  /*  -   */
  for (i=0; i<MAX_WIRE_SENSOR;  i++) 
  {
    Wire_Sensor.Time_Out[i]=0;
  }

  /*  -       */
  for (i=0; i<MAX_RADIO_SENSOR;  i++) 
  {
    RF_Sensor.Same_Data_Time_Out[i]=0;
  }
 
}


/*******************************************************************************
* Function Name  : Program_Mode
* Description    : /  
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void Program_Mode (void)
{
 if (FLAG_PROGRAM_MODE_STATE)
  {
   FLAG_PROGRAM_MODE_RESET;
   Program_Mode_Timeout=0;
   LED_OFF;
   LED_Long_Flash=0;
   LED_Short_Flash=6; //3    
  }
  else
  {
   FLAG_PROGRAM_MODE_SET;
   Program_Mode_Timeout=PROGRAM_MODE_TIMEOUT_LEN;
   LED_OFF;
   LED_Long_Flash=0;
   LED_Short_Flash=4; //2    
  }

}


/*******************************************************************************
* Function Name  : Save_Event_to_Buffer
* Description    :    
* Input          : Event - 
* Output         : None
* Return         : 0 -   , 1 -     , 2 -      
*******************************************************************************/ 
char Save_Event_to_Buffer(TypeDef_EVENT Event)
{
  portBASE_TYPE                 xStatus;
  TypeDef_GPRS_EVENT            GPRS_Event;
  char z=2, i;
 
/* ,    .
       ,      
     ,    .   xSemaphoreTake() 
      ,    . */
 xSemaphoreTake( Mutex_Save_Event, portMAX_DELAY );
 {
   
  /*     */
  if (Event.Code_Event!=SERVER_QUERY_EVENT)
  {
    xStatus = xQueueSendToBack(Queue_Event, &Event, 0 );
    if( xStatus != pdPASS )
    {
      /*    .  . */
      z= 0;
    }
  }
  
  /*         */
  if (MODE_FLAG_GPRS_STATE || (Event.Code_Event==SERVER_QUERY_EVENT) )
    {
      GPRS_Period=*(uint16_t *) GPRS_PERIOD_LEN; //""  
      
      //   
      GPRS_Event.Code_Event=Event.Code_Event; // 
      GPRS_Event.Group=Event.Group; //
      GPRS_Event.Sensor=Event.Sensor; // 
      GPRS_Event.Mode_Flags=MODE_FLAGS; //  
      GPRS_Event.Inputs_State=Inputs_State; //  ,  , 220 ...
      GPRS_Event.KZ_Obriv_State=KZ_Obriv_State; //      
      GPRS_Event.Outputs_State=Outputs_State; //  
      GPRS_Event.GSM_Level=GSM_Level; //  GSM-
      GPRS_Event.Who=Event.Who;
      
      //   DS1820
      for (i=0; i<MAX_DS1820; i++)
      {
        GPRS_Event.DS1820_Data_Current[i]=DS1820_Sensor.Data_Current[i];
      }

      //  
      for (i=0; i<MAX_RADIO_SENSOR; i++)
      {
        GPRS_Event.RF_Data_Current[i]=RF_Sensor.Data_Current[i] ;
      } 


      //  
      for (i=0; i<ADC_CH; i++)
      {
        GPRS_Event.ADC_Value[i]=ADC_value[i] ;
      } 
      
      xStatus = xQueueSendToBack(Queue_GPRS_Event, &GPRS_Event, 0 );
      if( xStatus != pdPASS )
   	{
    	/*    .  . */
          z=1;
   	}
    }  
 }

 
 /*     ! */
 xSemaphoreGive( Mutex_Save_Event ); 
 
  return z;

}

/*******************************************************************************
* Function Name  : Input_Analysis
* Description    :      
* Input          : current_state -   ; input -  
* Output         : None
* Return         : NO_CHANGE -   ;
*                  OBRIV_CHANGE -     3;
*                  KZ_CHANGE -     2;
*	           HIGH_CHANGE -     1; 
*	           LOW_CHANGE -     0
*******************************************************************************/ 

char Input_Analysis (unsigned char current_state, char input) 
{
/*           */
  static uint16_t Input_Filtr[13]=
  {
    IN_FILTR_LEN, //   1
    IN_FILTR_LEN, //   2
    IN_FILTR_LEN, //   3
    IN_FILTR_LEN, //   4
    IN_FILTR_LEN, //   5
    IN_FILTR_LEN, //   6
    IN_FILTR_LEN, //   7
    IN_FILTR_LEN, //   8
    IN_FILTR_LEN, //   ARM (/ )
    IN_FILTR_LEN, //   BUTTON ()
    IN_EXT_POWER_FILTR_LEN, //   EXT_POWER (220V)
    IN_MAIN_POWER_FILTR_LEN,  //   MAIN_POWER (ACC)
    IN_FILTR_LEN //   
  };
  char temp=NORMA_STATE;

  char type=*(char*)(VXOD_MODE+input);
  
  //    -1..-8
  if (input < (INPUT_8+1) )
  {
    if ( ((0x01 & (Inputs_State>>input) )==0) && ((0x01 & (KZ_Obriv_State>>input) )==0) && ((0x01 & (KZ_Obriv_State>> (input+8)) )==0) ) temp=NORMA_STATE;
    if ( ((0x01 & (Inputs_State>>input) )==1) && ((0x01 & (KZ_Obriv_State>>input) )==0) && ((0x01 & (KZ_Obriv_State>> (input+8)) )==0) ) temp=TREVOGA_STATE;
    if ( ((0x01 & (Inputs_State>>input) )==1) && ((0x01 & (KZ_Obriv_State>>input) )==1) && ((0x01 & (KZ_Obriv_State>> (input+8)) )==0) ) temp=KZ_STATE;
    if ( ((0x01 & (Inputs_State>>input) )==1) && ((0x01 & (KZ_Obriv_State>>input) )==0) && ((0x01 & (KZ_Obriv_State>> (input+8)) )==1) ) temp=OBRIV_STATE;    
    
    /*         */
    if (temp==current_state) 
    {
      /*    */    
      /*    */    
      Input_Filtr[input]=*(uint16_t *)(INPUT_FILTR_LEN + 2*input); 
      if (type==VXOD_COUNTER) Input_Filtr[input]=0; //       
      /*  -      */
      return NO_CHANGE;
    }
    else
    {
      /*   */    
    
      /*   */
      if (type!=VXOD_COUNTER) Input_Filtr[input]--;
    
      if (Input_Filtr[input]==0)
      {
        /*    */
        Input_Filtr[input]=*(uint16_t *)(INPUT_FILTR_LEN + 2*input);
        if (type==VXOD_COUNTER) Input_Filtr[input]=0; //       
        return Update_current_state(current_state,input);
      }
     
      /*  -      */
      return NO_CHANGE;
    }
  }
  else
  {
    /*   220,      */
   if ((0x01 & (Inputs_State>>input)) == current_state)
   {
    /*    */    
    
    /*    */
    Input_Filtr[input]=IN_FILTR_LEN;
    if (input==INPUT_EXT_POWER) Input_Filtr[input]=*(uint16_t *)INPUT_EXT_POWER_FILTR_LEN;
    if (input==INPUT_MAIN_POWER) Input_Filtr[input]=*(uint16_t *)INPUT_MAIN_POWER_FILTR_LEN;
    if (input==INPUT_TAMPER) Input_Filtr[input]=*(uint16_t *)INPUT_TAMPER_FILTR_LEN;

    /*  -      */
    return NO_CHANGE;

   } 
    else 
   {

    /*   */    
    
    /*   */
    Input_Filtr[input]--;
    
    if (Input_Filtr[input]==0)
      {
          /*    -   */    
          /*    */
          Input_Filtr[input]=IN_FILTR_LEN;
	  if (input==INPUT_EXT_POWER) Input_Filtr[input]=*(uint16_t *)INPUT_EXT_POWER_FILTR_LEN;
	  if (input==INPUT_MAIN_POWER) Input_Filtr[input]=*(uint16_t *)INPUT_MAIN_POWER_FILTR_LEN;
          if (input==INPUT_TAMPER) Input_Filtr[input]=*(uint16_t *)INPUT_TAMPER_FILTR_LEN;
              
          if (current_state)
          {
              /*      1 */
              Inputs_State|=(1<<input);
              /*      1 */
              return HIGH_CHANGE; 
          }
          else
          {
              /*      0 */
              Inputs_State&=~(1<<input);
              /*      0 */
              return LOW_CHANGE;
          }
          
      }
    
    /*      -     */    
    
    /*  -     */
    return NO_CHANGE;
   }
  }
  
}

/*******************************************************************************
* Function Name  : Do_Wire_Sensor_Alarm
* Description    :   
* Input          : input - ID  (0..7); event_alarm -  
* Output         : None
* Return         : None
*******************************************************************************/  
void Do_Wire_Sensor_Alarm (char input, TypeDef_EVENT event_alarm)
{
  char i;
  portBASE_TYPE                 xStatus;
  TypeDef_DELAY_EVENT           Delay_Event; /*    */
  TypeDef_EVENT                 Event;
  
  event_alarm.Sensor=input+1; //sensor number
  
      i=(char) (10 * ( (Wire_Sensor.Parameter[input]>>SENSOR_DELAY_POSITION) & 0x07) ); //    
      
      
      if ( i && ( !( (Alarm_Delay==0) && (event_alarm.Restore) ) ) && !(event_alarm.KZ_Obriv) )
      {
        //   
        
        //  ,   "",   ,      
        if ( ((Alarm_Delay==0) || (Alarm_Delay > i)) && (!event_alarm.Restore) ) 
        {
          Alarm_Delay = i;
          if (!start_disarm)
          {
            start_disarm=1;
            Event.Code_Event=START_DISARM_EVENT; 
            Save_Event_to_Buffer(Event);
          } 
        }
        
        //  
        Delay_Event.Code_Event=event_alarm.Code_Event;
        Delay_Event.Group=event_alarm.Group;
        Delay_Event.Sensor=event_alarm.Sensor; 
        Delay_Event.Restore=event_alarm.Restore; //  
        // ""  ""  "" ,   ""  " "   -
        if ( ((Wire_Sensor.Parameter[input]>>SENSOR_SILENT_POSITION) & 0x01) || (event_alarm.Restore) ) 
          Delay_Event.Sirena_Event=0; //  ""     ""
        else 
          Delay_Event.Sirena_Event=1; //  ""  
        
        /*     ""  */
        xStatus = xQueueSendToBack(Queue_Delay_Event, &Delay_Event, 0 );
        if( xStatus != pdPASS )
        {
          /*    .  . */
          
          //      ""     
          Copy_from_Delay_Buffer ();
          
          //    ""   "",     
          if ( (!((Wire_Sensor.Parameter[input]>>SENSOR_SILENT_POSITION) & 0x01)) && (!event_alarm.Restore) ) Sirena (0);
          
          if (!event_alarm.Restore) Check_Out_Pulse_Alarm(event_alarm.Group); //       
          
          if (Save_Event_to_Buffer(event_alarm)) 
          {
            if (!event_alarm.Restore) Wire_Sensor.Time_Out[input]=*(char *)(WIRE_TIME_OUT_LEN+input); //-     
          }
        }
        else
        {
          if (!event_alarm.Restore) Wire_Sensor.Time_Out[input]=*(char *)(WIRE_TIME_OUT_LEN+input); //-     
        }
      }
      else
      {
        //   
        
        //     
        if (!event_alarm.Restore)
        {
          Alarm_File=File_Wire[input];
          Alarm_Voice=1;
        }
        
        //  ,        ""     
        if (!event_alarm.Restore) Copy_from_Delay_Buffer ();
        
        //    ""    ""//,     
        if ( (!((Wire_Sensor.Parameter[input]>>SENSOR_SILENT_POSITION) & 0x01)) && (!event_alarm.Restore) && (!event_alarm.KZ_Obriv) ) Sirena (0);
        
        if (!event_alarm.Restore) Check_Out_Pulse_Alarm(event_alarm.Group); //        
      
        if (Save_Event_to_Buffer(event_alarm)) 
        {
          if ( (!event_alarm.Restore) && (!event_alarm.KZ_Obriv) ) Wire_Sensor.Time_Out[input]=*(char *)(WIRE_TIME_OUT_LEN+input); //-     
        }
      }
}

/*******************************************************************************
* Function Name  : Arm_vxod
* Description    :     ,        / 
* Input          : arm_group - ,    , who - 
*		   None
* Output         : Arm_Delay -     
* Return         : None
*******************************************************************************/
void Arm_vxod(char arm_group, char who)
{
   char i=(char) (10 * ( (Wire_Sensor.Parameter[who-BY_VXOD_1]>>SENSOR_DELAY_POSITION) & 0x07) ); //    
   
   if (i)
	{ 
	 Arm_Delay=i;
	 Delay_arm_group |= arm_group;
         Delay_who=who;
	} 
   else 
	Arm(arm_group,0, who);
}

/*******************************************************************************
* Function Name  : Check_Input_Event
* Description    :      
* Input          : input -  ; in_state -  ; event_alarm -   
*                  Restore_Event -    
*                  KZ_Event -    
*                  Obriv_Event -    
* Output         : None
* Return         : None
*******************************************************************************/  
void Check_Input_Event (char input, unsigned char in_state, TypeDef_EVENT event_alarm, uint16_t Restore_Event, uint16_t KZ_Event, uint16_t Obriv_Event)
{
   char temp, mode= *(char*)(VXOD_MODE+input);
   
   event_alarm.Restore=0;
   event_alarm.KZ_Obriv=0; 

   if (
        (Wire_Sensor.Time_Out[input]==0) ||
        (mode != VXOD_OXRANA)
      )
   {
    temp=Input_Analysis(in_state,input);
    if (temp) 
     {
      /*     Debug-*/
      if ( mode != VXOD_COUNTER )  periodic_print=INPUTS_PERIODIC_PRINT_LEN;
      
      if ( (mode == VXOD_OXRANA) && (!FLAG_PROGRAM_MODE_STATE) ) //     
      {  
        /*      */
        if ( 
              (temp==KZ_CHANGE) || 
              (temp==OBRIV_CHANGE) || 
              (temp==HIGH_CHANGE) || 
              ( (temp==LOW_CHANGE) && (0x01 & ( (* (char *) INPUT_NORMA_EVENT)>>input)) )  
            ) 
         {
          // , ,   ,  
          if (temp==LOW_CHANGE)
          {
            event_alarm.Code_Event=Restore_Event;
            event_alarm.Restore=1;
          }
          
          if (temp==KZ_CHANGE)
          {
            event_alarm.Code_Event=KZ_Event;
            event_alarm.KZ_Obriv=1;            
          }
 
          if (temp==OBRIV_CHANGE)
          {
            event_alarm.Code_Event=Obriv_Event;
            event_alarm.KZ_Obriv=1;            
          }         
          
            //,    ""   ""  / 
            if ( 
                  ( (temp==KZ_CHANGE || temp==OBRIV_CHANGE) && ( ((*(char*)(KZ_OBRIV_24H))>>input) & 0x01) ) || 
                  ((Wire_Sensor.Parameter[input]>>SENSOR_24H_POSITION) & 0x01) 
                )
            {
              Do_Wire_Sensor_Alarm(input, event_alarm);
            }
            else
            {
              if (MODE_ARM_STATE & event_alarm.Group) Do_Wire_Sensor_Alarm(input, event_alarm);
            }
          
          }
        }
      
      if ( ( mode == VXOD_LOW_TO_ARM || mode == VXOD_HIGH_TO_ARM || mode == VXOD_PULSE_TO_ARM ) && (!FLAG_PROGRAM_MODE_STATE) ) // /     
      {      
          switch (mode)
          {
          case VXOD_HIGH_TO_ARM:
              if (temp==HIGH_CHANGE) Arm_vxod(event_alarm.Group, BY_VXOD_1+input); //
              if (temp==LOW_CHANGE) Disarm(event_alarm.Group, BY_VXOD_1+input); //            
            break;
           
          case VXOD_PULSE_TO_ARM:
            if (temp==LOW_CHANGE)
            {
                if ( 
                      ( MODE_ARM_STATE & event_alarm.Group ) || 
                      ( Arm_Delay && (Delay_arm_group & event_alarm.Group) ) 
                    )
                  Disarm(event_alarm.Group, BY_VXOD_1+input);
                else
                  Arm_vxod(event_alarm.Group, BY_VXOD_1+input);
            }
            break;
            
          case VXOD_LOW_TO_ARM:  
              if (temp==LOW_CHANGE) Arm_vxod(event_alarm.Group, BY_VXOD_1+input); //
              if (temp==HIGH_CHANGE) Disarm(event_alarm.Group, BY_VXOD_1+input); //           
            break;
            
          default:
              
              break;
            
          }
          
          if (temp==KZ_CHANGE)
          {
            event_alarm.Code_Event=KZ_Event;
            event_alarm.KZ_Obriv=1;            
          }
 
          if (temp==OBRIV_CHANGE)
          {
            event_alarm.Code_Event=Obriv_Event;
            event_alarm.KZ_Obriv=1;            
          }         
          
          // / 
          if (temp==KZ_CHANGE || temp==OBRIV_CHANGE)
            {
              Do_Wire_Sensor_Alarm(input, event_alarm);
            }          
          
      }
      
      if ( mode == VXOD_COUNTER )
      {
        //  (6-)
          if (temp==LOW_CHANGE)
          {
            Counters[input]++;
            if (Counters[input]>MAX_PULSE) Counters[input]=0;
            Save_Counters_Timeout=SAVE_COUNTERS_TIMEOUT_LEN;
          }
        
        
          if (temp==KZ_CHANGE)
          {
            event_alarm.Code_Event=KZ_Event;
            event_alarm.KZ_Obriv=1;            
          }
 
          if (temp==OBRIV_CHANGE)
          {
            event_alarm.Code_Event=Obriv_Event;
            event_alarm.KZ_Obriv=1;            
          }         
          
          // / 
          if (temp==KZ_CHANGE || temp==OBRIV_CHANGE)
            {
              Do_Wire_Sensor_Alarm(input, event_alarm);
            }          
      }
      
     }
   } 
}

/*******************************************************************************
* Function Name  : Copy_from_Delay_Buffer
* Description    :      ""     
* Input          : None
* Output         : None
* Return         : 0 -   , 1 - ""       
*******************************************************************************/ 
char Copy_from_Delay_Buffer (void)
{

  TypeDef_EVENT                 Event;
  TypeDef_DELAY_EVENT           Delay_Event; /*    */
  char z=1;
 
/* ,    .
       ,      
     ,    .   xSemaphoreTake() 
      ,    . */
 xSemaphoreTake( Mutex_Copy_Delay_Event, portMAX_DELAY );
 { 
  Alarm_Delay=0; //  
  /*      ""  */
  while( xQueueReceive( Queue_Delay_Event, &Delay_Event, 0 ) == pdPASS )
  {
    if (Delay_Event.Sirena_Event==1) {Sirena(0);} // ,    ""
    if (Delay_Event.Sirena_Event==2) {Sirena(60);} //    -  
    if (!Delay_Event.Restore) Check_Out_Pulse_Alarm(Delay_Event.Group); //       
    
    Event.Code_Event=Delay_Event.Code_Event;
    Event.Group =Delay_Event.Group;
    Event.Sensor=Delay_Event.Sensor;
    /*      */
    z=Save_Event_to_Buffer (Event);
  }
 }
 
 /*     ! */
 xSemaphoreGive( Mutex_Copy_Delay_Event );
 
 return z;
}

/*******************************************************************************
* Function Name  : Read_Output
* Description    :         
* Input          : , , 
* Output         : None
* Return         : 1 - , 0 - 
*******************************************************************************/ 
uint8_t Read_Output (GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin, char output)
{
  uint8_t z=GPIO_ReadInputDataBit(GPIOx,GPIO_Pin);
  if ( 0x01 & ( (* (char *) OUTPUT_INVERT)>>output) ) return !z; else return z;
}

/*******************************************************************************
* Function Name  : Set_Output
* Description    :           
* input          : , , 
* Output         : None
* Return         : None 
*******************************************************************************/ 
void Set_Output(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin, char output)
{
  char i;
  
  if ( 0x01 & ( (* (char *) OUTPUT_INVERT)>>output) )
    GPIOx->BRR = GPIO_Pin; //clear output
  else
    GPIOx->BSRR = GPIO_Pin; //set output
  
  
  if ( (!Output_Time_Out[output]) )
    {
      Output_Time_Out[output]= * (uint16_t *) (OUTPUT_TIME_OUT_LEN + 2*output);
    }  
 
  //       
 if ( (*(char*)(OUTPUT_MODE+output)==NORMAL_MODE) || (*(char*)(OUTPUT_MODE+output)==CALL_MODE) )
 { 
   switch (output)
   {
   case OUTPUT_1:
     i=SOCKET_1_ON_COMMAND;
     break;
   case OUTPUT_2:
     i=SOCKET_2_ON_COMMAND;
     break;
   case OUTPUT_3:
     i=SOCKET_3_ON_COMMAND;
     break;
   case OUTPUT_4:
     i=SOCKET_4_ON_COMMAND;
     break;
   default:
     i=0;
     break;
   }   
   
   if (i) xQueueSendToBack(Queue_TRX_Command, & i, 0 ); //      -1..-4   OKO-TRX
 } 
  
}

/*******************************************************************************
* Function Name  : Clear_Output
* Description    :           
* Input          : , , 
* Output         : None
* Return         : None 
*******************************************************************************/ 
void Clear_Output(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin, char output)
{
  char i=0;
  
    if ( 0x01 & ( (* (char *) OUTPUT_INVERT)>>output) )
      GPIOx->BSRR = GPIO_Pin; //set output
    else
      GPIOx->BRR = GPIO_Pin; //clear output
  
      Output_Time_Out[output]= 0;
 
 //            
 if ( (*(char*)(OUTPUT_MODE+output)==NORMAL_MODE) || (*(char*)(OUTPUT_MODE+output)==CALL_MODE) )
 {  
   switch (output)
   {
   case OUTPUT_1:
     i=SOCKET_1_OFF_COMMAND;
     break;
   case OUTPUT_2:
     i=SOCKET_2_OFF_COMMAND;
     break;
   case OUTPUT_3:
     i=SOCKET_3_OFF_COMMAND;
     break;
   case OUTPUT_4:
     i=SOCKET_4_OFF_COMMAND;
     break;
   default:
     i=0;
     break;
   }   
   
   if (i) xQueueSendToBack(Queue_TRX_Command, & i, 0 ); //      -1..-4   OKO-TRX
 }
}

/*******************************************************************************
* Function Name  : Check_Out_Pulse_Alarm
* Description    :          
* Input          : 
* Output         : None
* Return         : 0 -   , !0 -   
*******************************************************************************/ 
char Check_Out_Pulse_Alarm(char group)
{
  char z=0;
  //     NORMAL_MODE  CALL_MODE
  if ( ( (( * (char *) (OUTPUT_MODE + 0))==NORMAL_MODE) || (( * (char *) (OUTPUT_MODE + 0))==CALL_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 0))) ) {z |= (1<<OUTPUT_1); OUT1_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 1))==NORMAL_MODE) || (( * (char *) (OUTPUT_MODE + 1))==CALL_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 1))) ) {z |= (1<<OUTPUT_2); OUT2_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 2))==NORMAL_MODE) || (( * (char *) (OUTPUT_MODE + 2))==CALL_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 2))) ) {z |= (1<<OUTPUT_3); OUT3_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 3))==NORMAL_MODE) || (( * (char *) (OUTPUT_MODE + 3))==CALL_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 3))) ) {z |= (1<<OUTPUT_4); OUT4_ON;}
#ifndef OKO_U2
  if ( ( (( * (char *) (OUTPUT_MODE + 4))==NORMAL_MODE) || (( * (char *) (OUTPUT_MODE + 4))==CALL_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 4))) ) {z |= (1<<OUTPUT_5); OUT5_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 5))==NORMAL_MODE) || (( * (char *) (OUTPUT_MODE + 5))==CALL_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 5))) ) {z |= (1<<OUTPUT_6); OUT6_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 6))==NORMAL_MODE) || (( * (char *) (OUTPUT_MODE + 6))==CALL_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 6))) ) {z |= (1<<OUTPUT_7); OUT7_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 7))==NORMAL_MODE) || (( * (char *) (OUTPUT_MODE + 7))==CALL_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 7))) ) {z |= (1<<OUTPUT_8); OUT8_ON;}
#endif
  
  return z;
}

/*******************************************************************************
* Function Name  : Check_Out_Call
* Description    :        
* Input          : None
* Output         : None
* Return         : 0 -   , !0 -   
*******************************************************************************/ 
char Check_Out_Call( void )
{
  char z=0;
  //     CALL_MODE
  if ( ( * (char *) (OUTPUT_MODE + 0))==CALL_MODE ) {z |= (1<<OUTPUT_1); if (OUT1_STATE) OUT1_OFF else OUT1_ON}
  if ( ( * (char *) (OUTPUT_MODE + 1))==CALL_MODE ) {z |= (1<<OUTPUT_2); if (OUT2_STATE) OUT2_OFF else OUT2_ON}
  if ( ( * (char *) (OUTPUT_MODE + 2))==CALL_MODE ) {z |= (1<<OUTPUT_3); if (OUT3_STATE) OUT3_OFF else OUT3_ON}
  if ( ( * (char *) (OUTPUT_MODE + 3))==CALL_MODE ) {z |= (1<<OUTPUT_4); if (OUT4_STATE) OUT4_OFF else OUT4_ON}
#ifndef OKO_U2
  if ( ( * (char *) (OUTPUT_MODE + 4))==CALL_MODE ) {z |= (1<<OUTPUT_5); if (OUT5_STATE) OUT5_OFF else OUT5_ON}
  if ( ( * (char *) (OUTPUT_MODE + 5))==CALL_MODE ) {z |= (1<<OUTPUT_6); if (OUT6_STATE) OUT6_OFF else OUT6_ON}
  if ( ( * (char *) (OUTPUT_MODE + 6))==CALL_MODE ) {z |= (1<<OUTPUT_7); if (OUT7_STATE) OUT7_OFF else OUT7_ON}
  if ( ( * (char *) (OUTPUT_MODE + 7))==CALL_MODE ) {z |= (1<<OUTPUT_8); if (OUT8_STATE) OUT8_OFF else OUT8_ON}
#endif
  
  return z;
}

/*******************************************************************************
* Function Name  : Check_Out_Pulse_Disarm
* Description    :        
* Input          : 
* Output         : None
* Return         : 0 -   , !0 -   
*******************************************************************************/ 
char Check_Out_Pulse_Disarm(char group)
{
  char z=0;
  //     DISARM_GROUP_MODE  ARM_DISARM_GROUP_MOD
  if ( ( (( * (char *) (OUTPUT_MODE + 0))==DISARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 0))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 0))) ) {z |= (1<<OUTPUT_1); OUT1_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 1))==DISARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 1))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 1))) ) {z |= (1<<OUTPUT_2); OUT2_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 2))==DISARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 2))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 2))) ) {z |= (1<<OUTPUT_3); OUT3_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 3))==DISARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 3))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 3))) ) {z |= (1<<OUTPUT_4); OUT4_ON;}
#ifndef OKO_U2
  if ( ( (( * (char *) (OUTPUT_MODE + 4))==DISARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 4))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 4))) ) {z |= (1<<OUTPUT_5); OUT5_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 5))==DISARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 5))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 5))) ) {z |= (1<<OUTPUT_6); OUT6_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 6))==DISARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 6))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 6))) ) {z |= (1<<OUTPUT_7); OUT7_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 7))==DISARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 7))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 7))) ) {z |= (1<<OUTPUT_8); OUT8_ON;}
#endif
  
  return z;
}

/*******************************************************************************
* Function Name  : Check_Out_Pulse_Arm
* Description    :        
* Input          : 
* Output         : None
* Return         : 0 -   , !0 -   
*******************************************************************************/ 
char Check_Out_Pulse_Arm(char group)
{
  char z=0;
  //     ARM_GROUP_MODE  ARM_DISARM_GROUP_MOD
  if ( ( (( * (char *) (OUTPUT_MODE + 0))==ARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 0))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 0))) ) {z |= (1<<OUTPUT_1); OUT1_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 1))==ARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 1))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 1))) ) {z |= (1<<OUTPUT_2); OUT2_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 2))==ARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 2))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 2))) ) {z |= (1<<OUTPUT_3); OUT3_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 3))==ARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 3))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 3))) ) {z |= (1<<OUTPUT_4); OUT4_ON;}
#ifndef OKO_U2
  if ( ( (( * (char *) (OUTPUT_MODE + 4))==ARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 4))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 4))) ) {z |= (1<<OUTPUT_5); OUT5_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 5))==ARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 5))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 5))) ) {z |= (1<<OUTPUT_6); OUT6_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 6))==ARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 6))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 6))) ) {z |= (1<<OUTPUT_7); OUT7_ON;}
  if ( ( (( * (char *) (OUTPUT_MODE + 7))==ARM_GROUP_MODE) || (( * (char *) (OUTPUT_MODE + 7))==ARM_DISARM_GROUP_MODE) ) && (group & ( * (char *) (OUTPUT_GROUP + 7))) ) {z |= (1<<OUTPUT_8); OUT8_ON;}
#endif
  
  return z;
}
/*******************************************************************************
* Function Name  : Read_Input
* Description    :         
* Input          : , , 
* Output         : None
* Return         : 3 - , 2 - , 1 - , 0 - 
*******************************************************************************/ 
uint8_t Read_Input (GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin, char input)
{
  uint8_t z=GPIO_ReadInputDataBit(GPIOx,GPIO_Pin);
  uint16_t level;
  char type=*(char*)(VXOD_TYPE+input);
  
  //if ( (0x01 & ( (* (char *) INPUT_KZ)>>input)) ||  (0x01 & ( (* (char *) INPUT_OBRIV)>>input)) )
  if ( type )
  {
    //  () -    
    

    
    //     0   
    level=ADC_KZ_PARAM_OKO_LEVEL;
    if (type==OXRANIY) level=ADC_KZ_OXRANIY_LEVEL;
    if (type==PARAM_OXRANIY) level=ADC_KZ_PARAM_OXRANIY_LEVEL; 
    
    if (ADC_value[ADC_INPUT_1+input]<level) return KZ_STATE; //  


    //           
    level=ADC_NORMA_PARAM_OKO_LEVEL;
    if (type==OXRANIY) level=ADC_NORMA_OXRANIY_LEVEL;
    if (type==PARAM_OXRANIY) level=ADC_NORMA_PARAM_OXRANIY_LEVEL;
    if (ADC_value[ADC_INPUT_1+input]<level)
    {
      //     
      if ( 0x01 & ( (* (char *) INPUT_INVERT)>>input) ) 
        //  -      
        return NORMA_STATE; //      
      else 
        return TREVOGA_STATE; //    
    }    

    //           
    level=ADC_TREVOGA_PARAM_OKO_LEVEL;
    if (type==OXRANIY) level=ADC_TREVOGA_OXRANIY_LEVEL;
    if (type==PARAM_OXRANIY) level=ADC_TREVOGA_PARAM_OXRANIY_LEVEL;    
    if (ADC_value[ADC_INPUT_1+input]<level)
    {
      //     
      if ( 0x01 & ( (* (char *) INPUT_INVERT)>>input) ) 
        //  -      
        return TREVOGA_STATE; //      
      else 
        return NORMA_STATE; //   
    }  
    
    //   
    if ( (type==PARAM_OXRANIY) || (type==PARAM_OKO) ) return OBRIV_STATE; //      
    
   
    //   
    if ( 0x01 & ( (* (char *) INPUT_INVERT)>>input) ) 
      //  -     
        return TREVOGA_STATE; //      
      else 
        return NORMA_STATE; //   
      
  }
  else
  {
    //  -  ( )
    if ( 0x01 & ( (* (char *) INPUT_INVERT)>>input) ) 
    {
      //  -     
      if (z) return TREVOGA_STATE; else return NORMA_STATE;
    }
    else
    {
      if (z) return NORMA_STATE; else return TREVOGA_STATE;
    }
    
  }
}
 

/*******************************************************************************
* Function Name  : Update_current_state
* Description    :        Inputs_State, KZ_Obriv_State
* Input          : current_state -  , input -  
* Output         : None
* Return         : 3 - , 2 - , 1 - , 0 - 
*******************************************************************************/       
char Update_current_state (char current_state, char input )
{
        if (current_state==TREVOGA_STATE)
          {
              /*      1 */
              Inputs_State|=(1<<input);
              /*  ,     0 */
              KZ_Obriv_State&=~(1<<input);
              KZ_Obriv_State&=~(1<<(input+8));
              /*      1 */
              return HIGH_CHANGE; 
          }
        
        if (current_state==NORMA_STATE)
          {
              /*      0 */
              Inputs_State&=~(1<<input);
              /*  ,     0 */
              KZ_Obriv_State&=~(1<<input);
              KZ_Obriv_State&=~(1<<(input+8));
              /*      0 */
              return LOW_CHANGE; 
          } 
 
         if (current_state==KZ_STATE)
          {
              /*      1 */
              Inputs_State|=(1<<input);
              /*  =1,  =0 */
              KZ_Obriv_State|=(1<<input);
              KZ_Obriv_State&=~(1<<(input+8));
              /*      KZ */
              return KZ_CHANGE; 
          }
        
         if (current_state==OBRIV_STATE)
          {
              /*      1 */
              Inputs_State|=(1<<input);
              /*  =0,  =1 */
              KZ_Obriv_State&=~(1<<input);
              KZ_Obriv_State|=(1<<(input+8));
              /*      OBRIV */
              return OBRIV_CHANGE; 
          } 
        
        return LOW_CHANGE;     
     
} 

/*******************************************************************************
* Function Name  : Compare_T
* Description    :    
* Input          : T_before -  , T_current -  
* Output         : None
* Return         :  
*******************************************************************************/   
char Compare_T (char T_before, char T_current)
{
  if ((T_before > NO_TEMPERATURE) && (T_current < NO_TEMPERATURE) ) return (256 - T_before + T_current);
  if ((T_before < NO_TEMPERATURE) && (T_current > NO_TEMPERATURE) ) return (256 - T_current + T_before);
  if (T_before>T_current) return (T_before-T_current); else return (T_current-T_before);
}