
#ifndef _TASK_I_O_TIMERS_
  #define _TASK_I_O_TIMERS_

/*       */
  #define INPUT_1                       0
  #define INPUT_2                       1
  #define INPUT_3                       2
  #define INPUT_4                       3
  #define INPUT_5                       4
  #define INPUT_6                       5
  #define INPUT_7                       6
  #define INPUT_8                       7
  #define INPUT_ARM                     8
  #define INPUT_BUTTON                  9
  #define INPUT_EXT_POWER               10
  #define INPUT_MAIN_POWER              11
  #define INPUT_TAMPER		        12
  #define INPUT_INT_POWER               13

  #define INPUT_1_STATE			(0x01 & (Inputs_State>>INPUT_1))
  #define INPUT_2_STATE			(0x01 & (Inputs_State>>INPUT_2))
  #define INPUT_3_STATE			(0x01 & (Inputs_State>>INPUT_3))
  #define INPUT_4_STATE			(0x01 & (Inputs_State>>INPUT_4))
  #define INPUT_5_STATE			(0x01 & (Inputs_State>>INPUT_5))
  #define INPUT_6_STATE			(0x01 & (Inputs_State>>INPUT_6))
  #define INPUT_7_STATE			(0x01 & (Inputs_State>>INPUT_7))
  #define INPUT_8_STATE			(0x01 & (Inputs_State>>INPUT_8))
  #define INPUT_EXT_POWER_STATE		(0x01 & (Inputs_State>>INPUT_EXT_POWER))
  #define INPUT_MAIN_POWER_STATE	(0x01 & (Inputs_State>>INPUT_MAIN_POWER))
  #define INPUT_TAMPER_STATE		(0x01 & (Inputs_State>>INPUT_TAMPER))
  #define INPUT_INT_POWER_STATE		(0x01 & (Inputs_State>>INPUT_INT_POWER))

/*       */
  #define OUTPUT_1                       0
  #define OUTPUT_2                       1
  #define OUTPUT_3                       2
  #define OUTPUT_4                       3
  #define OUTPUT_5                       4
  #define OUTPUT_6                       5
  #define OUTPUT_7                       6
  #define OUTPUT_8                       7
  #define OUTPUT_SIRENA                  8

/*   , mc */
#define I_O_TIMERS_PERIODIC_LEN                 10 // !!!

/*  DEBUG  , 30c */
#define INPUTS_PERIODIC_PRINT_LEN               30000/I_O_TIMERS_PERIODIC_LEN

/*   , ,  / , 100 mc */
#define IN_FILTR_LEN                            100/I_O_TIMERS_PERIODIC_LEN

/*   EXT_POWER -   220, 10000 mc */
#define IN_EXT_POWER_FILTR_LEN               10000/I_O_TIMERS_PERIODIC_LEN

/*   MAIN_POWER -   12 , 60000 mc */
#define IN_MAIN_POWER_FILTR_LEN              60000/I_O_TIMERS_PERIODIC_LEN


/*       */
#define NO_CHANGE                 	0
#define HIGH_CHANGE                 	1
#define LOW_CHANGE                 	2
#define KZ_CHANGE                 	3
#define OBRIV_CHANGE                 	4

/*    */
#define NORMA_STATE                 	0
#define TREVOGA_STATE                 	1
#define KZ_STATE                 	2
#define OBRIV_STATE                 	3


  void Task_I_O_TIMERS ( void *pvParameters );
  char Input_Analysis (unsigned char current_state, char input);
  void Arm (char arm_group, char arm_in_any_case, char who);
  void Disarm (char disarm_group, char who);
  void Program_Mode (void);
  char Save_Event_to_Buffer(TypeDef_EVENT Event);
  void Check_Input_Event (char input, unsigned char in_state, TypeDef_EVENT event_alarm, uint16_t Restore_Event, uint16_t KZ_Event, uint16_t Obriv_Event);
  void Sirena (char beep);
  char Copy_from_Delay_Buffer (void);
  void Set_Output(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin, char output);
  void Clear_Output(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin, char output);
  char Check_Out_Pulse_Alarm(char group);
  char Check_Out_Pulse_Disarm(char group);
  char Check_Out_Pulse_Arm(char group);
  char Check_Out_Call( void );
  uint8_t Read_Input(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin, char input);
  uint8_t Read_Output (GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin, char output);
  char Update_current_state (char current_state, char input );
  char Compare_T (char T_before, char T_current);
  
#endif