
#include "libraries.h"
extern xQueueHandle                     Queue_Print_Debug;
extern xSemaphoreHandle                 Mutex_Flash_Access;
extern xTaskHandle                      pxTask_I_O_TIMERS;
extern xTaskHandle                      pxTask_ADC;
extern xTaskHandle                      pxTask_1WIRE_1;
extern xTaskHandle                      pxTask_1WIRE_2;
extern xTaskHandle                      pxTask_SPI;
extern xTaskHandle                      pxTask_RS485;
extern xTaskHandle                      pxTask_PRINT_DEBUG;
extern xTaskHandle                      pxTask_GSM;
extern xTaskHandle                      pxTask_CORE_IDLE;

extern volatile unsigned short int      Task_1WIRE_1_Alive;
extern volatile unsigned short int      Task_1WIRE_2_Alive;
extern volatile unsigned short int      Task_ADC_Alive;
extern volatile unsigned short int      Task_GSM_Alive;
extern volatile unsigned short int      Task_SPI_Alive;
extern volatile unsigned short int      Task_RS485_Alive;
extern volatile TypeDef_USB_Mode        USB_Mode;
extern volatile unsigned short int      Check_Tasks;
extern volatile char                    Working_Flag[];
extern const char                       SW_Version_Text[];
extern const char                       HW_Version_Text[];
extern volatile unsigned short int      Inputs_State;
extern volatile unsigned short int      KZ_Obriv_State;
extern char                             IMEI_Number[];
extern uint32_t                         Device_Serial_0, Device_Serial_1, Device_Serial_2;

//IWD -   task_Debug
#define T_DEBUG_WD_LEN                  30
volatile char                           T_debug_wd = T_DEBUG_WD_LEN;

/*         */
//extern const char Flash_pointer1[]; 

/*  ""  HWM  */
const char All_Task_Alive[] @ "FLASH"=             "\x0D\x0A ALL TASKS ALIVE";
#if !defined (_1WIRE_1_BLOCKED)
const char Task_1WIRE_1_Dead[] @ "FLASH"=          "\x0D\x0A TASK 1-WIRE_1 DEAD!";
const char HWM_1WIRE_1[] @ "FLASH"=                "\x0D\x0A HWM 1WIRE_1: ";
#endif
#if !defined (_1WIRE_2_BLOCKED)
const char Task_1WIRE_2_Dead[] @ "FLASH"=          "\x0D\x0A TASK 1-WIRE_2 DEAD!";
const char HWM_1WIRE_2[] @ "FLASH"=                "\x0D\x0A HWM 1WIRE_2: ";
#endif
#if !defined (ADC_BLOCKED) 
const char Task_ADC_Dead[] @ "FLASH"=              "\x0D\x0A ATASK ADC DEAD!";
const char HWM_ADC[] @ "FLASH"=                    "\x0D\x0A HWM ADC: ";
#endif
const char Task_GSM_Dead[] @ "FLASH"=              "\x0D\x0A TASK GSM DEAD!";
#if !defined (SPI_BLOCKED)
const char Task_SPI_Dead[] @ "FLASH"=              "\x0D\x0A TASK SPI DEAD!";
const char HWM_SPI[] @ "FLASH"=                    "\x0D\x0A HWM SPI: ";
#endif
#if !defined (RS485_BLOCKED)
const char Task_RS485_Dead[] @ "FLASH"=            "\x0D\x0A TASK RS485 DEAD!";
const char HWM_RS485[] @ "FLASH"=                  "\x0D\x0A HWM RS485: ";
#endif
const char HWM_Core[] @ "FLASH"=                   "\x0D\x0A HWM Core: ";
const char HWM_I_O_TIMERS[] @ "FLASH"=             "\x0D\x0A HWM I_O_TIMERS: ";
const char HWM_PRINT_DEBUG[] @ "FLASH"=            "\x0D\x0A HWM PRINT_DEBUG: ";
const char HWM_GSM[] @ "FLASH"=                    "\x0D\x0A HWM GSM: ";
const char Watch_Dog[] @ "FLASH"=                  "\x0D\x0A Watch Dog";

/*******************************************************************************
* Function Name  : Task_PRINT_DEBUG
* Description    :  -      
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 

void Task_PRINT_DEBUG( void *pvParameters )
{

/*    ""   */
#if !defined (_1WIRE_1_BLOCKED) 
unsigned short int Task_1WIRE_1_Alive_Check=0;
#endif
#if !defined (_1WIRE_2_BLOCKED) 
unsigned short int Task_1WIRE_2_Alive_Check=0;
#endif
#if !defined (ADC_BLOCKED) 
unsigned short int Task_ADC_Alive_Check=0;
#endif
unsigned short int Task_GSM_Alive_Check=0;
#if !defined (SPI_BLOCKED)
unsigned short int Task_SPI_Alive_Check=0;
#endif
#if !defined (RS485_BLOCKED)
unsigned short int Task_RS485_Alive_Check=0;
#endif

/*          DEBUG */
char *task_message[]={
  "\x0D\x0A Core Idle: ",
  "\x0D\x0A 1Wire-1 Send: ",
  "\x0D\x0A 1Wire-1 Receive: ",
  "\x0D\x0A 1Wire-2 Send: ",
  "\x0D\x0A 1Wire-2 Receive: ",
  "\x0D\x0A SPI Send: ",
  "\x0D\x0A SPI Receive: ",
  "\x0D\x0A RS485 Send: ",
  "\x0D\x0A RS485 Receive: ",
  "\x0D\x0A Send to Modem: ",
  "\x0D\x0A Receive from Modem: ",
  "\x0D\x0A ADC: ",
  "\x0D\x0A Inputs: ",
  "\x0D\x0A System: ",
  "\x0D\x0A TEST: ",
  "\x0D\x0A Stack Overflow: ",
  "\x0D\x0A DS1820 Data: ",
  NULL
};  
  
      TypeDef_PRINT_DEBUG xMessage;

      char i,j,temp;
      char temp1[12];
      char *Flash_pointer;
      
      
      
      vTaskDelay(550/portTICK_RATE_MS);
#if !defined (_1WIRE_1_BLOCKED) 
      Task_1WIRE_1_Alive_Check=Task_1WIRE_1_Alive;
#endif
#if !defined (_1WIRE_2_BLOCKED) 
      Task_1WIRE_2_Alive_Check=Task_1WIRE_2_Alive;
#endif
#if !defined (ADC_BLOCKED) 
      Task_ADC_Alive_Check=Task_ADC_Alive;
#endif 
      Task_GSM_Alive_Check=Task_GSM_Alive;
#if !defined (SPI_BLOCKED)
      Task_SPI_Alive_Check=Task_SPI_Alive;
#endif
#if !defined (RS485_BLOCKED)
      Task_RS485_Alive_Check=Task_RS485_Alive;
#endif

 for( ;; ) 
 {
  //IWD -   task_Debug
  T_debug_wd = T_DEBUG_WD_LEN;
  
     /*    - */
  if (USB_Mode==SaveConfigMode)
   {
     FLAG_SAVE_CONFIG_COMMAND_SET;
     vTaskDelay(20/portTICK_RATE_MS);
     i=Save_Config();
     switch (i)
     {
      case 2:
       SendDataToHost ("Er",2);
       break;
      case 1:
       Read_Config_from_EEPROM();
       FLAG_GPRS_INI_COMMAND_SET;
       SendDataToHost ("Ok",2);
       break;
      case 0:
       SendDataToHost ("No",2);
       break;  
      default:
       break;      
     }
     FLAG_SAVE_CONFIG_COMMAND_RESET;
     USB_Mode=UsbIdleMode;
   }

     /*   -   - */
  if (USB_Mode==UploadConfigMode)
   {
	/* ,    .
       ,      
     ,    .   xSemaphoreTake() 
      ,    . */

    xSemaphoreTake( Mutex_Flash_Access, portMAX_DELAY ); //     Flash-

      temp1[0]=0; //CRC
      Flash_pointer= (char *) CONFIGURATOR_BASE_ADDRESS; //Flash_pointer1;
      for(i = 0; i < (32+32); i++) //4 (2 )     4 ( )  
       {
         SendDataToHost (Flash_pointer,128);
         for(j = 0; j < 128; j++)
	  {
	   	temp1[0] ^= *Flash_pointer;
		Flash_pointer ++;
	  }
	 vTaskDelay(60/portTICK_RATE_MS);
       } 
	SendDataToHost (temp1,1);
	USB_Mode=UsbIdleMode;
     /*     ! */
     xSemaphoreGive( Mutex_Flash_Access );
   }


  /*   */
  if (USB_Mode==StateMode)
  {
    //HexToCharExt(temp1,Inputs_State);
    //SendDataToHost (temp1,strlen(temp1));   
    USB_Mode=UsbIdleMode;
  }
  
  
    /*   */
  if (USB_Mode==SWConfigMode)
   {
        SendDataToHost ("SW:",3);
	SendDataToHost (SW_Version_Text,strlen(SW_Version_Text));
	USB_Mode=UsbIdleMode;
   }

  /*  HW-*/
  if (USB_Mode==HandshakeMode)
   {
        SendDataToHost ("HW:",3);
	SendDataToHost (HW_Version_Text,strlen(HW_Version_Text));
	USB_Mode=UsbIdleMode;
   }
  
  /*  IMEI*/
  if (USB_Mode==IMEIMode)
   {
     SendDataToHost ("IMEI:",5);
     if (strlen(IMEI_Number))
	SendDataToHost (IMEI_Number,strlen(IMEI_Number));
     else
       SendDataToHost (" ",1);
     
     USB_Mode=UsbIdleMode;
   }
  

  
  if (USB_Mode==DebugMode || USB_Mode==ModemMode)
   {

    /*        DEBUG-   100 mc*/
    if ( xQueueReceive( Queue_Print_Debug, &xMessage, 10 / portTICK_RATE_MS ) == pdPASS )
     {
       
       /*    USB- */ 
       if ( xMessage.Debug_Data_Len > (USART_RX_DATA_SIZE-32) ) xMessage.Debug_Data_Len = (USART_RX_DATA_SIZE-32);
       
       switch ( xMessage.Debug_Data_type )
        {
        case Debug_Data_type_LONG:
          
          /* print DEBUG LONG data from task */
          SendDataToHost ( task_message[xMessage.Debug_Source_ID],strlen(task_message[xMessage.Debug_Source_ID]));
          //sprintf ( temp1,"%u", xMessage.Debug_Long_Data);
          HexToCharExt(temp1,xMessage.Debug_Long_Data);
          SendDataToHost ( temp1,strlen(temp1));
          
          break;
        
        case Debug_Data_type_HEX:
          
          /* print DEBUG HEX data from task */
          SendDataToHost ( task_message[xMessage.Debug_Source_ID],strlen(task_message[xMessage.Debug_Source_ID]));
          /* i=0 ... xMessage.Debug_Char_Data_Len-1 */
          for(i = 0; i < xMessage.Debug_Data_Len; i++)
          {
            //sprintf (temp1,"%X",*xMessage.Debug_Char_Data);
            HexToCharExt(temp1,*xMessage.Debug_Char_Data);
            xMessage.Debug_Char_Data++;
            SendDataToHost (temp1,strlen(temp1));    
            SendDataToHost ("-",1);
          }

          break;
 
        case Debug_Data_type_2HEX:
          
          /* print DEBUG 2HEX data from task */
          SendDataToHost ( task_message[xMessage.Debug_Source_ID],strlen(task_message[xMessage.Debug_Source_ID]));
          /* i=0 ... xMessage.Debug_Char_Data_Len-1 */
          for(i = 0; i < xMessage.Debug_Data_Len; i++)
          {
            //sprintf (temp1,"%X",*xMessage.Debug_u16_Data);
            HexToCharExt(temp1,*xMessage.Debug_u16_Data);
            xMessage.Debug_u16_Data++;
            SendDataToHost (temp1,strlen(temp1));    
            SendDataToHost ("-",1);
          }
         
          break;
         
        case Debug_Data_type_ASCII:
          /* print DEBUG ASCII data from task */
          if (!(USB_Mode==ModemMode))
            SendDataToHost ( task_message[xMessage.Debug_Source_ID],strlen(task_message[xMessage.Debug_Source_ID]));
          SendDataToHost (xMessage.Debug_Char_Data,xMessage.Debug_Data_Len);
    
            
          break;

        case Debug_Data_type_BIN:
          /* print DEBUG BIN data from task */
          SendDataToHost ( task_message[xMessage.Debug_Source_ID],strlen(task_message[xMessage.Debug_Source_ID]));
          /* i=0 ... xMessage.Debug_Char_Data_Len-1 */
          for(i = 0; i < xMessage.Debug_Data_Len; i++)
          {
            temp=*xMessage.Debug_Char_Data;
            xMessage.Debug_Char_Data++;
            
            for (j=0; j < 8; j++)
            {
              temp1[0]=0x30+(0x01 & (temp>>(7-j)));
              SendDataToHost (temp1,1);    
              SendDataToHost ("-",1);
            }
          }    
            
          break;
          
          
        default:


         break;  
        }

     }
     /****************************/

    


    
    /*  ""  HWM   */
    if ( (!Check_Tasks) && (USB_Mode==DebugMode) )
    {
      Check_Tasks=CHECK_TASKS_LEN;
      i=1;
#if !defined (_1WIRE_1_BLOCKED)
      
      //  "high water mark"   
      SendDataToHost (HWM_1WIRE_1,strlen(HWM_1WIRE_1));
      HexToCharExt(temp1,uxTaskGetStackHighWaterMark(pxTask_1WIRE_1));
      SendDataToHost ( temp1,strlen(temp1));
          
      if (Task_1WIRE_1_Alive_Check==Task_1WIRE_1_Alive)
      {
        i=0;
        SendDataToHost (Task_1WIRE_1_Dead,strlen(Task_1WIRE_1_Dead));
      }
#endif
      
#if !defined (_1WIRE_2_BLOCKED) 
 
       //  "high water mark"   
      SendDataToHost (HWM_1WIRE_2,strlen(HWM_1WIRE_2));
      HexToCharExt(temp1,uxTaskGetStackHighWaterMark(pxTask_1WIRE_2));
      SendDataToHost ( temp1,strlen(temp1));
      
      if (Task_1WIRE_2_Alive_Check==Task_1WIRE_2_Alive)
      {
        i=0;
        SendDataToHost (Task_1WIRE_2_Dead,strlen(Task_1WIRE_2_Dead));
      }
#endif
      
#if !defined (ADC_BLOCKED)

       //  "high water mark"   
      SendDataToHost ( HWM_ADC,strlen(HWM_ADC));
      HexToCharExt(temp1,uxTaskGetStackHighWaterMark(pxTask_ADC));
      SendDataToHost ( temp1,strlen(temp1));
      
      if (Task_ADC_Alive_Check==Task_ADC_Alive)
      {
        i=0;
        SendDataToHost (Task_ADC_Dead,strlen(Task_ADC_Dead));
      }
#endif
 

#if !defined (SPI_BLOCKED)

      //  "high water mark"   
      SendDataToHost ( HWM_SPI,strlen(HWM_SPI));
      HexToCharExt(temp1,uxTaskGetStackHighWaterMark(pxTask_SPI));
      SendDataToHost ( temp1,strlen(temp1));
      
      if (Task_SPI_Alive_Check==Task_SPI_Alive)
      {
        i=0;
        SendDataToHost (Task_SPI_Dead,strlen(Task_SPI_Dead));
      }
#endif

#if !defined (RS485_BLOCKED)

      //  "high water mark"   
      SendDataToHost ( HWM_RS485,strlen(HWM_RS485));
      HexToCharExt(temp1,uxTaskGetStackHighWaterMark(pxTask_RS485));
      SendDataToHost ( temp1,strlen(temp1));
      
      if (Task_RS485_Alive_Check==Task_RS485_Alive)
      {
        i=0;
        SendDataToHost (Task_RS485_Dead,strlen(Task_RS485_Dead));
      }
#endif

       //  "high water mark"   
      SendDataToHost (HWM_GSM,strlen(HWM_GSM));
      HexToCharExt(temp1,uxTaskGetStackHighWaterMark(pxTask_GSM));
      SendDataToHost ( temp1,strlen(temp1)); 
      
      if (Task_GSM_Alive_Check==Task_GSM_Alive)
      {
        i=0;
        SendDataToHost (Task_GSM_Dead,strlen(Task_GSM_Dead));
      }
      
      //  "high water mark"   
      SendDataToHost (HWM_Core,strlen(HWM_Core));
      HexToCharExt(temp1,uxTaskGetStackHighWaterMark(pxTask_CORE_IDLE));
      SendDataToHost ( temp1,strlen(temp1));
      
      //  "high water mark"   
      SendDataToHost (HWM_I_O_TIMERS,strlen(HWM_I_O_TIMERS));
      HexToCharExt(temp1,uxTaskGetStackHighWaterMark(pxTask_I_O_TIMERS));
      SendDataToHost ( temp1,strlen(temp1));
      
      //  "high water mark"   
      SendDataToHost (HWM_PRINT_DEBUG,strlen(HWM_PRINT_DEBUG));
      HexToCharExt(temp1,uxTaskGetStackHighWaterMark(pxTask_PRINT_DEBUG));
      SendDataToHost ( temp1,strlen(temp1));      
      
      if (i) SendDataToHost (All_Task_Alive,strlen(All_Task_Alive));
      
      if (FLAG_WATCH_DOG_STATE) SendDataToHost (Watch_Dog,strlen(Watch_Dog));
      

      // unique ID
      SendDataToHost ("\x0D\x0A ID: ",7);
      HexToCharExt(temp1,Device_Serial_0 );
      SendDataToHost ( temp1,strlen(temp1));
      SendDataToHost ("-",1);
      HexToCharExt(temp1,Device_Serial_1 );
      SendDataToHost ( temp1,strlen(temp1));
      SendDataToHost ("-",1);
      HexToCharExt(temp1,Device_Serial_2 );
      SendDataToHost ( temp1,strlen(temp1));
      
      /*
      char buff[200];
      // Format device signature 
      sprintf(buff, "Device signature: 0x%04X\r\n", TM_ID_GetSignature());
      SendDataToHost (buff,24);
      
      // Format device signature 
      sprintf(buff, "Device revision: 0x%04X\r\n", TM_ID_GetRevision());
      SendDataToHost (buff,strlen(buff));
      // Format flash size 
      sprintf(buff, "Flash size: %u kB\r\n", TM_ID_GetFlashSize()); 
      SendDataToHost (buff,strlen(buff)); 
      // Format unique ID in 8-bit read mode 
      sprintf(buff, "Unique ID in 8-bit read mode: 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X\r\n",
        TM_ID_GetUnique8(0),    // LSB 
        TM_ID_GetUnique8(1),
        TM_ID_GetUnique8(2),
        TM_ID_GetUnique8(3),
        TM_ID_GetUnique8(4),
        TM_ID_GetUnique8(5),
        TM_ID_GetUnique8(6),
        TM_ID_GetUnique8(7),
        TM_ID_GetUnique8(8),
        TM_ID_GetUnique8(9),
        TM_ID_GetUnique8(10),
        TM_ID_GetUnique8(11)    // MSB 
      );  
     SendDataToHost (buff,strlen(buff)); 
      */
      
      
      
#if !defined (_1WIRE_1_BLOCKED)               
      Task_1WIRE_1_Alive_Check=Task_1WIRE_1_Alive;
#endif
#if !defined (_1WIRE_2_BLOCKED) 
      Task_1WIRE_2_Alive_Check=Task_1WIRE_2_Alive;
#endif
#if !defined (ADC_BLOCKED) 
      Task_ADC_Alive_Check=Task_ADC_Alive;
#endif      
      Task_GSM_Alive_Check=Task_GSM_Alive;
#if !defined (SPI_BLOCKED)
      Task_SPI_Alive_Check=Task_SPI_Alive;
#endif
#if !defined (RS485_BLOCKED)
      Task_RS485_Alive_Check=Task_RS485_Alive;
#endif

    }
    
   }
  
    /*     .    
          vTaskDelay(),     
        Blocked    .     '' */
    vTaskDelay(10/portTICK_RATE_MS);       
    
  } 
  
 
    
       /*     ,     (break)  
          ,      
           .  NULL, 
       vTaskDelete(), ,      (, 
       ) . */
    
//    vTaskDelete( NULL ); 
}

/*******************************************************************************
* Function Name  : HexToChar.
* Description    : Convert Hex 8bit value into char.
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/

void HexToChar (char *result , char input)
{
  /* high 4 bits*/
  if ((input>>4) < 10) *(result)=(input>>4)+0x30;
    else *(result)=(input>>4)+0x37;
  
  /* low 4 bits*/
  if ((input&0x0F) < 10) *(result+1)=(input&0x0F)+0x30;
    else *(result+1)=(input&0x0F)+0x37;

  *(result+2)='\0';
}

/*******************************************************************************
* Function Name  : HexToCharExt
* Description    : Convert Hex N Bits value into char.
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void HexToCharExt (char *result, HEX_TO_CHAR_DATA_TYPE input)
{

  char i, current_byte, j=0, z=0;
   
  for (i=0; i < sizeof(HEX_TO_CHAR_DATA_TYPE); i++)
  {
    current_byte=(input >> (sizeof(HEX_TO_CHAR_DATA_TYPE)-i-1)*8);
    if (current_byte) j=1;
    if ((j) || (i==sizeof(HEX_TO_CHAR_DATA_TYPE)-1)) 
    {
      HexToChar ((result+z*2) , current_byte);
      z++;
    }
  }
    
}

