
#include "libraries.h"

extern          xQueueHandle            Queue_Print_Debug;
extern volatile unsigned short int      Task_RS485_Alive;
extern volatile TypeDef_USB_Mode        USB_Mode;
extern volatile char                    GSM_Level;
extern volatile char                    Working_Flag[];
extern volatile TypeDef_TAMPER          Tamper;
extern volatile char                    SIM900_Rx_Buffer[];
extern volatile char                    Mode_Flag[];
extern  TypeDef_RADIO_SENSOR            RF_Sensor;
/* -     RS485-, *10 msec */
extern volatile char			RS485_Rx_Timeout;
/* -      1, *100 msec */
extern volatile char                    Key_Board_1_Command_Timeout;
extern volatile char                    Key_Board_1_Alive_Timeout;
/* -      2, *100 msec */
extern volatile char                    Key_Board_2_Command_Timeout;
extern volatile char                    Key_Board_2_Alive_Timeout;
/* -    1, *10 msec */
extern volatile char                    Piezo_KB1_Timeout;
/* -    2, *10 msec */
extern volatile char                    Piezo_KB2_Timeout;
/*    , * sec */
extern volatile char                    Arm_Delay;
/*  , * sec */
extern volatile char                    Alarm_Delay;

/*         */
extern volatile unsigned short int      Inputs_State;
/*    */
extern volatile unsigned short int      Outputs_State;


volatile char                           RS485_Rx_Position=0;
volatile uint16_t                       RS485_Tx_Position=0;

char                                    RS485_RxBuffer[RS485_RX_BUFFER_SIZE];
char                                    RS485_TxBuffer[RS485_TX_BUFFER_SIZE]; 
volatile char                         * RS485_TxBuffer_Pointer=RS485_TxBuffer;
uint16_t                                rs485_tx_len=RS485_TX_BUFFER_SIZE;
volatile char                           oko_kbm_broadcast_timeout=OKO_KBM_BROADCAST_TIMEOUT_LEN;

//IWD -   task_RS485
#define T_485_WD_LEN                    10
volatile char                           T_485_wd = T_485_WD_LEN;

/*******************************************************************************
* Function Name  : Task_RS485
* Description    :       RS485
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 

void Task_RS485 (void *pvParameters) 
{
  portBASE_TYPE                 xStatus;
  const portTickType            xTicksToWait = 0; 
  portTickType                  xLastWakeTime;
  TypeDef_PRINT_DEBUG           xMessage;
  char oko_kmb=0;
  
/*     
AA-55-A5-ADD-CMD-D1-D2-D3-CRC
AA-55 - 
A5 - 
ADD=0x01 -  
CMD=0x01 -  
D1=0xFF -  1,    
D2=0x0F -  2,    
D3=0xF0 -  3,    
CRC=0xYY -  

*/

/*     
5A-ADD-CMD-D1-D2-D3-CRC

5A - 
ADD=0x01 -  
CMD=0x01 -  
D1=0xFF -  1,    
D2=0x0F -  2,    
D3=0xF0 -  3,    
CRC=0xYY -  

  5A-01-01-0E-00-00-57
*/


  char RS485_RxBuffer_Print[RS485_RX_BUFFER_SIZE];
  char Key_Board_1_Command[KEY_BOARD_BUFFER_SIZE];
  char Key_Board_2_Command[KEY_BOARD_BUFFER_SIZE];
  char *temp_crc;
  char i, offset, crc,add=0x01;
  TypeDef_EVENT Event;

/*  xLastWakeTime    
       .   ,  
         .  xLastWakeTime  
        vTaskDelayUntil(). */
  xLastWakeTime = xTaskGetTickCount();
  
  vTaskDelay(750/portTICK_RATE_MS);
  
  /*        . */
  while (1)
  { 
     /*   ""   */
     Task_RS485_Alive++;
     if ( !oko_kbm_broadcast_timeout && oko_kmb ) 
     {
        oko_kbm_broadcast_timeout=OKO_KBM_BROADCAST_TIMEOUT_LEN;
        //     -
        RS485_TxBuffer[0]=0xAA;
        RS485_TxBuffer[1]=0x55;      
      
        RS485_TxBuffer[2]=0xA5;
        RS485_TxBuffer[3]=OKO_KBM_BROADCAST_ADDRESS;
        #ifndef OKO_U2
          RS485_TxBuffer[4]=BROADCAST_DATA_PRO;
        #else
          RS485_TxBuffer[4]=BROADCAST_DATA_U2;
        #endif 
          
        //     4 ,    4   
        RS485_TxBuffer[4] <<=4;
        if (INPUT_MAIN_POWER_STATE) RS485_TxBuffer[4] |=  0x01;
        if (INPUT_TAMPER_STATE) RS485_TxBuffer[4] |=  0x02;
        if (INPUT_INT_POWER_STATE) RS485_TxBuffer[4] |=  0x04;
        
        RS485_TxBuffer[5]=0x00;
        RS485_TxBuffer[6]=0x00; 
        
        //radiogerkon-1-8 alarm state
        for (i=0; i<8; i++)
        {
          if ( 
            !(0x0001 & (RF_Sensor.Data_Current[i]>>RADIO_SENSOR_STATE)) &&
            ( (RF_Sensor.Data_Current[i] & 0x000F)== RADIO_SENSOR_GERKON  || (RF_Sensor.Data_Current[i] & 0x000F)==RADIO_SENSOR_GERKON_POTENCIAL) 
            )
          {
            RS485_TxBuffer[5] |= (1<<i);
          }
        }
        
        //radiogerkon-1-8 alarm state
        for (i=8; i<16; i++)
        {
          if ( 
            !(0x0001 & (RF_Sensor.Data_Current[i]>>RADIO_SENSOR_STATE)) &&
            ( (RF_Sensor.Data_Current[i] & 0x000F)== RADIO_SENSOR_GERKON  || (RF_Sensor.Data_Current[i] & 0x000F)==RADIO_SENSOR_GERKON_POTENCIAL) 
            )
          {
            RS485_TxBuffer[6] |= (1<< (i-8));
          }
        }
        
        RS485_TxBuffer[7]=MODE_ARM_STATE;       //  -1..-8 
        temp_crc=RS485_TxBuffer;
        temp_crc++;
        temp_crc++;

        /*  CRC */
        crc=0;
        for (i=2; i<RS485_TX_BUFFER_SIZE-1; i++) 
        {
          crc=CRC8(*temp_crc,crc);
          temp_crc++;
        }
        /*     CRC*/ 
        *temp_crc=crc;     
 
        //   ,  
        DRIVER_485_SEND
        vTaskDelay(1/portTICK_RATE_MS);
        RS485_Tx_Position=1;  
        /* send RS485 to UART */
        RS485_TxBuffer_Pointer=RS485_TxBuffer;
        rs485_tx_len=RS485_TX_BUFFER_SIZE;
        USART_SEND_DATA_RS485(*RS485_TxBuffer_Pointer); //   
        //while (RS485_Tx_Position < rs485_tx_len) {} //  
     }
     else
     {
      //add=0x01;
      //   -   1,2
      if (add==0x01) add=0x02; else add=0x01;
 
      
      // 
      //
      RS485_TxBuffer[0]=0xAA;
      RS485_TxBuffer[1]=0x55;      
      
      RS485_TxBuffer[2]=0xA5;
      RS485_TxBuffer[3]=add;
      RS485_TxBuffer[4]=SET_ALL_LED_COMMAND;
      #ifndef OKO_U2
      RS485_TxBuffer[5]=(char) (0x00FF & Inputs_State);
      RS485_TxBuffer[6]=(char) (0x00FF & Outputs_State);
      #else
      RS485_TxBuffer[5]=(char) (0x000F & Inputs_State);
      RS485_TxBuffer[6]=(char) (0x000F & Outputs_State);      
      #endif
      
      //  220 - 0  ,  gsm1..3 - 1..3 , EXT_LED - 4 , piezo -5 ,  - 6 
      
      // 220
      RS485_TxBuffer[7]=INPUT_EXT_POWER_STATE;
       
      //  GSM-
      RS485_TxBuffer[7] &= 0xF1;
      if (GSM_Level>GSM_LEVEL_MEDIUM) 
      {
        RS485_TxBuffer[7] |=  0x0E;
      }
      else
      { 
        if (GSM_Level>GSM_LEVEL_LOW) 
        {
          RS485_TxBuffer[7] |=  0x06;
        }
        else
        {
          if (GSM_Level) RS485_TxBuffer[7] |=  0x02;
        }
      }
     
      //  
      if (LED_STATE) RS485_TxBuffer[7] |=  0x10;
 
      //        ,     
      if ( LED_STATE && (Arm_Delay || Alarm_Delay) ) RS485_TxBuffer[7] |=  0x20;
      
      //    
      if ( (add==0x01) && Piezo_KB1_Timeout) RS485_TxBuffer[7] |=  0x20;
      if ( (add==0x02) && Piezo_KB2_Timeout) RS485_TxBuffer[7] |=  0x20;
        
      // 
      if (SIRENA_STATE) RS485_TxBuffer[7] |=  0x40;  
        
      temp_crc=RS485_TxBuffer;
      temp_crc++;
      temp_crc++;

      /*  CRC */
      crc=0;
      for (i=2; i<RS485_TX_BUFFER_SIZE-1; i++) 
      {
        crc=CRC8(*temp_crc,crc);
        temp_crc++;
      }
      /*     CRC*/ 
      *temp_crc=crc;

      //   ,  
      DRIVER_485_SEND
      vTaskDelay(1/portTICK_RATE_MS);
      RS485_Tx_Position=1;  
      /* send RS485 to UART */
      RS485_TxBuffer_Pointer=RS485_TxBuffer;
      rs485_tx_len=RS485_TX_BUFFER_SIZE;
      USART_SEND_DATA_RS485(*RS485_TxBuffer_Pointer); //   
     
      //   
      RS485_Rx_Position=0;
      RS485_Rx_Timeout=RS485_RX_TIMEOUT_LEN;
      while ( RS485_Rx_Timeout && (RS485_Rx_Position < RS485_RX_BUFFER_SIZE) ) {}
      
      if (RS485_Rx_Position > (RS485_RX_BUFFER_SIZE-1) )
      {
        temp_crc=RS485_RxBuffer;

        /*  CRC */
        crc=0;
        for (i=0; i < (RS485_RX_BUFFER_SIZE-1); i++) 
        {
          crc=CRC8(*temp_crc,crc);
          temp_crc++;
        }
        
        //    
        if ( (crc==RS485_RxBuffer[RS485_RX_BUFFER_SIZE-1]) && (RS485_RxBuffer[0]==0x5A) && (RS485_RxBuffer[1]==add) )
        {
          if (add==1) Key_Board_1_Alive_Timeout=KB_ALIVE_TIMEOUT_LEN;
          if (add==2) Key_Board_2_Alive_Timeout=KB_ALIVE_TIMEOUT_LEN;
          if (RS485_RxBuffer[5]>>4) oko_kmb=1; // 4        -  -
        }
        
        //   
        if ( (crc==RS485_RxBuffer[RS485_RX_BUFFER_SIZE-1]) && (RS485_RxBuffer[0]==0x5A) && (RS485_RxBuffer[1]==add) && (RS485_RxBuffer[2]==KEY_PRESSED_COMMAND) && RS485_RxBuffer[3])
        {
          
          //     Debug-
          for(i = 0; i < RS485_RX_BUFFER_SIZE; i++ )
          {
            RS485_RxBuffer_Print[i]=RS485_RxBuffer[i];
          }
          
          //   - 
          if (Key_Board_1_Command_Timeout==0) {Key_Board_1_Command [0]=0x00;}// Piezo_KB1_Timeout=PIEZO_KB_TIMEOUT_SHORT_LEN;} //clear command KB1
          if (Key_Board_2_Command_Timeout==0) {Key_Board_2_Command [0]=0x00;}// Piezo_KB2_Timeout=PIEZO_KB_TIMEOUT_SHORT_LEN;} //clear command KB2
          
          if (add==1) 
          {
                
		// 
		if ( (RS485_RxBuffer_Print[3]== KEY_TAMPER_OFF) || (RS485_RxBuffer_Print[3]== KEY_TAMPER_ON) )
	 	{
		  	if (RS485_RxBuffer_Print[3]== KEY_TAMPER_OFF) 
                          Event.Code_Event=TAMPER_KB1_ALARM_EVENT;
                        else
                          Event.Code_Event=TAMPER_KB1_NORMA_EVENT;
		  	Event.Group=Tamper.Group ; 
		  	Save_Event_to_Buffer(Event);
	 	}
		else
		{
            		Key_Board_1_Command_Timeout=KEY_BOARD_COMMAND_TIMEOUT_LEN;
                        i=KB_Analize(Key_Board_1_Command, RS485_RxBuffer_Print[3]);
            		if (i==1) Piezo_KB1_Timeout=PIEZO_KB_TIMEOUT_LEN; // 
                        //if (i==0) Piezo_KB1_Timeout=PIEZO_KB_TIMEOUT_SHORT_LEN; // 
		}
          }
          
          if (add==2) 
          {
                
		// 
		if ( (RS485_RxBuffer_Print[3]== KEY_TAMPER_OFF) || (RS485_RxBuffer_Print[3]== KEY_TAMPER_ON) )
	 	{
		  	if (RS485_RxBuffer_Print[3]== KEY_TAMPER_OFF)
                          Event.Code_Event=TAMPER_KB2_ALARM_EVENT;
                        else
                          Event.Code_Event=TAMPER_KB2_NORMA_EVENT;
		  	Event.Group=Tamper.Group ; 
		  	Save_Event_to_Buffer(Event);
	 	}
		else
		{
            		Key_Board_2_Command_Timeout=KEY_BOARD_COMMAND_TIMEOUT_LEN;
                        i=KB_Analize(Key_Board_2_Command, RS485_RxBuffer_Print[3]);
            		if (i==1) Piezo_KB2_Timeout=PIEZO_KB_TIMEOUT_LEN; // 
                        //if (i==0) Piezo_KB2_Timeout=PIEZO_KB_TIMEOUT_SHORT_LEN; // 
		}
          }
          
            
    
          if (USB_Mode==DebugMode)
          {
            xMessage.Debug_Data_Len = RS485_RX_BUFFER_SIZE;
            xMessage.Debug_Source_ID = ReceiveRS485_Debug_ID;
            xMessage.Debug_Char_Data = RS485_RxBuffer_Print;
            xMessage.Debug_Data_type=Debug_Data_type_HEX;
        
            //    DEBUG 
            xStatus = xQueueSendToBack(Queue_Print_Debug, &xMessage, xTicksToWait ); 
            if( xStatus != pdPASS )
            {
            //    .  . 
        
            }
          }
        }
      }
  
     }
     
     /*   RS485_PERIODIC_LEN . */
     /*       RS485_PERIODIC_LEN .  
          vTaskDelay(),    ,  
        portTICK_RATE_MS      .
         xLastWakeTime    
        vTaskDelayUntil(),        xLastWakeTime
         . 
    !!!
      vTaskDelayUntil ,   
    FreeRTOSConfig.h    1 INCLUDE_vTaskDelayUntil.
    */ 
      
    //IWD -   task_RS485
    T_485_wd = T_485_WD_LEN;

    //      -
    if (FLAG_PAGE_OKO_KBM_FW_STATE) 
    {
      
      //       -
      //
      RS485_TxBuffer[0]=0xAA;
      RS485_TxBuffer[1]=0x55;      
      
      RS485_TxBuffer[2]=0xA5;
      RS485_TxBuffer[3]=OKO_KBM_BROADCAST_ADDRESS;
      RS485_TxBuffer[4]=BROADCAST_OKO_KBM_FIRMWARE_LOAD_COMMAND;
      RS485_TxBuffer[5]=0x00;
      RS485_TxBuffer[6]=0x00; 
      RS485_TxBuffer[7]=0x00;       
      temp_crc=RS485_TxBuffer;
      temp_crc++;
      temp_crc++;

      /*  CRC */
      crc=0;
      for (i=2; i<RS485_TX_BUFFER_SIZE-1; i++) 
      {
        crc=CRC8(*temp_crc,crc);
        temp_crc++;
      }
      /*     CRC*/ 
      *temp_crc=crc;

      //   ,  
      DRIVER_485_SEND
      vTaskDelay(1/portTICK_RATE_MS);
      RS485_Tx_Position=1;  
      /* send RS485 to UART */
      RS485_TxBuffer_Pointer=RS485_TxBuffer;
      rs485_tx_len=RS485_TX_BUFFER_SIZE;
      USART_SEND_DATA_RS485(*RS485_TxBuffer_Pointer); //   

      vTaskDelay(2500/portTICK_RATE_MS); //      
      
      for (i=0; i < MAX_PAGE_NUMBER_OKO_KBM; i++) 
      {
        //IWD -   task_RS485
        T_485_wd = 2*T_485_WD_LEN;
        while (!FLAG_PAGE_OKO_KBM_FW_STATE) {}
        offset=SIM900_Rx_Buffer[0];
        
        
        /*  CRC */
        temp_crc=(char*)SIM900_Rx_Buffer;
        temp_crc++;
        temp_crc++; // offset, curr_page, PAGE, 0x0d, 0x0a, 'O', 'K', 0x0d, 0x0a
        if (offset==3) temp_crc++; // offset, 0x0a, curr_page, PAGE, 0x0d, 0x0a, 0x0a, 'O', 'K', 0x0d, 0x0a, 0x0a
        crc=0;
        for (uint16_t count=0; count<OKO_KBM_FLASH_PAGE_SIZE; count++) 
        {
          crc=CRC8(*temp_crc,crc);
          temp_crc++;
        }

        SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(2*offset+2-0)]=crc;
        //   ,  
        DRIVER_485_SEND
        vTaskDelay(1/portTICK_RATE_MS);
        RS485_Tx_Position=1;  
        /* send RS485 to UART */
        RS485_TxBuffer_Pointer=SIM900_Rx_Buffer;
        RS485_TxBuffer_Pointer++; // 0x0d, 0x0a, PAGE, 0x0d, 0x0a, 'O', 'K', 0x0d, 0x0a
        if (offset==3) RS485_TxBuffer_Pointer++; // 0x0d, 0x0a, 0x0a, PAGE, 0x0d, 0x0a, 0x0a, 'O', 'K', 0x0d, 0x0a, 0x0a
        rs485_tx_len=OKO_KBM_FLASH_PAGE_SIZE+5; //curr_page, page_data, crc, "CON" or "END"
        USART_SEND_DATA_RS485(*RS485_TxBuffer_Pointer); //   
        while (RS485_Tx_Position < rs485_tx_len) {} //  
        vTaskDelay(2/portTICK_RATE_MS);
        /*
        if (
              SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(2*offset+2-1)]=='E' &&
              SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(2*offset+2-2)]=='N' &&
              SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(2*offset+2-3)]=='D'
          )
        {
          break;
          //i = MAX_PAGE_NUMBER_OKO_KBM;
        }
        */
        FLAG_PAGE_OKO_KBM_FW_RESET;
      }
      FLAG_PAGE_OKO_KBM_FW_RESET;
    }
    
    vTaskDelayUntil( &xLastWakeTime, ( (RS485_PERIODIC_LEN) / portTICK_RATE_MS ) );     
  }
  
      /*     ,     (break)  
          ,      
           .  NULL, 
       vTaskDelete(), ,      (, 
       ) . */
    
//    vTaskDelete( NULL ); 
}

/*******************************************************************************
* Function Name  : CRC8
* Description    :     - : a^8+a^5+a^4+1
* Input          : data -   , crc -  
* Output         : None
* Return         :  
*******************************************************************************/
char CRC8(char data, char crc)
{
  char i = data ^ crc;
  crc = 0;
  if(i & 0x01) crc ^= 0x5e;
  if(i & 0x02) crc ^= 0xbc;
  if(i & 0x04) crc ^= 0x61;
  if(i & 0x08) crc ^= 0xc2;
  if(i & 0x10) crc ^= 0x9d;
  if(i & 0x20) crc ^= 0x23;
  if(i & 0x40) crc ^= 0x46;
  if(i & 0x80) crc ^= 0x8c;
return crc;
}

/*******************************************************************************
* Function Name  : KB_Analize
* Description    :      
* Input          : Key_Board_Command -     , Pressed_Key -   
* Output         : None
* Return         : 0 - -   , 1 -  , 2 -  
*******************************************************************************/
char KB_Analize (char *Key_Board_Command, char Pressed_Key)
{
  char i, answer=2;

          //   
          i=0;
          while ( (i<(KEY_BOARD_BUFFER_SIZE-1)) && Key_Board_Command[i]) {i++;}
          if ( i<(KEY_BOARD_BUFFER_SIZE-1) )
          { 
              //   
              switch (Pressed_Key)
              {
                case KEY_BOARD_1:
                  Key_Board_Command[i]='1';
                  break;
                case KEY_BOARD_2:
                  Key_Board_Command[i]='2';
                  break;
                case KEY_BOARD_3:
                  Key_Board_Command[i]='3';
                  break;
                case KEY_BOARD_4:
                  Key_Board_Command[i]='4';
                  break;
                case KEY_BOARD_5:
                  Key_Board_Command[i]='5';
                  break;
                case KEY_BOARD_6:
                  Key_Board_Command[i]='6';
                  break;
                case KEY_BOARD_7:
                  Key_Board_Command[i]='7';
                  break;
                case KEY_BOARD_8:
                  Key_Board_Command[i]='8';
                  break;
                case KEY_BOARD_9:
                  Key_Board_Command[i]='9';
                  break;
                case KEY_BOARD_STAR:
                  Key_Board_Command[i]='*';
                  break;
                case KEY_BOARD_0:
                  Key_Board_Command[i]='0';
                  break;
                case KEY_BOARD_HASH:
                  Key_Board_Command[i]='#';
                  break;
                case KEY_BOARD_LEFT:
                  Key_Board_Command[i]='+';
                  break;
                case KEY_BOARD_ENTER:
                  //  
                  //FLAG_KB_COMMAND_SET
                  if ( Analize_Command(Key_Board_Command,0, OKO_KB) ) answer=1; else answer=0;
                  Key_Board_Command [0]=0x00; //clear command KB1
                  //FLAG_KB_COMMAND_RESET
                  break;
                case KEY_BOARD_RIGHT:
                  Key_Board_Command[i]='-';
                  break;
                  
                default:
                  Key_Board_Command[0]=0x00; //clear command KB1
                  break;
                }                 
              Key_Board_Command[i+1]=0x00; //            
          }
          else
          {
            Key_Board_Command[0]=0x00; //clear command KB1
          }
return answer;
}
/*******************************************************************************
* Function Name  : RS485_UART_config
* Description    :   UART
* Input          : USART_TypeDef* USART
* Output         : None
* Return         : None
*******************************************************************************/ 
void RS485_UART_config(void)
{
  GPIO_InitTypeDef  GPIO_InitStruct;
  USART_InitTypeDef USART_InitStructure;
  
  USART_DeInit(RS485_UART);
  
  RCC_APB2PeriphClockCmd(RS485_APB_PERIPH_PIN, ENABLE); 

  /* !!!    UART*/
  if (RS485_UART==USART1)
  {
    RCC_APB2PeriphClockCmd(RS485_APB_PERIPH_UART, ENABLE);
  } 
  else
  {
    RCC_APB1PeriphClockCmd(RS485_APB_PERIPH_UART, ENABLE); 
  }
  
  GPIO_InitStruct.GPIO_Pin = RS485_PIN_TX;
  GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(RS485_PORT, &GPIO_InitStruct);

  GPIO_InitStruct.GPIO_Pin = RS485_PIN_RX;
  GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_Init(RS485_PORT, &GPIO_InitStruct);
  

  
  USART_DeInit(RS485_UART);
  USART_InitStructure.USART_BaudRate = 9600;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_Init(RS485_UART, &USART_InitStructure);
  USART_Cmd(RS485_UART, ENABLE);
  
  NVIC_InitTypeDef NVIC_InitStructure;
  NVIC_InitStructure.NVIC_IRQChannel = RS485_UART_IRQN; 
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; 
  NVIC_Init(&NVIC_InitStructure);  
  
  //NVIC_EnableIRQ(RS485_UART_IRQN);
  USART_ITConfig(RS485_UART, USART_IT_RXNE, ENABLE); //    
  USART_ITConfig(RS485_UART, USART_IT_TC, ENABLE); //     

 
}

/*******************************************************************************
* Function Name  : RS485_PinConfig
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void RS485_PinConfig(void) 
{
  GPIO_InitTypeDef GPIO_InitStructure;
  
/*     RS485_RX_TX */   
  RCC_APB2PeriphClockCmd(RS485_RX_TX_APB_CLOCK , ENABLE);
  GPIO_InitStructure.GPIO_Pin = RS485_RX_TX_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init( RS485_RX_TX_PORT , &GPIO_InitStructure);
  GPIO_SetBits(RS485_RX_TX_PORT, RS485_RX_TX_PIN);  
  
}

/*******************************************************************************
* Function Name  : RS485_UART_IRQHANDLER
* Description    :  RS485_UART
* Input          : 
* Output         : 
* Return         : 
*******************************************************************************/
void RS485_UART_IRQHANDLER (void)
{
 char i;
 
  if ( USART_GetITStatus_RS485(RS485_UART, USART_IT_RXNE)!= RESET ) //      
  {
    USART_ClearITPendingBit_RS485(RS485_UART,USART_IT_RXNE); //   
    /* Receive data */
    i=USART_RECEIVE_DATA_RS485; // 
    
    if (RS485_Rx_Position < RS485_RX_BUFFER_SIZE)
    {
      RS485_RxBuffer[RS485_Rx_Position] = i;
      RS485_Rx_Position++;
      RS485_Rx_Timeout=RS485_RX_TIMEOUT_LEN;
    }
  }

  if ( USART_GetITStatus_RS485(RS485_UART, USART_IT_TC)!= RESET ) //     
    {
        USART_ClearITPendingBit_RS485(RS485_UART,USART_IT_TC); //   
        if ( RS485_Tx_Position < rs485_tx_len )
        {
          /* Transmit Data */
          //USART_SEND_DATA_RS485(RS485_TxBuffer[RS485_Tx_Position]);
          RS485_TxBuffer_Pointer++;
          USART_SEND_DATA_RS485(*RS485_TxBuffer_Pointer);
          RS485_Tx_Position++;
        }
        else
        {
          DRIVER_485_RECEIVE
          RS485_Rx_Timeout=RS485_RX_TIMEOUT_LEN;
        }
    }
  

  
}

void RS485_Config (void)
{
    RS485_PinConfig();
    RS485_UART_config();
    
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);
}



//*************          STM32f10x

/**
  * @brief  Clears the USARTx's interrupt pending bits.
  * @param  USARTx: Select the USART or the UART peripheral. 
  *   This parameter can be one of the following values:
  *   USART1, USART2, USART3, UART4 or UART5.
  * @param  USART_IT: specifies the interrupt pending bit to clear.
  *   This parameter can be one of the following values:
  *     @arg USART_IT_CTS:  CTS change interrupt (not available for UART4 and UART5)
  *     @arg USART_IT_LBD:  LIN Break detection interrupt
  *     @arg USART_IT_TC:   Transmission complete interrupt. 
  *     @arg USART_IT_RXNE: Receive Data register not empty interrupt.
  *   
  * @note
  *   - PE (Parity error), FE (Framing error), NE (Noise error), ORE (OverRun 
  *     error) and IDLE (Idle line detected) pending bits are cleared by 
  *     software sequence: a read operation to USART_SR register 
  *     (USART_GetITStatus()) followed by a read operation to USART_DR register 
  *     (USART_ReceiveData()).
  *   - RXNE pending bit can be also cleared by a read to the USART_DR register 
  *     (USART_ReceiveData()).
  *   - TC pending bit can be also cleared by software sequence: a read 
  *     operation to USART_SR register (USART_GetITStatus()) followed by a write 
  *     operation to USART_DR register (USART_SendData()).
  *   - TXE pending bit is cleared only by a write to the USART_DR register 
  *     (USART_SendData()).
  * @retval None
  */
void USART_ClearITPendingBit_RS485(USART_TypeDef* USARTx, uint16_t USART_IT)
{
  uint16_t bitpos = 0x00, itmask = 0x00;

  bitpos = USART_IT >> 0x08;
  itmask = ((uint16_t)0x01 << (uint16_t)bitpos);
  USARTx->SR = (uint16_t)~itmask;
}

/**
  * @brief  Checks whether the specified USART interrupt has occurred or not.
  * @param  USARTx: Select the USART or the UART peripheral. 
  *   This parameter can be one of the following values:
  *   USART1, USART2, USART3, UART4 or UART5.
  * @param  USART_IT: specifies the USART interrupt source to check.
  *   This parameter can be one of the following values:
  *     @arg USART_IT_CTS:  CTS change interrupt (not available for UART4 and UART5)
  *     @arg USART_IT_LBD:  LIN Break detection interrupt
  *     @arg USART_IT_TXE:  Tansmit Data Register empty interrupt
  *     @arg USART_IT_TC:   Transmission complete interrupt
  *     @arg USART_IT_RXNE: Receive Data register not empty interrupt
  *     @arg USART_IT_IDLE: Idle line detection interrupt
  *     @arg USART_IT_ORE:  OverRun Error interrupt
  *     @arg USART_IT_NE:   Noise Error interrupt
  *     @arg USART_IT_FE:   Framing Error interrupt
  *     @arg USART_IT_PE:   Parity Error interrupt
  * @retval The new state of USART_IT (SET or RESET).
  */
ITStatus USART_GetITStatus_RS485(USART_TypeDef* USARTx, uint16_t USART_IT)
{
  #define IT_Mask                   ((uint16_t)0x001F)  /*!< USART Interrupt Mask */
  uint32_t bitpos = 0x00, itmask = 0x00, usartreg = 0x00;
  ITStatus bitstatus = RESET;

   /* Get the USART register index */
  usartreg = (((uint8_t)USART_IT) >> 0x05);
  /* Get the interrupt position */
  itmask = USART_IT & IT_Mask;
  itmask = (uint32_t)0x01 << itmask;
  
  if (usartreg == 0x01) /* The IT  is in CR1 register */
  {
    itmask &= USARTx->CR1;
  }
  else if (usartreg == 0x02) /* The IT  is in CR2 register */
  {
    itmask &= USARTx->CR2;
  }
  else /* The IT  is in CR3 register */
  {
    itmask &= USARTx->CR3;
  }
  
  bitpos = USART_IT >> 0x08;
  bitpos = (uint32_t)0x01 << bitpos;
  bitpos &= USARTx->SR;
  if ((itmask != (uint16_t)RESET)&&(bitpos != (uint16_t)RESET))
  {
    bitstatus = SET;
  }
  else
  {
    bitstatus = RESET;
  }
  
  return bitstatus;  
}


