#ifndef _TASK_RS485_
  #define _TASK_RS485_

  #define RS485_RX_BUFFER_SIZE          7
  #define RS485_TX_BUFFER_SIZE          9
  #define KEY_BOARD_BUFFER_SIZE         30
  #define KEY_BOARD_COMMAND_TIMEOUT_LEN 50
  #define KB_ALIVE_TIMEOUT_LEN          20

  #define PIEZO_KB_TIMEOUT_LEN          1000/I_O_TIMERS_PERIODIC_LEN
  #define PIEZO_KB_TIMEOUT_SHORT_LEN    300/I_O_TIMERS_PERIODIC_LEN

  /*    */
  #define KEY_BOARD_1                       1
  #define KEY_BOARD_2                       2
  #define KEY_BOARD_3                       3
  #define KEY_BOARD_4                       4
  #define KEY_BOARD_5                       5
  #define KEY_BOARD_6                       6
  #define KEY_BOARD_7                       7
  #define KEY_BOARD_8                       8
  #define KEY_BOARD_9                       9
  #define KEY_BOARD_STAR                    10
  #define KEY_BOARD_0                       11
  #define KEY_BOARD_HASH                    12
  #define KEY_BOARD_LEFT                    13
  #define KEY_BOARD_ENTER                   14
  #define KEY_BOARD_RIGHT                   15
  #define KEY_TAMPER_ON                     16
  #define KEY_TAMPER_OFF                    17

  /*   , mc */
  #define RS485_PERIODIC_LEN            100

  /* -   , *10 mc */
  #define RS485_RX_TIMEOUT_LEN          8

  #define OKO_KBM_BROADCAST_TIMEOUT_LEN 20 //*100mc

  //  -  
  #define SET_ALL_LED_COMMAND		                0x01
  //  
  #define RESTART_COMMAND		                0x02

  #define BROADCAST_DATA_U2		                0x03 // 4-     
  #define BROADCAST_DATA_PRO		                0x04 // 4-     
  //      OKO-KBM
  #define BROADCAST_OKO_KBM_FIRMWARE_LOAD_COMMAND	0x05 // 4-     

/*       - */ 
  #define OKO_KBM_FLASH_PAGE_SIZE       1024


  #define MAX_PAGE_NUMBER_OKO_KBM       25

  //     OKO-KBM
  #define OKO_KBM_BROADCAST_ADDRESS	0xFF

  //  -   
  #define KEY_PRESSED_COMMAND		0x01

 // " - "  
 #define ALIVE_COMMAND			0x02

  #define  USART_RECEIVE_DATA_RS485             (uint8_t)(RS485_UART->DR)
  #define  USART_SEND_DATA_RS485(DATA)          (RS485_UART->DR = DATA)

  void RS485_UART_config(void);
  void RS485_PinConfig(void);
  void RS485_Config (void);
  void Task_RS485( void *pvParameters );
  char CRC8(char data, char crc);
  char KB_Analize (char *Key_Board_Command, char Pressed_Key);

  
//          STM32f10x  
  void USART_ClearITPendingBit_RS485(USART_TypeDef* USARTx, uint16_t USART_IT);
  ITStatus USART_GetITStatus_RS485(USART_TypeDef* USARTx, uint16_t USART_IT);


#endif