#include "libraries.h"

extern  xQueueHandle 			Queue_Print_Debug, Queue_Event, Queue_Delay_Event, Queue_TRX_Command;
extern volatile unsigned short int      Task_SPI_Alive;
extern volatile TypeDef_USB_Mode        USB_Mode;
extern volatile char			Program_Mode_Timeout;
extern volatile char			LED_Short_Flash;
extern volatile char			LED_Long_Flash;
extern volatile char                    Working_Flag[];
extern volatile char                    Mode_Flag[];
extern volatile char			RF_Data_Timeout;
extern  TypeDef_RADIO_SENSOR            RF_Sensor;
extern volatile char                    oko_rf_pro_version;
extern char *                           File_Radio[];
extern volatile char                    Alarm_Voice; 
extern char*                            Alarm_File;
extern volatile char                    SIM900_Rx_Buffer[];
extern uint32_t                         Device_Serial_0, Device_Serial_1, Device_Serial_2;

/*  , * sec */
extern volatile char                    Alarm_Delay;
//IWD -   task_SPI
#define T_SPI_WD_LEN                    10
volatile char                           T_spi_wd = T_SPI_WD_LEN;

/*******************************************************************************
* Function Name  : Task_SPI
* Description    :        SPI
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void Task_SPI (void *pvParameters) 
{

  
  //       OKO-RF-PRO -     SPI
  char i, crc, offset, length, sensor, oko_rf;
  //  0  4 -      (4- -    ), 5-  -  CRC, 6-    , 7 -  
  char RF_Sensor_Data[]={0,0,0,0,0,0,0,0};
  char RF_Sensor_Data_Print[]={0,0,0,0,0,0,0,0}; 
  char RF_Sensor_Data_Before[]={0,0,0,0}; //    
  char temp[5];
  char *temp_crc;
  uint16_t count;
   
  portBASE_TYPE xStatus;
  const portTickType xTicksToWait = 0; 
  portTickType  xLastWakeTime;
  TypeDef_PRINT_DEBUG xMessage;
  TypeDef_EVENT Event;
  
/*  xLastWakeTime    
       .   ,  
         .  xLastWakeTime  
        vTaskDelayUntil(). */
  xLastWakeTime = xTaskGetTickCount();
  
  vTaskDelay(400/portTICK_RATE_MS);
  
 
  /*        . */
  while (1)
  { 
 
     /*   ""   */
     Task_SPI_Alive++;

     RF_Sensor_Data[6]=0; //   
     //      OKO-RF-PRO      
     oko_rf=1;
     //if (SPI_Write_Read ('o')!= 'O') crc=1;
     SPI_Write_Read ('o');
     if (SPI_Write_Read ('k')!= 'K') oko_rf=0;
     if (SPI_Write_Read ('o')!= 'O') oko_rf=0;
     if (SPI_Write_Read ('r')!= 'R') oko_rf=0;
     if (SPI_Write_Read ('f')!= 'F') oko_rf=0;

      RF_Sensor_Data[6]=GET_EVENT_COMMAND;

      for (i = 0; i < 5; i++ )
      {
        temp[i]=0x55;
      }
      
      if ( oko_rf_pro_version>>4 ) //0x0N -   oko-rf
      {
        //  oko-TRX
        /*      -TRX */
        if( xQueueReceive( Queue_TRX_Command, & i, 0 ) == pdPASS )
        {
          RF_Sensor_Data[6]=i;
          if ( (RF_Sensor_Data[6]>=SOCKET_1_OFF_COMMAND) && (RF_Sensor_Data[6]<=SOCKET_4_ON_COMMAND) )
          {
            temp[0]=((*(char*)(SOCKET_CODE))<<3); // 5-   
          }
          else
          if ( (RF_Sensor_Data[6] == ARM_COMMAND) || (RF_Sensor_Data[6] == DISARM_COMMAND) || (RF_Sensor_Data[6] == ALARM_COMMAND) )
          {
            //     24      
            temp[0]=(char)((((0xFF & (Device_Serial_0>>0))^(0xFF & (Device_Serial_0>>8)))^(0xFF & (Device_Serial_0>>16)))^(0xFF & (Device_Serial_0>>24))) ;
            temp[1]=(char)((((0xFF & (Device_Serial_1>>0))^(0xFF & (Device_Serial_1>>8)))^(0xFF & (Device_Serial_1>>16)))^(0xFF & (Device_Serial_1>>24))) ;
            temp[2]=(char)((((0xFF & (Device_Serial_2>>0))^(0xFF & (Device_Serial_2>>8)))^(0xFF & (Device_Serial_2>>16)))^(0xFF & (Device_Serial_2>>24))) ;
          }
        }
      }
      
      RF_Sensor_Data[6]=SPI_Write_Read(RF_Sensor_Data[6]); //   -   
      

      
      /*       5   -    */
      crc=0; //  CRC 
      for(i = 0; i < 5; i++ )
      {
        RF_Sensor_Data[i]=SPI_Write_Read(temp[i]);
        if (i!=4 ) 
        {crc^=RF_Sensor_Data[i];}
        else
        { 
          RF_Sensor_Data[5]= ( (crc & 0xF0)^(~(crc<<4)) ) & 0xF0;
          crc = RF_Sensor_Data[5]-RF_Sensor_Data[i];
        }
       } 
      
   
    //            
    if (crc==0) SPI_Write_Read ('e'); else SPI_Write_Read ('n');
      
    oko_rf_pro_version=RF_Sensor_Data[6]; //   
      
    /*      ,    */
    if ( (RF_Sensor_Data[0]==0x00) && (RF_Sensor_Data[1]==0x00) && (RF_Sensor_Data[2]==0x00) ) {crc=1;}
    if ( (RF_Sensor_Data[0]==0x00) && (RF_Sensor_Data[1]==0x04) && (RF_Sensor_Data[2]==0x28) && (RF_Sensor_Data[2]==0x01) ) {crc=1;}
    if ( (RF_Sensor_Data[0]==0x00) && (RF_Sensor_Data[1]==0x00) && (RF_Sensor_Data[2]==0x28) && (RF_Sensor_Data[2]==0x05) ) {crc=1;}
    if ( (RF_Sensor_Data[0]==0x00) && (RF_Sensor_Data[1]==0x00) && (RF_Sensor_Data[2]==0x2D) && (RF_Sensor_Data[2]==0x55) ) {crc=1;}
 
 sensor=0;
 
 i=RF_Sensor_Data[3] & 0x0F;
 if (
	(i==RADIO_SENSOR_TERMO) ||
	(i==RADIO_SENSOR_PIR) ||
	(i==RADIO_SENSOR_POZHAR) ||
	(i==RADIO_SENSOR_GERKON) ||
        (i==RADIO_SENSOR_GERKON_POTENCIAL) ||
	(i==RADIO_SENSOR_TERMO_REPITER) ||
	(i==RADIO_BRELOK) ||
	(i==RADIO_BUTTON)

    )
   
  {

    //          -,    
    if (
        (RF_Sensor_Data[0]==RF_Sensor_Data_Before[0]) && 
	(RF_Sensor_Data[1]==RF_Sensor_Data_Before[1]) && 
	(RF_Sensor_Data[2]==RF_Sensor_Data_Before[2]) && 
	(RF_Sensor_Data[3]==RF_Sensor_Data_Before[3]) && 
	(RF_Data_Timeout!=0)
          ) 
     {
	crc=1;
     }
     else
     {
	if (crc==0)
	 {
       	  //       
     	  for(i = 0; i < 4; i++ )
     	  {
       	    RF_Sensor_Data_Before[i]=RF_Sensor_Data[i];
     	  } 
	  /* -      , *100 msec */
          //       ,    -  -,  - 
    	  if (	FLAG_PROGRAM_MODE_STATE || 		   (
		((RF_Sensor_Data[3] & 0x0F)==RADIO_BRELOK) && 
		((RF_Sensor_Data[3] & 0xF0)!=RADIO_PANIC)  ) 
	     ) RF_Data_Timeout=15; else RF_Data_Timeout=100; 
	}
     }
 
   //         
   if (crc==0)
   {
     oko_rf_pro_version=RF_Sensor_Data[6]; //   
     //     Debug-
     for(i = 0; i < 7; i++ )
      {
       	 RF_Sensor_Data_Print[i]=RF_Sensor_Data[i];
      }
     RF_Sensor_Data_Print[7]=0; //  

     /* , ""    */
     //     2  ,  - 3  
     if ( 
         ((RF_Sensor_Data[3] & 0x0F)==RADIO_SENSOR_TERMO) ||
         ((RF_Sensor_Data[3] & 0x0F)==RADIO_SENSOR_TERMO_REPITER)  
         ) 
        length=2; 
      else 
        length=3; 
     
     //    / -  
     sensor = Check_Sensor(RF_Sensor_Data,length); 
        
     /*    ,      */
     if (FLAG_PROGRAM_MODE_STATE)
     {
	/*            ,        */
	Program_Mode_Timeout=PROGRAM_MODE_TIMEOUT_LEN; //  
	if (sensor==0) sensor=Save_Sensor(RF_Sensor_Data); //      ,   
        
        Sirena(1); //   
        LED_OFF;
        LED_Long_Flash=0;
        LED_Short_Flash=2; //1   
      }
      else
      {
	//    
        if (sensor!=0) 
	{
	 /*  "" / */

	 //  /  
	 if ( ((RF_Sensor_Data[3] & 0x0F)==RADIO_BRELOK) || ((RF_Sensor_Data[3] & 0x0F)==RADIO_BUTTON) )
	  {
            //     ,   ""  (3  4  ) 
	    RF_Sensor.Data_Current[sensor-1]=(( (unsigned short int)(0x00FF & RF_Sensor_Data[2]) )<<8) | (unsigned short int)(0x00FF & RF_Sensor_Data[3]);
            
            if ((RF_Sensor_Data[3] & 0x0F)==RADIO_BRELOK)
            {
              // 
              switch (RF_Sensor_Data[3] & 0xF0)
              {
	      //  
              case RADIO_BRELOK_ARMED: 
                Arm( *(char*)(RF_BRELOK_ARM_BUTTON+sensor-1) , 0, sensor + BRELOK_1 - 1); //(ALL_GROUP);
                break;

               //   
              case RADIO_BRELOK_HOME: 
                Arm( *(char*)(RF_BRELOK_HOME_BUTTON+sensor-1) , 0, sensor + BRELOK_1 - 1); //(GROUP_HOME_DEFAULT);
                break;
                
	      //  
              case RADIO_BRELOK_DISARMED: 
                Disarm( *(char*)(RF_BRELOK_DISARM_BUTTON+sensor-1), sensor + BRELOK_1 - 1 ); //(ALL_GROUP);
                break;

	      // 
              case RADIO_PANIC: 
                 //     
                Alarm_File=File_Radio[sensor-1];
                Alarm_Voice=1;
        
                Event.Code_Event=RADIO_SENSOR1_PANIC_EVENT+EVENTS_PER_RADIO_SENSOR*(sensor-1);
                Event.Group=RF_Sensor.Group[sensor-1];
                Event.Sensor=sensor;
		Save_Event_to_Buffer(Event);
                break;

              default: 
                break;
              }
            }
            
            if ((RF_Sensor_Data[3] & 0x0F)==RADIO_BUTTON)
            {
              // 
              switch (RF_Sensor_Data[3] & 0xF0)
              {
	      // 
              case RADIO_BUTTON_PANIC: 
                 //     
                Alarm_File=File_Radio[sensor-1];
                Alarm_Voice=1;
                
                Event.Code_Event=RADIO_SENSOR1_PANIC_EVENT+EVENTS_PER_RADIO_SENSOR*(sensor-1);
                Event.Group=RF_Sensor.Group[sensor-1];
                Event.Sensor=sensor;
		Save_Event_to_Buffer(Event);
                break;

              default: 
                break;
              }
            }            
            
	  }
	  else
	  {
	   // 

           //     ,   ""  (3  4  ),        
	   RF_Sensor.Data_Current[sensor-1]=(( (unsigned short int)(0x00FF & RF_Sensor_Data[2]) )<<8) | (unsigned short int)(0x00FF & RF_Sensor_Data[3]) | (unsigned short int)(0x0001 << RADIO_PERIOD_STATE);
	   
           //  -  -    -   
           RF_Sensor.Time_Out[sensor-1]=RF_TIMEOUT_LEN ; //minuts

	   // ,      ,     -    
	   if ((RF_Sensor.Data_Before[sensor-1]!=RF_Sensor.Data_Current[sensor-1]) || (RF_Sensor.Same_Data_Time_Out[sensor-1]==0) )
	    {
	      //     
	      RF_Sensor.Data_Before[sensor-1] |=(unsigned short int) (0x0001 << RADIO_PERIOD_STATE);
 
	      //  -     
	      RF_Sensor.Same_Data_Time_Out[sensor-1]=*(char *) (RF_TIME_OUT_LEN+sensor-1); //            

	      //   
	      if ( (0x0001&(RF_Sensor.Data_Before[sensor-1]>>RADIO_TAMPER_STATE)) != (0x0001 & (RF_Sensor.Data_Current[sensor-1]>>RADIO_TAMPER_STATE)) )
		{
	         //   
		 if ( 0x0001 & (RF_Sensor.Data_Current[sensor-1]>>RADIO_TAMPER_STATE) )
		  {
		   //     1 
	           RF_Sensor.Data_Before[sensor-1] |= (unsigned short int)(1<<RADIO_TAMPER_STATE);
		  }
		  else
		  {
		   //     0  
	           RF_Sensor.Data_Before[sensor-1] &= (unsigned short int)~(1<<RADIO_TAMPER_STATE);
		   // 
                   Event.Code_Event=RADIO_SENSOR1_TAMPER_EVENT+EVENTS_PER_RADIO_SENSOR*(sensor-1);
                   Event.Group=RF_Sensor.Group[sensor-1];
                   Event.Sensor=sensor;
		   Save_Event_to_Buffer(Event);
		  }
		}

	      //    
	      if ( (0x0001 & (RF_Sensor.Data_Before[sensor-1]>>RADIO_BATT_STATE)) != (0x0001 & (RF_Sensor.Data_Current[sensor-1]>>RADIO_BATT_STATE)) )
		{
	         //   
		 if ( 0x0001 & (RF_Sensor.Data_Current[sensor-1]>>RADIO_BATT_STATE) )
		  {
		   //     1 
	           RF_Sensor.Data_Before[sensor-1] |= (unsigned short int)(1<<RADIO_BATT_STATE);
		  }
		  else
		  {
		   //     0  
	           RF_Sensor.Data_Before[sensor-1] &= (unsigned short int)~(1<<RADIO_BATT_STATE);
		   // 
                   Event.Code_Event=RADIO_SENSOR1_BATT_EVENT+EVENTS_PER_RADIO_SENSOR*(sensor-1);
                   Event.Group=RF_Sensor.Group[sensor-1];
                   Event.Sensor=sensor;
		   Save_Event_to_Buffer(Event);
		  }
		}

	      //   
	      if ( (0x0001 & (RF_Sensor.Data_Before[sensor-1]>>RADIO_SENSOR_STATE)) != (0x0001 & (RF_Sensor.Data_Current[sensor-1]>>RADIO_SENSOR_STATE)) )
		{
	         //   
		 if ( 0x0001 & (RF_Sensor.Data_Current[sensor-1]>>RADIO_SENSOR_STATE) )
		  {
		   //     1 
	           RF_Sensor.Data_Before[sensor-1] |= (unsigned short int)(1<<RADIO_SENSOR_STATE);
                   
		   //       ,    
		   if ( (MODE_ARM_STATE & RF_Sensor.Group[sensor-1]) && ( (RF_Sensor.Data_Current[sensor-1] & 0x000F)== RADIO_SENSOR_GERKON  || (RF_Sensor.Data_Current[sensor-1] & 0x000F)==RADIO_SENSOR_GERKON_POTENCIAL) ) 
                    {
                      Event.Code_Event=RADIO_SENSOR1_NORMA_EVENT+EVENTS_PER_RADIO_SENSOR*(sensor-1); 
                      Event.Group=RF_Sensor.Group[sensor-1];
                      Event.Sensor=sensor;
                      Save_Event_to_Buffer(Event);
                    }
                   
		  }
		  else
		  {
                    //     0  
                    RF_Sensor.Data_Before[sensor-1] &= (unsigned short int)~(1<<RADIO_SENSOR_STATE);
                    Event.Code_Event=RADIO_SENSOR1_ALARM_EVENT+EVENTS_PER_RADIO_SENSOR*(sensor-1);
                    Event.Group=RF_Sensor.Group[sensor-1];
                    Do_RF_Sensor_Alarm(sensor, Event);
 		  }
		}
                else
                {
                  //   
                  // ,    0      
                  if ( 
                      !( ((RF_Sensor.Data_Current[sensor-1] & 0x000F)==RADIO_SENSOR_GERKON) || ((RF_Sensor.Data_Current[sensor-1] & 0x000F)==RADIO_SENSOR_GERKON_POTENCIAL) ) &&  //   
                      !(0x0001 & (RF_Sensor.Data_Current[sensor-1]>>RADIO_SENSOR_STATE)) 
                      )
		  {
                    Event.Code_Event=RADIO_SENSOR1_ALARM_EVENT+EVENTS_PER_RADIO_SENSOR*(sensor-1);
                    Event.Group=RF_Sensor.Group[sensor-1];
                    Do_RF_Sensor_Alarm(sensor, Event);
                  }                 
                }
              
             //     
             RF_Sensor.Data_Before[sensor-1]=(0xFF0F & RF_Sensor.Data_Current[sensor-1]) | (0x00F0 & RF_Sensor.Data_Before[sensor-1]) ;
	   }
	 }
        }
      }
   }

  }
     
    if ( (USB_Mode==DebugMode) && (crc==0) && oko_rf )
      {
        RF_Sensor_Data_Print[7]=sensor; // 
	xMessage.Debug_Data_Len = 8;
	xMessage.Debug_Source_ID = ReceiveSPI_Debug_ID;
        xMessage.Debug_Char_Data = RF_Sensor_Data_Print;
        xMessage.Debug_Data_type=Debug_Data_type_HEX;
        
        /*   .
          -   .  
          ,     pvParameters.
            - ,    
          Blocked,      ,
            */
        xStatus = xQueueSendToBack(Queue_Print_Debug, &xMessage, xTicksToWait );
        if( xStatus != pdPASS )
          {
            /*    ,    xTicksToWait .
             . */
         
          }
      }    
    //IWD -   task_SPI
     T_spi_wd = T_SPI_WD_LEN;   

    //      -TRX
    if (FLAG_PAGE_OKO_TRX_FW_STATE) 
    {
      
      //     -TRX
      vTaskDelay(150/portTICK_RATE_MS); //150msec pause
      SPI_Write_Read ('o');
      SPI_Write_Read ('k');
      SPI_Write_Read ('o');
      SPI_Write_Read ('r');
      SPI_Write_Read ('f');
      SPI_Write_Read (OKO_TRX_FIRMWARE_LOAD_COMMAND);

      vTaskDelay(2500/portTICK_RATE_MS); //      
      
      for (i=0; i < MAX_PAGE_NUMBER_OKO_RF; i++) 
      {
        //IWD -   task_SPI
        T_spi_wd = 2*T_SPI_WD_LEN; 
        
        while (!FLAG_PAGE_OKO_TRX_FW_STATE) {}
        
        offset=SIM900_Rx_Buffer[0];
        
        
        /*  CRC */
        temp_crc=(char*)SIM900_Rx_Buffer;
        temp_crc++;
        temp_crc++; // offset, curr_page, PAGE, 0x0d, "CON", 0x0d, 0x0a
        if (offset==3) temp_crc++; // offset, 0x0a, curr_page, PAGE, 0x0d, "CON", 'K', 0x0d, 0x0a, 0x0a
        crc=0;
        for (count=0; count<OKO_TRX_FLASH_PAGE_SIZE; count++) 
        {
          crc=CRC8(*temp_crc,crc);
          temp_crc++;
        }

        SIM900_Rx_Buffer[OKO_TRX_FLASH_PAGE_SIZE+3*offset+2-(2*offset+2-0)]=crc;
        
        //   
        for (count=0; count < (OKO_TRX_FLASH_PAGE_SIZE+5); count++)  //curr_page, page_data, crc, "CON"
        {
          SPI_Write_Read (SIM900_Rx_Buffer[offset-1+count]);
        }        
        
        FLAG_PAGE_OKO_TRX_FW_RESET;
      }
      FLAG_PAGE_OKO_TRX_FW_RESET;
    }
   
    /*   -  SPI_PERIODIC_LEN . */
    vTaskDelayUntil( &xLastWakeTime, ( SPI_PERIODIC_LEN / portTICK_RATE_MS ) );
  }

  
}

/*******************************************************************************
* Function Name  : Check_Sensor
* Description    :        
* Input          : Sensor_Data -      
*                  length -    -  ID  
* Output         : None
* Return         : !0 -      , 0 -     
*******************************************************************************/ 
char Check_Sensor (char * Sensor_Data, char length)
{
  
  char i=0;
  uint16_t eeprom_data;
  
  for (i=0; i < MAX_RADIO_SENSOR; i++)
  {     
   //  0,      
   if (! Virtual_EEPROM (START_RADIO_ADDR + i*2, & eeprom_data, READ_DATA_EEPROM)) 
    {
     if ( 
         (Sensor_Data[0]== (char) (eeprom_data>>8)) &&   //  -  
         (Sensor_Data[1]== (char) (eeprom_data & 0x00FF)) //  -  
         )
      {
              
       //  0,      
       if (! Virtual_EEPROM (START_RADIO_ADDR + i*2+1, & eeprom_data, READ_DATA_EEPROM)) 
        {
          if (length==2) 
          {
            //,  ID    2 
            //    
            if ( (Sensor_Data[3] & 0x0F)== (char) (eeprom_data & 0x000F) )  return (i+1); // 
          } 
          else
          {
 	   if ( Sensor_Data[2]== (char) (eeprom_data>>8)  ) 
           {
             if (length==3) 
             {
              //,  ID    3 
               //    
              if (
                    ((Sensor_Data[3] & 0x0F)== (char) (eeprom_data & 0x000F)) || 
                    ( ( Sensor_Data[3]== (RADIO_PANIC | RADIO_BRELOK) ) && ( (char) (eeprom_data & 0x000F) == RADIO_SENSOR_GERKON)  )  ||
                    ( ( (Sensor_Data[3] & 0x0F)== RADIO_SENSOR_GERKON  ) && ( (char) (eeprom_data & 0x00FF) == (RADIO_PANIC | RADIO_BRELOK))  ) //      
                  )
                 return (i+1); // 
             }
             else
             {
                if ( Sensor_Data[3]== (char) (eeprom_data & 0x00FF) ) return (i+1); //,  4  
             }
           }    
          }
        }
      }    
    }  

  }

  return 0; //    
} 

/*******************************************************************************
* Function Name  : Save_to_EEPROM_Radio
* Description    :   Radio  EEPROM   
* Input          : Sensor_Data -      Radio
*		   pos -  
* Output         : None
* Return         : None
*******************************************************************************/ 
void Save_to_EEPROM_Radio (char * Sensor_Data, char pos)
{
  uint16_t eeprom_data;

  //    
  eeprom_data =  (( (uint16_t) Sensor_Data[0] & 0x00FF)<<8) |  ((uint16_t) Sensor_Data[1] & 0x00FF);
  Virtual_EEPROM (START_RADIO_ADDR + (pos-1)*2+0, & eeprom_data, SAVE_DATA_EEPROM);

  eeprom_data =  (( (uint16_t) Sensor_Data[2] & 0x00FF)<<8) |  ((uint16_t) Sensor_Data[3] & 0x00FF);
  Virtual_EEPROM (START_RADIO_ADDR + (pos-1)*2+1, & eeprom_data, SAVE_DATA_EEPROM);
}

/*******************************************************************************
* Function Name  : Save_Sensor
* Description    :     
* Input          : Sensor_Data -      
* Output         : None
* Return         :       
*******************************************************************************/ 
char Save_Sensor (char * Sensor_Data)
{
  char i=0;
  uint16_t eeprom_data,eeprom_data1;
  
  //     
  for (i=0; i < MAX_RADIO_SENSOR; i++)
  {     
   //  !=0,      
   if ( Virtual_EEPROM (START_RADIO_ADDR + i*2, & eeprom_data, READ_DATA_EEPROM) ||  
	Virtual_EEPROM (START_RADIO_ADDR + i*2+1, & eeprom_data1, READ_DATA_EEPROM) 
	) 
    {
     Save_to_EEPROM_Radio (Sensor_Data, i+1);
     return (i+1);
    }

   //     ,   
   if ( (eeprom_data==0) && (eeprom_data1==0) )
    {
     Save_to_EEPROM_Radio (Sensor_Data, i+1);
     return (i+1);
    }

  }

  //   -   
  //  0,      
  if (! Virtual_EEPROM (RADIO_LOOP, & eeprom_data, READ_DATA_EEPROM))
    {
      eeprom_data++;
      if (eeprom_data>MAX_RADIO_SENSOR) eeprom_data=1;
      Virtual_EEPROM (RADIO_LOOP, & eeprom_data, SAVE_DATA_EEPROM);    
      Save_to_EEPROM_Radio (Sensor_Data,(char) eeprom_data);
      return (char) eeprom_data;

    }
    else
    {
      //    1
      eeprom_data = 1;
      Virtual_EEPROM (RADIO_LOOP, & eeprom_data, SAVE_DATA_EEPROM);    
      Save_to_EEPROM_Radio (Sensor_Data,(char) eeprom_data);
      return 1;
    }
  //return 0;
} 

/*******************************************************************************
* Function Name  : Do_RF_Sensor_Alarm_
* Description    :   
* Input          : sensor -   ; event_alarm -  
* Output         : None
* Return         : None
*******************************************************************************/  
void Do_RF_Sensor_Alarm_ (char sensor, TypeDef_EVENT event_alarm)
{  
  char i;
  portBASE_TYPE                 xStatus;
  TypeDef_DELAY_EVENT           Delay_Event; /*    */
      
      i=(char) (10 * ( (RF_Sensor.Parameter[sensor-1]>>SENSOR_DELAY_POSITION) & 0x07) ); //   
      
      if (i)
      {
        if ( (Alarm_Delay==0) || (Alarm_Delay > i) ) Alarm_Delay = i;
        
        //   
        Delay_Event.Code_Event=event_alarm.Code_Event;
        Delay_Event.Group=event_alarm.Group;
        Delay_Event.Sensor=sensor;
        Delay_Event.Restore=0;
        
        // ""  ""  "" ,   ""  " "   -
        if ((RF_Sensor.Parameter[sensor-1]>>SENSOR_SILENT_POSITION) & 0x01) 
            {Delay_Event.Sirena_Event=0;} 
          else 
            {if ( (RF_Sensor.Data_Current[sensor-1] & 0x000F)== RADIO_SENSOR_POZHAR ) Delay_Event.Sirena_Event=2; else Delay_Event.Sirena_Event=1;}
        
        /*     ""  */
        xStatus = xQueueSendToBack(Queue_Delay_Event, &Delay_Event, 0 );
        if( xStatus != pdPASS )
        {
          /*    .  . */
          
          //      ""     
          Copy_from_Delay_Buffer ();
          
          if ( (RF_Sensor.Data_Current[sensor-1] & 0x000F)== RADIO_SENSOR_POZHAR )
            //    ""
            {if ( !((RF_Sensor.Parameter[sensor-1]>>SENSOR_SILENT_POSITION) & 0x01) ) Sirena(60);}   //    
          else
            //    "",     
            {if ( !((RF_Sensor.Parameter[sensor-1]>>SENSOR_SILENT_POSITION) & 0x01) ) Sirena (0);}        
          Check_Out_Pulse_Alarm(event_alarm.Group); //       
          Save_Event_to_Buffer(event_alarm);
        }
      }
      else
      {
        
        //     
        {
          Alarm_File=File_Radio[sensor-1];
          Alarm_Voice=1;
        }
        
        //      ""     
        Copy_from_Delay_Buffer ();
        
        if ( (RF_Sensor.Data_Current[sensor-1] & 0x000F)== RADIO_SENSOR_POZHAR )
          //    ""
          {if ( !((RF_Sensor.Parameter[sensor-1]>>SENSOR_SILENT_POSITION) & 0x01) ) Sirena(60);}   //    
        else
          //    "",     
          {if ( !((RF_Sensor.Parameter[sensor-1]>>SENSOR_SILENT_POSITION) & 0x01) ) Sirena (0);}    
        
        Check_Out_Pulse_Alarm(event_alarm.Group); //       
        Save_Event_to_Buffer(event_alarm); 
      }   


   
   
   
}

/*******************************************************************************
* Function Name  : Do_RF_Sensor_Alarm
* Description    :   
* Input          : sensor -   ; event_alarm -  
* Output         : None
* Return         : None
*******************************************************************************/  
void Do_RF_Sensor_Alarm (char sensor, TypeDef_EVENT event_alarm)
{  
  //,    ""  
  if (
      ((RF_Sensor.Parameter[sensor-1]>>SENSOR_24H_POSITION) & 0x01) ||      //""
      ((RF_Sensor.Data_Current[sensor-1] & 0x000F)== RADIO_SENSOR_POZHAR)   //   
     )
  {
    Do_RF_Sensor_Alarm_(sensor, event_alarm);
  }
  else
  {
    //,   
    if ( MODE_ARM_STATE & RF_Sensor.Group[sensor-1] ) 
      Do_RF_Sensor_Alarm_(sensor, event_alarm);
  } 

}

/*******************************************************************************
* Function Name  : SPI_Config
* Description    :   SPI
* Input          : 
* Output         : None
* Return         : None
*******************************************************************************/ 
void SPI_Config(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  SPI_InitTypeDef SPI_InitStructure;

//   MRF_SS   MRF_SLAVE   
  RCC_APB2PeriphClockCmd(MRF_SS_APB_CLOCK , ENABLE);
  GPIO_InitStructure.GPIO_Pin = MRF_SS_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(MRF_SS_PORT , &GPIO_InitStructure);

  MRF_SELECT_OFF //deselect MRF49  
  
//   SPI2   B
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);

//   SPI2      
    /* Configure SPI2 pins: SCK, MISO and MOSI -------------------------------*/
   GPIO_InitStructure.GPIO_Pin   =  GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
   GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
   GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AF_PP;
   GPIO_Init(GPIOB, &GPIO_InitStructure);

  /* Set default settings */
  SPI_StructInit(&SPI_InitStructure);
 //    SPI 
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex; // 
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b; //   8 
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low; // 
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge; //   
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft; //    NSS 
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_128; //  SCK
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB; //    
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master; //  - 
  SPI_Init(SPI2, &SPI_InitStructure); // SPI2
  SPI_Cmd(SPI2, ENABLE); //   SPI1....
 
//   NSS  ,    
//     ,   SPI  , 
//         .

  SPI_NSSInternalSoftwareConfig(SPI2, SPI_NSSInternalSoft_Set);

}


//--------------------------------------------------------------------
// SPI_Write_Read ()
//--------------------------------------------------------------------
u8 SPI_Write_Read (u8 spi_data)
{
    //u8 SPI_Received_Byte;

    /* Wait for SPI2 Tx buffer empty */
    while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET) {}
    
     /* Send SPI2 data */
    SPI_I2S_SendData(SPI2, spi_data);
    //taskYIELD();
    
       /* Wait for SPI2 data reception */
    while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET) {}

      /* Read SPI2 received data */
    //SPI_Received_Byte = SPI_I2S_ReceiveData(SPI2); 
 
    return SPI_RECEIVE_DATA_RF_PRO;
}





