
#include "libraries.h"
extern xQueueHandle                     Queue_Print_Debug, Queue_Event, Queue_GPRS_Event, Queue_TRX_Command;
extern xSemaphoreHandle                 Mutex_Flash_Access, xSemaphore_GSM_UART_Handler;
extern volatile unsigned short int      GSM_Answer_Wait;
extern volatile unsigned short int      DTMF_Command_Wait;
extern volatile unsigned short int      Check_GSM;
extern volatile unsigned short int      Task_GSM_Alive;
extern volatile char                    Working_Flag[];
extern volatile char                    Mode_Flag[];
extern volatile TypeDef_USB_Mode        USB_Mode;
extern volatile char			SIRENA_Short_Beep;
extern volatile char			Program_Mode_Timeout;
extern volatile char			LED_Short_Flash;
extern volatile char			LED_Long_Flash;
extern volatile unsigned short int      Inputs_State;
extern volatile unsigned short int      Outputs_State;
extern volatile unsigned short int      KZ_Obriv_State;
extern volatile TypeDef_RADIO_SENSOR    RF_Sensor;
extern volatile TypeDef_WIRE_SENSOR     Wire_Sensor;
extern volatile TypeDef_DS1820_SENSOR   DS1820_Sensor;
extern volatile char                    oko_rf_pro_version;
extern volatile char                    GSM_Level;
extern volatile char                   	Arm_Delay;
extern volatile char                    Alarm_Voice;
extern char*                            Alarm_File;
extern TypeDef_OWNER                    Owner;
extern volatile TypeDef_IBUTTON         IButton;
extern volatile char                    Delay_arm_group;
extern volatile char                    Delay_who;
extern volatile TypeDef_POWER           Power;
extern volatile TypeDef_TAMPER          Tamper;
extern volatile char			GPRS_Fault_Timeout;
extern volatile char			Load_Data_Timeout;
extern const  uint32_t                  flash_valid;
extern volatile uint16_t                Output_Time_Out[];
extern volatile char                    pin_timeout;
extern volatile char                    reset_pin_error_timeout;
extern volatile uint32_t                Counters[];

/*  HW  */
extern const char HW_Version_Text[];

/*    */
extern const char SW_Version_Text[];


//for FTP
const char Cmd_Set_FTP_ID[] @ "FLASH" =                 "AT+FTPCID=1\r";
const char Cmd_Set_FTP_Server[] @ "FLASH" =             "AT+FTPSERV=\"boby.is-an-engineer.com\"\r"; 
const char Cmd_Set_FTP_UseName[] @ "FLASH" =            "AT+FTPUN=\"device\"\r"; 
const char Cmd_Set_FTP_Password[] @ "FLASH" =           "AT+FTPPW=\"device\"\r"; 
const char Cmd_Set_FTP_Get_FileName_KBM[] @ "FLASH" =   "AT+FTPGETNAME=\"kbm.bin\"\r";
const char Cmd_Set_FTP_Get_Path_KBM[] @ "FLASH" =       "AT+FTPGETPATH=\"/firmware/oko_kbm/\"\r";  
const char Cmd_Get_FTP_to_FS_KBM[] @ "FLASH" =          "AT+FTPGETTOFS=0,\"kbm.bin\"\r"; 
const char Cmd_Set_FTP_Get_FileName_TRX[] @ "FLASH" =   "AT+FTPGETNAME=\"trx.bin\"\r";
const char Cmd_Set_FTP_Get_Path_TRX[] @ "FLASH" =       "AT+FTPGETPATH=\"/firmware/oko_trx/\"\r";    
const char Cmd_Get_FTP_to_FS_TRX[] @ "FLASH" =          "AT+FTPGETTOFS=0,\"trx.bin\"\r"; 



#ifndef OKO_U2
/* AT-  GSM- SIM900*/
const char Cmd_Memory_Init[] @ "FLASH" =            "AT+CFSINIT\r";
const char Cmd_Memory_Size[] @ "FLASH" =            "AT+CFSGFRS?\r";
const char Cmd_Memory_Term[] @ "FLASH" =            "AT+CFSTERM\r";
const char Cmd_Play_Start[] @ "FLASH" =             "AT+CPAMR=\"";
const char Cmd_Play_End[] @ "FLASH" =               ".amr\",0\r";
#else
/* AT-  GSM- SIM800*/
const char Cmd_Memory_Size[] @ "FLASH" =            "AT+FSMEM\r";
//AT+CREC=4,"C:\User\alarm.amr",0,100 - play file with volume 100%, AT+CREC=4,1,0,100
const char Cmd_Play_Start[] @ "FLASH" =            "AT+CREC=4,\"C:\\User\\";
const char Cmd_Play_End_default[] @ "FLASH" =       ".amr\",0,100\r";
//AT+CREC=1,"C:\User\alarm.amr",0,10   - record, 10 sec, AT+CREC=1,1,0,5,0,0
const char Cmd_Record_Start[] @ "FLASH" =           "AT+CREC=1,\"C:\\User\\";
const char Cmd_Record_End_default[] @ "FLASH" =     ".amr\",0,3,0,0\r"; 
#endif

char *File_Wire[9]=
{
  "w1",//     -1
  "w2",//     -2
  "w3",//     -3
  "w4",//     -4
  "w5",//     -5
  "w6",//     -6
  "w7",//     -7
  "w8",//     -8
  "ok" //    DTMF-
};

char *File_Radio[16]=
{
  "r1",//     -1
  "r2",//     -2
  "r3",//     -3
  "r4",//     -4
  "r5",//     -5
  "r6",//     -6
  "r7",//     -7
  "r8",//     -8
  "r9",//     -9
  "r10",//     -10
  "r11",//     -11
  "r12",//     -12
  "r13",//     -13
  "r14",//     -14
  "r15",//     -15
  "r16"  //     -16
};

const char Cmd_CBC[] @ "FLASH" =                  "AT+CBC\r";
const char Cmd_AT[] @ "FLASH" =                   "AT\r";
const char Cmd_ATE0[] @ "FLASH" =                 "ATE0\r";
const char Cmd_CPIN[] @ "FLASH" =                 "AT+CPIN?\r";
const char Cmd_CLIP[] @ "FLASH" =                 "AT+CLIP=1\r";
const char Cmd_CMGF[] @ "FLASH" =                 "AT+CMGF=1\r";
const char Cmd_CSCS_GSM[] @ "FLASH" =             "AT+CSCS=\"GSM\"\r";
const char Cmd_MIC[] @ "FLASH" =                  "AT+CMIC=0,15\r";
const char Cmd_SP[] @ "FLASH" =                   "AT+CLVL=99\r";
//const char Cmd_ECHO[] @ "FLASH" =                 "AT+ECHO=0,7,5,1\r";
//const char Cmd_SIDET[] @ "FLASH" =                "AT+SIDET=0,0\r";
const char Cmd_SIGNAL[] @ "FLASH" =               "AT+CSQ\r";
const char Cmd_IMEI[] @ "FLASH" =                 "AT+GSN\r";
const char Cmd_CREG[] @ "FLASH" =                 "AT+CREG=1\r";
const char Cmd_SET_CENG[] @ "FLASH" =             "AT+CENG=1,1\r";
const char Cmd_GET_CENG[] @ "FLASH" =             "AT+CENG?\r";
const char Cmd_DDET_ON[] @ "FLASH" =              "AT+DDET=1\r"; //AT+DDET=1,500,0\r
const char Cmd_DDET_OFF[] @ "FLASH" =             "AT+DDET=0\r";
const char Cmd_SET_SJDR[] @ "FLASH" =             "AT+SJDR=1,1,255,1\r";
const char Cmd_GET_SJDR[] @ "FLASH" =             "AT+SJDR?\r";
const char Cmd_ATA[] @ "FLASH" =                  "ATA\r";
const char Cmd_GET_REG[] @ "FLASH" =              "AT+CREG?\r";
const char Cmd_ATH[] @ "FLASH" =                  "ATH\r";
const char Cmd_SMS_MEM[] @ "FLASH" =              "AT+CPMS=\"SM\"\r";
const char Cmd_ALL_SMS[] @ "FLASH" =              "AT+CMGL=\"ALL\"\r";
//const char Cmd_UNREAD_SMS[] @ "FLASH" =           "AT+CMGL=\"REC UNREAD\",1\r";
//const char Cmd_DEL_SMS[] @ "FLASH" =              "AT+CMGD=";
const char Cmd_DEL_ALL_SMS[] @ "FLASH" =          "AT+CMGDA=\"DEL ALL\"\r";
const char Cmd_TONE[] @ "FLASH" =                 "AT+VTS=\"9\"\r"; // "AT+CPAMR=\"001.amr\",0\r"; "AT+VTS=\"9\"\r";
const char Cmd_SEND_SMS[] @ "FLASH" =             "AT+CMGS=\"";
const char Cmd_ATD[] @ "FLASH" =                  "ATD";
const char Cmd_CLCC[] @ "FLASH" =                 "AT+CLCC\r";
const char Cmd_CLTS_[] @ "FLASH" =                "AT+CLTS?\r";
const char Cmd_CLTS[] @ "FLASH" =                 "AT+CLTS=1\r";
const char Cmd_ATW[] @ "FLASH" =                  "AT&W\r";
const char Cmd_GET_CCLK[] @ "FLASH" =             "AT+CCLK?\r";
const char Cmd_CSPN[] @ "FLASH" =                 "AT+CSPN?\r";
const char Cmd_CUSD[] @ "FLASH" =                 "AT+CUSD=1,\"";
const char Cmd_STKAR_[] @ "FLASH" =               "AT+STKAR?\r";
const char Cmd_STKAR2[] @ "FLASH" =               "AT+STKAR=2\r";

//-- GPRS command
const char Cmd_SAPBR_GPRS[] @ "FLASH" =                 "AT+SAPBR=3,1,\"CONTYPE\",\"GPRS\"\r"; //set bearer1 parameter Contype
const char Cmd_SAPBR_APN[] @ "FLASH" =                  "AT+SAPBR=3,1,\"APN\",\""; //ser bearer1 parameter APN
const char Cmd_SAPBR_Activate[] @ "FLASH" =             "AT+SAPBR=1,1\r"; //activate bearer1 context
const char Cmd_SAPBR_Query[] @ "FLASH" =                "AT+SAPBR=2,1\r"; //query bearer1 
const char Cmd_Get_Location[] @ "FLASH" =               "AT+CIPGSMLOC=1,1\r"; //get location
const char Cmd_SAPBR_Deactivate[] @ "FLASH" =           "AT+SAPBR=0,1\r"; //deactivate bearer
const char Cmd_IP_Single[] @ "FLASH" =                  "AT+CIPMUX=0\r"; 
const char Cmd_IP_Non_Tr[] @ "FLASH" =                  "AT+CIPMODE=0\r";
//const char Cmd_IP_Head[] @ "FLASH" =                    "AT+CIPHEAD=1\r";
//const char Cmd_IP_Srip[] @ "FLASH" =                    "AT+CIPSRIP=1\r";
const char Cmd_IP_State[] @ "FLASH" =                   "AT+CIPSTATUS\r";
const char Cmd_GPRS_Attach[] @ "FLASH" =                "AT+CGATT=1\r";
//const char Cmd_GPRS_Detach[] @ "FLASH" =                "AT+CGATT=0\r";
//const char Cmd_GPRS_State[] @ "FLASH" =                 "AT+CGATT?\r";
const char Cmd_Auto_Off[] @ "FLASH" =                   "AT+CIPATS=0\r";
const char Cmd_APN[] @ "FLASH" =                        "AT+CIPCSGP=1,\"";
const char APN_Default[] @ "FLASH" =                    "internet";
const char APN_KS_contract[] @ "FLASH" =                "www.kyivstar.net"; //+CSPN: "KYIVSTAR", 0
//const char APN_KS_prepaid[] @ "FLASH" =                 "www.ab.kyivstar.net";
const char APN_MTS_contract[] @ "FLASH" =               "www.umc.ua";
//const char APN_MTS_prepaid[] @ "FLASH" =                "internet";
const char APN_Utel[] @ "FLASH" =		        "3g.utel.ua";  //+CSPN: "Ukrtelecom", 0
const char Cmd_Clport_Lun[] @ "FLASH" =                 "AT+CLPORT=\"UDP\",3030\r";
const char Cmd_Ext_UDP_Mode[] @ "FLASH" =               "AT+CIPUDPMODE=1\r";
const char Cmd_Server_TCP[] @ "FLASH" =                 "AT+CIPSTART=\"TCP\",\"";
const char Cmd_Server_UDP[] @ "FLASH" =                 "AT+CIPSTART=\"UDP\",\"";
const char Cmd_IP_Send[] @ "FLASH" =                    "AT+CIPSEND\r";
const char Cmd_IP_Send_with_len[] @ "FLASH" =           "AT+CIPSEND=";
const char Cmd_IP_Shut[] @ "FLASH" =                    "AT+CIPSHUT\r";
const char Cmd_IP_Close[] @ "FLASH" =                   "AT+CIPCLOSE\r";
const char Text_Get[] @ "FLASH" =                       "GET /oko_pro.php?p1=";
const char Text_HTTP[] @ "FLASH" =                      " HTTP/1.1\x0D\x0AHost: ";
const char Text_GSM_Location[] @ "FLASH" =              "http://77.120.122.83/mobile.php?p1=GSM_Location:";

/*  GSM- SIM900/800*/
const char Answer_Closed[] @ "FLASH" =           "CLOSED";
const char Answer_Rec_Stop[] @ "FLASH" =         "+CREC: 2";
//const char Answer_Play_Stop[] @ "FLASH" =        "+CREC: 0";
const char Answer_Error[] @ "FLASH" =            "ERROR";
const char Answer_SMS_Ready[] @ "FLASH" =        "SMS Ready";
const char Answer_STKAR2[] @ "FLASH" =           "+STKAR: 2";
const char Answer_Location[] @ "FLASH" =         "+CIPGSMLOC: ";
const char Answer_USSD[] @ "FLASH" =             "+CUSD:";
const char Answer_CBC[] @ "FLASH" =              "+CBC:";
const char Answer_OK[] @ "FLASH" =               "OK";
const char Answer_Close_OK[] @ "FLASH" =          "CLOSE OK";
const char Answer_Shut_OK[] @ "FLASH" =          "SHUT OK";
const char Answer_CLIP[] @ "FLASH" =             "+CLIP: \"";
const char Answer_REG[] @ "FLASH" =              "+CREG: 1,";
const char Answer_SIGNAL[] @ "FLASH" =           "+CSQ: ";
const char Answer_SMS_MEM[] @ "FLASH" =           "+CPMS: ";
const char Answer_ALL_SMS[] @ "FLASH" =           "+CMGL: ";
const char Answer_SEND[] @ "FLASH" =              ">";
const char Answer_NO_CARRIER[] @ "FLASH" =        "NO CARRIER";
const char Answer_BUSY[] @ "FLASH" =              "BUSY";
const char Answer_DTMF[] @ "FLASH" =              "+DTMF:";
const char Answer_CLCC_MOC[] @ "FLASH" =          "+CLCC: 1,0,";
const char Answer_Connect_OK[] @ "FLASH" =        "CONNECT ";
const char Answer_Send_OK[] @ "FLASH" =           "SEND OK";
const char Answer_Command_List[] @ "FLASH" =      "COMMAND:";
const char Answer_IMEI[] @ "FLASH" =              "q";
const char Answer_CSPN[] @ "FLASH" =              "+CSPN: \"";
const char SPN_KYIVSTAR[] @ "FLASH" =          	  "KYIVSTAR";
const char SPN_UTEL[] @ "FLASH" =          	  "Ukrtelecom";
const char SPN_MTS[] @ "FLASH" =          	  "MTS";
const char URC_Jamming_Detection[] @ "FLASH" =    "+SJDR: JAMMING DETECTED"; //"+SJDR: NO JAMMING" +SJDR: JAMMING DETECTED
const char URC_RING[] @ "FLASH" =                 "RING"; // 
const char URC_SMS[] @ "FLASH" =                  "+CMTI: \"SM\","; // 

/* - */
const char Disarmed_sms[] @ "FLASH" = 	                "00";
const char Armed_sms[] @ "FLASH" = 	                "01";
const char Android_sms[] @ "FLASH"= 	                "02*";
const char Netmon_sms[] @ "FLASH"= 	                "02#";
const char Status_sms[] @ "FLASH"= 	                "02";
const char USSD_Command[] @ "FLASH" =                   "03";
const char GSM_Location_Command[] @ "FLASH" =           "04*";
const char Call_me[] @ "FLASH"= 	                "07";
const char Config_sms[] @ "FLASH"= 	                "08";
const char Radio_Code_sms[] @ "FLASH"= 	                "*09";
const char Save_Owner_1_Phone[] @ "FLASH" =             "11";
const char Save_Owner_2_Phone[] @ "FLASH" =             "12";
const char Save_Owner_3_Phone[] @ "FLASH" =             "13";
const char Save_Owner_4_Phone[] @ "FLASH" =             "14";
const char Save_Owner_5_Phone[] @ "FLASH" =             "15";
const char Save_Owner_6_Phone[] @ "FLASH" =             "16";
const char Save_Owner_7_Phone[] @ "FLASH" =             "17";
const char Save_Owner_8_Phone[] @ "FLASH" =             "18";
const char Clear_Owner_1_Phone[] @ "FLASH" =            "21";
const char Clear_Owner_2_Phone[] @ "FLASH" =            "22";
const char Clear_Owner_3_Phone[] @ "FLASH" =            "23";
const char Clear_Owner_4_Phone[] @ "FLASH" =            "24";
const char Clear_Owner_5_Phone[] @ "FLASH" =            "25";
const char Clear_Owner_6_Phone[] @ "FLASH" =            "26";
const char Clear_Owner_7_Phone[] @ "FLASH" =            "27";
const char Clear_Owner_8_Phone[] @ "FLASH" =            "28";
const char SMS_Owner[] @ "FLASH" =	                "30";
const char Ring_Owner[] @ "FLASH" =	                "31";
const char Answer_Owner[] @ "FLASH" =	                "32";
const char Change_PIN[] @ "FLASH" =	                "33";
const char Arm_Delay_Command[] @ "FLASH" =              "36";
const char Alarm_Delay_Command[] @ "FLASH" =            "37";
const char Set_Tmin[] @ "FLASH" =	                "490";
const char Set_Tn[] @ "FLASH" =		                "491";
const char Set_Tmax[] @ "FLASH" =	                "492";

const char OKO_KBM_Load_FM_Command[] @ "FLASH" =        "#60*";
const char OKO_RF_Load_FM_Command[] @ "FLASH" =         "#60#";
const char Standart_Load_FM_Command[] @ "FLASH" =       "#60";
const char Load_FM_Command[] @ "FLASH" =                "60";

const char GPRS_On_Command[] @ "FLASH" =                "68";
const char GPRS_Off_Command[] @ "FLASH" =               "69";
const char Server_Query_Command[] @ "FLASH" =           "70";

const char Reset_Command[] @ "FLASH" =                  "75";

const char Owner_Group_Command[] @ "FLASH" =            "781";
const char IButton_Group_Command[] @ "FLASH" =          "782";
const char Sensor_Group_Command[] @ "FLASH" =           "783";
const char DS1820_Group_Command[] @ "FLASH" =           "784";
const char Tamper_Group_Command[] @ "FLASH" =           "785";
const char _220V_Group_Command[] @ "FLASH" =            "786";
const char Clear_IButton_Command[] @ "FLASH" =          "787";
const char Clear_DS1820_Command[] @ "FLASH" =	        "788";
const char Clear_Radio_Command[] @ "FLASH" =	        "789";
const char Arm_SMS_Command[] @ "FLASH" =                "790";
const char Disarm_SMS_Command[] @ "FLASH" =             "791";
const char Arm_Check_Input_Command[] @ "FLASH" =        "792";
const char Arm_Not_Check_Input_Command[] @ "FLASH" =    "793";
const char Sensor_Silent_Command[] @ "FLASH" =          "794";
const char Sensor_24h_Command[] @ "FLASH" =             "795";
const char Arm_Disarm_Beep_Off_Command[] @ "FLASH" =    "796";
const char Arm_Disarm_Beep_On_Command[] @ "FLASH" =     "797";
const char Arm_Not_Clear_Buffer_Command[] @ "FLASH" =   "798";
const char Arm_Clear_Buffer_Command[] @ "FLASH" =       "799";

const char Termo_sms[] @ "FLASH"= 	                "9";

const char Out1_ON_Command[] @ "FLASH" =	        "*#19";
const char Out1_OFF_Command[] @ "FLASH" =	        "*#10";
const char Out2_ON_Command[] @ "FLASH" =	        "*#29";
const char Out2_OFF_Command[] @ "FLASH" =	        "*#20";
const char Out3_ON_Command[] @ "FLASH" =	        "*#39";
const char Out3_OFF_Command[] @ "FLASH" =	        "*#30";
const char Out4_ON_Command[] @ "FLASH" =	        "*#49";
const char Out4_OFF_Command[] @ "FLASH" =	        "*#40";
const char Out5_ON_Command[] @ "FLASH" =	        "*#59";
const char Out5_OFF_Command[] @ "FLASH" =	        "*#50";
const char Out6_ON_Command[] @ "FLASH" =	        "*#69";
const char Out6_OFF_Command[] @ "FLASH" =	        "*#60";
const char Out7_ON_Command[] @ "FLASH" =	        "*#79";
const char Out7_OFF_Command[] @ "FLASH" =	        "*#70";
const char Out8_ON_Command[] @ "FLASH" =	        "*#89";
const char Out8_OFF_Command[] @ "FLASH" =	        "*#80";
const char Group1_Arm_Command[] @ "FLASH" =	        "*19";
const char Group1_Disarm_Command[] @ "FLASH" =	        "*10";
const char Group2_Arm_Command[] @ "FLASH" =	        "*29";
const char Group2_Disarm_Command[] @ "FLASH" =	        "*20";
const char Group3_Arm_Command[] @ "FLASH" =	        "*39";
const char Group3_Disarm_Command[] @ "FLASH" =	        "*30";
const char Group4_Arm_Command[] @ "FLASH" =	        "*49";
const char Group4_Disarm_Command[] @ "FLASH" =	        "*40";
const char Group5_Arm_Command[] @ "FLASH" =	        "*59";
const char Group5_Disarm_Command[] @ "FLASH" =	        "*50";
const char Group6_Arm_Command[] @ "FLASH" =	        "*69";
const char Group6_Disarm_Command[] @ "FLASH" =	        "*60";
const char Group7_Arm_Command[] @ "FLASH" =	        "*79";
const char Group7_Disarm_Command[] @ "FLASH" =	        "*70";
const char Group8_Arm_Command[] @ "FLASH" =	        "*89";
const char Group8_Disarm_Command[] @ "FLASH" =	        "*80";
const char Program_ON_Command[] @ "FLASH" =	        "#1";
const char Program_OFF_Command[] @ "FLASH" =	        "#0";
const char Next_Command[] @ "FLASH" =                   "xx";

//      -
const char Panika_Text[] @ "FLASH" =                    " PANIKA\x0A";
const char Tamper_Text[] @ "FLASH" =                    " VSKRYTIE DATCHIKA\x0A";
const char Battery_Text[] @ "FLASH" =                   " RAZRIAD BATTAREYKI\x0A";
const char Period_Text[] @ "FLASH" =                    " NET TESTOVOGO SIGNALA\x0A";
const char Norma_Text[] @ "FLASH" =                     " VOSSTANOVLENIE\x0A";
const char Alarm_Text[] @ "FLASH" =                     " NARUSHENIE\x0A";

//  GSM   
const char GSM_High_Text[] @ "FLASH" =                  "GSM: VYSOKIJ ";
const char GSM_Medium_Text[] @ "FLASH" =                "GSM: SREDNIJ ";
const char GSM_Low_Text[] @ "FLASH" =                   "GSM: NIZKIJ ";
const char Outputs_Text[] @ "FLASH" =                   "OUTPUTS: ";

const char Low_Li_Ion_Text[] @ "FLASH" =                "Li-Ion LOW\x0A";
const char GSM_Jamming_Detection_Text[] @ "FLASH" =     "TREVOGA\x0AGSM JUMMING DETECTION!!!";
const char Fraud_Detection_Text[] @ "FLASH" =           "TREVOGA\x0APODBOR SEKRETNOGO KODA!!!";
const char Force_Disarm_Text[] @ "FLASH" =              "PRINUDITELNOE SNIATIE OHRANY!!!\x0A";
const char Fault_Arm_Text[] @ "FLASH" =                 "OSHIBKA POSTANOVKI NA OHRANU\x0A";
const char KB1_No_Text[] @ "FLASH" =                    "POTERIA SVIAZI S KLAVIATUROY 1";
const char KB2_No_Text[] @ "FLASH" =                    "POTERIA SVIAZI S KLAVIATUROY 2";

/*      Debug */
const char No_SIM_Text[] @ "FLASH" =                    "No SIM-card or blocked by PIN-code\r";

/*      GSM-*/
char                                   SIM900_Rx_Buffer[SIM900_RX_BUFFER_SIZE+1];
volatile   unsigned short int          Received_DataLength=0; //    

/*      , ,  */
char                                   Temp_Buffer[TEMP_BUFFER_SIZE+1];

/*         (1...999\r )*/
char                                    Incoming_SMS_Position[4];

/*      , */
char                                    Incoming_Phone_Number[PHONE_MAX_LEN+1];

/*      */
char                                    Owner_Phone_Number[PHONE_MAX_LEN+1];

/*    IMEI GSM-*/
char                                    IMEI_Number[IMEI_MAX_LEN+1]={0};

/*    USSD-*/
char                                    USSD_Query[USSD_QUERY_MAX_LEN+1]={0};

/*    */
char                                    Balance[BALANCE_MAX_LEN+1]={0};

/*     GSM-*/
char                                    No_Registration=0;

/*   SIM- */
char                                    No_SIM_Card = 1;

char                                    Get_Termo_Sensor=0; //     /

volatile char                           dtmf_command_timeout;
volatile char                           dtmf_code=0;
volatile char                           No_Carrier=0;

volatile char                           Modem_Mode_Time_Out;

const char                              *Cmd_APN_=APN_Default;

//IWD -   task_GSM
#define T_GSM_WD_LEN                    120
#define T_GSM_WD_LONG_LEN               600
volatile uint16_t                       T_gsm_wd = T_GSM_WD_LEN;

/*    */
volatile char                           Current_Server = 0;

volatile char                           SMS_Ready_timeout=60;

/*       ,   USB   */
uint16_t                        USB_Len;
char *                          USB_Data;

/*******************************************************************************
* Function Name  : Task_GSM
* Description    :      GSM-
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Task_GSM( void *pvParameters )
{  
  TypeDef_EVENT Event;
  uint16_t temp;
  
  /*     EEPROM */
  Read_Config_from_EEPROM();
  
  vTaskDelay(300/portTICK_RATE_MS);

  SIM900_ON();
  SIM900_Ini();

  while(1)
  {
    /*   ""   */
    Task_GSM_Alive++;

    /*   */
    if (FLAG_SIM900_RING_STATE) Check_Ring();
    
    /*     GSM- */
    if (!Check_GSM)  
    {
      Check_SIM900();
      /*     SMS */
      FLAG_SIM900_SMS_SET;
      //GPRS_Send_ContactID("5010 180001R13000002\x14");
    }

    
    /*   SMS */
    if (FLAG_SIM900_SMS_STATE && !SMS_Ready_timeout ) 
    { 
      if(Check_SMS()) 
        FLAG_SIM900_SMS_SET; 
      else 
        FLAG_SIM900_SMS_RESET;
      
      /*   SMS */
      //Send_Command_To_SIM900 (Cmd_DEL_ALL_SMS, strlen(Cmd_DEL_ALL_SMS));
      //Wait_For_SIM900_Answer (Answer_OK, 3*GSM_ANSWER_WAIT_1SEC);  
    }

    /*     */
    if (FLAG_DEFAULT_SETTING_STATE) Set_Default_Settings();

    /* ,       */
    if (FLAG_SAVE_MODE_STATE) Save_Mode_to_EEPROM();

    /* ,       */
    if (FLAG_SAVE_OUTPUT_STATE) Save_Output_to_EEPROM();
   
    /* ,      */ 
    if (FLAG_RESET_COMMAND_STATE) NVIC_SystemReset();
    
    //     OKO-KBM
    if (FLAG_LOAD_OKO_KBM_FW_STATE)
    {
      FLAG_LOAD_OKO_KBM_FW_RESET;
      #ifdef OKO_U2 
      Load_OKO_KBM_FW();
      #endif
    }
    
    //     OKO-RF
    if (FLAG_LOAD_OKO_TRX_FW_STATE)
    {
      FLAG_LOAD_OKO_TRX_FW_RESET;
      #ifdef OKO_U2 
      Load_OKO_TRX_FW();
      #endif
    }
    
    /*    ,         */
    if ( (No_Registration==NO_REGISTRATION_LEN) && (!FLAG_SIM900_RING_STATE) ) GPRS_Event_Check();
    
    /*    ,        */
    if ( (No_Registration==NO_REGISTRATION_LEN) && (!FLAG_SIM900_RING_STATE) ) Event_Check();
    
    /* ,         */ 
    if ( (FLAG_STATUS_SEND_STATE) && (No_Registration==NO_REGISTRATION_LEN) && (!FLAG_SIM900_RING_STATE) )
     {
      FLAG_STATUS_SEND_RESET;
      Send_Status_SMS_to_Phone(Incoming_Phone_Number);
     }

    /* ,         */ 
    if ( (FLAG_TERMO_SEND_STATE) && (No_Registration==NO_REGISTRATION_LEN) && (!FLAG_SIM900_RING_STATE) )
     {
      FLAG_TERMO_SEND_RESET;
      /*    */
      if (!Send_Termo_SMS_to_Phone(Incoming_Phone_Number)) Send_Termo_SMS_to_Phone(Incoming_Phone_Number);
     }    

    /* ,        GSM- */ 
    if ( (FLAG_NETMON_SEND_STATE) && (No_Registration==NO_REGISTRATION_LEN) && (!FLAG_SIM900_RING_STATE) )
     {
      FLAG_NETMON_SEND_RESET;
      /*    */
      if (!Send_Netmon_SMS_to_Phone(Incoming_Phone_Number)) Send_Netmon_SMS_to_Phone(Incoming_Phone_Number);
     } 
    
    /* ,          */ 
    if ( (FLAG_GSM_LOCATION_SEND_STATE) && (No_Registration==NO_REGISTRATION_LEN) && (!FLAG_SIM900_RING_STATE) )
     {
      FLAG_GSM_LOCATION_SEND_RESET;
      /*    */
      if (!Send_GSM_Location_SMS_to_Phone(Incoming_Phone_Number)) Send_GSM_Location_SMS_to_Phone(Incoming_Phone_Number);
     }  
    
    /* ,     USSD- */ 
    if ( (FLAG_USSD_SEND_STATE || FLAG_USSD_BALANCE_SEND_STATE) && (No_Registration==NO_REGISTRATION_LEN) && (!FLAG_SIM900_RING_STATE) )
     {
      FLAG_USSD_SEND_RESET;
      /*    USSD-    */
      if (!Send_USSD_SMS_to_Phone(Incoming_Phone_Number)) Send_USSD_SMS_to_Phone(Incoming_Phone_Number);
      FLAG_USSD_BALANCE_SEND_RESET;
     } 
    
    /* ,     Android-    */ 
    if ( (FLAG_ANDROID_SEND_STATE) && (No_Registration==NO_REGISTRATION_LEN) && (!FLAG_SIM900_RING_STATE) )
     {
      FLAG_ANDROID_SEND_RESET;
      /*    */
      if (!Send_Android_SMS_to_Phone(Incoming_Phone_Number)) Send_Android_SMS_to_Phone(Incoming_Phone_Number);
     }

    /* ,          */ 
    if ( (FLAG_CONFIG_SEND_STATE) && (No_Registration==NO_REGISTRATION_LEN) && (!FLAG_SIM900_RING_STATE) )
     {
      FLAG_CONFIG_SEND_RESET;
      /*    */
      if (!Send_Config_SMS_to_Phone(Incoming_Phone_Number)) Send_Config_SMS_to_Phone(Incoming_Phone_Number);
     }

    /* ,         */ 
    if ( (FLAG_RADIO_CODE_SEND_STATE) && (No_Registration==NO_REGISTRATION_LEN) && (!FLAG_SIM900_RING_STATE) )
     {
      FLAG_RADIO_CODE_SEND_RESET;
      /*    */
      if (!Send_Radio_Code_SMS_to_Phone(Incoming_Phone_Number)) Send_Radio_Code_SMS_to_Phone(Incoming_Phone_Number);
     }

    /* ,        ,    */ 
    if ( (FLAG_PARAMETER_SEND_STATE) && (No_Registration==NO_REGISTRATION_LEN) && (!FLAG_SIM900_RING_STATE) )
     {
      FLAG_PARAMETER_SEND_RESET;
      /*    */
      if (!Send_Parameter_SMS_to_Phone(Incoming_Phone_Number)) Send_Parameter_SMS_to_Phone(Incoming_Phone_Number);
     }    
    
    /* ,        */ 
    if ( (FLAG_CALL_STATE) && (No_Registration==NO_REGISTRATION_LEN) && (!FLAG_SIM900_RING_STATE) )
     {
      FLAG_CALL_RESET;
      /*       */
      if (!Ring_to_Phone(Incoming_Phone_Number, NOT_OWNER, 0, 0, Answer_OK )) Ring_to_Phone(Incoming_Phone_Number, NOT_OWNER, 0, 0, Answer_OK);
     }
    
    /* ,     GPRS */ 
    if (FLAG_GPRS_INI_COMMAND_STATE) 
    { 
      FLAG_GPRS_INI_COMMAND_RESET;
      GPRS_Ini();
    }
    
    /* ,       */ 
    if (FLAG_SAVE_COUNTERS_STATE)
    {
      FLAG_SAVE_COUNTERS_RESET;
      Save_Counters();
    }
    
    /* ,    GSM JUMMING DETECTION*/ 
    if (FLAG_GSM_JUMMING_DETECTION_STATE) 
    { 
      FLAG_GSM_JUMMING_DETECTION_RESET;
      Event.Code_Event= GSM_JUMMING_DETECTION_EVENT;
      Event.Group=ALL_GROUP;
      Save_Event_to_Buffer(Event);
    } 
    
        //  -  -
    if ( 
          (No_Registration==NO_REGISTRATION_LEN) && 
          (!FLAG_SIM900_RING_STATE) && 
          (!GPRS_Fault_Timeout) && 
          (FLAG_DICONNECT_STATE) &&
          (*(char*)GPRS_PROTOCOL != HTTP_OKO)  
        ) 
      Connect_to_Server();
    
    //  
    #define MODEM_MODE_TIME_OUT_LEN 120
    if (USB_Mode==ModemMode)
    {
      USB_Mode=DebugMode;
      Send_Command_To_SIM900 ("Enter to modem mode\r", strlen("Enter to modem mode\r"));
      USB_Mode=ModemMode;
      while (USB_Mode==ModemMode)
      {
        T_gsm_wd = T_GSM_WD_LEN; // IWD -   task_GSM
        Task_GSM_Alive++;
        if (USB_Len)
        {
          temp=USB_Len;
          USB_Len=0;
          Send_Command_To_SIM900_ (USB_Data, temp);
          Modem_Mode_Time_Out=MODEM_MODE_TIME_OUT_LEN;
        }
      }
      USB_Mode=DebugMode;
      Send_Command_To_SIM900 ("Exit from modem mode\r", strlen("Exit from modem mode\r"));
      USB_Mode=UsbIdleMode;
    }
    
    // IWD -   task_GSM
    T_gsm_wd = T_GSM_WD_LEN;
    
    vTaskDelay(5/portTICK_RATE_MS);
  }
  
   /*     ,     (break)  
          ,      
           .  NULL, 
       vTaskDelete(), ,      (, 
       ) . */
  
  //vTaskDelete( NULL ); 
}

/*******************************************************************************
* Function Name  : SIM900_PinConfig
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void SIM900_Pin_Config(void) 
{
  GPIO_InitTypeDef GPIO_InitStructure;
  
/*    / GSM-   "" (Powerkey)  */  
  RCC_APB2PeriphClockCmd(PWRKEY_APB_CLOCK , ENABLE);
  GPIO_InitStructure.GPIO_Pin = PWRKEY_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(PWRKEY_PORT , &GPIO_InitStructure);

 /*    /  GSM- */
  RCC_APB2PeriphClockCmd(POWER_GSM_APB_CLOCK , ENABLE);
  GPIO_InitStructure.GPIO_Pin = POWER_GSM_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(POWER_GSM_PORT , &GPIO_InitStructure); 

/*      RING  GSM-  */
  RCC_APB2PeriphClockCmd(SIM900_RING_APB_CLOCK, ENABLE);
  GPIO_InitStructure.GPIO_Pin = SIM900_RING_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(SIM900_RING_PORT, &GPIO_InitStructure);
  
}


/*******************************************************************************
* Function Name  : SIM900_ON
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void SIM900_ON(void) 
{
/*    GSM- */ 
  POWER_GSM_OFF

  vTaskDelay(1000/ portTICK_RATE_MS);

/*    GSM- */ 
  POWER_GSM_ON

  vTaskDelay(1000/ portTICK_RATE_MS);

 /*    PowerKey  / GSM-*/
  PWRKEY_ON
   
  vTaskDelay(1500/ portTICK_RATE_MS);  

  PWRKEY_OFF 
 
  vTaskDelay(2500/ portTICK_RATE_MS);
  
}

/*******************************************************************************
* Function Name  : SIM900_Auto_Baud
* Description    : 
* Input          : None
* Output         : None
* Return         : 1 -    , 0 -    
*******************************************************************************/ 
char SIM900_Auto_Baud(void) 
{
  char i;
  
  for (i=0; i<5;  i++) 
  {
    Send_Command_To_SIM900 (Cmd_AT, strlen(Cmd_AT));
    if (Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC)) return 1; 
  }
  return 0;
}


void Calc_Pointer(char * result, uint32_t data)
{
  //from 000 000 to 999 999

  
  *result=0x30 + data/100000;
  data %=100000;
  result++;

  *result=0x30 + data/10000;
  data %=10000;
  result++;

  *result=0x30 + data/1000;
  data %=1000;
  result++; 
 
  *result=0x30 + data/100;
  data %=100;
  result++; 

  *result=0x30 + data/10;
  data %=10;
  result++; 
  
  *result=0x30 + data;
}

/*******************************************************************************
* Function Name  : Load_OKO_TRX_FW
* Description    :   FTP-     GSM- 
*                    -RF
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Load_OKO_TRX_FW(void)
{

  
  char read_file[]="AT+FSREAD=C:\\user\\ftp\\trx.bin,1,1024,000000\r"; // OKO_RF_FLASH_PAGE_SIZE = 1024
  char delete_file[]="AT+FSDEL=C:\\user\\ftp\\trx.bin\r"; 
  uint32_t  Pointer_in_file=0;
  char offset=2, fault_num=0, page_counter;
  

  
// AT-  GSM- SIM800
  Send_Command_To_SIM900 (Cmd_Memory_Size, strlen(Cmd_Memory_Size));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);  
  
  Send_Command_To_SIM900 (Cmd_SAPBR_GPRS, strlen(Cmd_SAPBR_GPRS));
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_SAPBR_APN, strlen(Cmd_SAPBR_APN));
  Send_Command_To_SIM900_ (Cmd_APN_, strlen(Cmd_APN_));
  Send_Command_To_SIM900_ ("\"\r", 2);
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_SAPBR_Activate, strlen(Cmd_SAPBR_Activate));
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);  
    
  Send_Command_To_SIM900 (Cmd_Set_FTP_ID, strlen(Cmd_Set_FTP_ID));  
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_Set_FTP_Server, strlen(Cmd_Set_FTP_Server));   
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_Set_FTP_UseName, strlen(Cmd_Set_FTP_UseName));  
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_Set_FTP_Password, strlen(Cmd_Set_FTP_Password));  
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_Set_FTP_Get_FileName_TRX, strlen(Cmd_Set_FTP_Get_FileName_TRX));  
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_Set_FTP_Get_Path_TRX, strlen(Cmd_Set_FTP_Get_Path_TRX)); 
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_Get_FTP_to_FS_TRX, strlen(Cmd_Get_FTP_to_FS_TRX));  
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  T_gsm_wd = 3*T_GSM_WD_LONG_LEN;
  if (Wait_For_SIM900_Answer ("+FTPGETTOFS: 0,12288", 120*GSM_ANSWER_WAIT_1SEC)) 
  {
    //  -    -RF
    for (page_counter=0; (page_counter < MAX_PAGE_NUMBER_OKO_RF) && (fault_num < 10); page_counter++) //MAX_PAGE_NUMBER
    {
      T_gsm_wd = T_GSM_WD_LONG_LEN;

      Pointer_in_file = page_counter * OKO_TRX_FLASH_PAGE_SIZE;
      Calc_Pointer(&read_file[37], Pointer_in_file);
      
      vTaskDelay(200/ portTICK_RATE_MS);
      
      FLAG_DATA_RECEIVED_RESET; 
      Send_Command_To_SIM900(read_file,strlen(read_file)); //strlen(read_file)); 49

      /*  -   GSM-*/
      GSM_Answer_Wait=5*GSM_ANSWER_WAIT_1SEC;

      while (!FLAG_DATA_RECEIVED_STATE && GSM_Answer_Wait) {} //&& Receive_timeout

      if (FLAG_DATA_RECEIVED_STATE)
      {
        FLAG_DATA_RECEIVED_RESET;
        FLAG_ANALIZING_SET;
            
        offset=2;

        {

          if (  Received_DataLength==(OKO_TRX_FLASH_PAGE_SIZE+3*offset+2) && // 0x0d, 0x0a, PAGE, 0x0d, 0x0a, 'O', 'K', 0x0d, 0x0a
                SIM900_Rx_Buffer[0]==0x0D && SIM900_Rx_Buffer[1]==0x0A && SIM900_Rx_Buffer[OKO_TRX_FLASH_PAGE_SIZE+3*offset+2-(offset+2)]=='O' && SIM900_Rx_Buffer[OKO_TRX_FLASH_PAGE_SIZE+3*offset+2-(offset+1)]=='K'
              ) 
          {
          }
          else
          {
            offset=3; // 0x0d, 0x0a, 0x0a, PAGE, 0x0d, 0x0a, 0x0a, 'O', 'K', 0x0d, 0x0a, 0x0a
          }

          
          if (  Received_DataLength==(OKO_TRX_FLASH_PAGE_SIZE+3*offset+2) && 
                SIM900_Rx_Buffer[0]==0x0D && SIM900_Rx_Buffer[1]==0x0A && SIM900_Rx_Buffer[OKO_TRX_FLASH_PAGE_SIZE+3*offset+2-(offset+2)]=='O' && SIM900_Rx_Buffer[OKO_TRX_FLASH_PAGE_SIZE+3*offset+2-(offset+1)]=='K'
              )
          {
            // Save PAGE to OKO-TRX FLASH
            fault_num=0;
            SIM900_Rx_Buffer[0]=offset;
            SIM900_Rx_Buffer[offset-1]=page_counter;
            SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(2*offset+2-1)]='C';
            SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(2*offset+2-2)]='O';
            SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(2*offset+2-3)]='N';
            FLAG_PAGE_OKO_TRX_FW_SET;
            
            GSM_Answer_Wait=6*GSM_ANSWER_WAIT_1SEC;
            while (FLAG_PAGE_OKO_TRX_FW_STATE && GSM_Answer_Wait) {}
            
          }
          else
          {
            page_counter--;
            fault_num++;
          }
        }
        
        FLAG_ANALIZING_RESET;
      }
      else
      {
          page_counter--;
          fault_num++;
      }
    }          
        
  }   
  
  Send_Command_To_SIM900 (Cmd_SAPBR_Deactivate, strlen(Cmd_SAPBR_Deactivate));
  Wait_For_SIM900_Answer (Answer_OK, 3*GSM_ANSWER_WAIT_1SEC); 
  
  Send_Command_To_SIM900 (delete_file, strlen(delete_file));
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);  
  
  FLAG_ANALIZING_RESET; 
}

/*******************************************************************************
* Function Name  : Load_OKO_KBM_FW
* Description    :   FTP-     GSM- 
*                    -
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Load_OKO_KBM_FW(void)
{

  
  char read_file[]="AT+FSREAD=C:\\user\\ftp\\kbm.bin,1,1024,000000\r"; // OKO_KBM_FLASH_PAGE_SIZE = 1024
  char delete_file[]="AT+FSDEL=C:\\user\\ftp\\kbm.bin\r";
  uint32_t  Pointer_in_file=0;
  char offset=2, fault_num=0, page_counter;
  

  
// AT-  GSM- SIM800
  Send_Command_To_SIM900 (Cmd_Memory_Size, strlen(Cmd_Memory_Size));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);  
  
  Send_Command_To_SIM900 (Cmd_SAPBR_GPRS, strlen(Cmd_SAPBR_GPRS));
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_SAPBR_APN, strlen(Cmd_SAPBR_APN));
  Send_Command_To_SIM900_ (Cmd_APN_, strlen(Cmd_APN_));
  Send_Command_To_SIM900_ ("\"\r", 2);
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_SAPBR_Activate, strlen(Cmd_SAPBR_Activate));
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);  
    
  Send_Command_To_SIM900 (Cmd_Set_FTP_ID, strlen(Cmd_Set_FTP_ID));  
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_Set_FTP_Server, strlen(Cmd_Set_FTP_Server));   
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_Set_FTP_UseName, strlen(Cmd_Set_FTP_UseName));  
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_Set_FTP_Password, strlen(Cmd_Set_FTP_Password));  
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_Set_FTP_Get_FileName_KBM, strlen(Cmd_Set_FTP_Get_FileName_KBM));  
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_Set_FTP_Get_Path_KBM, strlen(Cmd_Set_FTP_Get_Path_KBM)); 
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_Get_FTP_to_FS_KBM, strlen(Cmd_Get_FTP_to_FS_KBM));  
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  T_gsm_wd = 3*T_GSM_WD_LONG_LEN;
  if (Wait_For_SIM900_Answer ("+FTPGETTOFS: 0,25600", 120*GSM_ANSWER_WAIT_1SEC)) 
  {
          //  -    -
    for (page_counter=0; (page_counter < MAX_PAGE_NUMBER_OKO_KBM) && (fault_num < 10); page_counter++) //MAX_PAGE_NUMBER
    {
      T_gsm_wd = T_GSM_WD_LONG_LEN;

      Pointer_in_file = page_counter * OKO_KBM_FLASH_PAGE_SIZE;
      Calc_Pointer(&read_file[37], Pointer_in_file);
      
      vTaskDelay(200/ portTICK_RATE_MS);
      
      FLAG_DATA_RECEIVED_RESET; 
      Send_Command_To_SIM900(read_file,strlen(read_file)); //strlen(read_file)); 49

      /*  -   GSM-*/
      GSM_Answer_Wait=5*GSM_ANSWER_WAIT_1SEC;

      while (!FLAG_DATA_RECEIVED_STATE && GSM_Answer_Wait) {} //&& Receive_timeout

      if (FLAG_DATA_RECEIVED_STATE)
      {
        FLAG_DATA_RECEIVED_RESET;
        FLAG_ANALIZING_SET;
        //TEST 
            /*   
            vTaskDelay(200/portTICK_RATE_MS);
            taskENTER_CRITICAL ();
            SendDataToHost("START",strlen("START")); 
            for (uint16_t j=0;j<Received_DataLength; j++)
            {
              SendDataToHost(&SIM900_Rx_Buffer[j],1);
              taskEXIT_CRITICAL();
              if ( (j%16)==0 ) vTaskDelay(3/portTICK_RATE_MS);
              taskENTER_CRITICAL();
            }
            SendDataToHost("END",strlen("END")); 
            taskEXIT_CRITICAL (); 
            vTaskDelay(200/portTICK_RATE_MS); */
            
        offset=2;
        /*
        if ( 
              (Received_DataLength < (OKO_KBM_FLASH_PAGE_SIZE+3*offset+2)) &&
                (
                  (SIM900_Rx_Buffer[2]=='E' && SIM900_Rx_Buffer[3]=='R' && SIM900_Rx_Buffer[4]=='R' && SIM900_Rx_Buffer[5]=='O' && SIM900_Rx_Buffer[6]=='R') ||
                  (SIM900_Rx_Buffer[3]=='E' && SIM900_Rx_Buffer[4]=='R' && SIM900_Rx_Buffer[5]=='R' && SIM900_Rx_Buffer[6]=='O' && SIM900_Rx_Buffer[7]=='R')
                )
           )
        {
          //send END firmware loading
          offset=2;
          SIM900_Rx_Buffer[0]=offset;
          SIM900_Rx_Buffer[offset-1]=0;
          SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(2*offset+2-1)]='E';
          SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(2*offset+2-2)]='N';
          SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(2*offset+2-3)]='D';
          FLAG_PAGE_OKO_KBM_FW_SET;
            
          GSM_Answer_Wait=6*GSM_ANSWER_WAIT_1SEC;
          while (FLAG_PAGE_OKO_KBM_FW_STATE && GSM_Answer_Wait) {}
            
          vTaskDelay(100/ portTICK_RATE_MS);
          break;  
          //page_counter = MAX_PAGE_NUMBER_OKO_KBM; 
        }
        else */
        {

          if (  Received_DataLength==(OKO_KBM_FLASH_PAGE_SIZE+3*offset+2) && // 0x0d, 0x0a, PAGE, 0x0d, 0x0a, 'O', 'K', 0x0d, 0x0a
                SIM900_Rx_Buffer[0]==0x0D && SIM900_Rx_Buffer[1]==0x0A && SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(offset+2)]=='O' && SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(offset+1)]=='K'
              ) 
          {
          }
          else
          {
            offset=3; // 0x0d, 0x0a, 0x0a, PAGE, 0x0d, 0x0a, 0x0a, 'O', 'K', 0x0d, 0x0a, 0x0a
          }

          
          if (  Received_DataLength==(OKO_KBM_FLASH_PAGE_SIZE+3*offset+2) && 
                SIM900_Rx_Buffer[0]==0x0D && SIM900_Rx_Buffer[1]==0x0A && SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(offset+2)]=='O' && SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(offset+1)]=='K'
              )
          {
            // Save PAGE to OKO-KBM FLASH
            fault_num=0;
            SIM900_Rx_Buffer[0]=offset;
            SIM900_Rx_Buffer[offset-1]=page_counter;
            SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(2*offset+2-1)]='C';
            SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(2*offset+2-2)]='O';
            SIM900_Rx_Buffer[OKO_KBM_FLASH_PAGE_SIZE+3*offset+2-(2*offset+2-3)]='N';
            FLAG_PAGE_OKO_KBM_FW_SET;
            
            GSM_Answer_Wait=6*GSM_ANSWER_WAIT_1SEC;
            while (FLAG_PAGE_OKO_KBM_FW_STATE && GSM_Answer_Wait) {}
            
            //vTaskDelay(100/ portTICK_RATE_MS);
          }
          else
          {
            page_counter--;
            fault_num++;
          }
        }
        
        FLAG_ANALIZING_RESET;
      }
      else
      {
          page_counter--;
          fault_num++;
      }
    }          
        
  }   
  
  Send_Command_To_SIM900 (Cmd_SAPBR_Deactivate, strlen(Cmd_SAPBR_Deactivate));
  Wait_For_SIM900_Answer (Answer_OK, 3*GSM_ANSWER_WAIT_1SEC); 
  
  Send_Command_To_SIM900 (delete_file, strlen(delete_file));
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);   
  
  FLAG_ANALIZING_RESET; 
}
/*******************************************************************************
* Function Name  : Check_SPN
* Description    : 
* Input          : Check_value -    
* Output         : None
* Return         : 1 -  , 0 -  
*******************************************************************************/ 
char Check_SPN (const char *Check_value, unsigned short int position) 
{
  char  i,ExpAnsLen;
  /*    "" */
  ExpAnsLen=strlen(Check_value);  

  for (i=0; i<ExpAnsLen;  i++) 
  {
	if (*Check_value!=SIM900_Rx_Buffer[position]) return 0;
	position++;
	Check_value++;
  }
  return 1;
}


/*******************************************************************************
* Function Name  : Wait_For_SIM900_Answer
* Description    :    GSM-   
* Input          : char *Expected_Answer -    ""
                  gsm_answer_wait - -   ""   GSM-     
* Output         : None
* Return         : 0-     "", 
                  !=0 -   "",     ""
*******************************************************************************/ 
unsigned short int Wait_For_SIM900_Answer (const char *Expected_Answer, unsigned short int gsm_answer_wait) 
{ 
  unsigned short int            SIM900_InputDataLength;
  unsigned short int            temp, index, result=0;
  char                          i,j,ExpAnsLen;
  const char                   *Expected_Answer_Start;

  // IWD -   task_GSM
  T_gsm_wd = T_GSM_WD_LEN;
  
  /*     "" */
  Expected_Answer_Start=Expected_Answer;
  
  /*    "" */
  ExpAnsLen=strlen(Expected_Answer);

  
  /*  -   ""   GSM-*/
  GSM_Answer_Wait=gsm_answer_wait;

  /*   GSM-   ""  GSM_Answer_Wait */
  while (
          GSM_Answer_Wait && 
          !((Expected_Answer_Start==Answer_Connect_OK || Expected_Answer_Start==Answer_Command_List ) && FLAG_SIM900_RING_STATE) //,    ,    
         )
  {
    
    /*       */
    if( FLAG_DATA_RECEIVED_STATE)      
     {
        SIM900_InputDataLength=Received_DataLength;
        FLAG_DATA_RECEIVED_RESET;
        
        /*   GSM-.         "" */
        for (index=0; (index < (SIM900_InputDataLength - ExpAnsLen + 1)) && (SIM900_InputDataLength >= ExpAnsLen);  index++)
        {
          /*    GSM-   "" */
          if  (
		(*Expected_Answer==SIM900_Rx_Buffer[index]) ||
		( (Expected_Answer_Start==Answer_IMEI) && (SIM900_Rx_Buffer[index] >= 0x30) && (SIM900_Rx_Buffer[index] <= 0x39) ) // 0..9,    IMEI
	      )
            {
              
              /*    "",       GSM- */
              for (j=0; j < ExpAnsLen;  j++)
              {
                  /*   ,         */
                  if (
			!(
				(*Expected_Answer==SIM900_Rx_Buffer[index+j]) ||
				( (Expected_Answer_Start==Answer_IMEI) && (SIM900_Rx_Buffer[index+j] > 0x2F) && (SIM900_Rx_Buffer[index+j] < 0x3A) ) // 0..9,    IMEI
			 )
		     ) break;

                  Expected_Answer++;
                  
                  /* ,       "" */
                  if (j == (ExpAnsLen-1)) 
                  {
                    /*  ""     GSM-*/
                    result=1;
                    
                    
                    /**********  ,     "" **********/
                    
                    /*  -  ""   USSD- */
                    /*  +CUSD: 0,"Na rahunku 4.78 grn. Nomer die do 03.12.16. Bonusy: 0.00 grn do 23.12.22; 0 KB. Detalnishe pro bonusy za nomerom *100#",64 */
                    if (Expected_Answer_Start==Answer_USSD) 
                    {
                        /*    USSD-       GSM-*/
                        FLAG_ANALIZING_SET; //      
                        
                        temp = index+j+1;
                        for (j=0; j < 10; j++)
    			{
                          if ( SIM900_Rx_Buffer[temp] == '\0' ) return 0; //    USSD-
                          
                          //  
                          if ( SIM900_Rx_Buffer[temp] == '"' ) {return (temp+1);} //    USSD- 
                          temp++;
                        }
                        
    			return 0; //    USSD-
                    }   
                    
                    
                    /*  -  ""    CBC (  ) +CBC: 0,100,4534 */
                    if (Expected_Answer_Start==Answer_CBC) 
                      {
                        temp = index+j+1;
                        
    			for (j=0; j < 5; j++)
    			{
                          //  
                          if ( SIM900_Rx_Buffer[temp] == ',' ) {j=5;} 
                          temp++;
                        }
                        for (j=0; j < 5; j++)
    			{
                          //  
                          if ( SIM900_Rx_Buffer[temp] == ',' ) {return (temp+1);} //     
                          temp++;
                        }
                        
    			return 0; //   		
		      }
                      
                      
                    /*  -  ""    SPN (  -) */
                    if (Expected_Answer_Start==Answer_CSPN) 
                      {
			if (Check_SPN(SPN_KYIVSTAR,index+j+1)) return KYIVSTAR_APN_contract;
			if (Check_SPN(SPN_MTS,index+j+1)) return MTS_APN_contract;
			if (Check_SPN(SPN_UTEL,index+j+1)) return UTEL_APN;
			return Default_APN;			
		      }

                    /*  -  ""    IMEI */
                    if (Expected_Answer_Start==Answer_IMEI) 
                      {
                        FLAG_ANALIZING_SET; //      
                        /*  IMEI   IMEI_Number -    IMEI  */
                        temp = index+j+0; 

    			IMEI_Number[0]='\0';
    			for (j=0; j < IMEI_MAX_LEN; j++)
    			{
                          if ( (SIM900_Rx_Buffer[temp] > 0x2F) &&  (SIM900_Rx_Buffer[temp] < 0x3A) ) // 0..9
                            IMEI_Number[j]=SIM900_Rx_Buffer[temp];
                          else 
                          {
                            break;
                          } 
                         temp++;
                        }
                        IMEI_Number[j]='\0';
                        FLAG_ANALIZING_RESET; //      
    			return j; //  !0 -  IMEI,
                      }  


                    /*  -  ""    CONNECT OK */
                    if (Expected_Answer_Start==Answer_Connect_OK)
                      {
                        if ( (SIM900_Rx_Buffer[index+j+1]=='O') && (SIM900_Rx_Buffer[index+j+2]=='K') ) return 1; else return 0;
                      } 
                    
                    
                    /*  -  ""     */
                    if (Expected_Answer_Start==Answer_CLIP) /*  +CLIP: "+380... */
                    {
                       /*            GSM-*/
                       FLAG_ANALIZING_SET; //       
                       /*      Incoming_Phone_Number -        */
                       i = Save_Incoming_Call(index+j+1); /*  !0 -  , 0 -     */
                       FLAG_ANALIZING_RESET; //      
                       
                       /*  !0 -  , 0 -     */
                       return i; 
                    }
                    
                    
                    /*  -  ""      */
                    if (Expected_Answer_Start==Answer_REG) /*  +CREG: 1,F */
                    {
                       return SIM900_Rx_Buffer[index+j+1]; /*   'F' -     */
                    }
                    
                    /*  -  ""   */
                    if (Expected_Answer_Start==Answer_Command_List) /*  COMMAND:1975*#40; */
                    {
                       //return (index+j+1); /*       */
                      if (SIM900_Rx_Buffer[index+j+1]!=';')
                        return (index+j+1); /*       */
                      else
                        return 1; // ""    
                    }

                    /*  -  ""      GSM*/
                    if (Expected_Answer_Start==Answer_Location) /*  +CIPGSMLOC: 601 */
                    {
                       return (index+j+1); /*       */
                    }                    
                    
                      
                    /*  -  ""     */
                    if (Expected_Answer_Start==Answer_CLCC_MOC) /*  +CLCC: 1,0,F */
                    {
                       return SIM900_Rx_Buffer[index+j+1]; /*   'F' -    */
                    }


                    /*  -  ""    GSM-*/
                    if (Expected_Answer_Start==Answer_SIGNAL) /*  +CSQ: xx, */
                    {
                       if (SIM900_Rx_Buffer[index+j+2]==',')
                       {
                          i=SIM900_Rx_Buffer[index+j+1] - 0x30;
                       }
                       else
                       {
                          i=10*(SIM900_Rx_Buffer[index+j+1] - 0x30) + (SIM900_Rx_Buffer[index+j+2] - 0x30);
                       }
                       return i; /*   GSM- */
                    }
 
                    
                    /*  -  ""     SMS */
                    if (Expected_Answer_Start==Answer_SMS_MEM) /*  +CPMS: F, */
                    {
                       return SIM900_Rx_Buffer[index+j+1]; /*   'F' -  SMS   SIM */
                    }

                    
                    
                    /*  -  ""     SMS */
                    if (Expected_Answer_Start==Answer_ALL_SMS) /*  +CMGL: F,"REC READ" */
                    {
                       /*     SMS       GSM-*/
                       FLAG_ANALIZING_SET; //      
                       return (index+j+1); /*      ,    SMS*/
                    }
                    
                    return 1; /*    */
                      
                  }
              }
              Expected_Answer=Expected_Answer_Start;
            }
        }
        //   ERROR  SIM900
        if ( Check_Answer(Answer_Error,Received_DataLength) )  return 0;    
     }
    
    //vTaskDelay(10/portTICK_RATE_MS);
    
  }
  
  return result;
}
/*******************************************************************************
* Function Name  : PDP_Deactivation
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void PDP_Deactivation (void) 
{
  vTaskDelay(500/portTICK_RATE_MS);
 
  //close current connection
  Send_Command_To_SIM900 (Cmd_IP_Close, strlen(Cmd_IP_Close));
  Wait_For_SIM900_Answer (Answer_Close_OK, 7*GSM_ANSWER_WAIT_1SEC); 
  
  //deact pdp content
  Send_Command_To_SIM900 (Cmd_IP_Shut, strlen(Cmd_IP_Shut));
  Wait_For_SIM900_Answer (Answer_Shut_OK, 7*GSM_ANSWER_WAIT_1SEC);  

  //Send_Command_To_SIM900 (Cmd_GPRS_Detach, strlen(Cmd_GPRS_Detach));
  //Wait_For_SIM900_Answer (Answer_OK, 3*GSM_ANSWER_WAIT_1SEC);

  
}
/*******************************************************************************
* Function Name  : GPRS_Ini
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void GPRS_Ini(void) 
{

static  TypeDef_APN Current_APN=Default_APN;


  Send_Command_To_SIM900 (Cmd_IMEI, strlen(Cmd_IMEI));
  if ( Wait_For_SIM900_Answer (Answer_IMEI, GSM_ANSWER_WAIT_1SEC)!= IMEI_MAX_LEN ) 
  {
    Send_Command_To_SIM900 (Cmd_IMEI, strlen(Cmd_IMEI));
    Wait_For_SIM900_Answer (Answer_IMEI, GSM_ANSWER_WAIT_1SEC); 
  }

  //   APN (   )
  Send_Command_To_SIM900 (Cmd_CSPN, strlen(Cmd_CSPN));
  Current_APN= (TypeDef_APN) Wait_For_SIM900_Answer (Answer_CSPN, GSM_ANSWER_WAIT_1SEC);
  if (Current_APN==KYIVSTAR_APN_contract) Cmd_APN_=APN_KS_contract;
  if (Current_APN==MTS_APN_contract) Cmd_APN_=APN_MTS_contract;
  if (Current_APN==UTEL_APN) Cmd_APN_=APN_Utel;

  if ( *(char *)(APN_USER)) Cmd_APN_ = (char *) (APN_USER); //,     APN

  Send_Command_To_SIM900 (Cmd_GPRS_Attach, strlen(Cmd_GPRS_Attach));
  Wait_For_SIM900_Answer (Answer_OK, 3*GSM_ANSWER_WAIT_1SEC);
  
  PDP_Deactivation();
  
  Send_Command_To_SIM900 (Cmd_Auto_Off, strlen(Cmd_Auto_Off));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);

  //SET APN - "AT+CIPCSGP=1,"www.ab.kyivstar.net"\r";
  Send_Command_To_SIM900 (Cmd_APN, strlen(Cmd_APN));
  Send_Command_To_SIM900_ (Cmd_APN_, strlen(Cmd_APN_));
  Send_Command_To_SIM900_ ("\"\r", 2);
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
  
  Send_Command_To_SIM900 (Cmd_IP_Single, strlen(Cmd_IP_Single));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
 
  Send_Command_To_SIM900 (Cmd_IP_Non_Tr, strlen(Cmd_IP_Non_Tr));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);

  //Send_Command_To_SIM900 (Cmd_IP_Head, strlen(Cmd_IP_Head));
  //Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);  
  
  //Send_Command_To_SIM900 (Cmd_IP_Srip, strlen(Cmd_IP_Srip));
  //Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);

}
/*******************************************************************************
* Function Name  : SIM900_Ini
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void SIM900_Ini(void) 
{ 

  /* / GSM-      */
  while (!SIM900_Auto_Baud()) SIM900_ON();

  vTaskDelay(1000/portTICK_RATE_MS);

  Send_Command_To_SIM900 (Cmd_ATE0, strlen(Cmd_ATE0));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
  
  //   STK
  Send_Command_To_SIM900 (Cmd_STKAR_, strlen(Cmd_STKAR_));
  if (!Wait_For_SIM900_Answer (Answer_STKAR2, 2*GSM_ANSWER_WAIT_1SEC))
  {
    //,   ERROR  SIM900
    if (!Check_Answer(Answer_Error,Received_DataLength))
    {
      //  - 
      Send_Command_To_SIM900 (Cmd_STKAR2, strlen(Cmd_STKAR2));
      Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
    
      //   
      Send_Command_To_SIM900 (Cmd_ATW, strlen(Cmd_ATW));
      Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);  
      SIM900_ON();
      while (!SIM900_Auto_Baud()) SIM900_ON();
      vTaskDelay(1000/portTICK_RATE_MS);
      Send_Command_To_SIM900 (Cmd_ATE0, strlen(Cmd_ATE0));
      Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
    }
  }

  vTaskDelay(1500/portTICK_RATE_MS);
  
  Send_Command_To_SIM900 (Cmd_CPIN, strlen(Cmd_CPIN));
  if (!Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC)) 
  {
    System_GSM_Debug(No_SIM_Text, strlen(No_SIM_Text));
    No_SIM_Card=1;
  } 
  else
  {
     No_SIM_Card=0;
  }

  Send_Command_To_SIM900 (Cmd_CLIP, strlen(Cmd_CLIP));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
  
  

  Send_Command_To_SIM900 (Cmd_CMGF, strlen(Cmd_CMGF));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
  
  Send_Command_To_SIM900 (Cmd_CSCS_GSM, strlen(Cmd_CSCS_GSM));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
  
  Send_Command_To_SIM900 (Cmd_MIC, strlen(Cmd_MIC));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 

  Send_Command_To_SIM900 (Cmd_SP, strlen(Cmd_SP));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
  
  //Send_Command_To_SIM900 (Cmd_ECHO, strlen(Cmd_ECHO));
  //Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);    

  //Send_Command_To_SIM900 (Cmd_SIDET, strlen(Cmd_SIDET));
  //Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
  
  Send_Command_To_SIM900 (Cmd_CREG, strlen(Cmd_CREG));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 

  Send_Command_To_SIM900 (Cmd_DDET_ON, strlen(Cmd_DDET_ON));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 

  Send_Command_To_SIM900 (Cmd_SET_CENG, strlen(Cmd_SET_CENG));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
  
  Send_Command_To_SIM900 (Cmd_SET_SJDR, strlen(Cmd_SET_SJDR));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
  
  //Send_Command_To_SIM900 (Cmd_CLTS_, strlen(Cmd_CLTS_));
  //Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
  
  //Send_Command_To_SIM900 (Cmd_CLTS, strlen(Cmd_CLTS));
  //Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 

  //Send_Command_To_SIM900 (Cmd_ATW, strlen(Cmd_ATW));
  //Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
  
  /*       GSM-*/
  No_Registration=NO_REGISTRATION_LEN-1;
  
  GPRS_Ini();

}

/*******************************************************************************
* Function Name  : SIM900_UART_Config
* Description    :   UART    GSM-
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void SIM900_UART_Config(void)
{
  GPIO_InitTypeDef  GPIO_InitStruct;
  USART_InitTypeDef USART_InitStructure;
  
  RCC_APB2PeriphClockCmd(SIM900_APB_PERIPH_PIN, ENABLE);

   /* !!!    UART*/
  if (SIM900_UART==USART1)
  {
    RCC_APB2PeriphClockCmd(SIM900_APB_PERIPH_UART, ENABLE);
  } 
  else
  {
    RCC_APB1PeriphClockCmd(SIM900_APB_PERIPH_UART, ENABLE); 
  }
  
  GPIO_InitStruct.GPIO_Pin = SIM900_PIN_TX;
  GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(SIM900_PORT, &GPIO_InitStruct);

  GPIO_InitStruct.GPIO_Pin = SIM900_PIN_RX;
  GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_Init(SIM900_PORT, &GPIO_InitStruct);
 
  USART_InitStructure.USART_BaudRate = SIM900_UART_BAUD;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_Init(SIM900_UART, &USART_InitStructure);
  USART_Cmd(SIM900_UART, ENABLE);
  
  NVIC_InitTypeDef NVIC_InitStructure;
  NVIC_InitStructure.NVIC_IRQChannel = SIM900_UART_IRQN; 
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; 
  NVIC_Init(&NVIC_InitStructure);  
  
  /*      */
  //NVIC_EnableIRQ(SIM900_UART_IRQN);
  USART_ITConfig(SIM900_UART, USART_IT_IDLE, ENABLE); 
  
  USART_ITConfig(SIM900_UART, USART_IT_RXNE, ENABLE);
  
}

/*******************************************************************************
* Function Name  : Task_GSM_Data_Analize
* Description    :     ,     GSM_UART
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Task_GSM_Data_Analize( void *pvParameters )
{
  portBASE_TYPE                 xStatus;
  //portBASE_TYPE                 xTaskWoken;
  TypeDef_PRINT_DEBUG           xMessage; 
  portTickType                  xTicksToWait = 0;
  TypeDef_EVENT                 Event;
  unsigned short int z;
  char i;
  
  /*       . */
  for( ;; )
  {
     /*     .    
         , . .  ,     
          .     ,  
           xSemaphoreTake()    
        '' () .  ,   
            xSemaphoreTake(). */
     xSemaphoreTake( xSemaphore_GSM_UART_Handler, portMAX_DELAY );
     /*    ,    .
               */
     
            z=Check_Answer(Answer_Command_List, Received_DataLength);
            if (z>1)
            {
              FLAG_ANALIZING_SET; //      
              Analize_Command(SIM900_Rx_Buffer, z, OKO_SERVER);
              FLAG_ANALIZING_RESET; //      
            } 

            // ,       
            if (Check_Answer(Answer_NO_CARRIER, Received_DataLength)) No_Carrier=1; //   "" 
            
            // ,    DTMF-
            i=Check_Answer(Answer_DTMF, Received_DataLength);
            if (i) dtmf_code=i;
      
             //    URC  Jamming Detection
            if (Check_Answer (URC_Jamming_Detection, Received_DataLength))
            {
              //    ,         GSM
              if ((* (char *) JAMMING_BEEP) && (!Output_Time_Out[OUTPUT_SIRENA]) ) Sirena (* (char *) JAMMING_BEEP);
              FLAG_GSM_JUMMING_DETECTION_SET;
            }  

             //    URC  RING
            if (Check_Answer (URC_RING, Received_DataLength))
            {
              FLAG_SIM900_RING_SET;
            } 

             //    URC  SMS
            if (Check_Answer (URC_SMS, Received_DataLength))
            {
              //    SMS 
              FLAG_SIM900_SMS_SET;
            } 
            
            //     
            if (Check_Answer (Answer_Closed, Received_DataLength))
            {
              FLAG_DICONNECT_SET;
            }  
            
            //     SIM    SMS
            if (SMS_Ready_timeout) {if (Check_Answer (Answer_SMS_Ready, Received_DataLength))  SMS_Ready_timeout=0;}
            
            if ( (*(char*) GPRS_PROTOCOL == UDP_VPN_LUN_7T) && (Received_DataLength<4) )
            {
              //    
              if (SIM900_Rx_Buffer[0]==0x51)
              {
                //  
                Event.Code_Event=SERVER_QUERY_EVENT; 
                Save_Event_to_Buffer(Event);
              }
              if (SIM900_Rx_Buffer[0]==0x52)
              {
                Arm(ALL_GROUP, 1, REMOUT_PULT); //    
              }              
            }
            
            if (USB_Mode==DebugMode || USB_Mode==ModemMode)
              {

                //        DEBUG 
                xMessage.Debug_Data_Len = Received_DataLength;
                xMessage.Debug_Source_ID = ReceiveDataFromSIM900_Debug_ID;
                xMessage.Debug_Char_Data = SIM900_Rx_Buffer;
                xMessage.Debug_Data_type=Debug_Data_type_ASCII;

    
                //     DEBUG     
                xStatus = xQueueSendToBack(Queue_Print_Debug, &xMessage, xTicksToWait ); 
                if( xStatus != pdPASS )
                {
                  //    .  . 
        
                }
              } 
    
     
  }
}
/*******************************************************************************
* Function Name  : SIM900_UART_IRQHANDLER
* Description    :     UART
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SIM900_UART_IRQHANDLER (void)
{
  //portBASE_TYPE                 xStatus;
  //portBASE_TYPE                 xTaskWoken;
  //TypeDef_PRINT_DEBUG           xMessage; 
  portBASE_TYPE                 xHigherPriorityTaskWoken=pdFALSE;
 
  char i;
  char end_of_line;
  static unsigned short int Current_position=0;
  //unsigned short int z;
  
  /* USART in Receiver mode */
  if ( (USART_GetITStatus(SIM900_UART, USART_IT_RXNE) == SET) || (USART_GetITStatus(SIM900_UART, USART_IT_IDLE) == SET) ) 
  {
      
        end_of_line=0;
        
        /*    */
        if ( USART_GetITStatus(SIM900_UART, USART_IT_IDLE) == SET ) 
            {end_of_line=1; USART_ClearITPendingBit(SIM900_UART, USART_IT_IDLE);} 
          //else
            //{USART_ClearITPendingBit(SIM900_UART, USART_IT_RXNE);}
        
        /* Receive Transaction data */
	i=USART_RECEIVE_DATA_GSM;

        
        if (!FLAG_ANALIZING_STATE)
        {
          
          if (!end_of_line)
          {
            SIM900_Rx_Buffer[Current_position]=i;
            Current_position++;
          }
          
          if ( (Current_position>=SIM900_RX_BUFFER_SIZE) || (end_of_line)  ) //buffer is full or  end of line
          {
            //      
            SIM900_Rx_Buffer[Current_position] ='\0';
            Received_DataLength=Current_position;
            Current_position=0;
            FLAG_DATA_RECEIVED_SET;
            
            // ''    . 
            xSemaphoreGiveFromISR( xSemaphore_GSM_UART_Handler, &xHigherPriorityTaskWoken );
            
          }
        }
  }
  
  
}

/*******************************************************************************
* Function Name  : Send_Command_To_SIM900_
* Description    :   
* Input          : char * data, uint16_t data_len
* Output         : None
* Return         : None
*******************************************************************************/
void Send_Command_To_SIM900_( const char *data, uint16_t data_len) 
{ 
  portBASE_TYPE xStatus;
  const portTickType xTicksToWait = DEBUG_WAIT / portTICK_RATE_MS;
  TypeDef_PRINT_DEBUG xMessage; 

  
  xMessage.Debug_Data_Len = data_len;
  xMessage.Debug_Char_Data = (char *) data;
  
  
  if (USB_Mode==DebugMode)
   {
 
    /*        DEBUG */  

    xMessage.Debug_Source_ID = Send_Command_To_SIM900_Debug_ID;
    xMessage.Debug_Data_type=Debug_Data_type_ASCII;
        
    /*   .
          -   .  
          ,     pvParameters.
            - ,    
          Blocked,      ,
            */
    xStatus = xQueueSendToBack(Queue_Print_Debug, &xMessage, xTicksToWait );
    if( xStatus != pdPASS )
     {
         /*    ,    xTicksToWait .
             . */
     }
   }

  /*     UART- GSM-*/

  /*  100 mc*/
  vTaskDelay(100/portTICK_RATE_MS);  
  
  /* send data to UART Modem */
  while(data_len)
  {
    // clear flag, send byte, wait cleared flag
    USART_ClearFlag(SIM900_UART, USART_FLAG_TC);
    USART_SendData_GSM(*data);
    while(USART_GetFlagStatus(SIM900_UART,USART_FLAG_TC) == RESET) {}
    data++;
    data_len--;
  } 
    
}

/*******************************************************************************
* Function Name  : Send_Command_To_SIM900
* Description    :   
* Input          : char * data, uint16_t data_len
* Output         : None
* Return         : None
*******************************************************************************/
void Send_Command_To_SIM900( const char *data, uint16_t data_len) 
{ 
  /*  400 mc*/
  vTaskDelay(400/portTICK_RATE_MS);  
  /*     UART- GSM-*/  
  Send_Command_To_SIM900_( data, data_len);
}


/*******************************************************************************
* Function Name  : Save_Incoming_Call
* Description    :    
* Input          : 
* Output         :       Incoming_Phone_Number
* Return         :   , 0 -   
*******************************************************************************/
char Save_Incoming_Call( unsigned short int i )
{
  char j;
  if (i)
  {
    Incoming_Phone_Number[0]='\0';
    for (j=0; j < PHONE_MAX_LEN; j++)
    {
       if (SIM900_Rx_Buffer[i]!='\"')
       {
         if ( (j==0) && (SIM900_Rx_Buffer[i]!='+') )
          {
           Incoming_Phone_Number[j]='+'; // SIM800C +CLIP: "380672201234",145,"",0,"",0
           j=1;
          }
         Incoming_Phone_Number[j]=SIM900_Rx_Buffer[i];
       }
       else 
       {
           Incoming_Phone_Number[j]='\0';
           return j;
       } 
       i++;
    }
           
    Incoming_Phone_Number[0]='\0';
    return 0;
    
  }
  
 
  return 0;
}

/*******************************************************************************
* Function Name  : Check_Command
* Description    :    -
* Input          : i -      
*                  Command_List -    
*                  _Command -     
* Output         : None
* Return         : >0- ,   -; 0- 
*******************************************************************************/
char Check_Command (char *Command_List, const char *_Command, unsigned short int i)
{
  char k,j=strlen(_Command);
  
  for (k=0; k<j; k++)
  {
    if (Command_List[i+k]!=*_Command) return 0;
    _Command++;
  }
  return j;
}

/*******************************************************************************
* Function Name  : Check_Parameter_End
* Description    :     -   
* Input          : data -    -
* Output         : 
* Return         : 2 -  ( ), 1 -    , 0 -  
*******************************************************************************/
char Check_Parameter_End (char data)
{
  if (data==0x0d) return 0;
  if (data==0x0a) return 0;
  if (data==';') return 0;
  if (data=='\0') return 0;
  if (data==',') return 2;
  return 1;
}

/*******************************************************************************
* Function Name  : Save_Owner_Phone_to_EEPROM
* Description    :      
* Input          : OWNER_PHONE_W -        
*                  Phone_Number -    ,    
*                  i -      
* Output         : 
* Return         : >=0 -   ( ), -1 -  
*******************************************************************************/
signed char Save_Owner_Phone_to_EEPROM(uint16_t OWNER_PHONE_W, char *Phone_Number, unsigned short int i)
{
  signed char z=-1;
  char j, k, high=1, low=1;
  uint16_t data;
  
  // 8   2       
  for (k=0; (k<8 && !(high==0 || low==0)); k++)
  {
    high=Phone_Number[i+k*2];
    j=Check_Parameter_End(high);
    if (j!=1) high=0;
    if (j==2) z=k*2; // 
    low=0;
    if (high!=0)
     {
     low=Phone_Number[i+k*2+1];
     j=Check_Parameter_End(low);
     if (j!=1) low=0;
     if (j==2) z=k*2+1; // 
     }
    //  
    data=(((uint16_t)(high))<<8) | low;
    Virtual_EEPROM(OWNER_PHONE_W+k, & data, SAVE_DATA_EEPROM);
  }
  

  if ( !(high==0 || low==0) ) 
    {if (Check_Parameter_End(Phone_Number[i+k*2])==2) z=k*2;} // 

  return z;
}

/*******************************************************************************
* Function Name  : Save_USSD_Query
* Description    :  USSD-
* Input          : _Command_Buffer -     -
*                  i -    -
* Output         : 
* Return         : !-1 -   ( ), -1 -  
*******************************************************************************/
signed char Save_USSD_Query (char *_Command_Buffer, unsigned short int i)
{
  signed char z=-1;
  char j, k;
  USSD_Query[0]='\0';
  for (k=0; k<USSD_QUERY_MAX_LEN; k++)
  {
    j=Check_Parameter_End(_Command_Buffer[i+k]);
    if (j==1) USSD_Query[k]=_Command_Buffer[i+k];
    if (j==0) break;
    if (j==2) {z=k; break;}//   
  }
  USSD_Query[k]='\0';
  return z;
}
/*******************************************************************************
* Function Name  : Clear_from_EEPROM
* Description    :     -  00000
* Input          : Pointer_W -      
*			len -   
*                  _Command_Buffer -     -
*                  i -    -
* Output         : 
* Return         : 0 -    ( ), -1 -  
*******************************************************************************/
signed char Clear_from_EEPROM (uint16_t Pointer_W, char *_Command_Buffer, unsigned short int i, char len)
{
  
  signed char z=-1;
  uint16_t eeprom_data;
  char j;

  eeprom_data=0x0000;
  // 
  for (j=0; j<len; j++)
  {
    Virtual_EEPROM(Pointer_W+j, & eeprom_data, SAVE_DATA_EEPROM);
  }

  if (Check_Parameter_End(_Command_Buffer[i])==2) z=0; // 

  return z;
}


/*******************************************************************************
* Function Name  : Save_PIN_to_EEPROM
* Description    :   - (4 )
* Input          : _Command_Buffer -     -
*                  i -    -
* Output         : 
* Return         : 4 -   ( ), -1 -  
*******************************************************************************/
signed char Save_PIN_to_EEPROM (char *_Command_Buffer, unsigned short int i)
{
  char j;
  uint16_t eeprom_data;
  
  
  //    -     4 
  for (j=0; j<4; j++)
  {
   if (Check_Parameter_End(_Command_Buffer[i+j])!=1) return -1;
  }

  //    
  eeprom_data=(uint16_t) ((((uint16_t)(_Command_Buffer[i+0]))<<8) | _Command_Buffer[i+1]);
  Virtual_EEPROM(PIN_CODE_W1, & eeprom_data, SAVE_DATA_EEPROM);
  eeprom_data=(uint16_t) ((((uint16_t)(_Command_Buffer[i+2]))<<8) | _Command_Buffer[i+3]);
  Virtual_EEPROM(PIN_CODE_W2, & eeprom_data, SAVE_DATA_EEPROM);
  

  if (Check_Parameter_End(_Command_Buffer[i+4])==2) return 4; else return -1;

}

/*******************************************************************************
* Function Name  : Save_Param_to_EEPROM
* Description    :        ,  ,  , "", ""
* Input          : T_type:  
*               SAVE_ARM_DELAY -    , 
*               SAVE_ALARM_DELAY -  
*               SAVE_SENSOR_GROUP -  
*               SAVE_SENSOR_SILENT - ""
*               SAVE_SENSOR_24H - ""
*                ..
*                  _Command_Buffer -     
*                  i -     
* Output         : 
* Return         : >=0 -   ( ), -1 -  
*******************************************************************************/
signed char Save_Param_to_EEPROM(char T_type, char *_Command_Buffer, unsigned short int i)
{
  uint16_t eeprom_data, temp;
  signed char z=-1;
  char j, len=0, radio=0, d=0, sensor=0, parameter=0, k;
  #define SEPARATION              '#'

  //  
  //5#2   -1  2   
  //8#7   -8  7 
  //*10#5   -10  5 
  //*3#0   -3  0 

  //       
  j=_Command_Buffer[i+len];
  
  if ( !( ( (j>0x2F) && (j<0x3A)) || (j=='#') || (j=='*') ) )return -1; //     0..9, *  #
  switch (j) 
  {
 
   case '#': // 
   case '0': //  
     if ( (j=='0' && T_type==GET_TERMO) || (j=='#') ) 
     { 
      len++;
      j=_Command_Buffer[i+len];

      //   ,   
      if (j==',')
      { 
        z=len; // 
      }
      else
      {
        if ( Check_Parameter_End (j) ) return -1; //,       
      }
      
      if (T_type==GET_TERMO)
      {
        Get_Termo_Sensor=0;
        //       
        FLAG_TERMO_SEND_SET;        
      }
      else
      {
        /*     c  ,     */ 
        FLAG_PARAMETER_SEND_SET;
      }
      return z;
     }
     
   case '*': 
    radio=1; //  -      

    len++;
    j=_Command_Buffer[i+len];//   
    
    if (!( (j>0x2F) && (j<0x3A) )) return -1; //     0..9
    
   default: 
    d=j; //   

    len++;
    j=_Command_Buffer[i+len];//   
        
    if ( !( ((j>0x2F) && (j<0x3A)) || (j==SEPARATION) ) ) return -1; //     0..9  SEPARATION

    if (j==SEPARATION) //      
    {
      sensor=d-0x30; //
    }
    else
    {
      sensor=10*(d-0x30) + (j-0x30); //  

      len++;
      j=_Command_Buffer[i+len];//      
      
      if (j!=SEPARATION) return -1; //    SEPARATION
    }
  }
 
 
  //   /
  switch (T_type) 
   {
    case SAVE_ALARM_DELAY:
    case SAVE_SENSOR_GROUP:
    case SAVE_SENSOR_SILENT:
    case SAVE_SENSOR_24H:
    case GET_TERMO:
      if (radio)
      {
        // 
        if ( !( (sensor > 0) && (sensor < (MAX_RADIO_SENSOR+1) ) ) ) return -1; //,    1 ... MAX_RADIO_SENSOR
      }
      else
      {
        //
        if ( !( (sensor > 0) && (sensor < (MAX_WIRE_SENSOR+1) ) ) ) return -1; //,    1..MAX_WIRE_SENSOR
      } 
    break;

    case CLEAR_RADIO:
      if ( !( (sensor > 0) && (sensor < (MAX_RADIO_SENSOR+1) ) ) ) return -1; //,    1 ... MAX_RADIO_SENSOR
    break;
    
    case SAVE_OWNER_GROUP:
      if ( !( (sensor > 0) && (sensor < (MAX_OWNER+1) ) ) ) return -1; //,    1..MAX_OWNER
    break;

    case CLEAR_IBUTTON:
    case SAVE_IBUTTON_GROUP:
      if ( !( (sensor > 0) && (sensor < (MAX_IBUTTON+1) ) ) ) return -1; //,    1..MAX_BUTTON
    break; 

    case CLEAR_DS1820:
    case SAVE_DS1820_GROUP:
      if ( !( (sensor > 0) && (sensor < (MAX_DS1820+1) ) ) ) return -1; //,    1..MAX_DS1820
    break; 
    
    case SAVE_ARM_DELAY:
      //1wire, Receiver
      if ( !( (sensor == 0) || (sensor ==9) ) ) return -1; //,   0,9  
    break;

    
    default:
     return -1;
   }
  


  // 
  len++;
  j=_Command_Buffer[i+len];

  if (T_type==GET_TERMO)
  {
     //   ,   
     if (j==',')
      { 
        z=len; // 
      }
      else
      {
        z=-1;
      } 
     
     if (radio) Get_Termo_Sensor=sensor+MAX_DS1820; else Get_Termo_Sensor=sensor;
     
     //       
     FLAG_TERMO_SEND_SET;      
     return z; 
  }
  
  if (T_type==CLEAR_RADIO) 
	{ 
	  if (Clear_from_EEPROM(START_RADIO_ADDR + 2*(sensor-1), _Command_Buffer, i+len, 2)==0) return len; else return -1;
	}

  if (T_type==CLEAR_DS1820) 
	{ 
	  if (Clear_from_EEPROM(START_T_ADDR + 4*(sensor-1), _Command_Buffer, i+len, 4)==0) return len; else return -1;
	}

  if (T_type==CLEAR_IBUTTON) 
	{ 
	  if (Clear_from_EEPROM(START_IBUTTON_ADDR + 3*(sensor-1), _Command_Buffer, i+len, 3)==0) return len; else return -1;
	}

//   
  parameter = j-0x30;
  switch (T_type) 
   {
    case SAVE_SENSOR_GROUP:
    case SAVE_OWNER_GROUP:
    case SAVE_IBUTTON_GROUP:
    case SAVE_DS1820_GROUP:
      parameter =0;
      k=1;
      len--;
      //    -     MAX_GROUP  "0"  "1"
      for (j=0; j<MAX_GROUP; j++)
      {
        len++;
        if ( (_Command_Buffer[i+len]!='1') && (_Command_Buffer[i+len]!='0') ) return -1;
        parameter+= k*( _Command_Buffer[i+len]-0x30 );
        k*=2;
      }
      
    break;
     
    case SAVE_ARM_DELAY:
    case SAVE_ALARM_DELAY:
     if ( !( (j>0x2F) && (j<0x38) ) ) return -1; // "" -    0..7 
    break;
     
    case SAVE_SENSOR_SILENT:
    case SAVE_SENSOR_24H:
     if ( !( (j>0x2F) && (j<0x32) ) ) return -1; //    0..1 
    break;
     
    default:
     return -1;
   }
  
  
  len++;
  j=_Command_Buffer[i+len];

  //   ,   
  if (j==',')
   { 
     z=len; // 
   }
   else
   {
      if ( Check_Parameter_End (j) ) return -1; //,       
   } 

  //   
  if (T_type==SAVE_ARM_DELAY)
  {
    /*   EEPROM     */
    //  0,   
    if (Virtual_EEPROM (ANSWER_ARM_PARAMETER_W, & eeprom_data, READ_DATA_EEPROM)) 
    {
      eeprom_data=ANSWER_ARM_PARAMETER_DEFAULT; //   ,          
    }
    //      1W1
    if (sensor==0) eeprom_data = (eeprom_data & (~(0x0007<<ARM_1W1_DELAY_POSITION))) | (uint16_t)(parameter<<ARM_1W1_DELAY_POSITION);
    //      RS485
    if (sensor==9) eeprom_data = (eeprom_data & (~(0x0007<<ARM_RS485_DELAY_POSITION))) | (uint16_t)(parameter<<ARM_RS485_DELAY_POSITION);
    
    Virtual_EEPROM (ANSWER_ARM_PARAMETER_W, & eeprom_data, SAVE_DATA_EEPROM);
  }

  // 
  if ( (T_type==SAVE_OWNER_GROUP) || (T_type==SAVE_SENSOR_GROUP) || (T_type==SAVE_IBUTTON_GROUP) || (T_type==SAVE_DS1820_GROUP) )
  { 
    if ( (!radio) && (T_type==SAVE_SENSOR_GROUP) ) 
      {temp=IN_1_2_GROUP_W; eeprom_data=GROUP_SENSOR_DEFAULT; Wire_Sensor.Group[sensor-1]=parameter;}
    if (radio && (T_type==SAVE_SENSOR_GROUP) ) 
      {temp=RADIO_1_2_GROUP_W; eeprom_data=GROUP_SENSOR_DEFAULT; RF_Sensor.Group[sensor-1]=parameter;}
    if (T_type==SAVE_OWNER_GROUP) 
      {temp=OWNER_1_2_GROUP_W; eeprom_data=GROUP_OWNER_DEFAULT; Owner.Group[sensor-1]=parameter; }
    if (T_type==SAVE_IBUTTON_GROUP) 
      {temp=IBUTTON_1_2_GROUP_W; eeprom_data=GROUP_IBUTTON_DEFAULT; IButton.Group[sensor-1]=parameter; }
    if (T_type==SAVE_DS1820_GROUP) 
      {temp=DS1820_1_2_GROUP_W; eeprom_data=GROUP_DS1820_DEFAULT; DS1820_Sensor.Group[sensor-1]=parameter; } 
    
     /*   EEPROM  */
     //  0,   
     if (Virtual_EEPROM (temp + ((sensor-1)>>1), & eeprom_data, READ_DATA_EEPROM)) 
     {
     }    

     if (sensor%2==0)  // 
       eeprom_data = (eeprom_data & 0xFF00) | (uint16_t)(parameter); 
     else // 
       eeprom_data = (eeprom_data & 0x00FF) | ( ((uint16_t)(parameter) )<<8);
    
     Virtual_EEPROM (temp + ((sensor-1)>>1), & eeprom_data, SAVE_DATA_EEPROM);
    
  }
  
  
  // , "", ""
  if ( (T_type==SAVE_ALARM_DELAY) || (T_type==SAVE_SENSOR_SILENT) || (T_type==SAVE_SENSOR_24H) )
  {
     if (radio) temp=RADIO_1_2_PARAMETER_W; else temp=IN_1_2_PARAMETER_W;
   
     /*   EEPROM  /*/
     //  0,   
     if (Virtual_EEPROM (temp + ((sensor-1)>>1), & eeprom_data, READ_DATA_EEPROM)) 
     {
       if (radio) eeprom_data=RF_SENSOR_DEFAULT; else eeprom_data=WIRE_SENSOR_DEFAULT; //   ,          
     }
     
     switch (T_type) 
      {
       case SAVE_ALARM_DELAY:
        if (sensor%2==0)  // 
          eeprom_data = (eeprom_data & (~(0x0007<<SENSOR_DELAY_POSITION))) | (uint16_t)(parameter<<SENSOR_DELAY_POSITION); 
	else // 
          eeprom_data = (eeprom_data & (~(0x0007<<(8+SENSOR_DELAY_POSITION)))) | (uint16_t)(parameter<<(8+SENSOR_DELAY_POSITION));
        break;
        
       case SAVE_SENSOR_SILENT:
        if (sensor%2==0)  // 
          eeprom_data = (eeprom_data & (~(0x0001<<SENSOR_SILENT_POSITION))) | (uint16_t)(parameter<<SENSOR_SILENT_POSITION); 
	else // 
          eeprom_data = (eeprom_data & (~(0x0001<<(8+SENSOR_SILENT_POSITION)))) | (uint16_t)(parameter<<(8+SENSOR_SILENT_POSITION));
        break; 
        
       case SAVE_SENSOR_24H:
        if (sensor%2==0)  // 
          eeprom_data = (eeprom_data & (~(0x0001<<SENSOR_24H_POSITION))) | (uint16_t)(parameter<<SENSOR_24H_POSITION); 
	else // 
          eeprom_data = (eeprom_data & (~(0x0001<<(8+SENSOR_24H_POSITION)))) | (uint16_t)(parameter<<(8+SENSOR_24H_POSITION));
        break; 
        
       default:
        return -1;      
      }
     
     Virtual_EEPROM (temp + ((sensor-1)>>1), & eeprom_data, SAVE_DATA_EEPROM);

     if (radio) 
      {
       if (sensor%2==0) 
	  {RF_Sensor.Parameter[sensor-1]= (char) (eeprom_data & 0x00FF);}
	  else
	  {RF_Sensor.Parameter[sensor-1]= (char) ((eeprom_data>>8) & 0x00FF);}
      }
      else
      {
	if (sensor%2==0) 
	  {Wire_Sensor.Parameter[sensor-1]= (char) (eeprom_data & 0x00FF);}
	  else
	  {Wire_Sensor.Parameter[sensor-1]= (char) ((eeprom_data>>8) & 0x00FF);}
      }	

  }

   
 return z;
}
/*******************************************************************************
* Function Name  : Save_Temperature_to_EEPROM
* Description    :     
* Input          : T_type:  
*                       SAVE_T_MIN_SETTING- Tmin 
*                       SAVE_T_MAX_SETTING - Tmax
*                       SAVE_T_N_SETTING - T nagrev
*                  _Command_Buffer -     
*                  i -     
* Output         : 
* Return         : >=0 -   ( ), -1 -  
*******************************************************************************/
signed char Save_Temperature_to_EEPROM(char T_type, char *_Command_Buffer, unsigned short int i)
{
  #define TERMO_SEPARATION              '#'
  signed char z=-1;
  char j, len=0, radio=0, minus=0, d=0, sensor=0, temperature=0x80;
  uint16_t eeprom_data;
  
  //  
  //r5#-4  *5#-4 	         5, =-4
  //r12#+25  *12#+25 	 12, =+25
  //1#45 	                 DS1820 1, =+45
  //7#-10	                 DS1820 7, =-10

  //       
  j=_Command_Buffer[i+len];
  
  if ( !( ((j>0x2F) && (j<0x3A)) || (j=='r') || (j=='*') ) )return -1; //     0..9, *  r
  
  switch (j) 
  {
    
   case 'r':
   case '*': 
    radio=1; //  -      

    len++;
    j=_Command_Buffer[i+len];//   
    
    if (!((j>0x2F) && (j<0x3A))) return -1; //     0..9
    
   default: 
    d=j; //   

    len++;
    j=_Command_Buffer[i+len];//   
        
    if ( !( ((j>0x2F) && (j<0x3A)) || (j==TERMO_SEPARATION) ) ) return -1; //     0..9  TERMO_SEPARATION
    if (j==TERMO_SEPARATION) //      
    {
      sensor=d-0x30; //
    }
    else
    {
      sensor=10*(d-0x30) + (j-0x30); //  

      len++;
      j=_Command_Buffer[i+len];//      
      
      if (j!=TERMO_SEPARATION) return -1; //    TERMO_SEPARATION
    }
  }
  
  //      
  if (radio)
  {
    // 
    if ( !( (sensor > 0) && (sensor <= MAX_RADIO_SENSOR) ) ) return -1; //,    1 ... MAX_RADIO_SENSOR
  }
  else
  {
    // DS1820
    if ( !( (sensor > 0) && (sensor <= MAX_DS1820) ) ) return -1; //,    1 ... MAX_DS1820
    
  }



  //  
  len++;
  j=_Command_Buffer[i+len];
  
  if ( !( (j>0x2F && j<0x3A) || (j=='+') || (j=='-') ) ) return -1; //     0..9  +  -  

  switch (j) 
  {
    
   case '-':

     minus=1; //  
 
   case '+':

    len++;
    j=_Command_Buffer[i+len];//   
    
    if (!(j>0x2F && j<0x3A)) return -1; //     0..9
     
   default:

    d=j; //  

    len++;
    j=_Command_Buffer[i+len];//  
    
    
    if (j>0x2F && j<0x3A) 
     {
      //     0..9
      temperature=10*(d-0x30) + (j-0x30); //  
      if (minus && temperature) temperature = 256 - temperature;

      len++;
      j=_Command_Buffer[i+len];

      //   ,   
      if (j==',')
       { 
	z=len; // 
       }
       else
       {
         if ( Check_Parameter_End (j) ) return -1; //,       
       }
     }
     else
     {
      temperature = d-0x30; //
      if (minus && temperature) temperature = 256 - temperature;

      //   ,   
      if (j==',')
       { 
	z=len; // 
       }
       else
       {
         if ( Check_Parameter_End (j) ) return -1; //,       
       }	

     }
     
  }

  if ( (T_type==SAVE_T_N_SETTING) && (temperature==99) ) temperature=NO_TEMPERATURE; // 

  //   
  if (radio)
   {
      // 
      if (T_type==SAVE_T_N_SETTING)
      {
        //  0,   
        if (Virtual_EEPROM (RADIO_1_2_T_NAGREV_W + ((sensor-1)>>1), & eeprom_data, READ_DATA_EEPROM)) 
        {
          eeprom_data=T_N_DEFAULT; //. 
        }
        
        if (sensor%2==0)  // 
        {
          eeprom_data = (eeprom_data & 0xFF00) | (uint16_t)(temperature);
          RF_Sensor.Tn[sensor-1]= (char) (eeprom_data & 0x00FF);
        } 
        else // 
        {
          eeprom_data = (eeprom_data & 0x00FF) | ( ((uint16_t)(temperature) )<<8);
          RF_Sensor.Tn[sensor-1]= (char) ((eeprom_data>>8) & 0x00FF);
        }
    
        Virtual_EEPROM (RADIO_1_2_T_NAGREV_W + ((sensor-1)>>1), & eeprom_data, SAVE_DATA_EEPROM);        
      }
      else
      {
        //  0,   
        if (Virtual_EEPROM (RADIO_1_MIN_MAX_W + (sensor-1), & eeprom_data, READ_DATA_EEPROM)) 
        {
          eeprom_data=( ((uint16_t)(T_MIN)) << 8 ) | ( (uint16_t)(T_MAX) ); //=+5, =+40
        }

        if (T_type==SAVE_T_MAX_SETTING) eeprom_data= (eeprom_data & 0xFF00) | (uint16_t) temperature; 
          else eeprom_data= (eeprom_data & 0x00FF) | ( ((uint16_t) temperature) <<8 );

        /*   Tmin, Tmax*/
        Virtual_EEPROM (RADIO_1_MIN_MAX_W + (sensor-1), & eeprom_data, SAVE_DATA_EEPROM); 
      }
   }
   else
   {
    // DS1820
      if (T_type==SAVE_T_N_SETTING)
      {
        //  0,   
        if (Virtual_EEPROM (DS1820_1_2_T_NAGREV_W + ((sensor-1)>>1), & eeprom_data, READ_DATA_EEPROM)) 
        {
          eeprom_data=T_N_DEFAULT; //. 
        }
        if (sensor%2==0)  // 
        {
          eeprom_data = (eeprom_data & 0xFF00) | (uint16_t)(temperature);
          DS1820_Sensor.Tn[sensor-1]= (char) (eeprom_data & 0x00FF);
        } 
        else // 
        {
          eeprom_data = (eeprom_data & 0x00FF) | ( ((uint16_t)(temperature) )<<8);
          DS1820_Sensor.Tn[sensor-1]= (char) ((eeprom_data>>8) & 0x00FF);
        }
    
        Virtual_EEPROM (DS1820_1_2_T_NAGREV_W + ((sensor-1)>>1), & eeprom_data, SAVE_DATA_EEPROM);        
      }
      else
      {     
        //  0,   
        if (Virtual_EEPROM (DS1820_1_MIN_MAX_W + (sensor-1), & eeprom_data, READ_DATA_EEPROM)) 
        {
          eeprom_data=( ((uint16_t)(T_MIN)) << 8 ) | ( (uint16_t)(T_MAX) ); //=+5, =+40
        }

        if (T_type==SAVE_T_MAX_SETTING) eeprom_data= (eeprom_data & 0xFF00) | (uint16_t) temperature; 
          else eeprom_data= (eeprom_data & 0x00FF) | ( ((uint16_t) temperature) <<8 );

        /*   Tmin, Tmax*/
        Virtual_EEPROM (DS1820_1_MIN_MAX_W + (sensor-1), & eeprom_data, SAVE_DATA_EEPROM); 
      }
   }
  

  
  return z;
}




/*******************************************************************************
* Function Name  : Save_P_to_EEPROM
* Description    :   
* Input          : _Command_Buffer -     
*                  i -    
*		   mode: 
*			SAVE_ANSWER_SETTING -  ; 
*			SAVE_SMS_SETTING -  -; 
*			SAVE_RING_SETTING -   
*                       SAVE_SMS_ARM_SETTING -  -   ;
*                       SAVE_SMS_DISARM_SETTING -  -   ;
*			SAVE_TAMPER_GROUP -    
*			SAVE_220V_GROUP -    220
* Output         : 
* Return         : 8 -   ( ), -1 -  
*******************************************************************************/
signed char Save_P_to_EEPROM (char *_Command_Buffer, unsigned short int i, char mode)
{
  char j, k=1, config=0;
  uint16_t eeprom_data;
  
  
  //    -     8  "0"  "1"
  for (j=0; j<8; j++)
  {
   if ( (_Command_Buffer[i+j]!='1') && (_Command_Buffer[i+j]!='0') ) return -1;
   config+= k*( _Command_Buffer[i+j]-0x30 );
   k*=2;
  }

  if ( mode==SAVE_TAMPER_GROUP || mode==SAVE_220V_GROUP )
  {
    /*   EEPROM       220*/
    //  0,   
    if (Virtual_EEPROM (TAMPER_220_GROUP_W, & eeprom_data, READ_DATA_EEPROM)) 
     {
      eeprom_data=GROUP_TAMPER_POWER_DEFAULT; //   
     }

    if (mode==SAVE_TAMPER_GROUP) 
      eeprom_data=(0x00FF & eeprom_data) | (((uint16_t) config)<<8) ; 
    else 
      eeprom_data=(0xFF00 & eeprom_data) | (uint16_t) config ;
  
    
    Virtual_EEPROM (TAMPER_220_GROUP_W, & eeprom_data, SAVE_DATA_EEPROM);
  } 


  if ( (mode==SAVE_SMS_ARM_SETTING) || (mode==SAVE_SMS_DISARM_SETTING) )
  {
    /*   EEPROM  -  -1..-8     */
    //  0,   
    if (Virtual_EEPROM (SMS_ARM_DISARM_W, & eeprom_data, READ_DATA_EEPROM)) 
     {
      eeprom_data=SMS_ARM_DISARM_PARAMETER_DEFAULT; //   
     }

    if (mode==SAVE_SMS_ARM_SETTING) 
      eeprom_data=(0x00FF & eeprom_data) | (((uint16_t) config)<<8) ; 
    else 
      eeprom_data=(0xFF00 & eeprom_data) | (uint16_t) config ;
  
    
    Virtual_EEPROM (SMS_ARM_DISARM_W, & eeprom_data, SAVE_DATA_EEPROM);
  }  
  
  
  if (mode==SAVE_ANSWER_SETTING)
  {
    /*   EEPROM    -1..-8,     Ibutton,   */
    //  0,   
    if (Virtual_EEPROM (ANSWER_ARM_PARAMETER_W, & eeprom_data, READ_DATA_EEPROM)) 
     {
      eeprom_data=ANSWER_ARM_PARAMETER_DEFAULT; //   
     }
  
    eeprom_data=(0x00FF & eeprom_data) | (((uint16_t) config)<<8) ;

    Virtual_EEPROM (ANSWER_ARM_PARAMETER_W, & eeprom_data, SAVE_DATA_EEPROM);
  }
  
  if (mode==SAVE_SMS_SETTING || mode==SAVE_RING_SETTING)
  {
    /*   EEPROM     -  -1..-8 */
    //  0,   
    if (Virtual_EEPROM (SMS_RING_W, & eeprom_data, READ_DATA_EEPROM)) 
     {
      eeprom_data=SMS_RING_DEFAULT; //   
     }
  
    if (mode==SAVE_SMS_SETTING) eeprom_data=(0x00FF & eeprom_data) | (((uint16_t) config)<<8) ; else eeprom_data=(0xFF00 & eeprom_data) | (uint16_t) config ;

    Virtual_EEPROM (SMS_RING_W, & eeprom_data, SAVE_DATA_EEPROM);
  }

  
  if (Check_Parameter_End(_Command_Buffer[i+8])==2) return 8; else return -1;

}

/*******************************************************************************
* Function Name  : Ring_to_Phone
* Description    :      
* Input          : Phone_Number -   , owner - , short_call -  "" 
*                  alarm -     
*                  file -   
* Output         : None
* Return         : 0 - , !0 - 
*******************************************************************************/
char Ring_to_Phone (char * Phone_Number, char owner, char short_call, char alarm, const char * file)
{
  char i,k=0;
  unsigned short int state;

  if (!strlen(Phone_Number)) return 0; //,     0
  
  //       
  Send_Command_To_SIM900 (Cmd_ATD, strlen(Cmd_ATD));
  Send_Command_To_SIM900_ (Phone_Number, strlen(Phone_Number));
  Send_Command_To_SIM900_ (";\r", 2);
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);

  for (i = 0; i < 30; i++)
   { 
    /*   -   */  
    Send_Command_To_SIM900 (Cmd_CLCC, strlen(Cmd_CLCC));
    state=Wait_For_SIM900_Answer (Answer_CLCC_MOC, GSM_ANSWER_WAIT_1SEC);

    vTaskDelay(200/portTICK_RATE_MS);

    if (state==0) return k;

    if (state=='3') k++; //k=1; //    (  alert)	

    if (state=='0')
     {
       if (k)
       {
          //  
          Connect_for_DTMF_ (owner, 0, alarm, file);
          return 1;
       }
       else
       {
         //  
         break; //  
       }
     }

    vTaskDelay(800/portTICK_RATE_MS);
    
    if (short_call && (k>2) ) return k; //   "" 
    
   }
  
  //   
  Send_Command_To_SIM900 (Cmd_ATH, strlen(Cmd_ATH));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);

  return k;
}
/*******************************************************************************
* Function Name  : Arm_RS485
* Description    :     ,      RS485
* Input          : arm_group - ,    , who - 
*		   None
* Output         : Arm_Delay -     
* Return         : None
*******************************************************************************/
void Arm_RS485(char arm_group, char who)
{
uint16_t eeprom_data;
    /*   EEPROM       1Wire */
   //  0,   
   if (Virtual_EEPROM (ANSWER_ARM_PARAMETER_W, & eeprom_data, READ_DATA_EEPROM)) 
   {
      eeprom_data=ANSWER_ARM_PARAMETER_DEFAULT; //   ,    
      Virtual_EEPROM (ANSWER_ARM_PARAMETER_W, & eeprom_data, SAVE_DATA_EEPROM);
   }
   if ( 0x0007 & (eeprom_data>>ARM_RS485_DELAY_POSITION) )
	{ 
	 Arm_Delay= (char) (10 * ( 0x0007 & (eeprom_data>>ARM_RS485_DELAY_POSITION)));
	 Delay_arm_group |= arm_group;
         Delay_who=who;
	} 
   else 
	Arm(arm_group,0,who);
}

/*******************************************************************************
* Function Name  : Arm_Disarm
* Description    :   / 
* Input          : _Command_Buffer -     
*                  i -    
*                 owner - 
*		   arm: 
*			1 -   ; 
*			0 -   ; 
*               group 
*			
* Output         : 
* Return         : 0,1 -   ( ), -1 -  
*******************************************************************************/
signed char Arm_Disarm (char * _Command_Buffer, unsigned short int i, char owner, char arm, char group)
{
  char temp;
  signed char z;
  

  z=Check_Parameter_End(_Command_Buffer[i]);
  
  if ( (z==0) || (z==2))
    {
      if (z==2) z=0; else z=-1;
      
      if (owner==OKO_KB)
      {
        if (arm)
        { 
          if (group) 
            {Arm_RS485(group & (*(char*) KB_OKO_GROUP), owner );} 
          else 
            {Arm_RS485(ALL_GROUP & (*(char*) KB_OKO_GROUP), owner );}
        } 
        else 
        {
          if (group) 
            {Disarm(group & (*(char*) KB_OKO_GROUP), owner );} 
          else 
            {Disarm(ALL_GROUP & (*(char*) KB_OKO_GROUP), owner );}
        }
      }
      else
      { 
        ///    /
        if (owner==OKO_SERVER) 
        {
              if (arm)
              { 
                if (group) 
                   Arm(group,0, owner); 
                else 
                  Arm(ALL_GROUP,0, owner);
              } 
              else
              {
                if (group) 
                  Disarm(group, owner);
                else 
                  Disarm(ALL_GROUP, owner);
              }        
        }
        else
        {
          ///    ,  
          if ( (owner!=NOT_OWNER) && Owner.Group[owner]) 
            { 
              if (arm)
              { 
                if (group) 
                  { if (group & Owner.Group[owner]) Arm(group & Owner.Group[owner], 0, owner);} 
                else 
                  {Arm(Owner.Group[owner], 0, owner);}
              } 
              else
              {
                if (group) 
                  {if (group & Owner.Group[owner]) Disarm(group & Owner.Group[owner], owner);} 
                else 
                  {Disarm(Owner.Group[owner], owner);}
              }
            }
        }
      }
    }
    else
    {
     if (group==0)
     {  
      switch (_Command_Buffer[i]) 
  	{
          case '0': 
            temp=ALL_GROUP;
          break;

          case '1': 
            temp=GROUP_1;
          break;

          case '2': 
            temp=GROUP_2;
          break;

          case '3': 
            temp=GROUP_3;
          break;

          case '4': 
            temp=GROUP_4;
          break;

          case '5': 
            temp=GROUP_5;
          break;

          case '6': 
            temp=GROUP_6;
          break;

          case '7': 
            temp=GROUP_7;
          break;

          case '8': 
            temp=GROUP_8;
          break;

          default:
            temp=0;

	}
      
        z=-1;
      
	if (temp)
	{
           if (owner==OKO_KB)
            {
              if (arm) 
                {   
                  Arm_RS485(ALL_GROUP & temp & (*(char*)KB_OKO_GROUP), owner ); 
                }
                else 
                {
                  Disarm(ALL_GROUP & temp & (*(char*)KB_OKO_GROUP), owner );
                }
            }
            else
            {  
            
              ///    /
              if (owner==OKO_SERVER) 
              {
                if (arm)
                { 
                    Arm(temp,0, owner); 
                } 
                else
                {
                   Disarm(temp, owner);
                }        
              }
              else
              {  
                ///   ,  
                if (owner!=NOT_OWNER) 
		{ 
                  if (Owner.Group[owner] & temp)
                  { 
                    if (arm) 
                     {
                      Arm(Owner.Group[owner] & temp, 0, owner); 
                     }
                     else 
                     {
                       Disarm(Owner.Group[owner] & temp, owner);
                     }
                  }
                }
              }
            }

           if (Check_Parameter_End(_Command_Buffer[i+1])==2) z=1; else z=-1;
	 }
      } 
    } 
  return z;
}
/*******************************************************************************
* Function Name  : Analize_Command
* Description    :    
* Input          : Command_List -    , 
*               i -    
*               owner - 
* Output         : None
* Return         : 0 - -   , >0 -  
*******************************************************************************/ 
char Analize_Command (char * Command_List, unsigned short int i, char owner)
{
   char j;
   signed char z=0;
   uint16_t eeprom_data;
   TypeDef_EVENT Event;
   static char pin_error_num=MAX_PIN_ERROR_NUM;
   
   /*   
            vTaskDelay(500/portTICK_RATE_MS);
            taskENTER_CRITICAL (); 
            SendDataToHost ((Command_List+i),strlen(Command_List)-i);
            taskEXIT_CRITICAL (); 
   */
   
        //      - IMEI 
        for (j=0; j < strlen(IMEI_Number); j++)
        {
          if (Command_List[i+j]!=IMEI_Number[j]) z=1;
        }
        if ( (!z) && j ) {FLAG_DEFAULT_SETTING_SET; return 1;}
   
        //   -         (2 2-  )
        for (j=0; j < 2; j++)
        {
          //  0,   
          if (! Virtual_EEPROM (PIN_CODE_W1 + j, & eeprom_data, READ_DATA_EEPROM)) 
          {
            if (Command_List[i+j*2]!= (char) ((eeprom_data>>8) & 0xFF)) //high byte char
            {
              j=0;
              break;
            }
            
            if (Command_List[i+j*2+1]!=(char) ((eeprom_data) & 0xFF)) //low byte char
            {
              j=0;
              break;
            } 
          }
          else
          {
            j=0;
            break;
          }
        }
        
        
        // ,   ,    -       " "
        if (!j)
        {
          for (j=0; j < 4; j++)
          {
            if ( Command_List[i+j]!= *(char*)(FORCE_PIN + j) ) 
            {
              j=0;
              break;
            }            
          }
          
          if (j && ( (!pin_timeout) || (owner==OKO_SERVER) )) 
          {
            FLAG_FORCE_PIN_SET;
            i=i+4; //   -
            do
            {
              z=-1;
              j=Check_Command (Command_List, Disarmed_sms, i);
              i=i+j;
              if (j)
                {
                   z=Arm_Disarm (Command_List,i,owner,DISARM,0);
		} /*
		else
		{
		   j=Check_Command (Command_List, Armed_sms, i);
		   i=i+j;
		   if (j)
		     {
                       z=Arm_Disarm (Command_List,i,owner,ARM,0);
		     }
                }*/
              i=i+z+1; //z -   -   
            }
            while (z!=-1); //  do while
            FLAG_FORCE_PIN_RESET;
            return j;
          }
        }
 
        // ,   ,    -       " / "
        if (!j)
        {
          for (j=0; j < 4; j++)
          {
            if ( Command_List[i+j]!= *(char*)(ARM_DISARM_PIN + j) ) 
            {
              j=0;
              break;
            }            
          }
          
          if (j && ( (!pin_timeout) || (owner==OKO_SERVER) )) 
          {
            i=i+4; //   -
            do
            {
              z=-1;
              j=Check_Command (Command_List, Disarmed_sms, i);
              i=i+j;
              if (j)
                {
                   z=Arm_Disarm (Command_List,i,owner,DISARM,0);
		}
		else
		{
		   j=Check_Command (Command_List, Armed_sms, i);
		   i=i+j;
		   if (j)
		     {
                       z=Arm_Disarm (Command_List,i,owner,ARM,0);
		     }
                }
              i=i+z+1; //z -   -   
            }
            while (z!=-1); //  do while
            return j;
          }
        } 
        
        //  j>0,        
        if (j && ( (!pin_timeout) || (owner==OKO_SERVER) ))
        {
          if (owner!=OKO_SERVER) pin_error_num=MAX_PIN_ERROR_NUM;
          
          i=i+4; //   -
          /*   -  -  Debug- 
          vTaskDelay(500/portTICK_RATE_MS);
          taskENTER_CRITICAL (); 
          SendDataToHost (&SIM900_Rx_Buffer[i],strlen (SIM900_Rx_Buffer)-(i));
          taskEXIT_CRITICAL (); */

	  do //  do while
	  {
	   z=-1;
           j=Check_Command (Command_List, Save_Owner_1_Phone, i);
           i=i+j;
           if (j) 
	    {
	     z=Save_Owner_Phone_to_EEPROM(OWNER1_PHONE_W1,Command_List,i);
	    } 
	    else 
	    {
             j=Check_Command (Command_List, Save_Owner_2_Phone, i);
             i=i+j;
             if (j) 
	      {
	       z=Save_Owner_Phone_to_EEPROM(OWNER2_PHONE_W1,Command_List,i);
	      }
	      else
	      {
	       j=Check_Command (Command_List, Save_Owner_3_Phone, i);
	       i=i+j;
	       if (j)
	        {
		 z=Save_Owner_Phone_to_EEPROM(OWNER3_PHONE_W1,Command_List,i);
		}
		else
		{
		 j=Check_Command (Command_List, Save_Owner_4_Phone, i);
		 i=i+j;
		 if (j)
		  {
		   z=Save_Owner_Phone_to_EEPROM(OWNER4_PHONE_W1,Command_List,i);
		  }
		  else
		  {
		   j=Check_Command (Command_List, Save_Owner_5_Phone, i);
		   i=i+j;
		   if (j)
		    {
		     z=Save_Owner_Phone_to_EEPROM(OWNER5_PHONE_W1,Command_List,i);
		    }
		    else
		    {
		     j=Check_Command (Command_List, Save_Owner_6_Phone, i);
		     i=i+j;
		     if (j)
		      {
		       z=Save_Owner_Phone_to_EEPROM(OWNER6_PHONE_W1,Command_List,i);
		      }
		      else
		      {
		       j=Check_Command (Command_List, Save_Owner_7_Phone, i);
		       i=i+j;
		       if (j)
		        {
		         z=Save_Owner_Phone_to_EEPROM(OWNER7_PHONE_W1,Command_List,i);
		        }
		        else
		        {
		         j=Check_Command (Command_List, Save_Owner_8_Phone, i);
		         i=i+j;
		         if (j)
		          {
		           z=Save_Owner_Phone_to_EEPROM(OWNER8_PHONE_W1,Command_List,i);
		          }
		          else
		          {
		           j=Check_Command (Command_List, Clear_Owner_1_Phone, i);
		           i=i+j;
		           if (j)
		            {
		             z=Clear_from_EEPROM(OWNER1_PHONE_W1,Command_List,i,1);
		            }
		            else
		            {
		             j=Check_Command (Command_List, Clear_Owner_2_Phone, i);
		             i=i+j;
		             if (j)
		              {
		               z=Clear_from_EEPROM(OWNER2_PHONE_W1,Command_List,i,1);
		              }
		              else
		              {
		               j=Check_Command (Command_List, Clear_Owner_3_Phone, i);
		               i=i+j;
		               if (j)
		                {
		                 z=Clear_from_EEPROM(OWNER3_PHONE_W1,Command_List,i,1);
		                }
		                else
		                {
		                 j=Check_Command (Command_List, Clear_Owner_4_Phone, i);
		                 i=i+j;
		                 if (j)
		                  {
		                   z=Clear_from_EEPROM(OWNER4_PHONE_W1,Command_List,i,1);
		                  }
		                  else
		                  {
		                   j=Check_Command (Command_List, Clear_Owner_5_Phone, i);
		                   i=i+j;
		                   if (j)
		                    {
		                     z=Clear_from_EEPROM(OWNER5_PHONE_W1,Command_List,i,1);
		                    }
		                    else
		                    {
		                     j=Check_Command (Command_List, Clear_Owner_6_Phone, i);
		                     i=i+j;
		                     if (j)
		                      {
		                       z=Clear_from_EEPROM(OWNER6_PHONE_W1,Command_List,i,1);
		                      }
		                      else
		                      {
		                       j=Check_Command (Command_List, Clear_Owner_7_Phone, i);
		                       i=i+j;
		                       if (j)
		                        {
		                         z=Clear_from_EEPROM(OWNER7_PHONE_W1,Command_List,i,1);
		                        }
		                        else
		                        {
		                         j=Check_Command (Command_List, Clear_Owner_8_Phone, i);
		                         i=i+j;
		                         if (j)
		                          {
		                           z=Clear_from_EEPROM(OWNER8_PHONE_W1,Command_List,i,1);
		                          }
		                          else
		                          {
		                           j=Check_Command (Command_List, Disarmed_sms, i);
		                           i=i+j;
		                           if (j)
		                            {
                                              z=Arm_Disarm (Command_List,i,owner,DISARM,0);
		                            }
		                            else
		                            {
		                             j=Check_Command (Command_List, Armed_sms, i);
		                             i=i+j;
		                             if (j)
		                              {
                                                z=Arm_Disarm (Command_List,i,owner,ARM,0);
		                              }
		                              else
		                              {
		                               j=Check_Command (Command_List, Change_PIN, i);
		                               i=i+j;
		                               if (j)
		                                {
					         /*   - */   
		                                 z=Save_PIN_to_EEPROM(Command_List,i);
		                                }
		                                else
		                                {
		                                 j=Check_Command (Command_List, Android_sms, i);
		                                 i=i+j;
		                                 if (j)
		                                  {
					           /*    Android-   */ 
  						   FLAG_ANDROID_SEND_SET;
		                                   if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;
		                                  }
		                                  else
		                                  {
		                                  j=Check_Command (Command_List, Config_sms, i);
		                                  i=i+j;
		                                  if (j) 
                                                  {
					           /*       */ 
  						   FLAG_CONFIG_SEND_SET;
		                                   if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;
                                                  }
						  else
						  {
		                                  j=Check_Command (Command_List, Out1_ON_Command, i);
		                                  i=i+j;
		                                  if (j) {OUT1_ON; FLAG_SAVE_OUTPUT_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Out1_OFF_Command, i);
		                                  i=i+j;
		                                  if (j) {OUT1_OFF; FLAG_SAVE_OUTPUT_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Out2_ON_Command, i);
		                                  i=i+j;
		                                  if (j) {OUT2_ON; FLAG_SAVE_OUTPUT_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Out2_OFF_Command, i);
		                                  i=i+j;
		                                  if (j) {OUT2_OFF; FLAG_SAVE_OUTPUT_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Out3_ON_Command, i);
		                                  i=i+j;
		                                  if (j) {OUT3_ON; FLAG_SAVE_OUTPUT_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Out3_OFF_Command, i);
		                                  i=i+j;
		                                  if (j) {OUT3_OFF; FLAG_SAVE_OUTPUT_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Out4_ON_Command, i);
		                                  i=i+j;
		                                  if (j) {OUT4_ON; FLAG_SAVE_OUTPUT_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Out4_OFF_Command, i);
		                                  i=i+j;
		                                  if (j) {OUT4_OFF; FLAG_SAVE_OUTPUT_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Out5_ON_Command, i);
		                                  i=i+j;
		                                  if (j) 
                                                    { 
                                                      #ifndef OKO_U2 
                                                        OUT5_ON; 
                                                        FLAG_SAVE_OUTPUT_SET;
                                                      #else
                                                        j=0; 
                                                      #endif
                                                      if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;                
                                                    }
						  else
						  {
		                                  j=Check_Command (Command_List, Out5_OFF_Command, i);
		                                  i=i+j;
		                                  if (j) 
                                                    { 
                                                      #ifndef OKO_U2 
                                                        OUT5_OFF; 
                                                        FLAG_SAVE_OUTPUT_SET;
                                                      #else
                                                        j=0; 
                                                      #endif
                                                      if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;                
                                                    }
						  else
						  {
		                                  j=Check_Command (Command_List, Out6_ON_Command, i);
		                                  i=i+j;
		                                  if (j) 
                                                    { 
                                                      #ifndef OKO_U2 
                                                        OUT6_ON; 
                                                        FLAG_SAVE_OUTPUT_SET;
                                                      #else
                                                        j=0; 
                                                      #endif
                                                      if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;                
                                                    }
						  else
						  {
		                                  j=Check_Command (Command_List, Out6_OFF_Command, i);
		                                  i=i+j;
		                                  if (j) 
                                                    { 
                                                      #ifndef OKO_U2 
                                                        OUT6_OFF; 
                                                        FLAG_SAVE_OUTPUT_SET;
                                                      #else
                                                        j=0; 
                                                      #endif
                                                      if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;                
                                                    }
						  else
						  {
		                                  j=Check_Command (Command_List, Out7_ON_Command, i);
		                                  i=i+j;
		                                  if (j) 
                                                    { 
                                                      #ifndef OKO_U2 
                                                        OUT7_ON; 
                                                        FLAG_SAVE_OUTPUT_SET;
                                                      #else
                                                        j=0; 
                                                      #endif
                                                      if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;                
                                                    }
						  else
						  {
		                                  j=Check_Command (Command_List, Out7_OFF_Command, i);
		                                  i=i+j;
		                                  if (j) 
                                                    { 
                                                      #ifndef OKO_U2 
                                                        OUT7_OFF; 
                                                        FLAG_SAVE_OUTPUT_SET;
                                                      #else
                                                        j=0; 
                                                      #endif
                                                      if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;                
                                                    }
						  else
						  {
		                                  j=Check_Command (Command_List, Out8_ON_Command, i);
		                                  i=i+j;
		                                  if (j) 
                                                    { 
                                                      #ifndef OKO_U2 
                                                        OUT8_ON; 
                                                        FLAG_SAVE_OUTPUT_SET;
                                                      #else
                                                        j=0; 
                                                      #endif
                                                      if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;                
                                                    }
						  else
						  {
		                                  j=Check_Command (Command_List, Out8_OFF_Command, i);
		                                  i=i+j;
		                                  if (j) 
                                                    { 
                                                      #ifndef OKO_U2 
                                                        OUT8_OFF; 
                                                        FLAG_SAVE_OUTPUT_SET;
                                                      #else
                                                        j=0; 
                                                      #endif
                                                      if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;                
                                                    }
						  else
						  {
		                                  j=Check_Command (Command_List,Set_Tmin,i);
		                                  i=i+j;
		                                  if (j) {z=Save_Temperature_to_EEPROM (SAVE_T_MIN_SETTING,Command_List,i); }
						  else
						  {
		                                  j=Check_Command (Command_List, Set_Tmax, i);
		                                  i=i+j;
		                                  if (j) {z=Save_Temperature_to_EEPROM (SAVE_T_MAX_SETTING,Command_List,i);}
						  else
						  {
		                                  j=Check_Command (Command_List, Netmon_sms, i);
		                                  i=i+j;
		                                  if (j) 
		                                  {
					           /*       GSM-*/ 
  						   FLAG_NETMON_SEND_SET;
		                                   if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;
		                                  }
						  else
						  {
		                                  j=Check_Command (Command_List, SMS_Owner, i);
		                                  i=i+j;
		                                  if (j) {z=Save_P_to_EEPROM(Command_List,i,SAVE_SMS_SETTING);}
						  else
						  {
		                                  j=Check_Command (Command_List, Ring_Owner, i);
		                                  i=i+j;
		                                  if (j) {z=Save_P_to_EEPROM(Command_List,i,SAVE_RING_SETTING);}
						  else
						  {
		                                  j=Check_Command (Command_List, Call_me, i);
		                                  i=i+j;
		                                  if (j) 
                                                   {
                                                     /*      */ 
  						     FLAG_CALL_SET;
		                                     if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;
                                                   }
						  else
						  {
		                                  j=Check_Command (Command_List, Answer_Owner, i);
		                                  i=i+j;
		                                  if (j) {z=Save_P_to_EEPROM(Command_List,i,SAVE_ANSWER_SETTING);}
						  else
						  {
		                                  j=Check_Command (Command_List, Arm_Delay_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_Param_to_EEPROM (SAVE_ARM_DELAY,Command_List,i);}
						  else
						  {
		                                  j=Check_Command (Command_List, Alarm_Delay_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_Param_to_EEPROM (SAVE_ALARM_DELAY,Command_List,i);}
						  else
						  {
		                                  j=Check_Command (Command_List, Sensor_Group_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_Param_to_EEPROM (SAVE_SENSOR_GROUP,Command_List,i);}
						  else
						  {
		                                  j=Check_Command (Command_List, Sensor_Silent_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_Param_to_EEPROM (SAVE_SENSOR_SILENT,Command_List,i);}
						  else
						  {
		                                  j=Check_Command (Command_List, Sensor_24h_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_Param_to_EEPROM (SAVE_SENSOR_24H,Command_List,i);}
						  else
						  {
		                                  j=Check_Command (Command_List, Owner_Group_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_Param_to_EEPROM (SAVE_OWNER_GROUP,Command_List,i);}
						  else
						  {
		                                  j=Check_Command (Command_List, IButton_Group_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_Param_to_EEPROM (SAVE_IBUTTON_GROUP,Command_List,i);}
						  else
						  {
		                                  j=Check_Command (Command_List, DS1820_Group_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_Param_to_EEPROM (SAVE_DS1820_GROUP,Command_List,i);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group1_Arm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,ARM,GROUP_1);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group1_Disarm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,DISARM,GROUP_1);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group2_Arm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,ARM,GROUP_2);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group2_Disarm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,DISARM,GROUP_2);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group3_Arm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,ARM,GROUP_3);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group3_Disarm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,DISARM,GROUP_3);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group4_Arm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,ARM,GROUP_4);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group4_Disarm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,DISARM,GROUP_4);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group5_Arm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,ARM,GROUP_5);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group5_Disarm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,DISARM,GROUP_5);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group6_Arm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,ARM,GROUP_6);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group6_Disarm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,DISARM,GROUP_6);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group7_Arm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,ARM,GROUP_7);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group7_Disarm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,DISARM,GROUP_7);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group8_Arm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,ARM,GROUP_8);}
						  else
						  {
		                                  j=Check_Command (Command_List, Group8_Disarm_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Arm_Disarm (Command_List,i,owner,DISARM,GROUP_8);}
						  else
						  {
		                                  j=Check_Command (Command_List, Set_Tn, i);
		                                  i=i+j;
		                                  if (j) {z=Save_Temperature_to_EEPROM (SAVE_T_N_SETTING,Command_List,i);}
						  else
						  {
		                                  j=Check_Command (Command_List, Arm_Disarm_Beep_Off_Command, i);
		                                  i=i+j;
		                                  if (j) {MODE_FLAG_ARM_DISARM_SILENT_SET; FLAG_SAVE_MODE_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Arm_Disarm_Beep_On_Command, i);
		                                  i=i+j;
		                                  if (j) {MODE_FLAG_ARM_DISARM_SILENT_RESET; FLAG_SAVE_MODE_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Arm_SMS_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_P_to_EEPROM(Command_List,i,SAVE_SMS_ARM_SETTING);}
						  else
						  {
		                                  j=Check_Command (Command_List, Disarm_SMS_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_P_to_EEPROM(Command_List,i,SAVE_SMS_DISARM_SETTING);}
						  else
						  {
		                                  j=Check_Command (Command_List, Tamper_Group_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_P_to_EEPROM(Command_List,i,SAVE_TAMPER_GROUP);}
						  else
						  {
		                                  j=Check_Command (Command_List, _220V_Group_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_P_to_EEPROM(Command_List,i,SAVE_220V_GROUP);}
						  else
						  {
		                                  j=Check_Command (Command_List, GPRS_On_Command, i);
		                                  i=i+j;
		                                  if (j) {MODE_FLAG_GPRS_SET; FLAG_SAVE_MODE_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, GPRS_Off_Command, i);
		                                  i=i+j;
		                                  if (j) {MODE_FLAG_GPRS_RESET; FLAG_SAVE_MODE_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Server_Query_Command, i);
		                                  i=i+j;
		                                  if (j) {Event.Code_Event=SERVER_QUERY_EVENT ; Save_Event_to_Buffer(Event); if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Arm_Not_Clear_Buffer_Command, i);
		                                  i=i+j;
		                                  if (j) {MODE_FLAG_NOT_CLEAR_BUFFER_SET; FLAG_SAVE_MODE_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Arm_Clear_Buffer_Command, i);
		                                  i=i+j;
		                                  if (j) {MODE_FLAG_NOT_CLEAR_BUFFER_RESET; FLAG_SAVE_MODE_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Arm_Check_Input_Command, i);
		                                  i=i+j;
		                                  if (j) {MODE_FLAG_CHECK_INPUT_SET; FLAG_SAVE_MODE_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Arm_Not_Check_Input_Command, i);
		                                  i=i+j;
		                                  if (j) {MODE_FLAG_CHECK_INPUT_RESET; FLAG_SAVE_MODE_SET; if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;}
						  else
						  {
		                                  j=Check_Command (Command_List, Program_ON_Command, i);
		                                  i=i+j;
		                                  if (j) 
							{
   								FLAG_PROGRAM_MODE_SET;
   								Program_Mode_Timeout=PROGRAM_MODE_TIMEOUT_LEN;
   								LED_OFF;
   								LED_Long_Flash=0;
   								LED_Short_Flash=4; //2    
								if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;
							}
						  else
						  {
		                                  j=Check_Command (Command_List, Program_OFF_Command, i);
		                                  i=i+j;
		                                  if (j) 
							{
   								FLAG_PROGRAM_MODE_RESET;
   								Program_Mode_Timeout=0;
   								LED_OFF;
   								LED_Long_Flash=0;
   								LED_Short_Flash=6; //3    
								if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;
							}
						  else
						  {
		                                  j=Check_Command (Command_List, Clear_IButton_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_Param_to_EEPROM (CLEAR_IBUTTON,Command_List,i);}
						  else
						  {
		                                  j=Check_Command (Command_List, Clear_DS1820_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_Param_to_EEPROM (CLEAR_DS1820,Command_List,i);}
						  else
						  {
		                                  j=Check_Command (Command_List, Clear_Radio_Command, i);
		                                  i=i+j;
		                                  if (j) {z=Save_Param_to_EEPROM (CLEAR_RADIO,Command_List,i);}
						  else
						  {
		                                  j=Check_Command (Command_List, Radio_Code_sms, i);
		                                  i=i+j;
		                                  if (j) 
							{
					           	/*        */ 
  						   	FLAG_RADIO_CODE_SEND_SET;
		                                   	if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;
							}
						  else
						  {
		                                  j=Check_Command (Command_List, Reset_Command, i);
		                                  i=i+j;
		                                  if (j) {FLAG_RESET_COMMAND_SET; z=-1;} //Device Restart Flag
						  else
						  {
		                                  j=Check_Command (Command_List, Termo_sms, i);
		                                  i=i+j;
		                                  if (j) {z=Save_Param_to_EEPROM (GET_TERMO,Command_List,i);}
                                                  /*{
					           //       
  						   FLAG_TERMO_SEND_SET;
		                                   if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;                                                  
                                                  }*/
						  else
						  {
		                                  j=Check_Command (Command_List, USSD_Command, i);
		                                  i=i+j;
		                                  if (j) 
                                                  {
					           /*    USSD- */ 
  						   FLAG_USSD_SEND_SET;
                                                   z=Save_USSD_Query (Command_List,i);                                                  
                                                  }
						  else
						  {
		                                  j=Check_Command (Command_List, Status_sms, i);
		                                  i=i+j;
		                                  if (j) 
                                                  {
 					           /*            */ 
  						   FLAG_STATUS_SEND_SET;
		                                   if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;                                                   
                                                  }
						  else
						  {
		                                  j=Check_Command (Command_List, GSM_Location_Command, i);
		                                  i=i+j;
		                                  if (j) 
                                                  {
 					           /*          */ 
  						   FLAG_GSM_LOCATION_SEND_SET;
		                                   if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;                                                   
                                                  }
						  else
						  {
		                                  j=Check_Command (Command_List, OKO_KBM_Load_FM_Command, i);
		                                  i=i+j;
		                                  if (j) 
                                                  {
 					           /*      -  FTP */ 
  						   FLAG_LOAD_OKO_KBM_FW_SET;
		                                   if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;                                                       
                                                  }
						  else
						  {
		                                  j=Check_Command (Command_List, OKO_RF_Load_FM_Command, i);
		                                  i=i+j;
		                                  if (j) 
                                                  {
 					           /*      -TRX  FTP */ 
  						   FLAG_LOAD_OKO_TRX_FW_SET;
		                                   if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;                                                     
                                                  }
						  else
						  {
		                                  j=Check_Command (Command_List, Standart_Load_FM_Command, i);
		                                  i=i+j;
		                                  if (j) 
                                                  {
 					           /*     ()    FTP */ 
  						   FLAG_LOAD_STANDART_FW_SET;
		                                   if (Check_Parameter_End(Command_List[i])==2) z=0; else z=-1;                                                     
                                                  }
						  else
						  {
		                                  j=Check_Command (Command_List, Load_FM_Command, i);
		                                  i=i+j;
		                                  if (j) 
                                                  {
 					           /*        FTP */
                                                    
                                                  }
						  else
						  {
		                                  j=Check_Command (Command_List, Next_Command, i);
		                                  i=i+j;
		                                  if (j) {}
						  else
						  {

						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
						  }
		                                  }
		                                }
		                              }
		                            }
		                          }
		                        }
		                      }
		                    }
		                  }
		                }
		              }
		            }
		          }
		        }
		      }
		    }
		  }
		}
	      }
	    }
	   i=i+z+1; //z -   -   
	  }          
	  while (z!=-1); //  do while
          
        
        }
        else
        {
           j=0;
           //     -,   -
           if (owner!=OKO_SERVER) 
           {
             if (!reset_pin_error_timeout) {reset_pin_error_timeout=RESET_PIN_ERROR_TIMEOUT_LEN; pin_error_num=MAX_PIN_ERROR_NUM;}
             pin_error_num--;
             if (!pin_error_num)
             {
                pin_timeout=PIN_TIMEOUT_LEN;
                pin_error_num=MAX_PIN_ERROR_NUM;
                Event.Code_Event= FRAUD_DETECTION_EVENT;
                Event.Group=ALL_GROUP;
                Save_Event_to_Buffer(Event);
             }
           }
        }
        
   return j;
}     
/*******************************************************************************
* Function Name  : Check_SMS
* Description    :    SMS
* Input          : 
* Output         : None
* Return         : 1- SMS; 0- SMS
*******************************************************************************/

char Check_SMS( void ) 
{
   unsigned short int i, sms_buffer_len; 
   char z, j, owner=NOT_OWNER;

   
   //if (No_SIM_Card) return 0; //   -
   
   if (FLAG_SIM900_RING_STATE) return 1; //    
   
   Send_Command_To_SIM900 (Cmd_SMS_MEM, strlen(Cmd_SMS_MEM));
   if (Wait_For_SIM900_Answer(Answer_SMS_MEM, GSM_ANSWER_WAIT_1SEC)!='0')
   {
      
      if (FLAG_SIM900_RING_STATE) return 1; //    
      
      Send_Command_To_SIM900 (Cmd_ALL_SMS, strlen(Cmd_ALL_SMS));
      //Send_Command_To_SIM900 (Cmd_UNREAD_SMS, strlen(Cmd_UNREAD_SMS));
      
      /*      ,    SMS*/
      i=Wait_For_SIM900_Answer (Answer_ALL_SMS, 10*GSM_ANSWER_WAIT_1SEC);
      if (i)
      {
         /*    ,   
        +CMGL: 1,"REC UNREAD","+38067","","14/07/11,17:01:04+12"
        123412+38067  */
        
        /*     ,  */
        sms_buffer_len=strlen (SIM900_Rx_Buffer);
        
        /*      SMS*/
        for (j=0; j<3 ; j++)
        {
          if (SIM900_Rx_Buffer[i+j]!=',') 
            Incoming_SMS_Position[j]= SIM900_Rx_Buffer[i+j];
           else 
           {
             Incoming_SMS_Position[j]='\r';
             Incoming_SMS_Position[j+1]='\0';
             break;
           }
        }

        /*     SMS*/
        for (i=i+j+1, j=0; i< sms_buffer_len; i++)
        {
          if (SIM900_Rx_Buffer[i]=='\"') j++;
          //   -    
          if (j==3) 
          {
            j=Save_Incoming_Call(i+1);
            
            /*   
            vTaskDelay(500/portTICK_RATE_MS);
            taskENTER_CRITICAL (); 
            SendDataToHost (Incoming_Phone_Number,strlen(Incoming_Phone_Number));
            taskEXIT_CRITICAL (); */
            
            break;
          } 
        }
 
        
        //        -1...-MAX_OWNER
        for (z=0; z < MAX_OWNER; z++)
          {     
            Copy_Owner_Phone_from_EEPROM (OWNER1_PHONE_W1+z*8);
      
            if ( Phone_Verification())  
            {
              owner=z; // 
            }
          }
 
        
        /*      SMS*/
        for (i=i+1+j; i< sms_buffer_len; i++)
        {
          if (SIM900_Rx_Buffer[i]==0x0a) break;
        }
        i++;
        
        
        if (
               ((owner < MAX_OWNER) && (0x01 & ( (* (char *) SMS_OWNER_DENIED)>>owner))) || //,    SMS- 
               ((owner == NOT_OWNER) && (0x01 & ( (* (char *) SMS_NOT_OWNER_DENIED)>>0)))  //,    SMS-     
            )
        {
          //  
        }
        else
        {
          /*   SMS-*/
          Analize_Command(SIM900_Rx_Buffer, i, owner);
        }
	//vTaskDelay(500/portTICK_RATE_MS);
        FLAG_ANALIZING_RESET; //      
        Wait_For_SIM900_Answer (Answer_OK, 3*GSM_ANSWER_WAIT_1SEC);
	//vTaskDelay(3500/portTICK_RATE_MS);         
                              
        /*   SMS */
        //Send_Command_To_SIM900 (Cmd_DEL_SMS, strlen(Cmd_DEL_SMS));
        //Send_Command_To_SIM900_ (Incoming_SMS_Position, strlen(Incoming_SMS_Position));
        
        /*   SMS */
        Send_Command_To_SIM900 (Cmd_DEL_ALL_SMS, strlen(Cmd_DEL_ALL_SMS));
        Wait_For_SIM900_Answer (Answer_OK, 3*GSM_ANSWER_WAIT_1SEC); 

      }
      return 1;
   }
   return 0;
}


/*******************************************************************************
* Function Name  : Phone_Verification
* Description    :       
* Input          : 
* Output         : None
* Return         : 1- ; 0- 
*******************************************************************************/

char Phone_Verification( void ) 
{
   char i, 
        Owner_Phone_Len=strlen(Owner_Phone_Number), 
        Phone_Tail_Len=Owner_Phone_Len,
        Incoming_Phone_Number_Len=strlen(Incoming_Phone_Number);
   
   if (!Owner_Phone_Len) return 0;
   
   if (Owner_Phone_Len > PHONE_TAIL_LEN) Phone_Tail_Len=PHONE_TAIL_LEN;
   
   for (i=0; i < Phone_Tail_Len; i++)
   {
      if (Incoming_Phone_Number[Incoming_Phone_Number_Len-1-i]!= Owner_Phone_Number[Owner_Phone_Len-1-i]) return 0;
   }
   
   return 1;
}

/*******************************************************************************
* Function Name  : Copy_Owner_Phone_from_EEPROM
* Description    :      
* Input          : OWNER_PHONE_W -      ( 8   2 )
* Output         :   Owner_Phone_Number
* Return         : i-   2-  
*******************************************************************************/
char Copy_Owner_Phone_from_EEPROM (uint16_t OWNER_PHONE_W)
{
   char i;
   uint16_t eeprom_data;
 
   Owner_Phone_Number[0]='\0';
   
   //    8 2-   (16 )
   for (i=0; i < 8; i++)
   {
      //  0,   
      if (! Virtual_EEPROM (OWNER_PHONE_W + i, & eeprom_data, READ_DATA_EEPROM)) 
      {
        Owner_Phone_Number[i*2]= (char) ((eeprom_data>>8) & 0xFF); //high byte char
        Owner_Phone_Number[i*2+1]=(char) ((eeprom_data) & 0xFF); //low byte char
      }
      else
      {
        Owner_Phone_Number[i*2]='\0';
        return i;
      }
      
   }
   
   return i;

}
/*******************************************************************************
* Function Name  : Check_Ring
* Description    :    ,     
* Input          : 
* Output         : None
* Return         : 1-  ; 0-  
*******************************************************************************/
char Check_Ring (void) 
{
  char i, owner=NOT_OWNER;;
  uint16_t eeprom_data;
   
  /*      */
  FLAG_SIM900_RING_RESET;
  
  /*     SMS */
  FLAG_SIM900_SMS_SET;
  
  /*    (+CLIP: "+38067xxxxxxx" ...)  2*GSM_ANSWER_WAIT_1SEC */
  if (Wait_For_SIM900_Answer (Answer_CLIP, 2*GSM_ANSWER_WAIT_1SEC)) 
    {

      //      -1...-MAX_OWNER
      for (i=0; i < MAX_OWNER; i++)
        {     
          Copy_Owner_Phone_from_EEPROM (OWNER1_PHONE_W1+i*8);
      
          if (Phone_Verification())  
          {
           owner=i;
     	   /*   EEPROM    -1..-8 */
     	   //  0,   
     	   if (Virtual_EEPROM (ANSWER_ARM_PARAMETER_W, & eeprom_data, READ_DATA_EEPROM)) 
      	   {
       	    eeprom_data=ANSWER_ARM_PARAMETER_DEFAULT; //   ,    
       	    Virtual_EEPROM (ANSWER_ARM_PARAMETER_W, & eeprom_data, SAVE_DATA_EEPROM);
      	   }
  
	   if ( 0x0001 & (eeprom_data>>(8+i)) )
	   {
            //      -  
            Connect_for_DTMF(owner,0x01 & ( (* (char *) NO_TIMEOUT)>>i) );
	   }
	   else
	   {
             
            //     
            //Wait_For_SIM900_Answer (Answer_CLIP, 2*GSM_ANSWER_WAIT_1SEC); //     ""
            //vTaskDelay(3500/portTICK_RATE_MS);
            
            if (0x01 & ( (* (char *) OUTPUT_BY_CALL)>>i))
            {
             //     ,  ,   
             Check_Out_Call();
            }
            else
            {
	     //  ,         -          
	     if ( 
                (MODE_ARM_STATE & Owner.Group[i]) ||                    //    ,   
                (Arm_Delay && (Delay_arm_group & Owner.Group[i]))       //       - ,   
                ) 
              Disarm(Owner.Group[i],owner); //   ,   
             else 
             {
              Arm(Owner.Group[i],0,owner);
              if ( 0x01 & ( (*(char*)ARM_CALLBACK )>>i) )
              {
                //    (        )
                //   
                //vTaskDelay(100/portTICK_RATE_MS);
                Send_Command_To_SIM900 (Cmd_ATH, strlen(Cmd_ATH));
                Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
                vTaskDelay(3000/portTICK_RATE_MS); // 3 
                // 
                /*       */
                if (!Ring_to_Phone(Incoming_Phone_Number, i, 1, 0, Answer_OK)) Ring_to_Phone(Incoming_Phone_Number, i, 1, 0, Answer_OK);
              }
             }
            }

      	    //   
	    //vTaskDelay(100/portTICK_RATE_MS);
      	    Send_Command_To_SIM900 (Cmd_ATH, strlen(Cmd_ATH));
      	    Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
	   }

	   //
           return 1;
          }
        }


      /*     -1...-8. 
	   ,         */
      if (FLAG_PROGRAM_MODE_STATE)
       {
	 Program_Mode_Timeout=PROGRAM_MODE_TIMEOUT_LEN; //  

	 //    
      	 for (i=0; i < MAX_OWNER; i++)
         {     
          Copy_Owner_Phone_from_EEPROM (OWNER1_PHONE_W1+i*8);
	  
          //   ,    
          if (strlen(Owner_Phone_Number)==0)  
          {
            owner=i;
            //       
	    Save_Owner_Phone_to_EEPROM (OWNER1_PHONE_W1+i*8,Incoming_Phone_Number,0);

            Sirena(1); //   
            LED_OFF;
            LED_Long_Flash=0;
            LED_Short_Flash=2; //1   

            // 
            Connect_for_DTMF(owner,0);
            return 1;
          }
         }
       }

	
      //   
      Send_Command_To_SIM900 (Cmd_ATH, strlen(Cmd_ATH));
      Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
      return 1;

    }
  
  return 0;
}


/*******************************************************************************
* Function Name  : Check_Answer
* Description    : 
* Input          : char *Expected_Answer -    ""
* Output         : None
* Return         : 0-     "", 
                  !=0 -   "",     ""
*******************************************************************************/ 
unsigned short int Check_Answer (const char *Expected_Answer, unsigned short int SIM900_InputDataLength) 
{ 

  unsigned short int            index;
  char                          j,ExpAnsLen;
  const char                    *Expected_Answer_Start;

    /*     "" */
    Expected_Answer_Start=Expected_Answer;  
    
    /*    "" */
    ExpAnsLen=strlen(Expected_Answer);
    if (SIM900_InputDataLength >= ExpAnsLen)
	{
         /*   GSM-.         "" */
        for (index=0; index < (SIM900_InputDataLength - ExpAnsLen + 1) ;  index++)
        {
          /*    GSM-   "" */
          if (*Expected_Answer==SIM900_Rx_Buffer[index])
            {
              /*    "",       GSM- */
              for (j=0; j < ExpAnsLen;  j++)
              {
                  /*   ,         */
                  if (*Expected_Answer!=SIM900_Rx_Buffer[index+j]) break;
                  Expected_Answer++;
                  
                  /* ,       "" */
                  if (j == (ExpAnsLen-1)) 
                  {
                    /*  ""     GSM-*/
                    /*  ,     "" */
                    
                    
                    /*  -  ""  DTMF*/
                    if (Expected_Answer_Start==Answer_DTMF) /*  +DTMF:F */
                    {
                      if (SIM900_Rx_Buffer[index+j+1]==' ')
                      {
                        return SIM900_Rx_Buffer[index+j+2]; /* SIM800C +DTMF: F  -   'F' -  DTMF- */
                      }
                      else
                      {
                        return SIM900_Rx_Buffer[index+j+1]; /* SIM900 +DTMF:F  -   'F' -  DTMF- */
                      }
                    }

                    /*  -  ""   */
                    if (Expected_Answer_Start==Answer_Command_List) /*  COMMAND:1975*#40; */
                    {
                       //return (index+j+1); /*       */
                      if (SIM900_Rx_Buffer[index+j+1]!=';')
                        return (index+j+1); /*       */
                      else
                        return 1; // ""    
                    }
                    
                    return 1; /*    */
                      
                  }
              }
              Expected_Answer=Expected_Answer_Start;
            }
        }
       } 
       
       
  
  return 0;  
}


/*******************************************************************************
* Function Name  : Record_Alarm_Message
* Description    :        ,    GSM-
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Record_Alarm_Message(const char * file)
{
  
 
 #ifndef OKO_U2
    /* AT-  GSM- SIM900*/
   Send_Command_To_SIM900 (Cmd_Memory_Init, strlen(Cmd_Memory_Init));
   Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);

   Send_Command_To_SIM900 (Cmd_Memory_Size, strlen(Cmd_Memory_Size));
   Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);

   Send_Command_To_SIM900 (Cmd_Memory_Term, strlen(Cmd_Memory_Term));
   Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
 
   /*      */
   Send_Command_To_SIM900 (Cmd_Play_Start, strlen(Cmd_Play_Start));
   Send_Command_To_SIM900_ (file, strlen(file));
   Send_Command_To_SIM900_ (Cmd_Play_End, strlen(Cmd_Play_End));
   Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
   
#else
   char * temp;
/* AT-  GSM- SIM800*/
   Send_Command_To_SIM900 (Cmd_Memory_Size, strlen(Cmd_Memory_Size));
   Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
   
   /*     DTMF-*/
   Send_Command_To_SIM900 (Cmd_DDET_OFF, strlen(Cmd_DDET_OFF));
   Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);  

   /*   -  */
   Send_Command_To_SIM900 (Cmd_TONE, strlen(Cmd_TONE));
   Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 

   /*   -    GSM-   */
   Send_Command_To_SIM900_ (Cmd_Record_Start, strlen(Cmd_Record_Start));
   Send_Command_To_SIM900_ (file, strlen(file));
   if (*(char*)(RECORD_END)) temp=(char *)(RECORD_END); else temp=(char *) Cmd_Record_End_default;
   Send_Command_To_SIM900_ (temp, strlen(temp));
   Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
   
   /*    */
   Wait_For_SIM900_Answer (Answer_Rec_Stop, 6*GSM_ANSWER_WAIT_1SEC);

   /*     DTMF-*/
   Send_Command_To_SIM900 (Cmd_DDET_ON, strlen(Cmd_DDET_ON));
   Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
  
   /*   -  */
   Send_Command_To_SIM900 (Cmd_TONE, strlen(Cmd_TONE));
   Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
   
   /*      */
   Send_Command_To_SIM900 (Cmd_Play_Start, strlen(Cmd_Play_Start));
   Send_Command_To_SIM900_ (file, strlen(file));
   if (*(char*)(PLAY_END)) temp=(char *)(PLAY_END); else temp=(char *) Cmd_Play_End_default;
   Send_Command_To_SIM900_ (temp, strlen(temp));
   Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
#endif   
}

/*******************************************************************************
* Function Name  : Connect_for_DTMF_
* Description    :  DTMF-
* Input          : owner - , 
*                  without_timeout -     
*                  alarm -   
*                  play -     
* Output         : None
* Return         : None
*******************************************************************************/

void Connect_for_DTMF_ ( char owner, char without_timeout, char alarm, const char * file ) 
{
  #define STAR_DTMF_COMMAND             7
  #define HASH_DTMF_COMMAND             6
  #define NUMBER_DTMF_COMMAND           5
  #define DTMF_0_COMMAND                4
  #define DTMF_9_COMMAND                3
  #define DTMF_1_COMMAND                2
  
  #define DTMF_COMMAND_TIMEOUT_LEN      50
  

  //unsigned short int    SIM900_InputDataLength;
  TypeDef_EVENT         Event;
  char i, dtmf_command=0;
  #ifdef OKO_U2
  char *temp;
  #endif
  
  No_Carrier=0;
  
  /*   -  */
  Send_Command_To_SIM900 (Cmd_TONE, strlen(Cmd_TONE));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);

  /*  -  DTMF-     GSM-*/
  DTMF_Command_Wait=DTMF_COMMAND_WAIT_30SEC;
  
  /*   GSM-   ""  GSM_Answer_Wait */
  while ( (DTMF_Command_Wait || without_timeout) && !No_Carrier )
  {
    /*   ""   */
    Task_GSM_Alive++;
    
    if (alarm)
    {
      /*   -    GSM-    */
      Send_Command_To_SIM900 (Cmd_Play_Start, strlen(Cmd_Play_Start));
      Send_Command_To_SIM900_ (file, strlen(file));
      #ifndef OKO_U2
        /* AT-  GSM- SIM900*/
        Send_Command_To_SIM900_ (Cmd_Play_End, strlen(Cmd_Play_End));
      #else  
        //SIM800
        if (*(char*)(PLAY_END)) temp=(char *)(PLAY_END); else temp=(char *)Cmd_Play_End_default;
        Send_Command_To_SIM900_ (temp, strlen(temp));
      #endif
      Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
      alarm=0; 
      Alarm_Voice=0;
    }
    
    if (Alarm_Voice)
    {
      /*   -    GSM-    */
      Send_Command_To_SIM900 (Cmd_Play_Start, strlen(Cmd_Play_Start));
      Send_Command_To_SIM900_ (Alarm_File, strlen(Alarm_File));
      #ifndef OKO_U2
        /* AT-  GSM- SIM900*/
        Send_Command_To_SIM900_ (Cmd_Play_End, strlen(Cmd_Play_End));
      #else
        //SIM800
        if (*(char*)(PLAY_END)) temp=(char *)(PLAY_END); else temp=(char *)Cmd_Play_End_default;
        Send_Command_To_SIM900_ (temp, strlen(temp));
      #endif
      Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
      Alarm_Voice=0; 
    }
    
    //   -     
     {
      if (!dtmf_command_timeout) dtmf_command=0;
      if (dtmf_code)
      {
        /* ,  DTMF-,  */
        /*  -  DTMF- */
        DTMF_Command_Wait=DTMF_COMMAND_WAIT_30SEC;      
	i=0;
        if (
              ((owner < MAX_OWNER) && (0x01 & ( (* (char *) DTMF_OWNER_DENIED)>>owner))) || //,    DTMF- 
              ((owner == NOT_OWNER) && (0x01 & ( (* (char *) DTMF_NOT_OWNER_DENIED)>>0)))  //,    DTMF-     
            ) 
        {
          //  DTMF-
        }
        else
        {        
        switch (dtmf_code)
        {
        case '0':
         dtmf_code=0;
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_9_COMMAND)) &&
              (0x01 & (dtmf_command>>DTMF_0_COMMAND)) 
             )
          {
            //    "  dtmf-
            Record_Alarm_Message(File_Wire[8]);
            dtmf_command=0;
          }
         else
         {           
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_9_COMMAND)) &&
              (0x01 & (dtmf_command>>DTMF_1_COMMAND))
             )
          {
            //      -10
            Record_Alarm_Message(File_Radio[9]); 
            dtmf_command=0;
          }
         else
         {           
          if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>NUMBER_DTMF_COMMAND))
             )
          {
            i=0;
            //  
            // 0,1,2 -   
            if ( (0x07 & dtmf_command) ==0x00 ) {OUT1_OFF; i=1;}
            if ( (0x07 & dtmf_command) ==0x01 ) {OUT2_OFF; i=1;}
            if ( (0x07 & dtmf_command) ==0x02 ) {OUT3_OFF; i=1;}
            if ( (0x07 & dtmf_command) ==0x03 ) {OUT4_OFF; i=1;}
            
            #ifndef OKO_U2
              if ( (0x07 & dtmf_command) ==0x04 ) {OUT5_OFF; i=1;}
              if ( (0x07 & dtmf_command) ==0x05 ) {OUT6_OFF; i=1;}
              if ( (0x07 & dtmf_command) ==0x06 ) {OUT7_OFF; i=1;}
              if ( (0x07 & dtmf_command) ==0x07 ) {OUT8_OFF; i=1;}
            #endif
              
            FLAG_SAVE_OUTPUT_SET; 
            dtmf_command=0;
            
          }
          else
          {
           if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_9_COMMAND))
             )
          {
            dtmf_command_timeout= DTMF_COMMAND_TIMEOUT_LEN;
            dtmf_command |=   (1<<DTMF_0_COMMAND);          
          }
          else
          {
          if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) 
             )            
          {
            dtmf_command_timeout= DTMF_COMMAND_TIMEOUT_LEN;
            dtmf_command |=   (1<<DTMF_0_COMMAND);
          }
          else
          {
            if (
                (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
                (0x01 & (dtmf_command>>NUMBER_DTMF_COMMAND))
                ) 
            {
              //  
              if (owner!=NOT_OWNER) 
              { 
                if ( Owner.Group[owner]  & (1<< (0x07 & dtmf_command)) ) 
                  Disarm( Owner.Group[owner] & (1<<(0x07 & dtmf_command)), owner );  // 0,1,2 -   
              }
              i=1;
              dtmf_command=0;              
            }
            else
            {
              if ( (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && (owner!=NOT_OWNER) )
              {
                /*    " " */
                FLAG_FORCE_PIN_SET;
              }
              dtmf_command=0;
              /*    */
              if (owner!=NOT_OWNER) { if (Owner.Group[owner]) Disarm(Owner.Group[owner], owner); }
              i=1;
            }
            }
           }
          }
         }
         }
          break;

        case '1':
         dtmf_code=0;
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_9_COMMAND)) &&
              ((0x01 & (dtmf_command>>DTMF_0_COMMAND)) || (0x01 & (dtmf_command>>DTMF_1_COMMAND)))
             )
          {
            //      -1/-11
            if (0x01 & (dtmf_command>>DTMF_0_COMMAND)) Record_Alarm_Message(File_Radio[0]); else  Record_Alarm_Message(File_Radio[10]);
            dtmf_command=0;
          }
         else
         {
          if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_9_COMMAND))
             )
          {
            dtmf_command_timeout= DTMF_COMMAND_TIMEOUT_LEN;
            dtmf_command |=   (1<<DTMF_1_COMMAND);          
          }
          else
          {
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_0_COMMAND))
             )
          {
            //      -1
            Record_Alarm_Message(File_Wire[0]); 
            dtmf_command=0;
          }
          else
          {
            if ( (0x01 & (dtmf_command >> STAR_DTMF_COMMAND)) && !(0x01 & (dtmf_command >> NUMBER_DTMF_COMMAND)) )
            {
              dtmf_command_timeout= DTMF_COMMAND_TIMEOUT_LEN;
              dtmf_command |=   (1<<NUMBER_DTMF_COMMAND) | 0x00 ; // 0,1,2 -   /
            }
            else
            {
              dtmf_command=0;          
              /*    */
              if (owner!=NOT_OWNER) { if (Owner.Group[owner]) Arm(Owner.Group[owner], 0, owner); }
              i=1;
            }
          }
          }
         }
          break;

        case '2':
         dtmf_code=0;
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_9_COMMAND)) &&
              ((0x01 & (dtmf_command>>DTMF_0_COMMAND)) || (0x01 & (dtmf_command>>DTMF_1_COMMAND)))
             )
          {
            //      -2/-12
            if (0x01 & (dtmf_command>>DTMF_0_COMMAND)) Record_Alarm_Message(File_Radio[1]); else  Record_Alarm_Message(File_Radio[11]);
            dtmf_command=0;
          }
         else
         {          
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_0_COMMAND))
             )
          {
            //      -2
            Record_Alarm_Message(File_Wire[1]); 
            dtmf_command=0;
          }
          else
          {
          
            if ( (0x01 & (dtmf_command >> STAR_DTMF_COMMAND)) && !(0x01 & (dtmf_command >> NUMBER_DTMF_COMMAND)) )
            {
              dtmf_command_timeout= DTMF_COMMAND_TIMEOUT_LEN;
              dtmf_command |=  (1<<NUMBER_DTMF_COMMAND) | 0x01 ; // 0,1,2 -   /
            }
            else
            {
              dtmf_command=0;          
          
              /*       */
              FLAG_STATUS_SEND_SET;
              DTMF_Command_Wait=0; //   
              i=1;
            }
          }
          }
          break;

        case '3':
         dtmf_code=0;
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_9_COMMAND)) &&
              ((0x01 & (dtmf_command>>DTMF_0_COMMAND)) || (0x01 & (dtmf_command>>DTMF_1_COMMAND)))
             )
          {
            //      -3/-13
            if (0x01 & (dtmf_command>>DTMF_0_COMMAND)) Record_Alarm_Message(File_Radio[2]); else  Record_Alarm_Message(File_Radio[12]);
            dtmf_command=0;
          }
         else
         {           
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_0_COMMAND)) 
             )
          {
            //      -3
            Record_Alarm_Message(File_Wire[2]); 
            dtmf_command=0;
          }
          else
          {
          
            if ( (0x01 & (dtmf_command >> STAR_DTMF_COMMAND)) && !(0x01 & (dtmf_command >> NUMBER_DTMF_COMMAND)) )
            {
              dtmf_command_timeout= DTMF_COMMAND_TIMEOUT_LEN;
              dtmf_command |=  (1<<NUMBER_DTMF_COMMAND) | 0x02 ; // 0,1,2 -   /
            }
            else
              dtmf_command=0;
          }
         }
          break;

        case '4':
         dtmf_code=0; 
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_9_COMMAND)) &&
              ((0x01 & (dtmf_command>>DTMF_0_COMMAND)) || (0x01 & (dtmf_command>>DTMF_1_COMMAND)))
             )
          {
            //      -4/-14
            if (0x01 & (dtmf_command>>DTMF_0_COMMAND)) Record_Alarm_Message(File_Radio[3]); else  Record_Alarm_Message(File_Radio[13]);
            dtmf_command=0;
          }
         else
         {           
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_0_COMMAND)) 
             )
          {
            //      -4
            Record_Alarm_Message(File_Wire[3]); 
            dtmf_command=0;
          }
          else
          {
          
            if ( (0x01 & (dtmf_command >> STAR_DTMF_COMMAND)) && !(0x01 & (dtmf_command >> NUMBER_DTMF_COMMAND)) )
            {
              dtmf_command_timeout= DTMF_COMMAND_TIMEOUT_LEN;
              dtmf_command |=  (1<<NUMBER_DTMF_COMMAND) | 0x03 ; // 0,1,2 -   /
            }
            else
              dtmf_command=0;  
          } 
         }       
          break;

        case '5':
         dtmf_code=0;
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_9_COMMAND)) &&
              ((0x01 & (dtmf_command>>DTMF_0_COMMAND)) || (0x01 & (dtmf_command>>DTMF_1_COMMAND)))
             )
          {
            //      -5/-15
            if (0x01 & (dtmf_command>>DTMF_0_COMMAND)) Record_Alarm_Message(File_Radio[4]); else  Record_Alarm_Message(File_Radio[14]);
            dtmf_command=0;
          }
         else
         {           
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_0_COMMAND)) 
             )
          {
            //      -5
            Record_Alarm_Message(File_Wire[4]); 
            dtmf_command=0;
          }
          else
          {
          
            if ( (0x01 & (dtmf_command >> STAR_DTMF_COMMAND)) && !(0x01 & (dtmf_command >> NUMBER_DTMF_COMMAND)) )
            {
              dtmf_command_timeout= DTMF_COMMAND_TIMEOUT_LEN;
              dtmf_command |=  (1<<NUMBER_DTMF_COMMAND) | 0x04 ; // 0,1,2 -   /
            }
            else
              dtmf_command=0;   
          } 
         }      
          break;

        case '6':
         dtmf_code=0;
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_9_COMMAND)) &&
              ((0x01 & (dtmf_command>>DTMF_0_COMMAND)) || (0x01 & (dtmf_command>>DTMF_1_COMMAND)))
             )
          {
            //      -6/-16
            if (0x01 & (dtmf_command>>DTMF_0_COMMAND)) Record_Alarm_Message(File_Radio[5]); else  Record_Alarm_Message(File_Radio[15]);
            dtmf_command=0;
          }
         else
         {           
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_0_COMMAND)) 
             )
          {
            //      -6
            Record_Alarm_Message(File_Wire[5]); 
            dtmf_command=0;
          }
          else
          {
          
            if ( (0x01 & (dtmf_command >> STAR_DTMF_COMMAND)) && !(0x01 & (dtmf_command >> NUMBER_DTMF_COMMAND)) )
            {
              dtmf_command_timeout= DTMF_COMMAND_TIMEOUT_LEN;
              dtmf_command |=  (1<<NUMBER_DTMF_COMMAND) | 0x05 ; // 0,1,2 -   /
            }
            else
              dtmf_command=0;  
          } 
         }       
          break;

        case '7':
         dtmf_code=0;
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_9_COMMAND)) &&
              (0x01 & (dtmf_command>>DTMF_0_COMMAND)) 
             )
          {
            //      -7
            Record_Alarm_Message(File_Radio[6]); 
            dtmf_command=0;
          }
         else
         {           
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_0_COMMAND)) 
             )
          {
            //      -7
            Record_Alarm_Message(File_Wire[6]); 
            dtmf_command=0;
          }
          else
          {
          
            if ( (0x01 & (dtmf_command >> STAR_DTMF_COMMAND)) && !(0x01 & (dtmf_command >> NUMBER_DTMF_COMMAND)) )
            {
              dtmf_command_timeout= DTMF_COMMAND_TIMEOUT_LEN;
              dtmf_command |=  (1<<NUMBER_DTMF_COMMAND) | 0x06 ; // 0,1,2 -   /
            }
            else
            {
              dtmf_command=0;
              Event.Code_Event=SERVER_QUERY_EVENT; 
              Save_Event_to_Buffer(Event);
              i=1; 
            }   
          } 
         }     
          break;

        case '8':
         dtmf_code=0;
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_9_COMMAND)) &&
              (0x01 & (dtmf_command>>DTMF_0_COMMAND)) 
             )
          {
            //      -8
            Record_Alarm_Message(File_Radio[7]); 
            dtmf_command=0;
          }
         else
         {           
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_0_COMMAND)) 
             )
          {
            //      -8
            Record_Alarm_Message(File_Wire[7]); 
            dtmf_command=0;
          }
          else
          {
          
            if ( (0x01 & (dtmf_command >> STAR_DTMF_COMMAND)) && !(0x01 & (dtmf_command >> NUMBER_DTMF_COMMAND)) )
            {
              dtmf_command_timeout= DTMF_COMMAND_TIMEOUT_LEN;
              dtmf_command |=  (1<<NUMBER_DTMF_COMMAND) | 0x07 ; // 0,1,2 -   / 
            }
            else
            {
              dtmf_command=0;          
              /*       */
              FLAG_CONFIG_SEND_SET;
              DTMF_Command_Wait=0; //   
              i=1;
            }   
          } 
         }      
          break;

        case '9':
         dtmf_code=0;
         if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>DTMF_9_COMMAND)) &&
              (0x01 & (dtmf_command>>DTMF_0_COMMAND)) 
             )
          {
            //      -9
            Record_Alarm_Message(File_Radio[8]);
            dtmf_command=0;
          }
         else
         {           
          if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>NUMBER_DTMF_COMMAND))
             )
          {
            i=0;
            //  
            // 0,1,2 -   
            if ( (0x07 & dtmf_command) ==0x00 ) {OUT1_ON; i=1;}
            if ( (0x07 & dtmf_command) ==0x01 ) {OUT2_ON; i=1;}
            if ( (0x07 & dtmf_command) ==0x02 ) {OUT3_ON; i=1;}
            if ( (0x07 & dtmf_command) ==0x03 ) {OUT4_ON; i=1;}
            
            #ifndef OKO_U2
              if ( (0x07 & dtmf_command) ==0x04 ) {OUT5_ON; i=1;}
              if ( (0x07 & dtmf_command) ==0x05 ) {OUT6_ON; i=1;}
              if ( (0x07 & dtmf_command) ==0x06 ) {OUT7_ON; i=1;}
              if ( (0x07 & dtmf_command) ==0x07 ) {OUT8_ON; i=1;}
            #endif
              
            FLAG_SAVE_OUTPUT_SET;             
            dtmf_command=0;
            
          }
          else
          {
            if (
              (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
              (0x01 & (dtmf_command>>HASH_DTMF_COMMAND)) 
             )            
            {
              dtmf_command_timeout= DTMF_COMMAND_TIMEOUT_LEN;
              dtmf_command |=   (1<<DTMF_9_COMMAND);
            }
            else
            {            
            
              if (
                (0x01 & (dtmf_command>>STAR_DTMF_COMMAND)) && 
                (0x01 & (dtmf_command>>NUMBER_DTMF_COMMAND))
                ) 
              {
                //  
                if (owner!=NOT_OWNER) 
                { 
                  if ( Owner.Group[owner]  & (1<<(0x07 & dtmf_command)) ) 
                    Arm( Owner.Group[owner] & (1<<(0x07 & dtmf_command)), 0, owner ); // 0,1,2 -   
                }
                i=1;
                dtmf_command=0;              
              }
              else
              {
                dtmf_command=0;
                /*  */

                //i=1;
              }
            }
          }
         }
          break;

        case '*':
          dtmf_code=0;
          dtmf_command = (1<<STAR_DTMF_COMMAND);
          dtmf_command_timeout= DTMF_COMMAND_TIMEOUT_LEN;
          break;
        
        case '#':
          dtmf_code=0;
          if ( 
              (0x01 & (dtmf_command >> STAR_DTMF_COMMAND)) && 
              !(0x01 & (dtmf_command >> HASH_DTMF_COMMAND)) &&
              !(0x01 & (dtmf_command >> NUMBER_DTMF_COMMAND))
              )
          {
            dtmf_command_timeout= DTMF_COMMAND_TIMEOUT_LEN;
            dtmf_command =  (1<<STAR_DTMF_COMMAND) | (1<<HASH_DTMF_COMMAND);
          }
          else
          {
            dtmf_command=0; 
            
            //i=1;
          }
          break;
        
        default:
          dtmf_code=0;
          
          break;
        }
        
        }     

        // IWD -   task_GSM
        if (without_timeout) T_gsm_wd = T_GSM_WD_LONG_LEN; else T_gsm_wd = T_GSM_WD_LEN; 
        
	if (i)
	{
          /*   -  */
          //vTaskDelay(100/portTICK_RATE_MS);
          Send_Command_To_SIM900 (Cmd_TONE, strlen(Cmd_TONE));
          Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
          /*   -    GSM-       */
          Send_Command_To_SIM900 (Cmd_Play_Start, strlen(Cmd_Play_Start));
          Send_Command_To_SIM900_ (File_Wire[8], strlen(File_Wire[8]));
          #ifndef OKO_U2
            /* AT-  GSM- SIM900*/
            Send_Command_To_SIM900_ (Cmd_Play_End, strlen(Cmd_Play_End));
          #else
            //SIM800
            if (*(char*)(PLAY_END)) temp=(char *)(PLAY_END); else temp=(char *)Cmd_Play_End_default;
            Send_Command_To_SIM900_ (temp, strlen(temp));
          #endif
          Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
	}      
      }
      
     }
    
    //vTaskDelay(10/portTICK_RATE_MS);
  }
  
  /*   -  */
  //vTaskDelay(100/portTICK_RATE_MS);    
  Send_Command_To_SIM900 (Cmd_ATH, strlen(Cmd_ATH));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
 
}

/*******************************************************************************
* Function Name  : Connect_for_DTMF
* Description    :     DTMF-
* Input          : owner - 
* Output         : None
* Return         : None
*******************************************************************************/
void Connect_for_DTMF ( char owner, char without_timeout ) 
{
  /*   -  */  
  Send_Command_To_SIM900 (Cmd_ATA, strlen(Cmd_ATA));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
  vTaskDelay(500/portTICK_RATE_MS);
  Connect_for_DTMF_(owner, without_timeout, 0, Cmd_AT);
}

/*******************************************************************************
* Function Name  : Check_SIM900
* Description    :    GSM-
* Input          : 
* Output         : None
* Return         : 1-   GSM-; 0-   GSM-, 2 -  ,   
*******************************************************************************/

char Check_SIM900( void ) 
{
  unsigned short int i;
  TypeDef_EVENT  Event;
  
  /*   GSM-    */
  if (!SIM900_Auto_Baud()) 
  {
    Event.Code_Event= GSM_INI_EVENT;
    Save_Event_to_Buffer(Event);
    /* GSM-   -  */
    SIM900_ON ();
    SIM900_Ini();
  }
  
  /*     GSM-,   */
  Check_GSM=CHECK_GSM_LEN;
  
  if (FLAG_SIM900_RING_STATE) return 2;

  // ""
  Send_Command_To_SIM900 (Cmd_ATE0, strlen(Cmd_ATE0));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC); 
 
   /*    GSM-*/
  Send_Command_To_SIM900 (Cmd_CBC, strlen(Cmd_CBC));
  i=Wait_For_SIM900_Answer (Answer_CBC, GSM_ANSWER_WAIT_1SEC); 
  if (i)
  {
    //   
    if (SIM900_Rx_Buffer[i] == '4')
    {
      if (!INPUT_INT_POWER_STATE)
      {
        taskENTER_CRITICAL();
        Inputs_State|=(1<<INPUT_INT_POWER); // set flag
        taskEXIT_CRITICAL();
      }
    }
    else
    {
      if ( (SIM900_Rx_Buffer[i] == '3') && ( (SIM900_Rx_Buffer[i+1]-0x30) < 5 ) ) //   3.5
      {
        if (INPUT_INT_POWER_STATE) 
        {
 
          taskENTER_CRITICAL();
          Inputs_State&=~(1<<INPUT_INT_POWER); // reset flag
          taskEXIT_CRITICAL(); 
          
          /*      */
          Event.Code_Event=INT_POWER_LOW_EVENT; 
          Event.Group=Power.Group; 
          Save_Event_to_Buffer(Event);
        }       
      }
    }
    
  }
  
 
  /*   GSM-(   GSM-)*/
  //Send_Command_To_SIM900 (Cmd_GET_CCLK, strlen(Cmd_GET_CCLK));
  //i=Wait_For_SIM900_Answer (Answer_REG, GSM_ANSWER_WAIT_1SEC);

  /*  Jamming */
  //Send_Command_To_SIM900 (Cmd_GET_SJDR, strlen(Cmd_GET_SJDR));
  //i=Wait_For_SIM900_Answer (Answer_REG, GSM_ANSWER_WAIT_1SEC);
  
  /*    "" GSM-*/
  Send_Command_To_SIM900 (Cmd_GET_REG, strlen(Cmd_GET_REG));
  i=Wait_For_SIM900_Answer (Answer_REG, GSM_ANSWER_WAIT_1SEC);

  /*        GSM-*/
  if ( (i=='1') || (i=='5'))
  {
    /*    ""  "" GSM- -  */
    No_Registration=NO_REGISTRATION_LEN;
    
    if (FLAG_SIM900_RING_STATE) return 2;
    
    /*   GSM-*/
    Send_Command_To_SIM900 (Cmd_SIGNAL, strlen(Cmd_SIGNAL));
    
    /*     rssi */
    GSM_Level=(char) Wait_For_SIM900_Answer (Answer_SIGNAL, GSM_ANSWER_WAIT_1SEC);
    
    return 1; /*  */
  }
  else
  {
    //  GSM-
    GSM_Level = 0;     
    
    //if Registration denied
    if (i=='3') No_Registration=0;
  }

 
  /*      GSM- */
  if (No_Registration) No_Registration--;
  
  if (!No_Registration)
  {
    /*    GSM-   NO_REGISTRATION_LEN -  */
    SIM900_ON ();
    SIM900_Ini(); 
  } 
  return 0; /*  */
}


/*******************************************************************************
* Function Name  : Save_Mode_to_EEPROM
* Description    :      EEPROM
* Input          : 
* Output         : None
* Return         : None
*******************************************************************************/
void Save_Mode_to_EEPROM (void)
{
  uint16_t eeprom_data;
  eeprom_data=MODE_FLAGS;
  /*     */
  Virtual_EEPROM (MODE_FLAGS_W, & eeprom_data, SAVE_DATA_EEPROM);

  FLAG_SAVE_MODE_RESET;

}

/*******************************************************************************
* Function Name  : Save_Output_to_EEPROM
* Description    :       EEPROM
* Input          : 
* Output         : None
* Return         : None
*******************************************************************************/
void Save_Output_to_EEPROM (void)
{
  unsigned short int Outputs=0;
  
 
  if (OUT1_STATE) Outputs|=(unsigned short int)(1<<OUTPUT_1);
  if (OUT2_STATE) Outputs|=(unsigned short int)(1<<OUTPUT_2);
  if (OUT3_STATE) Outputs|=(unsigned short int)(1<<OUTPUT_3);
  if (OUT4_STATE) Outputs|=(unsigned short int)(1<<OUTPUT_4);
#ifndef OKO_U2
  if (OUT5_STATE) Outputs|=(unsigned short int)(1<<OUTPUT_5);
  if (OUT6_STATE) Outputs|=(unsigned short int)(1<<OUTPUT_6);
  if (OUT7_STATE) Outputs|=(unsigned short int)(1<<OUTPUT_7);
  if (OUT8_STATE) Outputs|=(unsigned short int)(1<<OUTPUT_8);
#endif
  
  /*      */
  Virtual_EEPROM (OUTPUT_STATE_W, & Outputs, SAVE_DATA_EEPROM);
  



  FLAG_SAVE_OUTPUT_RESET;

}

/*******************************************************************************
* Function Name  : EEPROM_Default_Setting
* Description    :      
* Input          : 
* Output         : None
* Return         : None
*******************************************************************************/
void EEPROM_Default_Setting (void)
{
  char i;
  uint16_t eeprom_data;
  
  for (i=0; i<40; i++)
  {
      if (LED_STATE!= RESET) 
      {
         LED_OFF; 
      }
      else
      {
         LED_ON; 
      } 
      vTaskDelay(30/portTICK_RATE_MS);
  }
  LED_ON;

  
  
  /*    EEPROM*/
  eeprom_data=0x0000;
  Virtual_EEPROM(0x0000, & eeprom_data, FORMAT_EEPROM);
 
  /*     - 1234 */
  eeprom_data=0x3132;
  Virtual_EEPROM (PIN_CODE_W1, & eeprom_data, SAVE_DATA_EEPROM);
  eeprom_data=0x3334;
  Virtual_EEPROM (PIN_CODE_W2, & eeprom_data, SAVE_DATA_EEPROM);

  /*         */
  for (i=0; i<MAX_RADIO_SENSOR; i++)
  {
   eeprom_data=(((uint16_t)(T_MIN)) << 8) | ((uint16_t)(T_MAX)); //=+5, =+40
   Virtual_EEPROM (RADIO_1_MIN_MAX_W + i, & eeprom_data, SAVE_DATA_EEPROM);    
  }

  /*        DS1820*/
  for (i=0; i<MAX_DS1820; i++)
  {
   eeprom_data=(((uint16_t)(T_MIN)) << 8) | ((uint16_t)(T_MAX)); //=+5, =+40
   Virtual_EEPROM (DS1820_1_MIN_MAX_W + i, & eeprom_data, SAVE_DATA_EEPROM);    
  }
  
  /*        -1...-8 */
  eeprom_data=SMS_RING_DEFAULT;
  Virtual_EEPROM (SMS_RING_W, & eeprom_data, SAVE_DATA_EEPROM);

  /*     -1...-8, 
        1Wire (   Ibutton)*/
  eeprom_data=ANSWER_ARM_PARAMETER_DEFAULT;
  Virtual_EEPROM (ANSWER_ARM_PARAMETER_W, & eeprom_data, SAVE_DATA_EEPROM);
  
  LED_OFF;
  FLAG_DEFAULT_SETTING_RESET;
  
  Read_Config_from_EEPROM();
  
}

/*******************************************************************************
* Function Name  : SIM900_Config
* Description    :      GSM-
* Input          : 
* Output         : None
* Return         : None
*******************************************************************************/
void SIM900_Config (void)
{
    SIM900_Pin_Config();
    SIM900_UART_Config();
    
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);

}
  
/*******************************************************************************
* Function Name  : System_GSM_Debug
* Description    :        Debug 
* Input          : char * data, u8 data_len
* Output         : None
* Return         : None
*******************************************************************************/
void System_GSM_Debug( const char *data, u8 data_len) 
{ 
  portBASE_TYPE xStatus;
  const portTickType xTicksToWait = DEBUG_WAIT / portTICK_RATE_MS;

  TypeDef_PRINT_DEBUG xMessage; 
 
  if (USB_Mode==DebugMode)
   {
 
    /*        DEBUG */  
    xMessage.Debug_Data_Len = data_len;
    xMessage.Debug_Source_ID = System_Debug_ID;
    xMessage.Debug_Char_Data = (char *) data;
    xMessage.Debug_Data_type=Debug_Data_type_ASCII;
        
    /*   .
          -   .  
          ,     pvParameters.
            - ,    
          Blocked,      ,
            */
    xStatus = xQueueSendToBack(Queue_Print_Debug, &xMessage, xTicksToWait );
    if( xStatus != pdPASS )
     {
         /*    ,    xTicksToWait .
             . */
         
     }
   }
}


/* Receive Data */
//u8 USART_ReceiveData_GSM()
//{
//  return (u8)(SIM900_UART->DR);
//}


/* Transmit Data */
void USART_SendData_GSM(u8 Data)
{
  SIM900_UART->DR = Data;
}


/* Checks whether the specified USART flag is set or not */
FlagStatus USART_GetFlagStatus_GSM (uint16_t USART_FLAG)
{
  FlagStatus bitstatus = RESET;
 
  if ((SIM900_UART->SR & USART_FLAG) != (uint16_t)RESET)
  {
    bitstatus = SET;
  }
  else
  {
    bitstatus = RESET;
  }
  return bitstatus;
}

/* Clears the USARTx's pending flags */
void USART_ClearFlag_GSM(uint16_t USART_FLAG)
{
  SIM900_UART->SR = (uint16_t)~USART_FLAG;
}

/*******************************************************************************
* Function Name  : Send_SMS_to_Phone
* Description    :  -       
* Input          : SMS_Phone_Number -   , SMS_Text -    
*                prefix -   ""
*                extra -   ""
*                Event -   
*                owner_group -  
* Output         : None
* Return         : 0 -   , 1 -  
*******************************************************************************/
char Send_SMS_to_Phone (char * SMS_Phone_Number, const char * SMS_Text, char prefix, char extra, TypeDef_EVENT Event, char owner_group )
{
 char temp[3];
 char * pointer;
 char i;
 
  if (!strlen(SMS_Phone_Number)) return 0; //,     0
  
  //  
  Send_Command_To_SIM900 (Cmd_SEND_SMS, strlen(Cmd_SEND_SMS));
  Send_Command_To_SIM900_ (SMS_Phone_Number, strlen(SMS_Phone_Number));
  Send_Command_To_SIM900_ ("\"\r", 2);
  Wait_For_SIM900_Answer (Answer_SEND, 2*GSM_ANSWER_WAIT_1SEC);
  
  //print prefix if exist
  if (prefix==KZ_CHANGE) Send_Command_To_SIM900 ("KZ-", 3);
  if (prefix==OBRIV_CHANGE) Send_Command_To_SIM900 ("OBRIV-", 6); 
  
  //print main text
  Send_Command_To_SIM900 (SMS_Text, strlen(SMS_Text));
  
  //print extra if exist
  //print Identification
  if ( (extra==SHOW_IDENT) || (extra==SHOW_IDENT_REASON) )
  {
    if (owner_group!=Event.Group)
    {
      Send_Command_To_SIM900_ ("G: ", 3);
      for (i=0; i<8; i++)
      {
        if ( 0x01 & ((owner_group & Event.Group)>>i) )
        {
          temp[0]=0x31+i;
          temp[1]=',';
          Send_Command_To_SIM900_ (temp, 2);
        }
      }
      Send_Command_To_SIM900_ ("\x0A", 1);
    }
    
    switch (Event.Who)
    {
      case OWNER_1:
      case OWNER_2:
      case OWNER_3:
      case OWNER_4:
      case OWNER_5:
      case OWNER_6:
      case OWNER_7:
      case OWNER_8:
        Send_Command_To_SIM900_ ("Polzovatel-", 11);
        temp[0]=Event.Who+0x31;
        Send_Command_To_SIM900_ (temp, 1);
        break;
      
      case BY_VXOD_1:
      case BY_VXOD_2:
      case BY_VXOD_3:
      case BY_VXOD_4:
      case BY_VXOD_5:
      case BY_VXOD_6:
      case BY_VXOD_7:
      case BY_VXOD_8:
        Send_Command_To_SIM900_ ("Po vxodu-", 9);
        temp[0]=0x30 + (Event.Who - BY_VXOD_1 + 1) ;
        Send_Command_To_SIM900_ (temp, 1);        
        break;  
      
        
      case IBUTTON_1:
      case IBUTTON_2:
      case IBUTTON_3:
      case IBUTTON_4:
      case IBUTTON_5:
      case IBUTTON_6:
      case IBUTTON_7:
      case IBUTTON_8:
      case IBUTTON_9:
      case IBUTTON_10:
      case IBUTTON_11:
      case IBUTTON_12:        
        Send_Command_To_SIM900_ ("IButton-", 8);
        temp[0]=0x30 + (Event.Who - IBUTTON_1 + 1)/10 ;
        temp[1]=0x30 + (Event.Who - IBUTTON_1 + 1)%10 ;
        Send_Command_To_SIM900_ (temp, 2);
        break;

      case BRELOK_1:
      case BRELOK_2:
      case BRELOK_3:
      case BRELOK_4:
      case BRELOK_5:
      case BRELOK_6:
      case BRELOK_7:
      case BRELOK_8:
      case BRELOK_9:
      case BRELOK_10:
      case BRELOK_11:
      case BRELOK_12: 
      case BRELOK_13:
      case BRELOK_14: 
      case BRELOK_15: 
      case BRELOK_16:         
        Send_Command_To_SIM900_ ("Brelok-", 7);
        temp[0]=0x30 + (Event.Who - BRELOK_1 + 1)/10 ;
        temp[1]=0x30 + (Event.Who - BRELOK_1 + 1)%10 ;
        Send_Command_To_SIM900_ (temp, 2);
        break;
 
      case BY_KEYBOARD: 
        Send_Command_To_SIM900_ ("Po vxodu", 8);
        break;

      case OKO_SERVER: 
        Send_Command_To_SIM900_ ("Server OKO", 10);
        break;
        
      case OKO_KB: 
        Send_Command_To_SIM900_ ("OKO-KB", 6);
        break;

      case REMOUT_PULT: 
        Send_Command_To_SIM900_ ("Pult", 4);
        break;

        
      default:
        
        break;    
    }
    Send_Command_To_SIM900_ ("\x0A", 1);
  }
  
  if (extra==SHOW_IDENT_REASON)
  {
    // print reason
    if ( (Event.Code_Event>=INPUT_1_FAULT_ARMED_EVENT) && (Event.Code_Event<=INPUT_8_FAULT_ARMED_EVENT) )
    {
      pointer= (char *) (IN1_HIGH_TEXT + INPUT_EVENT_TEXT_LEN*2*(Event.Code_Event-INPUT_1_FAULT_ARMED_EVENT));
      Send_Command_To_SIM900_ ( pointer, strlen(pointer) );
    }
       
    if ( (Event.Code_Event>=RADIO_1_FAULT_ARMED_EVENT) && (Event.Code_Event<=RADIO_16_FAULT_ARMED_EVENT) )
    {
      pointer= (char *) (RADIO_SENSOR_NAME_1 + RADIO_SENSOR_NAME_LEN*(Event.Code_Event-RADIO_1_FAULT_ARMED_EVENT));
      Send_Command_To_SIM900_ ( pointer, strlen(pointer) );
      Send_Command_To_SIM900_ ( Alarm_Text, strlen(Alarm_Text) );
    }
    
  }

  
  //  <ctrl+Z>
  Send_Command_To_SIM900 ("\x1A", 1);
  return Wait_For_SIM900_Answer (Answer_OK, 12*GSM_ANSWER_WAIT_1SEC);  
}


/*******************************************************************************
* Function Name  : Send_Event
* Description    :     -      
* Input          : SMS_Text -    , 
*                  ring -    
*                  sms -   sms
*                  Event -  
* Output         : None
* Return         : None
*******************************************************************************/
void Send_Event (const char * SMS_Text, char ring, char sms, TypeDef_EVENT Event, char prefix, const char * file)
{
 char k,i;
 uint16_t eeprom_data, eeprom_data2;
 

     /*   EEPROM     -  -1..-8 */
     //  0,   
     if (Virtual_EEPROM (SMS_RING_W, & eeprom_data, READ_DATA_EEPROM)) 
      {
       eeprom_data=SMS_RING_DEFAULT; //   ,       
       Virtual_EEPROM (SMS_RING_W, & eeprom_data, SAVE_DATA_EEPROM);
      }

    /*   EEPROM  -  -1..-8     */
    //  0,   
    if (Virtual_EEPROM (SMS_ARM_DISARM_W, & eeprom_data2, READ_DATA_EEPROM)) 
      {
        eeprom_data2=SMS_ARM_DISARM_PARAMETER_DEFAULT; //   
	Virtual_EEPROM (SMS_ARM_DISARM_W, & eeprom_data2, SAVE_DATA_EEPROM);
      }

       
     //   -1...-MAX_OWNER
     for (k=0; k<MAX_OWNER; k++)
     {
      if ( (Owner.Group[k] & Event.Group) && Copy_Owner_Phone_from_EEPROM(OWNER1_PHONE_W1+k*8) ) 
      {
        
       
	//   
	if ( ring && (0x0001 & (eeprom_data>>k)) )
	 {
          
          //      " "       -
          for (i=0; i < strlen(Owner_Phone_Number)+1; i++)
            { 
              Incoming_Phone_Number[i]=Owner_Phone_Number[i];
            }
          //Incoming_Phone_Number[i]='\0';
          
          //      
          if (!Ring_to_Phone(Owner_Phone_Number, k, 0, 1, file)) if (!Ring_to_Phone(Owner_Phone_Number, k, 0, 1, file)) Ring_to_Phone(Owner_Phone_Number, k, 0, 1, file);
         }

	//    
	if ( sms && (0x0001 & (eeprom_data>>(8+k))) )
	 {
           
	  if ( 
                Event.Code_Event==ARMED_EVENT || 
                ((Event.Code_Event>=INPUT_1_FAULT_ARMED_EVENT) && (Event.Code_Event<=RADIO_16_FAULT_ARMED_EVENT)) || 
                Event.Code_Event==DISARMED_EVENT || 
                Event.Code_Event==FORCE_DISARMED_EVENT 
              )
	   {
	  	if ( 
			( (Event.Code_Event==ARMED_EVENT || ((Event.Code_Event>=INPUT_1_FAULT_ARMED_EVENT) && (Event.Code_Event<=RADIO_16_FAULT_ARMED_EVENT)) ) && (0x0001 & (eeprom_data2>>(8+k))) ) || 
			( (Event.Code_Event==DISARMED_EVENT || Event.Code_Event==FORCE_DISARMED_EVENT) && (0x0001 & (eeprom_data2>>k)) )
	     	    )
		  {
             		//     
                        if ((Event.Code_Event>=INPUT_1_FAULT_ARMED_EVENT) && (Event.Code_Event<=RADIO_16_FAULT_ARMED_EVENT))
                          i=SHOW_IDENT_REASON;
                        else
                          i=SHOW_IDENT;
                        
                        //  /  ,     
                        if (Owner.Group[k] & Event.Group)
                        {
                          if (!Send_SMS_to_Phone(Owner_Phone_Number, SMS_Text, prefix, i, Event, Owner.Group[k])) 
                            if (!Send_SMS_to_Phone(Owner_Phone_Number, SMS_Text, prefix, i, Event, Owner.Group[k])) 
                              Send_SMS_to_Phone(Owner_Phone_Number, SMS_Text, prefix, i, Event, Owner.Group[k]);
                        }
		  }
	   }
	   else
	   {
             if (Event.Code_Event==GSM_JUMMING_DETECTION_EVENT)
             {
               if ( 0x01 & ( (*(char*)GSM_JAMMING_SMS )>>k) )
               {
                  //     
                  if (!Send_SMS_to_Phone(Owner_Phone_Number, SMS_Text, prefix, NOTHING, Event, Owner.Group[k])) 
                    if (!Send_SMS_to_Phone(Owner_Phone_Number, SMS_Text, prefix, NOTHING, Event, Owner.Group[k])) 
                      Send_SMS_to_Phone(Owner_Phone_Number, SMS_Text, prefix, NOTHING, Event, Owner.Group[k]);
               }
             }
             else
             {
                if (Event.Code_Event==FRAUD_DETECTION_EVENT)
                {
                  if ( 0x01 & ( (*(char*)FRAUD_SMS )>>k) )
                  {
                      //     
                      if (!Send_SMS_to_Phone(Owner_Phone_Number, SMS_Text, prefix, NOTHING, Event, Owner.Group[k])) 
                        if (!Send_SMS_to_Phone(Owner_Phone_Number, SMS_Text, prefix, NOTHING, Event, Owner.Group[k])) 
                          Send_SMS_to_Phone(Owner_Phone_Number, SMS_Text, prefix, NOTHING, Event, Owner.Group[k]);
                  }
                }
                else
                {
                  //     
                  if (!Send_SMS_to_Phone(Owner_Phone_Number, SMS_Text, prefix, NOTHING, Event, Owner.Group[k])) 
                    if (!Send_SMS_to_Phone(Owner_Phone_Number, SMS_Text, prefix, NOTHING, Event, Owner.Group[k])) 
                      Send_SMS_to_Phone(Owner_Phone_Number, SMS_Text, prefix, NOTHING, Event, Owner.Group[k]);
                }
             }
	   }
         }

      }
     }
  
}

/*******************************************************************************
* Function Name  : Add_String
* Description    :     
* Input          : add_to - ,    (  )
*                  add_from - ,    (  )
*                  len -   
* Output         : None
* Return         :     
*******************************************************************************/

char * Add_String (char * add_to, const char * add_from, char len)
{
  char i;

  for (i = 0; i < len; i++)
   {
    *add_to=*add_from;
    add_from++;
    add_to++;
   } 
  return  add_to;
}

/*******************************************************************************
* Function Name  : Print_T
* Description    :           
* Input          : add_to - ,    
*                  temperature -    
* Output         : None
* Return         :    
*******************************************************************************/

char * Print_T (char * add_to,  char temperature)
{
  if (temperature==NO_TEMPERATURE)
  {
     *add_to=' ';
     add_to++;
     return  add_to;    
  }
  
   if (temperature>NO_TEMPERATURE)
    {
     //  
     temperature=256-temperature; 
     *add_to='-';
     add_to++;
    }
    else
    {
     *add_to='+';
     add_to++;            
    }
   
   //  "",   0
   if (temperature/10!=0)
    {
      *add_to=temperature/10+0x30;
      add_to++;
    }
   
   // ""
   *add_to=temperature%10+0x30;
   add_to++;   
   
     // ""
   *add_to='C';
   add_to++;

   
   return  add_to;
}

/*******************************************************************************
* Function Name  : Print_T_Tmin_Tmax
* Description    :           -
* Input          : add_to - ,    
*                  temperature -    
* Output         : None
* Return         :    
*******************************************************************************/

char * Print_T_Tmin_Tn_Tmax (char * temp_result,  char temperature, char sensor, uint16_t termo_min_max, char Tn)
{
uint16_t eeprom_data;
        
          *temp_result=0x0A;
          temp_result++;
          *temp_result='T';
          temp_result++; 
          *temp_result='=';
          temp_result++;
          temp_result = Print_T(temp_result, temperature);
          *temp_result=0x0A;
          temp_result++; 

         
          /*   ,     EEPROM */
          //  0,   
          if ( Virtual_EEPROM (termo_min_max + (sensor-1), & eeprom_data, READ_DATA_EEPROM) ) 
          {
            eeprom_data=(((uint16_t)(T_MIN)) << 8) | ((uint16_t)(T_MAX)); //=+5, =+40  
          }
            //  , Tn, 
            *temp_result='T';
            temp_result++; 
            *temp_result='m';
            temp_result++;
            *temp_result='i';
            temp_result++;
            *temp_result='n';
            temp_result++;
            *temp_result='=';
            temp_result++;
            
            temp_result = Print_T(temp_result, (char)(eeprom_data>>8));
         
            *temp_result=0x0A;
            temp_result++; 

            if (Tn!= NO_TEMPERATURE)
            {
              *temp_result='T';
              temp_result++; 
              *temp_result='n';
              temp_result++;
              *temp_result='=';
              temp_result++;
            
              temp_result = Print_T(temp_result, Tn);
         
              *temp_result=0x0A;
              temp_result++;  
            }
            
            *temp_result='T';
            temp_result++; 
            *temp_result='m';
            temp_result++;
            *temp_result='a';
            temp_result++;
            *temp_result='x';
            temp_result++;
            *temp_result='=';
            temp_result++;
            
            temp_result = Print_T(temp_result, (char)(0x00FF & eeprom_data));
         
            *temp_result=0x0A;
            temp_result++;             
          
 
          
        
  return temp_result;
}



/*******************************************************************************
* Function Name  : GPRS_Send_data
* Description    :      
* Input          : buffer -     
* Output         : None
* Return         : 0 -   , 1-  
*******************************************************************************/
char GPRS_Send_data (char * buffer)
{
  char z=0;
  unsigned short int i;
  char temp[3];
  
          if (*(char*) GPRS_PROTOCOL == UDP_VPN_LUN_7T)
          {
            //         
            Send_Command_To_SIM900 (& buffer[1], buffer[0]);
          }
          else
          {
            Send_Command_To_SIM900 (buffer, strlen(buffer));
          }
          
          if (*(char*) GPRS_PROTOCOL == TCP_OKO)  Send_Command_To_SIM900_ ("\x0D\x0A", 2); //TCP OKO
          
          
          if (*(char*) GPRS_PROTOCOL == UDP_VPN_LUN_7T)
          {
            temp[0]=0x4F;
            temp[1]=buffer[1]; //  
            temp[2]='\0';
            z=Wait_For_SIM900_Answer(temp, 15*GSM_ANSWER_WAIT_1SEC); //    
          }
          else
          {
            //  <ctrl+Z>
            Send_Command_To_SIM900_ ("\x1A", 1);
          }
          
          if (*(char*) GPRS_PROTOCOL == TCP_SURGARD) 
          {
            z=Wait_For_SIM900_Answer("\x06", 15*GSM_ANSWER_WAIT_1SEC); //    Uniport, 
          }
        
          if (*(char*) GPRS_PROTOCOL == TCP_OKO)
          {  
            if (Wait_For_SIM900_Answer(Answer_Send_OK, 7*GSM_ANSWER_WAIT_1SEC)) z=1;  
            i=Wait_For_SIM900_Answer(Answer_Command_List, 15*GSM_ANSWER_WAIT_1SEC);
            if ( i ) 
            {
              z=1;
              /*    */
              //FLAG_ANALIZING_SET; //      
              //Analize_Command(SIM900_Rx_Buffer, i, OKO_SERVER);
              //vTaskDelay(500/portTICK_RATE_MS);
              //FLAG_ANALIZING_RESET; //      
            }        
          }
          
  return z;
}
/*******************************************************************************
* Function Name  : Command_Send
* Description    :  -   
* Input          : buffer -     
* Output         : None
* Return         : None
*******************************************************************************/
void Command_Send (char * buffer)
{
  char i;
  
        if (*(char*) GPRS_PROTOCOL == UDP_VPN_LUN_7T)
        {
          Send_Command_To_SIM900 (Cmd_IP_Send_with_len, strlen(Cmd_IP_Send_with_len));
          i=0x30 + buffer[0]/100;
          Send_Command_To_SIM900_ (&i, 1);
          i=0x30 + (buffer[0]%100)/10;
          Send_Command_To_SIM900_ (&i, 1);
          i=0x30 + buffer[0]%10;
          Send_Command_To_SIM900_ (&i, 1);
          Send_Command_To_SIM900_ ("\r", 1);
        }
        else
        {
          Send_Command_To_SIM900 (Cmd_IP_Send, strlen(Cmd_IP_Send));
        }
}
/*******************************************************************************
* Function Name  : Command_Send
* Description    :  -   
* Input          : buffer -     
* Output         : None
* Return         : None
*******************************************************************************/
void Change_Server (char gprs_time_out)
{
        if (!Current_Server)
        {
          if (*(char *) SERVER_2) Current_Server=1; else GPRS_Fault_Timeout=gprs_time_out;
        }
        else
        {
          if (*(char *) SERVER_1) Current_Server=0; else GPRS_Fault_Timeout=gprs_time_out;
        }  
}
/*******************************************************************************
* Function Name  : GPRS_Send_
* Description    :      
* Input          : buffer -     , 
* Output         : None
* Return         : 0 -   , 1-  
*******************************************************************************/
char GPRS_Send_ (char * buffer)
{
  char z=0;
  
  if (GPRS_Fault_Timeout) return z;

  //  
  Command_Send (buffer);
  
  if (Wait_For_SIM900_Answer (Answer_SEND, 2*GSM_ANSWER_WAIT_1SEC))
   {
      z=GPRS_Send_data(buffer);
   } 
   else
   {
    //  <ctrl+Z>
    Send_Command_To_SIM900_ ("\x1A", 1);
    
    PDP_Deactivation();
    //Send_Command_To_SIM900 (Cmd_GPRS_Attach, strlen(Cmd_GPRS_Attach));
    //if (Wait_For_SIM900_Answer (Answer_OK, 10*GSM_ANSWER_WAIT_1SEC))
    {
      //if (FLAG_SIM900_RING_STATE) return 0; //    
      // connect to server "AT+CIPSTART="TCP","77.120.122.83","80"\r";
      if (*(char*) GPRS_PROTOCOL == UDP_VPN_LUN_7T)
      {
        Send_Command_To_SIM900 (Cmd_Clport_Lun, strlen(Cmd_Clport_Lun));
        Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
        Send_Command_To_SIM900 (Cmd_Ext_UDP_Mode, strlen(Cmd_Ext_UDP_Mode));
        Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
        
        Send_Command_To_SIM900 (Cmd_Server_UDP, strlen(Cmd_Server_UDP));
      }
      else
      {
        Send_Command_To_SIM900 (Cmd_Server_TCP, strlen(Cmd_Server_TCP));
      }
      
      if (!Current_Server)
      {
        Send_Command_To_SIM900_ ((char *) SERVER_1, strlen((char *) SERVER_1));
        Send_Command_To_SIM900_ ("\",\"", 3);
        if (*(char*) GPRS_PROTOCOL == UDP_VPN_LUN_7T)
          Send_Command_To_SIM900_ ("3030", 4);
        else
          Send_Command_To_SIM900_ ((char *) PORT_1, strlen((char *) PORT_1));
      }
      else
      {
        Send_Command_To_SIM900_ ((char *) SERVER_2, strlen((char *) SERVER_2));
        Send_Command_To_SIM900_ ("\",\"", 3);
        
        if (*(char*) GPRS_PROTOCOL == UDP_VPN_LUN_7T)
          Send_Command_To_SIM900_ ("3030", 4);
        else
          Send_Command_To_SIM900_ ((char *) PORT_2, strlen((char *) PORT_2));
      }
      Send_Command_To_SIM900_ ("\"\r", 2); 
      
      if (Wait_For_SIM900_Answer (Answer_Connect_OK, 10*GSM_ANSWER_WAIT_1SEC)) 
      {  
        //if (FLAG_SIM900_RING_STATE) return 0; //    
        // 
        Command_Send (buffer);
        
        if (Wait_For_SIM900_Answer (Answer_SEND, 2*GSM_ANSWER_WAIT_1SEC))
        {
            z=GPRS_Send_data(buffer);
        }      
      }
      else
      {
        Change_Server(0);
      }   
    }
   }
  
  return z;
}

/*******************************************************************************
* Function Name  : Connect_to_Server
* Description    :   
* Input          : None
* Output         : None
* Return         : 0 -    , 1-    
*******************************************************************************/
char Connect_to_Server (void)
{
  char z=0;
   //check current connection
    Send_Command_To_SIM900 (Cmd_IP_State, strlen(Cmd_IP_State));
    if (Wait_For_SIM900_Answer (Answer_Connect_OK, 2*GSM_ANSWER_WAIT_1SEC))
    {
        //active connection
        FLAG_DICONNECT_RESET;
        z=1;
    }
    else
    {
      PDP_Deactivation();
      //Send_Command_To_SIM900 (Cmd_GPRS_Attach, strlen(Cmd_GPRS_Attach));
      //if (Wait_For_SIM900_Answer (Answer_OK, 10*GSM_ANSWER_WAIT_1SEC))
      {      
        // connect to server "AT+CIPSTART="TCP","77.120.122.83","80"\r";
        if (*(char*) GPRS_PROTOCOL == UDP_VPN_LUN_7T)
        {
          Send_Command_To_SIM900 (Cmd_Clport_Lun, strlen(Cmd_Clport_Lun));
          Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
          Send_Command_To_SIM900 (Cmd_Ext_UDP_Mode, strlen(Cmd_Ext_UDP_Mode));
          Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
        
          Send_Command_To_SIM900 (Cmd_Server_UDP, strlen(Cmd_Server_UDP));
        }
        else
        {
          Send_Command_To_SIM900 (Cmd_Server_TCP, strlen(Cmd_Server_TCP));
        }
        
        if (!Current_Server)
          {
            Send_Command_To_SIM900_ ((char *) SERVER_1, strlen((char *) SERVER_1));
            Send_Command_To_SIM900_ ("\",\"", 3);
            if (*(char*) GPRS_PROTOCOL == UDP_VPN_LUN_7T)
              Send_Command_To_SIM900_ ("3030", 4);
            else
              Send_Command_To_SIM900_ ((char *) PORT_1, strlen((char *) PORT_1));
          }
          else
          {
            Send_Command_To_SIM900_ ((char *) SERVER_2, strlen((char *) SERVER_2));
            Send_Command_To_SIM900_ ("\",\"", 3);
            if (*(char*) GPRS_PROTOCOL == UDP_VPN_LUN_7T)
              Send_Command_To_SIM900_ ("3030", 4);
            else
              Send_Command_To_SIM900_ ((char *) PORT_2, strlen((char *) PORT_2));
          }
        Send_Command_To_SIM900_ ("\"\r", 2); 
      
        if (Wait_For_SIM900_Answer (Answer_Connect_OK, 30*GSM_ANSWER_WAIT_1SEC)) 
        {  
          FLAG_DICONNECT_RESET;
          z=1;
        }
        else
        {
          Change_Server(0);
        } 
      }
    }  
   
 return z; 
}

/*******************************************************************************
* Function Name  : GPRS_Send
* Description    :    
* Input          : buffer -     
* Output         : None
* Return         : 0 -   , 1-  
*******************************************************************************/
char GPRS_Send (char * buffer)
{
 char z=0;
 //unsigned short int i;
 static char fault=0;
 
 if (GPRS_Fault_Timeout) return z;
 
 if ( *(char*) GPRS_PROTOCOL == HTTP_OKO )//(Check_Command ((char *) PORT, "80", 0))
 {  
    //HTTP  
  //Send_Command_To_SIM900 (Cmd_GPRS_Attach, strlen(Cmd_GPRS_Attach)); //GPRS ATTACH
  //if (Wait_For_SIM900_Answer (Answer_OK, 10*GSM_ANSWER_WAIT_1SEC))
  {
    if (FLAG_SIM900_RING_STATE) return 0; //    
    
    // connect to server "AT+CIPSTART="TCP","77.120.122.83","80"\r";
    Send_Command_To_SIM900 (Cmd_Server_TCP, strlen(Cmd_Server_TCP));
    if (!Current_Server)
    {
      Send_Command_To_SIM900_ ((char *) SERVER_1, strlen((char *) SERVER_1));
      Send_Command_To_SIM900_ ("\",\"", 3);
      Send_Command_To_SIM900_ ((char *) PORT_1, strlen((char *) PORT_1));
    }
    else
    {
      Send_Command_To_SIM900_ ((char *) SERVER_2, strlen((char *) SERVER_2));
      Send_Command_To_SIM900_ ("\",\"", 3);
      Send_Command_To_SIM900_ ((char *) PORT_2, strlen((char *) PORT_2));      
    }
    Send_Command_To_SIM900_ ("\"\r", 2); 
    
    if (Wait_For_SIM900_Answer(Answer_Connect_OK, 20*GSM_ANSWER_WAIT_1SEC)) 
    {  
      if (FLAG_SIM900_RING_STATE) return 0; //    
      Send_Command_To_SIM900 (Cmd_IP_Send, strlen(Cmd_IP_Send));
      if (Wait_For_SIM900_Answer (Answer_SEND, 2*GSM_ANSWER_WAIT_1SEC))
      {

        Send_Command_To_SIM900 (Text_Get, strlen(Text_Get));
        Send_Command_To_SIM900_ (buffer, strlen(buffer));
        
        //" HTTP/1.1\x0D\x0AHost: 77.120.122.83:80\x0D\x0A\x0D\x0A";
        Send_Command_To_SIM900_ (Text_HTTP, strlen(Text_HTTP)); 
        
        if (!Current_Server)
        {
          Send_Command_To_SIM900_ ((char *) SERVER_1, strlen((char *) SERVER_1));
          Send_Command_To_SIM900_ (":", 1);
          Send_Command_To_SIM900_ ((char *) PORT_1, strlen((char *) PORT_1));
        }
        else
        {
          Send_Command_To_SIM900_ ((char *) SERVER_2, strlen((char *) SERVER_2));
          Send_Command_To_SIM900_ (":", 1);
          Send_Command_To_SIM900_ ((char *) PORT_2, strlen((char *) PORT_2));
        }
        Send_Command_To_SIM900_ ("\x0D\x0A\x0D\x0A", 4);
        
        //  <ctrl+Z>
        Send_Command_To_SIM900_ ("\x1A", 1);
        if (Wait_For_SIM900_Answer(Answer_Send_OK, 7*GSM_ANSWER_WAIT_1SEC)) z=1;
        
        //i=Wait_For_SIM900_Answer(Answer_Command_List, 15*GSM_ANSWER_WAIT_1SEC);
        //if ( i ) 
        {
          //z=1;
          
          /*    */
          //FLAG_ANALIZING_SET; //      
                      /*   
            vTaskDelay(500/portTICK_RATE_MS);
            taskENTER_CRITICAL (); 
            SendDataToHost ((SIM900_Rx_Buffer+i),strlen(SIM900_Rx_Buffer)-i);
            taskEXIT_CRITICAL (); */
          
          //Analize_Command(SIM900_Rx_Buffer, i, OKO_SERVER);
          
          //vTaskDelay(500/portTICK_RATE_MS);
          //FLAG_ANALIZING_RESET; //      
          
        }
      }
    }
    else
    {
      Change_Server(GPRS_FAULT_TIMEOUT_LEN);
    }   
  }
  
  PDP_Deactivation();
  
 }
 else
 {
    z=GPRS_Send_(buffer);
    /*
    if ( *(char*) GPRS_PROTOCOL == TCP_OKO )
    {
      //  
      z=GPRS_Send_(buffer, TCP_OKO);
    }
    else
    {
      //  SurGard or ContactID or UDP_LUN_7T
      z=GPRS_Send_(buffer, *(char*) GPRS_PROTOCOL);     
    }
    */
   
    if (fault && !z) {PDP_Deactivation(); fault=0; Change_Server(0);}
    if (z) fault=0; else fault=1;    
 }
  

  
 return z;
}

/*******************************************************************************
* Function Name  : set_zero
* Description    :    
* Input          : start -     len -  
* Output         : None
* Return         : 0 -   , 1-  
*******************************************************************************/
void set_zero (char * start, char len)
{
  char i;
  for (i=0; i<len; i++)
  {
    *start='0';
    start++;
  }
}

/*******************************************************************************
* Function Name  : GPRS_Event_Check
* Description    :       
* Input          : None
* Output         : None
* Return         : 0 -     , 1-    
*                  2 -  
*******************************************************************************/
char GPRS_Event_Check (void)
{
 TypeDef_GPRS_EVENT Event;
 char i,j;
 static char packet_number=0x2F;
 
 #define DATA_LEN       (IMEI_MAX_LEN+1+(4*4)+4+4+2+1+(MAX_DS1820*2)+1+(MAX_RADIO_SENSOR*4)+1+(ADC_CH*4)+1+50+BALANCE_MAX_LEN+1 + (7*MAX_WIRE_SENSOR) ) 
 static char data[DATA_LEN]={0x00};// ,       
 uint16_t pos=0, k;
 
 if (data[0])
 {
   if ( GPRS_Send(data) ) data[0]='\0';
   
   return 0;
 }
  /*      */
 if( xQueueReceive( Queue_GPRS_Event, &Event, 0 ) == pdPASS )
 {
   //    
  if ( (*(char*) GPRS_PROTOCOL == HTTP_OKO)  || (*(char*) GPRS_PROTOCOL == TCP_OKO) )
  {
   data[pos] = '{'; if (pos<DATA_LEN) pos++;
   j=strlen(IMEI_Number);
   for (i=0; i<j; i++)
   {
     data[pos]=IMEI_Number[i];
     if (pos<DATA_LEN) pos++;
   }
   data[pos] = ','; if (pos<DATA_LEN) pos++;

    // 
  k=Event.Code_Event;
  for (i=0; i<4; i++)
   {
     data[pos] = Hex_Ascii((char)(0x000F & (k>>(12-i*4)))); if (pos<DATA_LEN) pos++;
   }
 
  data[pos] = ','; if (pos<DATA_LEN) pos++;
   //  
  k=Event.Mode_Flags;
  for (i=0; i<4; i++)
   {
     data[pos] = Hex_Ascii((char)(0x000F & (k>>(12-i*4)))); if (pos<DATA_LEN) pos++;
   }
  
  data[pos] = ','; if (pos<DATA_LEN) pos++;
  //  ,  , 220 ...
  k=Event.Inputs_State;
  for (i=0; i<4; i++)
   {
     data[pos] = Hex_Ascii((char)(0x000F & (k>>(12-i*4)))); if (pos<DATA_LEN) pos++;
   }
  //      
  k=Event.KZ_Obriv_State;
  for (i=0; i<4; i++)
   {
     data[pos] = Hex_Ascii((char)(0x000F & (k>>(12-i*4)))); if (pos<DATA_LEN) pos++;
   }
  
  
  data[pos] = ','; if (pos<DATA_LEN) pos++;
  //  
  k=Event.Outputs_State;
  for (i=0; i<4; i++)
   {
     data[pos] = Hex_Ascii((char)(0x000F & (k>>(12-i*4)))); if (pos<DATA_LEN) pos++;
   }

  data[pos] = ','; if (pos<DATA_LEN) pos++;
  //  GSM-
  data[pos] = Hex_Ascii((char)(0x000F & (Event.GSM_Level>>4))); if (pos<DATA_LEN) pos++;
  data[pos] = Hex_Ascii((char)(0x000F & Event.GSM_Level)); if (pos<DATA_LEN) pos++;

  data[pos] = ','; if (pos<DATA_LEN) pos++;
  //   DS1820
  for (i=0; i<MAX_DS1820; i++)
   {
     data[pos] = Hex_Ascii(Event.DS1820_Data_Current[i]>>4); if (pos<DATA_LEN) pos++;
     data[pos] = Hex_Ascii(0x0F & Event.DS1820_Data_Current[i]); if (pos<DATA_LEN) pos++; 
   }

  data[pos] = ','; if (pos<DATA_LEN) pos++;
  //  
  for (j=0; j<MAX_RADIO_SENSOR; j++)
   {
     k=Event.RF_Data_Current[j];
      for (i=0; i<4; i++)
      {
        data[pos] = Hex_Ascii((char)(0x000F & (k>>(12-i*4)))); if (pos<DATA_LEN) pos++;
      }
   }

  data[pos] = ','; if (pos<DATA_LEN) pos++;
  //  
  for (j=0; j<ADC_CH; j++)
   {
     k=Event.ADC_Value[j];
      for (i=0; i<4; i++)
      {
        data[pos] = Hex_Ascii((char)(0x000F & (k>>(12-i*4)))); if (pos<DATA_LEN) pos++;
      }
   }


  // 
  data[pos] = ','; if (pos<DATA_LEN) pos++;
  j=strlen(SW_Version_Text);
  for (i=0; i<j; i++)
   {
      data[pos] = SW_Version_Text[i]; if (pos<DATA_LEN) pos++; 
   } 

  // HW
  data[pos] = ','; if (pos<DATA_LEN) pos++;
  j=strlen(HW_Version_Text);
  for (i=0; i<j; i++)
   {
      data[pos] = HW_Version_Text[i]; if (pos<DATA_LEN) pos++; 
   } 
 
  // -
  data[pos] = ','; if (pos<DATA_LEN) pos++;
  if (Event.Code_Event==BALANCE_QUERY_EVENT)
  {
    j=strlen(Balance);
    for (i=0; i<j; i++)
    {
      data[pos] = Balance[i]; if (pos<DATA_LEN) pos++; 
    } 
    Balance[0]='\0';
  }
  
  // 
  for (i=0; i<MAX_WIRE_SENSOR; i++)
  {
    data[pos] = ','; if (pos<DATA_LEN) pos++;
    if (Counters[i]!=NO_PULSE && (*(char*)(VXOD_MODE+i)==VXOD_COUNTER))
    {
       data[pos] = 0x30+(Counters[i] / 100000); if (pos<DATA_LEN) pos++;
       data[pos] = 0x30+((Counters[i] % 100000) / 10000); if (pos<DATA_LEN) pos++;
       data[pos] = 0x30+(((Counters[i] % 100000) % 10000) / 1000); if (pos<DATA_LEN) pos++;
       data[pos] = 0x30+((((Counters[i] % 100000) % 10000) % 1000) / 100); if (pos<DATA_LEN) pos++;
       data[pos] = 0x30+(((((Counters[i] % 100000) % 10000) % 1000) % 100) / 10); if (pos<DATA_LEN) pos++;
       data[pos] = 0x30+(((((Counters[i] % 100000) % 10000) % 1000) % 100) % 10);  if (pos<DATA_LEN) pos++;    
    }
  }
  
  
  data[pos] = ','; if (pos<DATA_LEN) pos++; 
  data[pos] = '}'; if (pos<DATA_LEN) pos++;
  data[pos] = '\0';
 }
  
  if (*(char*) GPRS_PROTOCOL == TCP_SURGARD)
  {
    //GPRS_Send_ContactID("5010 180001R13000002\x14");
    data[pos++] = '5';
    data[pos++] = '0';
    data[pos++] = '1';
    data[pos++] = '0';
    data[pos++] = ' ';
    data[pos++] = '1';
    data[pos++] = '8';
    data[pos++] = *(char*) (DEVICE_ID+0);
    data[pos++] = *(char*) (DEVICE_ID+1);
    data[pos++] = *(char*) (DEVICE_ID+2);
    data[pos++] = *(char*) (DEVICE_ID+3);
    
    // 
    k=Event.Code_Event;

    if (k==DISARMED_EVENT || k==ARMED_EVENT)
    {
      if (k==DISARMED_EVENT)
        data[pos++] = 'E';
      else
        data[pos++] = 'R';
      data[pos++] = '4';
      data[pos++] = '0';
      data[pos++] = '0';
      
      if (Event.Group==ALL_GROUP)
        {
          data[pos++] = '0';
          data[pos++] = '0';
        }
        else
        {
          // 
          data[pos++] = '0';
          for (i=0; i<8; i++)
            {
              if (0x01 & (Event.Group>>i)) 
                {data[pos++] = 0x30+i+1; i=10;}
            }
          if (i<10) data[pos++] = '0';
        }
           
      set_zero(&data[pos],3);
      pos +=3;

    }
    else
    {
      if (k==DEVICE_START_EVENT || k==DEVICE_RESTART_EVENT)
      {
        data[pos++] = 'E';  
        data[pos++] = '3';
        data[pos++] = '0';
        data[pos++] = '5';
      
        set_zero(&data[pos],5);
        pos +=5;
      }
      else
      {
        if (k==PERIODIC_EVENT)
        {
        data[pos++] = 'E';  
        data[pos++] = '6';
        data[pos++] = '0';
        data[pos++] = '2';
      
        set_zero(&data[pos],5);
        pos +=5;
        }
        else
        {
        if (k==SERVER_QUERY_EVENT)
        {
        data[pos++] = 'E';  
        data[pos++] = '6';
        data[pos++] = '0';
        data[pos++] = '1';
        
        set_zero(&data[pos],5);
        pos +=5;
        }
        else
        {
        if ((k>=INPUT_1_FAULT_ARMED_EVENT) && (k<=RADIO_16_FAULT_ARMED_EVENT) )//(k==FAULT_ARMED_EVENT)
        {
          data[pos++] = 'R';  
          data[pos++] = '4';
          data[pos++] = '5';
          data[pos++] = '0';
      
           // 
           data[pos++] = '0';
           for (i=0; i<8; i++)
           {
             if (0x01 & (Event.Group>>i)) 
             {data[pos++] = 0x30+i+1; i=10;}
           }
           if (i<10) data[pos++] = '0';
           
           // 
           data[pos++] = 0x30 + ( Event.Sensor / 100 );
           data[pos++] = 0x30 + ( (Event.Sensor % 100) / 10 );
           data[pos++] = 0x30 + ( (Event.Sensor % 100) % 10 );         
        }
        else
        {          
         if (k==FORCE_DISARMED_EVENT)
        {
        data[pos++] = 'E';  
        data[pos++] = '1';
        data[pos++] = '2';
        data[pos++] = '4';
      
        if (Event.Group==ALL_GROUP)
          {
            data[pos++] = '0';
            data[pos++] = '0';
          }
          else
          {
            // 
            data[pos++] = '0';
            for (i=0; i<8; i++)
              {
                if (0x01 & (Event.Group>>i)) 
                  {data[pos++] = 0x30+i+1; i=10;}
              }
            if (i<10) data[pos++] = '0';
          }
           
        set_zero(&data[pos],3);
        pos +=3;
        }
        else
        {         
         if (k==_220_POWER_ON_EVENT || k==_220_POWER_OFF_EVENT || k==BACKUP_POWER_LOW_EVENT)
        {
        if (k==_220_POWER_OFF_EVENT)
        {
          data[pos++] = 'E';  
          data[pos++] = '3';
          data[pos++] = '0';
          data[pos++] = '1';
        }
        if (k==_220_POWER_ON_EVENT)
        {
          data[pos++] = 'R';  
          data[pos++] = '3';
          data[pos++] = '0';
          data[pos++] = '1';
        } 
        if (k==BACKUP_POWER_LOW_EVENT)
        {
          data[pos++] = 'E';  
          data[pos++] = '3';
          data[pos++] = '0';
          data[pos++] = '2';
        }        
        set_zero(&data[pos],5);
        pos +=5;
        }
        else
        {  
        if ( k<=HIGH_INPUT_8_EVENT ) 
        { 
           if (k%2) data[pos++] = 'E'; else data[pos++] = 'R';
           data[pos++] = '1';
           data[pos++] = '3';
           data[pos++] = '0';
           
           // 
           data[pos++] = '0';
           for (i=0; i<8; i++)
           {
             if (0x01 & (Event.Group>>i)) 
             {data[pos++] = 0x30+i+1; i=10;}
           }
           if (i<10) data[pos++] = '0';
           
           // 
           data[pos++] = 0x30 + ( Event.Sensor / 100 );
           data[pos++] = 0x30 + ( (Event.Sensor % 100) / 10 );
           data[pos++] = 0x30 + ( (Event.Sensor % 100) % 10 );           
        }
        else
        { 
        if ((k>=RADIO_SENSOR1_ALARM_EVENT) && (k<=RADIO_SENSOR16_PANIC_EVENT) )
        { 
         
          switch ((k-RADIO_SENSOR1_ALARM_EVENT+1)% EVENTS_PER_RADIO_SENSOR)  //   
            {
              // 
              case 0:
                data[pos++] = 'E';
                data[pos++] = '1';
                data[pos++] = '2';
                data[pos++] = '0';
                break;
              //  
              case 1:
                data[pos++] = 'E';
                data[pos++] = '1';
                data[pos++] = '3';
                data[pos++] = '0';
                break;
              //   
              case 2:
                data[pos++] = 'R';
                data[pos++] = '1';
                data[pos++] = '3';
                data[pos++] = '0';
                break;
              //    
              case 3:
                data[pos++] = 'E';
                data[pos++] = '1';
                data[pos++] = '4';
                data[pos++] = '4';
                break;          
              //   
              case 4:
                data[pos++] = 'E';
                data[pos++] = '3';
                data[pos++] = '8';
                data[pos++] = '4';
                break;
              //    
              case 5:
                data[pos++] = 'E';
                data[pos++] = '3';
                data[pos++] = '8';
                data[pos++] = '0';
                break;
          
              default: 
                break;
            }          
           // 
           data[pos++] = '0';
           for (i=0; i<8; i++)
           {
             if (0x01 & (Event.Group>>i)) 
             {data[pos++] = 0x30+i+1; i=10;}
           }
           if (i<10) data[pos++] = '0';
           
           // 
           data[pos++] = 0x30 + ( Event.Sensor / 100 );
           data[pos++] = 0x30 + ( (Event.Sensor % 100) / 10 );
           data[pos++] = 0x30 + ( (Event.Sensor % 100) % 10 );          
        }
        else
        {
        if (
            (k==TAMPER_ALARM_EVENT) || 
            (k==TAMPER_KB1_ALARM_EVENT) || 
            (k==TAMPER_KB2_ALARM_EVENT) || 
            (k==KB1_NO_EVENT) || 
            (k==KB2_NO_EVENT) ||
            (k==TAMPER_NORMA_EVENT) || 
            (k==TAMPER_KB1_NORMA_EVENT) ||
            (k==TAMPER_KB2_NORMA_EVENT)   
            )
        {
          if (
            (k==TAMPER_NORMA_EVENT) || 
            (k==TAMPER_KB1_NORMA_EVENT) ||
            (k==TAMPER_KB2_NORMA_EVENT)
              )              
              data[pos++] = 'R';
          else
              data[pos++] = 'E';
           data[pos++] = '1';
           data[pos++] = '3';
           data[pos++] = '7'; 
           // 
           data[pos++] = '0';
           for (i=0; i<8; i++)
           {
             if (0x01 & (Event.Group>>i)) 
             {data[pos++] = 0x30+i+1; i=10;}
           }
           if (i<10) data[pos++] = '0';
           data[pos++] = '0';
           data[pos++] = '0';
           data[pos++] = '0';           
        }
        else
        {
        if ( (k>=KZ_INPUT_1_EVENT) && (k<=OBRIV_INPUT_8_EVENT))
        {
          //      
           data[pos++] = 'E';
           data[pos++] = '1';
           data[pos++] = '4';
           if (k%2)
             data[pos++] = '1';
            else
              data[pos++] = '2';
            
           // 
           data[pos++] = '0';
           for (i=0; i<8; i++)
           {
             if (0x01 & (Event.Group>>i)) 
             {data[pos++] = 0x30+i+1; i=10;}
           }
           if (i<10) data[pos++] = '0';
           
           // 
           data[pos++] = 0x30 + ( Event.Sensor / 100 );
           data[pos++] = 0x30 + ( (Event.Sensor % 100) / 10 );
           data[pos++] = 0x30 + ( (Event.Sensor % 100) % 10 );         
        }
        else
        {
        if (k==GSM_JUMMING_DETECTION_EVENT || k==FRAUD_DETECTION_EVENT)
        {
          data[pos++] = 'E';  
          data[pos++] = '3';
          data[pos++] = '4';
          data[pos++] = '4';
        
          set_zero(&data[pos],5);
          pos +=5;        
        }
        else
        {
          
        data[pos++] = 'E';  
        data[pos++] = '7';
        data[pos++] = '5';
        data[pos++] = '0';
      
        set_zero(&data[pos],5);
        pos +=5;
        
        }
        }
        }
        } 
        }
        }
        }
        }
        }          
        } 
      }  
    }
   
    data[pos++] = '\x14';
    data[pos] = '\0';
  }
  
  
  if (*(char*) GPRS_PROTOCOL == UDP_VPN_LUN_7T)
  {
    if (packet_number > 0x37) packet_number=0x30; //   
    // 
    k=Event.Code_Event; 
    switch (k)
    {
      
    case DEVICE_START_EVENT:
        packet_number=0x2F;
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x0F; 
        data[3]=0x00;
        packet_number++;
        break;
        
    case SERVER_QUERY_EVENT: 
        data[0]=32;
        for (i=0; i<32; i++)
        {
          data[i+1]=0x00;
        }
        if (MODE_ARM_STATE) data[2] |=(1<<7);
        if ((0x00FF & Inputs_State)) data[2] |=(1<<0);
        //if (INPUT_EXT_POWER_STATE) data[2] |=(1<<x);
        //if (INPUT_MAIN_POWER_STATE) data[2] |=(1<<x);
        break;   
        
    case PERIODIC_EVENT:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x0A; 
        data[3]=0x00;
        packet_number++;
        break;    

    case ARMED_EVENT:
        data[0]=3; //   
        data[1]=packet_number;
        
        switch (Event.Who)
        {
        case OWNER_1:
        case IBUTTON_1:
        case BRELOK_1:
          data[2]=0x21; // 1
          break;

        case OWNER_2:
        case IBUTTON_2:
        case BRELOK_2:
          data[2]=0x22; // 2
          break;         

        case OWNER_3:
        case IBUTTON_3:
        case BRELOK_3:
          data[2]=0x23; // 3
          break;  
 

        case OWNER_4:
        case IBUTTON_4:
        case BRELOK_4:
          data[2]=0x24; // 4
          break; 


        case OWNER_5:
        case IBUTTON_5:
        case BRELOK_5:
          data[2]=0x25; // 5
          break;           

        case OWNER_6:
        case IBUTTON_6:
        case BRELOK_6:
          data[2]=0x26; // 6
          break;           

        case OWNER_7:
        case IBUTTON_7:
        case BRELOK_7:
          data[2]=0x27; // 7
          break;           

        case OWNER_8:
        case IBUTTON_8:
        case BRELOK_8:
          data[2]=0x28; // 8
          break;           

        case IBUTTON_9:
        case BRELOK_9:
          data[2]=0x29; // 9
          break;           

        case IBUTTON_10:
        case BRELOK_10:
          data[2]=0x2A; // 10
          break;           

        case IBUTTON_11:
        case BRELOK_11:
          data[2]=0x2B; // 11
          break;           

        case IBUTTON_12:
        case BRELOK_12:
          data[2]=0x2C; // 12
          break; 

        case NOT_OWNER:
          data[2]=0x2E; // 14
          break; 
          
        default:
          data[2]=0x2D; // 13
          break;          
          
        }
        
        data[3]=0x00;
        packet_number++;
        break;
        
    case REMOUT_ARMED_EVENT:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x20; //    
        data[3]=0x00;
        packet_number++;
        break;      
      
    case DISARMED_EVENT:
        data[0]=3; //   
        data[1]=packet_number;
        
        switch (Event.Who)
        {
        case OWNER_1:
        case IBUTTON_1:
        case BRELOK_1:
          data[2]=0x31; // 1
          break;

        case OWNER_2:
        case IBUTTON_2:
        case BRELOK_2:
          data[2]=0x32; // 2
          break;         

        case OWNER_3:
        case IBUTTON_3:
        case BRELOK_3:
          data[2]=0x33; // 3
          break;  
 

        case OWNER_4:
        case IBUTTON_4:
        case BRELOK_4:
          data[2]=0x34; // 4
          break; 


        case OWNER_5:
        case IBUTTON_5:
        case BRELOK_5:
          data[2]=0x35; // 5
          break;           

        case OWNER_6:
        case IBUTTON_6:
        case BRELOK_6:
          data[2]=0x36; // 6
          break;           

        case OWNER_7:
        case IBUTTON_7:
        case BRELOK_7:
          data[2]=0x37; // 7
          break;           

        case OWNER_8:
        case IBUTTON_8:
        case BRELOK_8:
          data[2]=0x38; // 8
          break;           

        case IBUTTON_9:
        case BRELOK_9:
          data[2]=0x39; // 9
          break;           

        case IBUTTON_10:
        case BRELOK_10:
          data[2]=0x3A; // 10
          break;           

        case IBUTTON_11:
        case BRELOK_11:
          data[2]=0x3B; // 11
          break;           

        case IBUTTON_12:
        case BRELOK_12:
          data[2]=0x3C; // 12
          break; 

        case NOT_OWNER:
          data[2]=0x3E; // 14
          break; 
          
        default:
          data[2]=0x3D; // 13
          break;          
          
        }        

        data[3]=0x00;
        packet_number++;
        break;  
  
    case START_DISARM_EVENT:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x0E; //
        data[3]=0x00;
        packet_number++;
        break;      

    case _220_POWER_ON_EVENT:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x19; //
        data[3]=0x00;
        packet_number++;
        break; 

    case _220_POWER_OFF_EVENT:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x09; //
        data[3]=0x00;
        packet_number++;
        break;         

    case BACKUP_POWER_LOW_EVENT:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x1C; //
        data[3]=0x00;
        packet_number++;
        break; 

    case BACKUP_POWER_OK_EVENT:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x1D; //
        data[3]=0x00;
        packet_number++;
        break;
        
    case HIGH_INPUT_1_EVENT:
    case KZ_INPUT_1_EVENT:
    case OBRIV_INPUT_1_EVENT:       
    case RADIO_SENSOR1_ALARM_EVENT:
    case RADIO_SENSOR1_PANIC_EVENT:
    case RADIO_SENSOR1_TAMPER_EVENT:  
    case RADIO_SENSOR1_ALARM_EVENT+6*8:
    case RADIO_SENSOR1_PANIC_EVENT+6*8:
    case RADIO_SENSOR1_TAMPER_EVENT+6*8: 
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x01; 
        data[3]=0x00;
        packet_number++;
        break;      

    case LOW_INPUT_1_EVENT:
    case RADIO_SENSOR1_NORMA_EVENT:
    case RADIO_SENSOR1_NORMA_EVENT+6*8:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x11; 
        data[3]=0x00;
        packet_number++;
        break;  
 
    case HIGH_INPUT_2_EVENT:
    case KZ_INPUT_2_EVENT:
    case OBRIV_INPUT_2_EVENT:       
    case RADIO_SENSOR1_ALARM_EVENT+6*1:
    case RADIO_SENSOR1_PANIC_EVENT+6*1:
    case RADIO_SENSOR1_TAMPER_EVENT+6*1:      
    case RADIO_SENSOR1_ALARM_EVENT+6*9:
    case RADIO_SENSOR1_PANIC_EVENT+6*9:
    case RADIO_SENSOR1_TAMPER_EVENT+6*9:      
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x02; 
        data[3]=0x00;
        packet_number++;
        break;      

    case LOW_INPUT_2_EVENT:
    case RADIO_SENSOR1_NORMA_EVENT+6*1:
    case RADIO_SENSOR1_NORMA_EVENT+6*9:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x12; 
        data[3]=0x00;
        packet_number++;
        break; 
 
    case HIGH_INPUT_3_EVENT:
    case KZ_INPUT_3_EVENT:
    case OBRIV_INPUT_3_EVENT:       
    case RADIO_SENSOR1_ALARM_EVENT+6*2:
    case RADIO_SENSOR1_PANIC_EVENT+6*2:
    case RADIO_SENSOR1_TAMPER_EVENT+6*2:      
    case RADIO_SENSOR1_ALARM_EVENT+6*10:
    case RADIO_SENSOR1_PANIC_EVENT+6*10:
    case RADIO_SENSOR1_TAMPER_EVENT+6*10:      
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x03; 
        data[3]=0x00;
        packet_number++;
        break;      

    case LOW_INPUT_3_EVENT:
    case RADIO_SENSOR1_NORMA_EVENT+6*2:
    case RADIO_SENSOR1_NORMA_EVENT+6*10:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x13; 
        data[3]=0x00;
        packet_number++;
        break; 
 
    case HIGH_INPUT_4_EVENT:
    case KZ_INPUT_4_EVENT:
    case OBRIV_INPUT_4_EVENT:       
    case RADIO_SENSOR1_ALARM_EVENT+6*3:
    case RADIO_SENSOR1_PANIC_EVENT+6*3:
    case RADIO_SENSOR1_TAMPER_EVENT+6*3:      
    case RADIO_SENSOR1_ALARM_EVENT+6*11:
    case RADIO_SENSOR1_PANIC_EVENT+6*11:
    case RADIO_SENSOR1_TAMPER_EVENT+6*11:      
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x04; 
        data[3]=0x00;
        packet_number++;
        break;      

    case LOW_INPUT_4_EVENT:
    case RADIO_SENSOR1_NORMA_EVENT+6*3:
    case RADIO_SENSOR1_NORMA_EVENT+6*11:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x14; 
        data[3]=0x00;
        packet_number++;
        break; 

    case HIGH_INPUT_5_EVENT:
    case KZ_INPUT_5_EVENT:
    case OBRIV_INPUT_5_EVENT:       
    case RADIO_SENSOR1_ALARM_EVENT+6*4:
    case RADIO_SENSOR1_PANIC_EVENT+6*4:
    case RADIO_SENSOR1_TAMPER_EVENT+6*4:      
    case RADIO_SENSOR1_ALARM_EVENT+6*12:
    case RADIO_SENSOR1_PANIC_EVENT+6*12:
    case RADIO_SENSOR1_TAMPER_EVENT+6*12:      
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x05; 
        data[3]=0x00;
        packet_number++;
        break;      

    case LOW_INPUT_5_EVENT:
    case RADIO_SENSOR1_NORMA_EVENT+6*4:
    case RADIO_SENSOR1_NORMA_EVENT+6*12:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x15; 
        data[3]=0x00;
        packet_number++;
        break;

    case HIGH_INPUT_6_EVENT:
    case KZ_INPUT_6_EVENT:
    case OBRIV_INPUT_6_EVENT:       
    case RADIO_SENSOR1_ALARM_EVENT+6*5:
    case RADIO_SENSOR1_PANIC_EVENT+6*5:
    case RADIO_SENSOR1_TAMPER_EVENT+6*5:      
    case RADIO_SENSOR1_ALARM_EVENT+6*13:
    case RADIO_SENSOR1_PANIC_EVENT+6*13:
    case RADIO_SENSOR1_TAMPER_EVENT+6*13:      
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x06; 
        data[3]=0x00;
        packet_number++;
        break;      

    case LOW_INPUT_6_EVENT:
    case RADIO_SENSOR1_NORMA_EVENT+6*5:
    case RADIO_SENSOR1_NORMA_EVENT+6*13:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x16; 
        data[3]=0x00;
        packet_number++;
        break;

    case HIGH_INPUT_7_EVENT:
    case KZ_INPUT_7_EVENT:
    case OBRIV_INPUT_7_EVENT:       
    case RADIO_SENSOR1_ALARM_EVENT+6*6:
    case RADIO_SENSOR1_PANIC_EVENT+6*6:
    case RADIO_SENSOR1_TAMPER_EVENT+6*6:      
    case RADIO_SENSOR1_ALARM_EVENT+6*14:
    case RADIO_SENSOR1_PANIC_EVENT+6*14:
    case RADIO_SENSOR1_TAMPER_EVENT+6*14:      
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x07; 
        data[3]=0x00;
        packet_number++;
        break;      

    case LOW_INPUT_7_EVENT:
    case RADIO_SENSOR1_NORMA_EVENT+6*6:
    case RADIO_SENSOR1_NORMA_EVENT+6*14:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x17; 
        data[3]=0x00;
        packet_number++;
        break;        

    case HIGH_INPUT_8_EVENT:
    case KZ_INPUT_8_EVENT:
    case OBRIV_INPUT_8_EVENT:       
    case RADIO_SENSOR1_ALARM_EVENT+6*7:
    case RADIO_SENSOR1_PANIC_EVENT+6*7:
    case RADIO_SENSOR1_TAMPER_EVENT+6*7:      
    case RADIO_SENSOR1_ALARM_EVENT+6*15:
    case RADIO_SENSOR1_PANIC_EVENT+6*15:
    case RADIO_SENSOR1_TAMPER_EVENT+6*15:      
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x08; 
        data[3]=0x00;
        packet_number++;
        break;      

    case LOW_INPUT_8_EVENT:
    case RADIO_SENSOR1_NORMA_EVENT+6*7:
    case RADIO_SENSOR1_NORMA_EVENT+6*15:
        data[0]=3; //   
        data[1]=packet_number;
        data[2]=0x18; 
        data[3]=0x00;
        packet_number++;
        break;          
        
      default: 
       data[0]='\0';
         break;      
    }
  }
  
  
  if (data[0]) {if ( GPRS_Send(data) ) data[0]='\0';}
  
  return 1;
 } 
 else 
 {return 2;}
}

/*******************************************************************************
* Function Name  : Event_Check
* Description    :      
* Input          : None
* Output         : None
* Return         : 0 -     , 1-    
*                  2 -  
*******************************************************************************/
char Event_Check (void)
{
 TypeDef_EVENT Event;
 
 char sensor, i, ring, sms, rf_termo=0;
 
 // ,             -
 char sensor_temp[RADIO_SENSOR_NAME_LEN*4]={0x00};
 char * temp_result;
 const char * temp;
 
  /*      */
 if( xQueueReceive( Queue_Event, &Event, 10 ) == pdPASS )
 {

   //     

   //    
   sensor=Event.Code_Event/2 + 1; //    
   if ((Event.Code_Event>=KZ_INPUT_1_EVENT) && (Event.Code_Event<=OBRIV_INPUT_8_EVENT) )
   {
     //      
     sensor=(Event.Code_Event-KZ_INPUT_1_EVENT)/2 + 1; //   
   }
   
   if ( 0x01 & ((*(char *) ALARM_RING_INPUT) >> (sensor-1)) ) ring=WITH_RING; else ring=WITHOUT_RING;
   if ( 0x01 & ((*(char *) ALARM_SMS_INPUT) >> (sensor-1)) ) sms=WITH_SMS; else sms=WITHOUT_SMS;
  
   // 
   if (Event.Code_Event==HIGH_INPUT_1_EVENT) Send_Event ( (char *) IN1_HIGH_TEXT, ring, sms, Event,0, File_Wire[0]);
   if (Event.Code_Event==HIGH_INPUT_2_EVENT) Send_Event ( (char *) IN2_HIGH_TEXT, ring, sms, Event,0, File_Wire[1]);
   if (Event.Code_Event==HIGH_INPUT_3_EVENT) Send_Event ( (char *) IN3_HIGH_TEXT, ring, sms, Event,0, File_Wire[2]);
   if (Event.Code_Event==HIGH_INPUT_4_EVENT) Send_Event ( (char *) IN4_HIGH_TEXT, ring, sms, Event,0, File_Wire[3]);
   if (Event.Code_Event==HIGH_INPUT_5_EVENT) Send_Event ( (char *) IN5_HIGH_TEXT, ring, sms, Event,0, File_Wire[4]);
   if (Event.Code_Event==HIGH_INPUT_6_EVENT) Send_Event ( (char *) IN6_HIGH_TEXT, ring, sms, Event,0, File_Wire[5]);
   if (Event.Code_Event==HIGH_INPUT_7_EVENT) Send_Event ( (char *) IN7_HIGH_TEXT, ring, sms, Event,0, File_Wire[6]);
   if (Event.Code_Event==HIGH_INPUT_8_EVENT) Send_Event ( (char *) IN8_HIGH_TEXT, ring, sms, Event,0, File_Wire[7]);
   
   // 
   if (Event.Code_Event==LOW_INPUT_1_EVENT) Send_Event ( (char *) IN1_LOW_TEXT, WITHOUT_RING, sms, Event,0, Answer_OK);
   if (Event.Code_Event==LOW_INPUT_2_EVENT) Send_Event ( (char *) IN2_LOW_TEXT, WITHOUT_RING, sms, Event,0, Answer_OK);
   if (Event.Code_Event==LOW_INPUT_3_EVENT) Send_Event ( (char *) IN3_LOW_TEXT, WITHOUT_RING, sms, Event,0, Answer_OK);
   if (Event.Code_Event==LOW_INPUT_4_EVENT) Send_Event ( (char *) IN4_LOW_TEXT, WITHOUT_RING, sms, Event,0, Answer_OK);
   if (Event.Code_Event==LOW_INPUT_5_EVENT) Send_Event ( (char *) IN5_LOW_TEXT, WITHOUT_RING, sms, Event,0, Answer_OK);
   if (Event.Code_Event==LOW_INPUT_6_EVENT) Send_Event ( (char *) IN6_LOW_TEXT, WITHOUT_RING, sms, Event,0, Answer_OK);
   if (Event.Code_Event==LOW_INPUT_7_EVENT) Send_Event ( (char *) IN7_LOW_TEXT, WITHOUT_RING, sms, Event,0, Answer_OK);
   if (Event.Code_Event==LOW_INPUT_8_EVENT) Send_Event ( (char *) IN8_LOW_TEXT, WITHOUT_RING, sms, Event,0, Answer_OK); 
   
   // 
   if (Event.Code_Event==KZ_INPUT_1_EVENT) Send_Event ( (char *) IN1_HIGH_TEXT, ring, sms, Event, KZ_CHANGE, Answer_OK);
   if (Event.Code_Event==KZ_INPUT_2_EVENT) Send_Event ( (char *) IN2_HIGH_TEXT, ring, sms, Event, KZ_CHANGE, Answer_OK);
   if (Event.Code_Event==KZ_INPUT_3_EVENT) Send_Event ( (char *) IN3_HIGH_TEXT, ring, sms, Event, KZ_CHANGE, Answer_OK);
   if (Event.Code_Event==KZ_INPUT_4_EVENT) Send_Event ( (char *) IN4_HIGH_TEXT, ring, sms, Event, KZ_CHANGE, Answer_OK);
   if (Event.Code_Event==KZ_INPUT_5_EVENT) Send_Event ( (char *) IN5_HIGH_TEXT, ring, sms, Event, KZ_CHANGE, Answer_OK);
   if (Event.Code_Event==KZ_INPUT_6_EVENT) Send_Event ( (char *) IN6_HIGH_TEXT, ring, sms, Event, KZ_CHANGE, Answer_OK);
   if (Event.Code_Event==KZ_INPUT_7_EVENT) Send_Event ( (char *) IN7_HIGH_TEXT, ring, sms, Event, KZ_CHANGE, Answer_OK);
   if (Event.Code_Event==KZ_INPUT_8_EVENT) Send_Event ( (char *) IN8_HIGH_TEXT, ring, sms, Event, KZ_CHANGE, Answer_OK);  

   // 
   if (Event.Code_Event==OBRIV_INPUT_1_EVENT) Send_Event ( (char *) IN1_HIGH_TEXT, ring, sms, Event, OBRIV_CHANGE, Answer_OK);
   if (Event.Code_Event==OBRIV_INPUT_2_EVENT) Send_Event ( (char *) IN2_HIGH_TEXT, ring, sms, Event, OBRIV_CHANGE, Answer_OK);
   if (Event.Code_Event==OBRIV_INPUT_3_EVENT) Send_Event ( (char *) IN3_HIGH_TEXT, ring, sms, Event, OBRIV_CHANGE, Answer_OK);
   if (Event.Code_Event==OBRIV_INPUT_4_EVENT) Send_Event ( (char *) IN4_HIGH_TEXT, ring, sms, Event, OBRIV_CHANGE, Answer_OK);
   if (Event.Code_Event==OBRIV_INPUT_5_EVENT) Send_Event ( (char *) IN5_HIGH_TEXT, ring, sms, Event, OBRIV_CHANGE, Answer_OK);
   if (Event.Code_Event==OBRIV_INPUT_6_EVENT) Send_Event ( (char *) IN6_HIGH_TEXT, ring, sms, Event, OBRIV_CHANGE, Answer_OK);
   if (Event.Code_Event==OBRIV_INPUT_7_EVENT) Send_Event ( (char *) IN7_HIGH_TEXT, ring, sms, Event, OBRIV_CHANGE, Answer_OK);
   if (Event.Code_Event==OBRIV_INPUT_8_EVENT) Send_Event ( (char *) IN8_HIGH_TEXT, ring, sms, Event, OBRIV_CHANGE, Answer_OK); 
   
 
   //    
   if ( 0x01 & ( (*(char*)(_SMS))>>_POWER)) sms=WITH_SMS; else sms=WITHOUT_SMS;
   if ( 0x01 & ( (*(char*)(_RING))>>_POWER)) ring=WITH_RING; else ring=WITHOUT_RING;     
   if (Event.Code_Event==_220_POWER_ON_EVENT) Send_Event ( (char *) _220V_ON_TEXT, WITHOUT_RING, sms, Event,0, Answer_OK);
   if (Event.Code_Event==_220_POWER_OFF_EVENT) Send_Event ( (char *) _220V_OFF_TEXT, ring, sms, Event,0, Answer_OK);
   if (Event.Code_Event==BACKUP_POWER_LOW_EVENT) Send_Event ( (char *) LOW_ACC_TEXT, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);
   if (Event.Code_Event==INT_POWER_LOW_EVENT) Send_Event ( (char *) Low_Li_Ion_Text, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);
   
   //     GSM-
   if (Event.Code_Event==GSM_JUMMING_DETECTION_EVENT) Send_Event ( (char *) GSM_Jamming_Detection_Text, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);

   //        
   if (Event.Code_Event==FRAUD_DETECTION_EVENT) Send_Event ( (char *) Fraud_Detection_Text, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);

   
   //     
   if (Event.Code_Event==TAMPER_ALARM_EVENT) Send_Event ( (char *) TAMPER_ALARM_TEXT, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);
   if (Event.Code_Event==TAMPER_NORMA_EVENT) Send_Event ( (char *) TAMPER_NORMA_TEXT, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);
   
   //     -1
   if (Event.Code_Event==TAMPER_KB1_ALARM_EVENT) Send_Event ( (char *) TAMPER_KB1_ALARM_TEXT, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);
   if (Event.Code_Event==TAMPER_KB1_NORMA_EVENT) Send_Event ( (char *) TAMPER_KB1_NORMA_TEXT, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);
   if (Event.Code_Event==KB1_NO_EVENT) Send_Event ( KB1_No_Text, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);
   
   //     -2
   if (Event.Code_Event==TAMPER_KB2_ALARM_EVENT) Send_Event ( (char *) TAMPER_KB2_ALARM_TEXT, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);
   if (Event.Code_Event==TAMPER_KB2_NORMA_EVENT) Send_Event ( (char *) TAMPER_KB2_NORMA_TEXT, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);
   if (Event.Code_Event==KB2_NO_EVENT) Send_Event ( KB2_No_Text, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);
   
   //    / 
   if (Event.Code_Event==ARMED_EVENT) Send_Event ( (char *) ARM_TEXT, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);
   if (Event.Code_Event==DISARMED_EVENT) Send_Event ( (char *) DISARM_TEXT, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);
   if (Event.Code_Event==FORCE_DISARMED_EVENT) Send_Event ( Force_Disarm_Text, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);
   if ( (Event.Code_Event>=INPUT_1_FAULT_ARMED_EVENT) && (Event.Code_Event<=RADIO_16_FAULT_ARMED_EVENT) ) Send_Event ( Fault_Arm_Text, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);
   

   //     DS1820
   if ((Event.Code_Event>=TERMO_DS1820_1_EVENT) && (Event.Code_Event<=TERMO_DS1820_8_EVENT) )
   {
     sensor=(Event.Code_Event-TERMO_DS1820_1_EVENT) +1; //   
     //      DS1820   , 
     temp_result = sensor_temp; //  ,   
     temp=(char *) (TERMO_DS1820_NAME_1 + TERMO_DS1820_NAME_LEN*(sensor-1)); //   
     temp_result=Add_String (temp_result,temp,strlen (temp));
     i=DS1820_Sensor.Data_Current[sensor-1];
     temp_result=Print_T_Tmin_Tn_Tmax (temp_result, i, sensor, DS1820_1_MIN_MAX_W, DS1820_Sensor.Tn[sensor-1]);
     //ring=WITHOUT_RING;
     //  -
     *temp_result=0x00; //  
     Send_Event (sensor_temp, WITHOUT_RING, WITH_SMS, Event,0, Answer_OK);     
   }
   
   //    
   if ((Event.Code_Event>=RADIO_SENSOR1_ALARM_EVENT) && (Event.Code_Event<=RADIO_SENSOR16_PANIC_EVENT) )
   {
     //    
     sensor=(Event.Code_Event-RADIO_SENSOR1_ALARM_EVENT) / EVENTS_PER_RADIO_SENSOR+1; //   
     
     //          
     temp_result = sensor_temp; //  ,   
     temp= (char *) (RADIO_SENSOR_NAME_1+RADIO_SENSOR_NAME_LEN*(sensor-1)); //   
     temp_result=Add_String (temp_result,temp,strlen (temp));
     
     //  ,      
     if (
         ((RF_Sensor.Data_Current[sensor-1] & 0x000F)== RADIO_SENSOR_TERMO) ||
         ((RF_Sensor.Data_Current[sensor-1] & 0x000F)== RADIO_SENSOR_TERMO_REPITER) 
        )
      {
        i=(RF_Sensor.Data_Current[sensor-1]>>8 ); //temperature
        temp_result=Print_T_Tmin_Tn_Tmax (temp_result, i, sensor, RADIO_1_MIN_MAX_W, RF_Sensor.Tn[sensor-1] );
        rf_termo=1;
      }

     ring=WITHOUT_RING;
     sms=WITH_SMS;
     //   
     //  
     switch ((Event.Code_Event-RADIO_SENSOR1_ALARM_EVENT+1)% EVENTS_PER_RADIO_SENSOR)  //   
      {
	// 
        case 0:
          temp=Panika_Text;
          temp_result=Add_String (temp_result,temp,strlen (temp));
	  ring=WITH_RING; 
          break;
        //  
        case 1:
          temp=Alarm_Text;
          temp_result=Add_String (temp_result,temp,strlen (temp));
          if ( 0x0001 & ((*(uint16_t *) ALARM_RING_RF) >> (sensor-1)) ) ring=WITH_RING; else ring=WITHOUT_RING;
          if ( 0x0001 & ((*(uint16_t *) ALARM_SMS_RF) >> (sensor-1)) ) sms=WITH_SMS; else sms=WITHOUT_SMS;
          break;
        //   
        case 2:
          temp=Norma_Text;
          temp_result=Add_String (temp_result,temp,strlen (temp)); 
          if ( 0x0001 & ((*(uint16_t *) ALARM_SMS_RF) >> (sensor-1)) ) sms=WITH_SMS; else sms=WITHOUT_SMS;
          break;
        //    
        case 3:
          temp=Tamper_Text;
          temp_result=Add_String (temp_result,temp,strlen (temp)); 
          break;          
        //   
        case 4:
          temp=Battery_Text;
          temp_result=Add_String (temp_result,temp,strlen (temp));
          break;
        //    
        case 5:
          temp=Period_Text;
          temp_result=Add_String (temp_result,temp,strlen (temp));
          
          return 1;
          
          break;
          
        default: 
          break;
      }
     
     //  -
     *temp_result=0x00; //  
     if (rf_termo) {ring=WITHOUT_RING;}
     Send_Event (sensor_temp, ring, sms, Event,0, File_Radio[sensor-1]);
   }
   
   
  return 1;
 } else {return 2;}

}

/*******************************************************************************
* Function Name  : Hex_Ascii
* Description    :    ASCII HEX- 
* Input          : Hex -  ( 4 )
* Output         : None
* Return         : ASCII HEX-
*******************************************************************************/
char Hex_Ascii (char Hex)
{
  if ((Hex & 0x0F) > 9 ) return (Hex+0x37); else return (Hex+0x30);
}
/*******************************************************************************
* Function Name  : Send_Android_SMS_to_Phone
* Description    :  -  -    
* Input          : SMS_Phone_Number -   
* Output         : None
* Return         : 0 -   , 1 -  
*******************************************************************************/
char Send_Android_SMS_to_Phone (char * SMS_Phone_Number)
{
  char data[160];
  char j,i, pos=0;
  unsigned short int k;

  if (!strlen(SMS_Phone_Number)) return 0; //,     0

  Send_Command_To_SIM900 (Cmd_SEND_SMS, strlen(Cmd_SEND_SMS));
  Send_Command_To_SIM900_ (SMS_Phone_Number, strlen(SMS_Phone_Number));
  Send_Command_To_SIM900_ ("\"\r", 2);
  Wait_For_SIM900_Answer (Answer_SEND, 2*GSM_ANSWER_WAIT_1SEC);

  // 80    160 HEX-ASCII  -    

  //   -
  for (i=0; i<160; i++)
   {
     data[i]='0';
   }
  
  //4+4+4+4+2+8*2+16*4=98
  //  
  k=MODE_FLAGS;
  for (i=0; i<4; i++)
   {
     data[pos] = Hex_Ascii((char)(0x000F & (k>>(12-i*4)))); pos++;
   }
 
  
  //  ,  , 220 ...
  k=Inputs_State;
  for (i=0; i<4; i++)
   {
     data[pos] = Hex_Ascii((char)(0x000F & (k>>(12-i*4)))); pos++;
   }
  
  //      
  k=KZ_Obriv_State;
  for (i=0; i<4; i++)
   {
     data[pos] = Hex_Ascii((char)(0x000F & (k>>(12-i*4)))); pos++;
   } 
  
  //  
  k=Outputs_State;
  for (i=0; i<4; i++)
   {
     data[pos] = Hex_Ascii((char)(0x000F & (k>>(12-i*4)))); pos++;
   }
  
  //  GSM-
  data[pos] = Hex_Ascii((char)(0x000F & (GSM_Level>>4))); pos++;
  data[pos] = Hex_Ascii((char)(0x000F & GSM_Level)); pos++;
  
  //   DS1820
  for (i=0; i<MAX_DS1820; i++)
   {
     data[pos] = Hex_Ascii(DS1820_Sensor.Data_Current[i]>>4); pos++;
     data[pos] = Hex_Ascii(0x0F & DS1820_Sensor.Data_Current[i]); pos++; 
   }
  
  //  
  for (j=0; j<MAX_RADIO_SENSOR; j++)
   {
     k=RF_Sensor.Data_Current[j];
     for (i=0; i<4; i++)
      {
        data[pos] = Hex_Ascii((char)(0x000F & (k>>(12-i*4)))); pos++;
      }
   }  
  
  Send_Command_To_SIM900 (data, 160);
  //  <ctrl+Z>
  Send_Command_To_SIM900 ("\x1A", 1);
  return Wait_For_SIM900_Answer (Answer_OK, 12*GSM_ANSWER_WAIT_1SEC); 

}

/*******************************************************************************
* Function Name  : Send_USSD_SMS_to_Phone
* Description    :  -   USSD-
* Input          : SMS_Phone_Number -   
* Output         : None
* Return         : 0 -   , 1 -  
*******************************************************************************/
char Send_USSD_SMS_to_Phone (char * SMS_Phone_Number)
{
  unsigned short int i;
  char data[160];
  char j,k,z;
  char *temp=USSD_Query;
  TypeDef_EVENT Event;
  
  if (FLAG_USSD_BALANCE_SEND_STATE)  temp=(char *) BALANCE_USSD;
    
  Send_Command_To_SIM900 (Cmd_CSCS_GSM, strlen(Cmd_CSCS_GSM));
  Wait_For_SIM900_Answer (Answer_OK, GSM_ANSWER_WAIT_1SEC);
  
  Send_Command_To_SIM900 (Cmd_CUSD, strlen(Cmd_CUSD));
  Send_Command_To_SIM900_ (temp, strlen(temp));
  Send_Command_To_SIM900_ ("\"\r", 2);
  i=Wait_For_SIM900_Answer (Answer_USSD, 7*GSM_ANSWER_WAIT_1SEC); 
 
  //   
  if (i)
  {
    for (k=0; k<159; k++)
    {
      if (SIM900_Rx_Buffer[i+k]!='"') data[k]= SIM900_Rx_Buffer[i+k] ; else break;
    }
    data[k]='\0';
  }

  FLAG_ANALIZING_RESET; //      
  
  if (i==0) return 0;
  
  temp=SMS_Phone_Number;
  if (FLAG_USSD_BALANCE_SEND_STATE)
   {
      FLAG_USSD_BALANCE_SEND_RESET;
      
      // 
      j=strlen(data);
      Balance[0]='\0';
      z=0;
      for (k=0; k<j; k++)
      {
        //  
        if ( (data[k] > 0x2F) && (data[k]<0x3A) ) 
        {
          for (z=0; z<BALANCE_MAX_LEN; z++)
          {
            if ( ((data[k] > 0x2F) && (data[k]<0x3A)) || (data[k] == '.') || (data[k] == ',') )
            { 
              Balance[z]=data[k];
              if (Balance[z]==',') Balance[z]='.';
            }
            else
            {
              break;
            }
            k++;
          }
          break;
        }
      }
      Balance[z]='\0';
      Event.Code_Event=BALANCE_QUERY_EVENT; 
      Save_Event_to_Buffer(Event);
      
      //  0 ... 65535
      for (k=0;k<6;k++)
      {
        if ( (Balance[k]=='.') || (Balance[k]=='\0')) break;
      }
      i=0; //
      if (k==6) k=5;
      if (k) {i += 1*(Balance[k-1]-0x30); k--;}
      if (k) {i += 10*(Balance[k-1]-0x30); k--;}
      if (k) {i += 100*(Balance[k-1]-0x30); k--;}
      if (k) {i += 1000*(Balance[k-1]-0x30); k--;}
      if (k) {i += 10000*(Balance[k-1]-0x30); k--;}

       //   ,      -1  ,          
      if ( (!FLAG_SMS_BALANCE_SEND_STATE) && ( i < ( * (uint16_t *) BALANCE_LEVEL )) )
      {
        FLAG_SMS_BALANCE_SEND_SET;
        Copy_Owner_Phone_from_EEPROM (OWNER1_PHONE_W1);
        temp=Owner_Phone_Number;
      }
      else
      {
        if ( i > ( * (uint16_t *) BALANCE_LEVEL ) ) FLAG_SMS_BALANCE_SEND_RESET;
        return 1;
      }
   }
  
  //   USSD-
  if (!strlen(temp)) return 0; //,     0
  
  Send_Command_To_SIM900 (Cmd_SEND_SMS, strlen(Cmd_SEND_SMS));
  Send_Command_To_SIM900_ (temp, strlen(temp));
  Send_Command_To_SIM900_ ("\"\r", 2);
  Wait_For_SIM900_Answer (Answer_SEND, 2*GSM_ANSWER_WAIT_1SEC);  
  
  Send_Command_To_SIM900 (data, strlen(data));
  //  <ctrl+Z>
  Send_Command_To_SIM900 ("\x1A", 1);
  return Wait_For_SIM900_Answer (Answer_OK, 12*GSM_ANSWER_WAIT_1SEC); 
}
/*******************************************************************************
* Function Name  : Send_GSM_Location_SMS_to_Phone
* Description    :  -   ,   GSM-
* Input          : SMS_Phone_Number -   
* Output         : None
* Return         : 0 -   , 1 -  
*******************************************************************************/
char Send_GSM_Location_SMS_to_Phone (char * SMS_Phone_Number)
{
  uint16_t i=0;
  char data_len=0;
  char data[160];
  char * data_;
  
  if (!strlen(SMS_Phone_Number)) return 0; //,     0
    
  Send_Command_To_SIM900 (Cmd_SAPBR_GPRS, strlen(Cmd_SAPBR_GPRS));
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_SAPBR_APN, strlen(Cmd_SAPBR_APN));
  Send_Command_To_SIM900_ (Cmd_APN_, strlen(Cmd_APN_));
  Send_Command_To_SIM900_ ("\"\r", 2);
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_SAPBR_Activate, strlen(Cmd_SAPBR_Activate));
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_SAPBR_Query, strlen(Cmd_SAPBR_Query));
  Wait_For_SIM900_Answer (Answer_OK, 2*GSM_ANSWER_WAIT_1SEC);

  Send_Command_To_SIM900 (Cmd_Get_Location, strlen(Cmd_Get_Location));
  i=Wait_For_SIM900_Answer (Answer_Location, 3*GSM_ANSWER_WAIT_1SEC);
  data[0]='\0';
  if (i)
  {
    //       GSM-
    FLAG_ANALIZING_SET; //      
    data_=data;
    while ( (SIM900_Rx_Buffer[i]!='\x0A') && (data_len<80) )
      {
        *data_=SIM900_Rx_Buffer[i];
        i++;
        data_++;
        data_len++;
      }
    *data_=0x0a;
    data_++;
    *data_=' ';
    data_++;
    *data_=0x0a;
    data_++;
    *data_=0x00; 
    FLAG_ANALIZING_RESET; //         
  }

  Send_Command_To_SIM900 (Cmd_SAPBR_Deactivate, strlen(Cmd_SAPBR_Deactivate));
  Wait_For_SIM900_Answer (Answer_OK, 3*GSM_ANSWER_WAIT_1SEC);  

  Send_Command_To_SIM900 (Cmd_SEND_SMS, strlen(Cmd_SEND_SMS));
  Send_Command_To_SIM900_ (SMS_Phone_Number, strlen(SMS_Phone_Number));
  Send_Command_To_SIM900_ ("\"\r", 2);
  Wait_For_SIM900_Answer (Answer_SEND, 2*GSM_ANSWER_WAIT_1SEC);
  
  Send_Command_To_SIM900 (Text_GSM_Location, strlen(Text_GSM_Location));
  Send_Command_To_SIM900_ (data, strlen(data));
  //  <ctrl+Z>
  Send_Command_To_SIM900 ("\x1A", 1);
  return Wait_For_SIM900_Answer (Answer_OK, 12*GSM_ANSWER_WAIT_1SEC);  
  
}
/*******************************************************************************
* Function Name  : Send_Netmon_SMS_to_Phone
* Description    :  -   GSM-
* Input          : SMS_Phone_Number -   
* Output         : None
* Return         : 0 -   , 1 -  
*******************************************************************************/
char Send_Netmon_SMS_to_Phone (char * SMS_Phone_Number)
{
  uint16_t i=0,z=0;
  char j, m, data_len=0;
  char ceng[]="0,\""; //"+CENG:0,\"";
  char data[160];
  char * data_;
  
  if (!strlen(SMS_Phone_Number)) return 0; //,     0

  //  GSM-

  Send_Command_To_SIM900 (Cmd_GET_CENG, strlen(Cmd_GET_CENG));
  
  if (Wait_For_SIM900_Answer (Answer_OK, 3*GSM_ANSWER_WAIT_1SEC))
  {
    FLAG_ANALIZING_SET; //      
    
    /*   
            vTaskDelay(500/portTICK_RATE_MS);
            taskENTER_CRITICAL (); 
            SendDataToHost ((SIM900_Rx_Buffer),strlen(SIM900_Rx_Buffer));
            taskEXIT_CRITICAL (); */
  /*
  oko-pro
+CENG: 1,1

+CENG:0,"0561,41,99,255,03,56,b863,04,00,6989,5"
+CENG:1,"0121,35,179,a4db,255,03,6989"
+CENG:2,"0721,33,142,1c21,255,03,6989"
+CENG:3,"0049,32,161,a4d9,255,03,6989"
+CENG:4,"0005,30,167,0899,255,03,6989"
+CENG:5,"0644,28,172,b861,255,03,6989"
+CENG:6,"0008,16,178,a4da,255,03,6989"

OK

  oko-u2
+CENG: 1,1

+CENG: 0,"0569,47,00,255,03,56,4b17,04,00,6989,255"
+CENG: 1,"0005,42,39,0899,255,03,6989"
+CENG: 2,"0606,33,22,4b15,255,03,6989"
+CENG: 3,"0083,31,25,0213,255,03,6989"
+CENG: 4,"0076,28,00,0214,255,03,6989"
+CENG: 5,"0053,27,00,30f3,255,03,6989"
+CENG: 6,"0721,25,14,1c21,255,03,6989"

OK  
  
  */  
  
    data_=data;
    for (m=0; (m<7) && (data_len<157) ; m++)
    {
      ceng[0]=m+0x30; //ceng[6]=m+0x30;
      for (i=z; i<Received_DataLength; i++)
      {
        j=Check_Command (SIM900_Rx_Buffer, ceng, i);
        if (j)
        {
          i=i+j;
          while ( (SIM900_Rx_Buffer[i]!='"') && (data_len<157) )
          {
            *data_=SIM900_Rx_Buffer[i];
            i++;
            data_++;
            data_len++;
          }
          z=i;
          *data_=0x0a;
          data_++;
          data_len++;
          break; //i=350;
        }
      }
    }
    *data_=0x00;
    FLAG_ANALIZING_RESET; //      
  
    Send_Command_To_SIM900 (Cmd_SEND_SMS, strlen(Cmd_SEND_SMS));
    Send_Command_To_SIM900_ (SMS_Phone_Number, strlen(SMS_Phone_Number));
    Send_Command_To_SIM900_ ("\"\r", 2);
    Wait_For_SIM900_Answer (Answer_SEND, 2*GSM_ANSWER_WAIT_1SEC);
  
    Send_Command_To_SIM900 (data, strlen(data));
    //  <ctrl+Z>
    Send_Command_To_SIM900 ("\x1A", 1);
    return Wait_For_SIM900_Answer (Answer_OK, 12*GSM_ANSWER_WAIT_1SEC);   
  }
  else 
    return 0;
  
}
/*******************************************************************************
* Function Name  : Send_Termo_SMS_to_Phone
* Description    :  -   
* Input          : SMS_Phone_Number -   
* Output         : None
* Return         : 0 -   , 1 -  
*******************************************************************************/
char Send_Termo_SMS_to_Phone (char * SMS_Phone_Number)
{
  char sensor_temp[RADIO_SENSOR_NAME_LEN*4]={0x00};
  char k,i, t_min, t_max, r_min, r_max;
  char *temp_result;
  unsigned short int cur_sms_len=0;
 
  if (!strlen(SMS_Phone_Number)) return 0; //,     0

  Send_Command_To_SIM900 (Cmd_SEND_SMS, strlen(Cmd_SEND_SMS));
  Send_Command_To_SIM900_ (SMS_Phone_Number, strlen(SMS_Phone_Number));
  Send_Command_To_SIM900_ ("\"\r", 2);
  Wait_For_SIM900_Answer (Answer_SEND, 2*GSM_ANSWER_WAIT_1SEC);

  if (Get_Termo_Sensor)
  {
    if (Get_Termo_Sensor>MAX_DS1820)
    {
      //radio termo
      r_min=Get_Termo_Sensor-MAX_DS1820-1;
      r_max=r_min+1;
      t_min=0;
      t_max=t_min;
    }
    else
    {
      //ds1820
      t_min=Get_Termo_Sensor-1;
      t_max=t_min+1;
      r_min=0;
      r_max=r_min;      
    }
  }
  else
  {
    t_min=0;
    t_max=MAX_DS1820;
    r_min=0;
    r_max=MAX_RADIO_SENSOR;
  }
  
   //    DS1820
  for (i=t_min; i<t_max; i++)
  {
   if ( (DS1820_Sensor.Data_Current[i]!=NO_TEMPERATURE) || Get_Termo_Sensor)
   {
      k=strlen( (char *) (TERMO_DS1820_NAME_1+TERMO_DS1820_NAME_LEN*i) );
      cur_sms_len +=k; 
      if (cur_sms_len<160) Send_Command_To_SIM900_ ( (char *) (TERMO_DS1820_NAME_1+TERMO_DS1820_NAME_LEN*i), k);
      temp_result = sensor_temp; 
      *temp_result=':';
      temp_result++;
      k=DS1820_Sensor.Data_Current[i];
      temp_result=Print_T_Tmin_Tn_Tmax (temp_result, k, i+1, DS1820_1_MIN_MAX_W, DS1820_Sensor.Tn[i]); 
      *temp_result=0x0A;
      temp_result++;
      //   -
      *temp_result=0x00; //  
      k=strlen(sensor_temp);
      cur_sms_len +=k;
      if (cur_sms_len<160) Send_Command_To_SIM900_ (sensor_temp, k);
   }
  }
 
   //   
  for (i=r_min; i<r_max; i++)
  {
   if 
     (
        Get_Termo_Sensor ||
        (
          (
            ((RF_Sensor.Data_Current[i] & 0x000F)== RADIO_SENSOR_TERMO) ||
            ((RF_Sensor.Data_Current[i] & 0x000F)== RADIO_SENSOR_TERMO_REPITER)
          ) && ( (((char) (RF_Sensor.Data_Current[i]>>8 ))!=NO_TEMPERATURE) ) //temperature  
        )
     )
   {
      k=strlen( (char *) (RADIO_SENSOR_NAME_1+RADIO_SENSOR_NAME_LEN*i) );
      cur_sms_len +=k; 
      if (cur_sms_len<160) Send_Command_To_SIM900_ ( (char *) (RADIO_SENSOR_NAME_1+RADIO_SENSOR_NAME_LEN*i), k);
      temp_result = sensor_temp; 
      *temp_result=':';
      temp_result++;
      
      if (
            ((RF_Sensor.Data_Current[i] & 0x000F)== RADIO_SENSOR_TERMO) ||
            ((RF_Sensor.Data_Current[i] & 0x000F)== RADIO_SENSOR_TERMO_REPITER)
          ) 
          k=(char) (RF_Sensor.Data_Current[i]>>8 );
        else
          k=NO_TEMPERATURE;
        
      temp_result=Print_T_Tmin_Tn_Tmax (temp_result, k, i+1, RADIO_1_MIN_MAX_W, RF_Sensor.Tn[i] );
      *temp_result=0x0A;
      temp_result++;
      //   -
      *temp_result=0x00; //  
      k=strlen(sensor_temp);
      cur_sms_len +=k;
      if (cur_sms_len<160) Send_Command_To_SIM900_ (sensor_temp, k);
   }
  }
  
  //  <ctrl+Z>
  Send_Command_To_SIM900 ("\x1A", 1);
  return Wait_For_SIM900_Answer (Answer_OK, 12*GSM_ANSWER_WAIT_1SEC);     
}


/*******************************************************************************
* Function Name  : Copy_String
* Description    :   
* Input          : String -    , Result - ,   
* Output         : None
* Return         : 1 -   
*******************************************************************************/
char Copy_String (char * Result, char * String)
{
  char k, i=strlen(String);
  for (k=0; k<i; k++)
  {
    *Result=*String;
    Result++;
    String++;
  }
  return i;
}

/*******************************************************************************
* Function Name  : Send_text_to_Phone
* Description    :  - 
* Input          : SMS_Phone_Number -   , sms -    
* Output         : None
* Return         : 0 -   , 1 -  
*******************************************************************************/
char Send_text_to_Phone (char * SMS_Phone_Number, char * sms)
{
  Send_Command_To_SIM900 (Cmd_SEND_SMS, strlen(Cmd_SEND_SMS));
  Send_Command_To_SIM900_ (SMS_Phone_Number, strlen(SMS_Phone_Number));
  Send_Command_To_SIM900_ ("\"\r", 2);
  Wait_For_SIM900_Answer (Answer_SEND, 2*GSM_ANSWER_WAIT_1SEC);  
  Send_Command_To_SIM900 ( sms, strlen(sms));
  //  <ctrl+Z>
  Send_Command_To_SIM900 ("\x1A", 1);
  return Wait_For_SIM900_Answer (Answer_OK, 12*GSM_ANSWER_WAIT_1SEC);                           
}
                           
/*******************************************************************************
* Function Name  : send_sms
* Description    :  -    
* Input          : SMS_Phone_Number -   , sms -    
* Output         : None
* Return         : 0 -   , 1 -  
*******************************************************************************/                             
char send_sms(char * SMS_Phone_Number, char * sms, char * temp)
{   
   /*    */
   if (!Send_text_to_Phone(SMS_Phone_Number, sms)) Send_text_to_Phone(SMS_Phone_Number, sms);
   
   return Copy_String(sms, temp );                             
}
                           
/*******************************************************************************
* Function Name  : Send_Status_SMS_to_Phone
* Description    :  -    
* Input          : SMS_Phone_Number -   
* Output         : None
* Return         : 0 -   , 1 -  
*******************************************************************************/
char Send_Status_SMS_to_Phone (char * SMS_Phone_Number)
{
  
  char z, k, cur_len=0;
  char sms[160];
  char * temp=(char *) ARM_TEXT;
  char *temp_result;
  char temp_val[20];
  
  if (!strlen(SMS_Phone_Number)) return 0; //,     0
  
  //  
  if (MODE_ARM_STATE)
  {
    cur_len +=Copy_String(&sms[cur_len], (char *) ARM_TEXT );
    if (MODE_ARM_STATE!=ALL_GROUP)
    {
      //    
      if (MODE_FLAG_ARM_1_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
      if (MODE_FLAG_ARM_2_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
      if (MODE_FLAG_ARM_3_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
      if (MODE_FLAG_ARM_4_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
      if (MODE_FLAG_ARM_5_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
      if (MODE_FLAG_ARM_6_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
      if (MODE_FLAG_ARM_7_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
      if (MODE_FLAG_ARM_8_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
      sms[cur_len++]=0x0A;
    }
   }
   else
   {
    cur_len +=Copy_String(&sms[cur_len], (char *) DISARM_TEXT );
   }


  //  220
   if (INPUT_EXT_POWER_STATE)
     temp=(char *) _220V_ON_TEXT;
   else
     temp=(char *) _220V_OFF_TEXT;

   if ( (cur_len + strlen(temp)) < 160 ) 
      {
        cur_len +=Copy_String(&sms[cur_len], temp );
      }
     else
      {
        sms[cur_len]='\0';
        cur_len=send_sms(SMS_Phone_Number, sms, temp);
      }  


  //   12 
  if (!INPUT_MAIN_POWER_STATE) 
  {
   temp=(char *) LOW_ACC_TEXT; 
   if ( (cur_len + strlen(temp)) < 160 ) 
      {
        cur_len +=Copy_String(&sms[cur_len], temp );
      }
     else
      {
        sms[cur_len]='\0';
        cur_len=send_sms(SMS_Phone_Number, sms, temp);
      } 
  }

  //    -  Li-Ion 
  if (!INPUT_INT_POWER_STATE) 
  {
   temp= (char *) Low_Li_Ion_Text; 
   if ( (cur_len + strlen(temp)) < 160 ) 
      {
        cur_len +=Copy_String(&sms[cur_len], temp );
      }
     else
      {
        sms[cur_len]='\0';
        cur_len=send_sms(SMS_Phone_Number, sms, temp);
      } 
  }
  
  //   
  if (INPUT_TAMPER_STATE)
    temp = (char *) TAMPER_NORMA_TEXT;
   else
    temp = (char *) TAMPER_ALARM_TEXT;
  
   if ( (cur_len + strlen(temp)) < 160 ) 
      {
        cur_len +=Copy_String(&sms[cur_len], temp );
      }
     else
      {
        sms[cur_len]='\0';
        cur_len=send_sms(SMS_Phone_Number, sms, temp);
      } 

  //   -1..-MAX_WIRE_SENSOR
  #ifndef OKO_U2
  for (k=0; k<MAX_WIRE_SENSOR; k++)
    #else
  for (k=0; k<4; k++) //for OKO_U2
  #endif  
   {
     
        if ( 0x0001 & (Inputs_State>>(INPUT_1+k)) )
          temp=(char *) (IN1_LOW_TEXT+INPUT_EVENT_TEXT_LEN*(2*k+1));//High_Text
        else
          temp=(char *) (IN1_LOW_TEXT+INPUT_EVENT_TEXT_LEN*2*k); //Low_Text
        
        if ( (cur_len + strlen(temp)) < (160-14)) 
          {
            //   
            if ( ( 0x0001 & (Inputs_State>>(INPUT_1+k)) ) && ( 0x0001 & (KZ_Obriv_State>>(INPUT_1+k)) ) ) 
              cur_len +=Copy_String(&sms[cur_len], "KZ-" );
            //   
            if ( ( 0x0001 & (Inputs_State>>(INPUT_1+k)) ) && ( 0x0001 & (KZ_Obriv_State>>(INPUT_1+k+8)) ) ) 
              cur_len +=Copy_String(&sms[cur_len], "OBRIV-" );
            
            cur_len +=Copy_String(&sms[cur_len], temp );
            
            if (Counters[k]!=NO_PULSE && (*(char*)(VXOD_MODE+k)==VXOD_COUNTER))
            {
              //max=999 999
              temp_val[0]=':';
              temp_val[1]=0x30+(Counters[k] / 100000);
              temp_val[2]=0x30+((Counters[k] % 100000) / 10000);
              temp_val[3]=0x30+(((Counters[k] % 100000) % 10000) / 1000);
              temp_val[4]=0x30+((((Counters[k] % 100000) % 10000) % 1000) / 100);
              temp_val[5]=0x30+(((((Counters[k] % 100000) % 10000) % 1000) % 100) / 10);
              temp_val[6]=0x30+(((((Counters[k] % 100000) % 10000) % 1000) % 100) % 10);
              temp_val[7]=0x0A;
              temp_val[8]='\0';
              temp = temp_val;
              cur_len +=Copy_String(&sms[cur_len], temp );
            }
          }
        else
          {
            sms[cur_len]='\0';
            /*     sms*/
            if (!Send_text_to_Phone(SMS_Phone_Number, sms)) Send_text_to_Phone(SMS_Phone_Number, sms);
            cur_len=0;
            //   
            if ( ( 0x0001 & (Inputs_State>>(INPUT_1+k)) ) && ( 0x0001 & (KZ_Obriv_State>>(INPUT_1+k)) ) ) 
              cur_len +=Copy_String(&sms[cur_len], "KZ-" );
            //   
            if ( ( 0x0001 & (Inputs_State>>(INPUT_1+k)) ) && ( 0x0001 & (KZ_Obriv_State>>(INPUT_1+k+8)) ) ) 
              cur_len +=Copy_String(&sms[cur_len], "OBRIV-" );
                   
            cur_len +=Copy_String(&sms[cur_len], temp );
          }        
   } 

   //  DS1820 -1  -1
   z=0;
   k=DS1820_Sensor.Data_Current[0];
   temp_result = temp_val; 
   *temp_result='T';
   temp_result++; 
   *temp_result='=';
   temp_result++;
   if (k!=NO_TEMPERATURE)
     {
      temp_result = Print_T(temp_result, k);
      *temp_result=0x0A;
      temp_result++;
      //   -
      *temp_result=0x00; //  
      z=1;
     }
     else
     {
      // -1  ,   
      if (
         ((RF_Sensor.Data_Current[0] & 0x000F)== RADIO_SENSOR_TERMO) ||
         ((RF_Sensor.Data_Current[0] & 0x000F)== RADIO_SENSOR_TERMO_REPITER) 
        )
       {
         k=(char) (RF_Sensor.Data_Current[0]>>8 ); //temperature
         if (k!=NO_TEMPERATURE)
          {
            temp_result = Print_T(temp_result, k);
            *temp_result=0x0A;
            temp_result++;
            //   -
            *temp_result=0x00; //  
	    z=1;
          }
       }  
     }
    if (z)
    {
      temp = temp_val;
  
      if ( (cur_len + strlen(temp)) < 160 ) 
      {
        cur_len +=Copy_String(&sms[cur_len], temp );
      }
      else
      {
        sms[cur_len]='\0';
        cur_len=send_sms(SMS_Phone_Number, sms, temp);
      } 
    }
   
 //   
   temp=(char *) (Outputs_Text); 
   if ( (cur_len + strlen(temp)) < (160-9)) 
      {
        cur_len +=Copy_String(&sms[cur_len], temp );
      }
     else
      {
        sms[cur_len]='\0';
        cur_len=send_sms(SMS_Phone_Number, sms, temp);
      }    
  
  if (OUT1_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
  if (OUT2_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
  if (OUT3_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
  if (OUT4_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
#ifndef OKO_U2  
  if (OUT5_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
  if (OUT6_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
  if (OUT7_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
  if (OUT8_STATE) sms[cur_len++]='1'; else sms[cur_len++]='0';
#endif
  sms[cur_len++]=0x0A;

  
  //  GSM-
  if (GSM_Level>GSM_LEVEL_MEDIUM) 
   {
    temp=(char *) (GSM_High_Text); 
   }
   else
   { 
    if (GSM_Level>GSM_LEVEL_LOW) 
     {
      temp=(char *) (GSM_Medium_Text); 
     }
     else
     {
      temp=(char *) (GSM_Low_Text);
     }
   } 
  
   if ( (cur_len + strlen(temp)) < 160 ) 
      {
        cur_len +=Copy_String(&sms[cur_len], temp );
      }
     else
      {
        sms[cur_len]='\0';
        cur_len=send_sms(SMS_Phone_Number, sms, temp);
      } 

  
   sms[cur_len]='\0';
   if (cur_len) send_sms(SMS_Phone_Number, sms, temp); 
   
   return 1;     
}


/*******************************************************************************
* Function Name  : Send_Radio_Code_SMS_to_Phone
* Description    :  -    
* Input          : SMS_Phone_Number -   
* Output         : None
* Return         : 0 -   , 1 -  
*******************************************************************************/
char Send_Radio_Code_SMS_to_Phone (char * SMS_Phone_Number)
{
  char data[160];
  char * data_;
  char i,j;
  uint16_t eeprom_data;
  
  
  if (!strlen(SMS_Phone_Number)) return 0; //,     0

  Send_Command_To_SIM900 (Cmd_SEND_SMS, strlen(Cmd_SEND_SMS));
  Send_Command_To_SIM900_ (SMS_Phone_Number, strlen(SMS_Phone_Number));
  Send_Command_To_SIM900_ ("\"\r", 2);
  Wait_For_SIM900_Answer (Answer_SEND, 2*GSM_ANSWER_WAIT_1SEC);

  data_=data;

  /*     EEPROM */
  for (i=0; i < MAX_RADIO_SENSOR; i++)
   {
    for (j=0; j<2; j++)
     {
      //  0,   
      if (Virtual_EEPROM (RADIO_1_W1+i*2+j, & eeprom_data, READ_DATA_EEPROM)) 
      {
        eeprom_data=0x0000;
      } 
      
      *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>12)));
      data_++;
      *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>8)));
      data_++;     
      
      *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>4)));
      data_++;
      *data_ = Hex_Ascii((char)(0x000F & eeprom_data));
      data_++;
     }
    *data_=0x0A;
    data_++;
   }

  *data_=0x00;
  
  Send_Command_To_SIM900 (data, strlen(data));
  //  <ctrl+Z>
  Send_Command_To_SIM900 ("\x1A", 1);
  return Wait_For_SIM900_Answer (Answer_OK, 12*GSM_ANSWER_WAIT_1SEC); 

}

/*******************************************************************************
* Function Name  : Send_Parameter_SMS_to_Phone
* Description    :  -    
* Input          : SMS_Phone_Number -   
* Output         : None
* Return         : 0 -   , 1 -  
*******************************************************************************/
char Send_Parameter_SMS_to_Phone (char * SMS_Phone_Number)
{
  char data[160];
  char * data_;
  char i;
  uint16_t eeprom_data, eeprom_data_;
  
  
  if (!strlen(SMS_Phone_Number)) return 0; //,     0

  Send_Command_To_SIM900 (Cmd_SEND_SMS, strlen(Cmd_SEND_SMS));
  Send_Command_To_SIM900_ (SMS_Phone_Number, strlen(SMS_Phone_Number));
  Send_Command_To_SIM900_ ("\"\r", 2);
  Wait_For_SIM900_Answer (Answer_SEND, 2*GSM_ANSWER_WAIT_1SEC);

 
  /*   -
  for (i=0; i<160; i++)
   {
     data[i]='0';
   }
  */
  
  data_=data;

/*    ,    */
    //  0,   
    if (Virtual_EEPROM (TAMPER_220_GROUP_W, & eeprom_data, READ_DATA_EEPROM)) 
    {
      eeprom_data=GROUP_TAMPER_POWER_DEFAULT;
    } 
    
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>12)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>8)));
    data_++;


    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>4)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & eeprom_data));
    data_++;

  *data_=0x0A;
  
  //     160 HEX-ASCII 

  *data_='I';
  data_++;
  *data_='n';
  data_++;
  *data_=':';
  data_++;

  /*      EEPROM */
  for (i=0; i < (MAX_WIRE_SENSOR>>1); i++)
   {
    //  0,   
    if (Virtual_EEPROM (IN_1_2_PARAMETER_W + i, & eeprom_data, READ_DATA_EEPROM)) 
    {
      eeprom_data=WIRE_SENSOR_DEFAULT;
    }
    //  0,   
    if (Virtual_EEPROM (IN_1_2_GROUP_W + i, & eeprom_data_, READ_DATA_EEPROM)) 
    {
      eeprom_data_=GROUP_SENSOR_DEFAULT;
    } 
    
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>12)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>8)));
    data_++;

    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data_>>12)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data_>>8)));
    data_++;    
    
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>4)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & eeprom_data));
    data_++;

    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data_>>4)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & eeprom_data_));
    data_++;    
    
   } 
  *data_=0x0A;
  data_++;  
  *data_='R';
  data_++;
  *data_='D';
  data_++;
  *data_=':';
  data_++;
  
  /*     EEPROM */
  for (i=0; i < (MAX_RADIO_SENSOR>>1); i++)
   {
    //  0,   
    if (Virtual_EEPROM (RADIO_1_2_PARAMETER_W + i, & eeprom_data, READ_DATA_EEPROM)) 
    {
      eeprom_data=RF_SENSOR_DEFAULT;
    }
    //  0,   
    if (Virtual_EEPROM (RADIO_1_2_GROUP_W + i, & eeprom_data_, READ_DATA_EEPROM)) 
    {
      eeprom_data_=GROUP_SENSOR_DEFAULT;
    }   
    
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>12)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>8)));
    data_++;

    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data_>>12)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data_>>8)));
    data_++;    
    
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>4)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & eeprom_data));
    data_++;
    
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data_>>4)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & eeprom_data_));
    data_++;    
   } 
 
  *data_=0x0A;
  data_++;   

  *data_='O';
  data_++;
  *data_='w';
  data_++;
  *data_=':';
  data_++;

  /*     EEPROM */
  for (i=0; i < (MAX_OWNER>>1); i++)
   {
    //  0,   
    if (Virtual_EEPROM (OWNER_1_2_GROUP_W + i, & eeprom_data, READ_DATA_EEPROM)) 
    {
      eeprom_data=GROUP_OWNER_DEFAULT;
    }  
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>12)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>8)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>4)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & eeprom_data));
    data_++;    
   }

  *data_=0x0A;
  data_++;   

  *data_='I';
  data_++;
  *data_='B';
  data_++;
  *data_=':';
  data_++;

  /*   IButton  EEPROM */
  for (i=0; i < (MAX_IBUTTON>>1); i++)
   {
    //  0,   
    if (Virtual_EEPROM (IBUTTON_1_2_GROUP_W + i, & eeprom_data, READ_DATA_EEPROM)) 
    {
      eeprom_data=GROUP_IBUTTON_DEFAULT;
    }  
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>12)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>8)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & (eeprom_data>>4)));
    data_++;
    *data_ = Hex_Ascii((char)(0x000F & eeprom_data));
    data_++;    
   } 
  
  *data_=0x00;
  
  Send_Command_To_SIM900 (data, strlen(data));
  //  <ctrl+Z>
  Send_Command_To_SIM900 ("\x1A", 1);
  return Wait_For_SIM900_Answer (Answer_OK, 12*GSM_ANSWER_WAIT_1SEC);    
}
/*******************************************************************************
* Function Name  : Send_Config_SMS_to_Phone
* Description    :  -     
* Input          : SMS_Phone_Number -   
* Output         : None
* Return         : 0 -   , 1 -  
*******************************************************************************/
char Send_Config_SMS_to_Phone (char * SMS_Phone_Number)
{
  char i, temp[]="        ";

  uint16_t eeprom_data;

  if (!strlen(SMS_Phone_Number)) return 0; //,     0

	
  Send_Command_To_SIM900 (Cmd_SEND_SMS, strlen(Cmd_SEND_SMS));
  Send_Command_To_SIM900_ (SMS_Phone_Number, strlen(SMS_Phone_Number));
  Send_Command_To_SIM900_ ("\"\r", 2);
  Wait_For_SIM900_Answer (Answer_SEND, 2*GSM_ANSWER_WAIT_1SEC);

  //  
  Send_Command_To_SIM900 ("SW:", 3);
  Send_Command_To_SIM900_ (SW_Version_Text, strlen(SW_Version_Text));

  // IMEI
  Send_Command_To_SIM900_ ("\x0AIMEI:", 6);
  Send_Command_To_SIM900_ (IMEI_Number, strlen(IMEI_Number));


  //    -
  for (i=0; i<2; i++)
  {
   //  0,   
   if (! Virtual_EEPROM (PIN_CODE_W1 + i, & eeprom_data, READ_DATA_EEPROM)) 
    {
     temp[i*2+1]=  (char) ((eeprom_data>>8) & 0xFF); //high byte char
     temp[i*2+2]= (char) ((eeprom_data) & 0xFF); //low byte char
    }
  }
  temp[0]=0x0A;
  Send_Command_To_SIM900_ (temp, 5);


  //  
  for (i=0; i < MAX_OWNER; i++)
   {     
     Copy_Owner_Phone_from_EEPROM (OWNER1_PHONE_W1+i*8);
     temp[0]=0x0A;
     temp[1]=i+0x31;
     temp[2]=':';
     Send_Command_To_SIM900_ (temp, 3);
	  
     //   ,    
     if (strlen(Owner_Phone_Number)!=0) Send_Command_To_SIM900_ (Owner_Phone_Number, strlen(Owner_Phone_Number)); 

   }

 

  /*      -  -1..-8 */
  //  0,   
  if ( !Virtual_EEPROM(SMS_RING_W, & eeprom_data, READ_DATA_EEPROM) ) 
   {
     //sms
     temp[0]=0x0A;
     temp[1]='S';
     temp[2]=':';
     Send_Command_To_SIM900_ (temp, 3);
     for (i=0; i < 8; i++)
      {
	temp[i]= 0x30 + (char) ( 0x0001 & (eeprom_data>>(8+i)) );
      }
     Send_Command_To_SIM900_ (temp, 8);
     
     //call
     temp[0]=0x0A;
     temp[1]='C';
     temp[2]=':';
     Send_Command_To_SIM900_ (temp, 3);
     for (i=0; i < 8; i++)
      {
	temp[i]= 0x30 + (char) ( 0x0001 & (eeprom_data>>i) );
      }
     Send_Command_To_SIM900_ (temp, 8);

   }
  
  /*     -1..-8 */
  //  0,   
  if ( !Virtual_EEPROM(ANSWER_ARM_PARAMETER_W, & eeprom_data, READ_DATA_EEPROM) ) 
   {
     //answer
     temp[0]=0x0A;
     temp[1]='A';
     temp[2]=':';
     Send_Command_To_SIM900_ (temp, 3);
     for (i=0; i < 8; i++)
      {
	temp[i]= 0x30 + (char) ( 0x0001 & (eeprom_data>>(8+i)) );
      }
     Send_Command_To_SIM900_ (temp, 8);     
   }
 
  
  if (oko_rf_pro_version)
  {
     temp[0]=0x0A;
     temp[1]='R';
     temp[2]='F';
     temp[3]=':';
     temp[4] = Hex_Ascii(oko_rf_pro_version>>4);
     temp[5] = Hex_Ascii(0x0F & oko_rf_pro_version);     
     //temp[4]=0x30 + oko_rf_pro_version;
     Send_Command_To_SIM900_ (temp, 6);
  }
  
  //  <ctrl+Z>
  Send_Command_To_SIM900 ("\x1A", 1);
  return Wait_For_SIM900_Answer (Answer_OK, 12*GSM_ANSWER_WAIT_1SEC);  
}

/*******************************************************************************
* Function Name  : Read_Config_from_EEPROM
* Description    :       
* Input          : 
* Output         : None
* Return         : None
*******************************************************************************/
void Read_Config_from_EEPROM (void)
{
    uint16_t eeprom_data;
    char i;
    
    /*     -  EEPROM */
    //  0,   , -    EEPROM
    if (Virtual_EEPROM(PIN_CODE_W1, & eeprom_data, READ_DATA_EEPROM)!=0 || 
        Virtual_EEPROM(PIN_CODE_W2, & eeprom_data, READ_DATA_EEPROM)!=0) 
      FLAG_DEFAULT_SETTING_SET;
    
     /*      EEPROM */
    //  0,   
    eeprom_data=0;
    if (Virtual_EEPROM (MODE_FLAGS_W, & eeprom_data, READ_DATA_EEPROM)==0) 
    {
      //Mode_Flags=eeprom_data;
    }
    for (i=0; i<16; i++)
    {
      Mode_Flag[i]= (char) (0x0001 & (eeprom_data>>i));
    }
    
    /*      EEPROM */
    //  0,   
    if (Virtual_EEPROM (OUTPUT_STATE_W, & eeprom_data, READ_DATA_EEPROM)==0) 
    {
      if ((eeprom_data>>OUTPUT_1)& 0x0001) OUT1_ON else OUT1_OFF
      if ((eeprom_data>>OUTPUT_2)& 0x0001) OUT2_ON else OUT2_OFF
      if ((eeprom_data>>OUTPUT_3)& 0x0001) OUT3_ON else OUT3_OFF
      if ((eeprom_data>>OUTPUT_4)& 0x0001) OUT4_ON else OUT4_OFF
      #ifndef OKO_U2  
        if ((eeprom_data>>OUTPUT_5)& 0x0001) OUT5_ON else OUT5_OFF
        if ((eeprom_data>>OUTPUT_6)& 0x0001) OUT6_ON else OUT6_OFF
        if ((eeprom_data>>OUTPUT_7)& 0x0001) OUT7_ON else OUT7_OFF
        if ((eeprom_data>>OUTPUT_8)& 0x0001) OUT8_ON else OUT8_OFF
      #endif  
    } 
    else 
    {
      OUT1_OFF; OUT2_OFF; OUT3_OFF; OUT4_OFF; 
      #ifndef OKO_U2
      OUT5_OFF; OUT6_OFF; OUT7_OFF; OUT8_OFF;
      #endif
    }


    /*     EEPROM */
    for (i=0; i < (MAX_RADIO_SENSOR>>1); i++)
     {
      //  0,   
      if (Virtual_EEPROM (RADIO_1_2_PARAMETER_W + i, & eeprom_data, READ_DATA_EEPROM)==0) 
      {
        RF_Sensor.Parameter[i*2]= (char) ((eeprom_data>>8) & 0x00FF);
        RF_Sensor.Parameter[i*2+1]= (char) (eeprom_data & 0x00FF);
      }  
      else
      {
        RF_Sensor.Parameter[i*2]= (char) ((RF_SENSOR_DEFAULT>>8) & 0x00FF);
        RF_Sensor.Parameter[i*2+1]= (char) (RF_SENSOR_DEFAULT & 0x00FF);        
      }

      //  0,   
      if (Virtual_EEPROM (RADIO_1_2_GROUP_W + i, & eeprom_data, READ_DATA_EEPROM)==0) 
      {
        RF_Sensor.Group[i*2]= (char) ((eeprom_data>>8) & 0x00FF);
        RF_Sensor.Group[i*2+1]= (char) (eeprom_data & 0x00FF);
      }  
      else
      {
        RF_Sensor.Group[i*2]= (char) ((GROUP_SENSOR_DEFAULT>>8) & 0x00FF);
        RF_Sensor.Group[i*2+1]= (char) (GROUP_SENSOR_DEFAULT & 0x00FF);        
      }       
      
      //  0,   
      if (Virtual_EEPROM (RADIO_1_2_T_NAGREV_W + i, & eeprom_data, READ_DATA_EEPROM)==0) 
      {
        RF_Sensor.Tn[i*2]= (char) ((eeprom_data>>8) & 0x00FF);
        RF_Sensor.Tn[i*2+1]= (char) (eeprom_data & 0x00FF);
      }  
      else
      {
        RF_Sensor.Tn[i*2]= (char) ((T_N_DEFAULT>>8) & 0x00FF);
        RF_Sensor.Tn[i*2+1]= (char) (T_N_DEFAULT & 0x00FF);        
      }       
      
      
     }  
 
    /*      EEPROM */
    for (i=0; i < (MAX_WIRE_SENSOR>>1); i++)
     {
      //  0,   
      if (Virtual_EEPROM (IN_1_2_PARAMETER_W + i, & eeprom_data, READ_DATA_EEPROM)==0) 
      {
        Wire_Sensor.Parameter[i*2]= (char) ((eeprom_data>>8) & 0x00FF);
        Wire_Sensor.Parameter[i*2+1]= (char) (eeprom_data & 0x00FF);
      }  
      else
      {
        Wire_Sensor.Parameter[i*2]= (char) ((WIRE_SENSOR_DEFAULT>>8) & 0x00FF);
        Wire_Sensor.Parameter[i*2+1]= (char) (WIRE_SENSOR_DEFAULT & 0x00FF);        
      }
      
      //  0,   
      if (Virtual_EEPROM (IN_1_2_GROUP_W + i, & eeprom_data, READ_DATA_EEPROM)==0) 
      {
        Wire_Sensor.Group[i*2]= (char) ((eeprom_data>>8) & 0x00FF);
        Wire_Sensor.Group[i*2+1]= (char) (eeprom_data & 0x00FF);
      }  
      else
      {
        Wire_Sensor.Group[i*2]= (char) ((GROUP_SENSOR_DEFAULT>>8) & 0x00FF);
        Wire_Sensor.Group[i*2+1]= (char) (GROUP_SENSOR_DEFAULT & 0x00FF);        
      }      
      
     }
  
  
    /*     EEPROM */
    for (i=0; i < (MAX_OWNER>>1); i++)
     {
        //  0,   
        if (Virtual_EEPROM (OWNER_1_2_GROUP_W + i, & eeprom_data, READ_DATA_EEPROM)==0) 
        {
          Owner.Group[i*2]= (char) ((eeprom_data>>8) & 0x00FF);
          Owner.Group[i*2+1]= (char) (eeprom_data & 0x00FF);
        }  
        else
        {
          Owner.Group[i*2]= (char) ((GROUP_OWNER_DEFAULT>>8) & 0x00FF);
          Owner.Group[i*2+1]= (char) (GROUP_OWNER_DEFAULT & 0x00FF);        
        }       
     }  
    
    /*   IButton  EEPROM */
    for (i=0; i < (MAX_IBUTTON>>1); i++)
     {
        //  0,   
        if (Virtual_EEPROM (IBUTTON_1_2_GROUP_W + i, & eeprom_data, READ_DATA_EEPROM)==0) 
        {
          IButton.Group[i*2]= (char) ((eeprom_data>>8) & 0x00FF);
          IButton.Group[i*2+1]= (char) (eeprom_data & 0x00FF);
        }  
        else
        {
          IButton.Group[i*2]= (char) ((GROUP_IBUTTON_DEFAULT>>8) & 0x00FF);
          IButton.Group[i*2+1]= (char) (GROUP_IBUTTON_DEFAULT & 0x00FF);        
        }       
     }      

    /*   DS1820  EEPROM */
    for (i=0; i < (MAX_DS1820>>1); i++)
     {
        //  0,   
        if (Virtual_EEPROM (DS1820_1_2_GROUP_W + i, & eeprom_data, READ_DATA_EEPROM)==0) 
        {
          DS1820_Sensor.Group[i*2]= (char) ((eeprom_data>>8) & 0x00FF);
          DS1820_Sensor.Group[i*2+1]= (char) (eeprom_data & 0x00FF);
        }  
        else
        {
          DS1820_Sensor.Group[i*2]= (char) ((GROUP_DS1820_DEFAULT>>8) & 0x00FF);
          DS1820_Sensor.Group[i*2+1]= (char) (GROUP_DS1820_DEFAULT & 0x00FF);        
        }

        //  0,   
        if (Virtual_EEPROM (DS1820_1_2_T_NAGREV_W + i, & eeprom_data, READ_DATA_EEPROM)==0) 
        {
          DS1820_Sensor.Tn[i*2]= (char) ((eeprom_data>>8) & 0x00FF);
          DS1820_Sensor.Tn[i*2+1]= (char) (eeprom_data & 0x00FF);
        }  
        else
        {
          DS1820_Sensor.Tn[i*2]= (char) ((T_N_DEFAULT>>8) & 0x00FF);
          DS1820_Sensor.Tn[i*2+1]= (char) (T_N_DEFAULT & 0x00FF);        
        }
       
     } 

	/*       220  EEPROM */
    //  0,   
    if (Virtual_EEPROM (TAMPER_220_GROUP_W, & eeprom_data, READ_DATA_EEPROM)==0) 
      {
         Tamper.Group= (char) ((eeprom_data>>8) & 0x00FF);
         Power.Group= (char) (eeprom_data & 0x00FF);
      }  
      else
      {
         Tamper.Group= (char) ((GROUP_TAMPER_POWER_DEFAULT>>8) & 0x00FF);
         Power.Group= (char) (GROUP_TAMPER_POWER_DEFAULT & 0x00FF);        
      }  
   
}


/*******************************************************************************
* Function Name  : Copy_from_Page1_to_Page2
* Description    :      -  
* Input          : Address1 -   ""  
*               Address2 -   ""  
*               len -   ,  4!!!
* Output         : None
* Return         : None
*******************************************************************************/
void Copy_from_Page1_to_Page2 (uint32_t Address1, uint32_t Address2, uint16_t len)
{
 uint32_t Data; 
 
  /* Program the user Flash area word by word */

  while (len)
  {
    Data = *(__IO uint32_t *)Address1;
    
    if (FLASH_ProgramWord(Address2, Data) == FLASH_COMPLETE)
    {
      Address1 = Address1 + 4;
      Address2 = Address2 + 4;
      len = len-4;
    }
    else
    {
      /* Error occurred while writing data in Flash memory.
         User can add here some code to deal with this error 
      while (1)
      {
      } */
      len=0;
    }
    
  }  
  
}


/*******************************************************************************
* Function Name  : Flash_Init
* Description    :       
*                   
* Input          : Data -     FLASH_VALID,     ""  ,   
* Output         : None
* Return         : None
*******************************************************************************/
void Flash_Init(uint32_t Data) //@ ((uint32_t)(FLASH_BASE + 0x7B000 - 0x100))
{
uint32_t Address = COUNTERS_STATE_BASE_ADDRESS, State_Counter;
char m;

  if (flash_valid!=Data)
    {

	//     
      if (FLASH_ErasePage(CONFIGURATOR_BASE_ADDRESS)!= FLASH_COMPLETE)
      {
        /* Error occurred while sector erase.
         User can add here some code to deal with this error
        while (1)
        {
        }
        */
      }

      if (FLASH_ErasePage(CONFIGURATOR_BASE_ADDRESS+PAGE_SIZE)!= FLASH_COMPLETE)
      {
        /* Error occurred while sector erase.
         User can add here some code to deal with this error
        while (1)
        {
        }
        */
      }
      //       
      Copy_from_Page1_to_Page2 (DEFAULT_CONFIGURATOR_BASE_ADDRESS, CONFIGURATOR_BASE_ADDRESS, PAGE_SIZE*2);
     
      //     
      if (FLASH_ErasePage(COUNTERS_STATE_BASE_ADDRESS)!= FLASH_COMPLETE)
      {
        /* Error occurred while sector erase.
         User can add here some code to deal with this error
        while (1)
        {
        }
        */
      }
      
      if (FLASH_ErasePage(COUNTERS_STATE_BASE_ADDRESS+PAGE_SIZE)!= FLASH_COMPLETE)
      {
        /* Error occurred while sector erase.
         User can add here some code to deal with this error
        while (1)
        {
        }
        */
      }    
    }
  
   
   //    
   for (State_Counter=0; State_Counter < (PAGE_SIZE/4); State_Counter++ )
    {
      Data = *( uint32_t *) Address;
      if ( Data == 0xFFFFFFFF ) break; // ""  -  0xFFFFFFFF
      m=(char)(Data>>28);
      if (m < MAX_WIRE_SENSOR) Counters[m]=0x0FFFFFFF & Data;
      Address+=4;
    }
  
}
/*******************************************************************************
* Function Name  : Save_Counters
* Description    :   -     
* Input          : 
* Output         : None
* Return         : None 
*******************************************************************************/
void Save_Counters(void)
{
uint32_t Data, Address = COUNTERS_STATE_BASE_ADDRESS, State_Counter;
uint32_t temp[MAX_WIRE_SENSOR]={NO_PULSE,NO_PULSE,NO_PULSE,NO_PULSE,NO_PULSE,NO_PULSE,NO_PULSE,NO_PULSE};
char i,m;

   //    
   for (State_Counter=0; State_Counter < (PAGE_SIZE/4); State_Counter++ )
    {
      Data = *( uint32_t *) Address;
      if ( Data == 0xFFFFFFFF ) break; // ""  -  0xFFFFFFFF
      m=(char)(Data>>28);
      if (m < MAX_WIRE_SENSOR) temp[m]=0x0FFFFFFF & Data;
      Address+=4;
    }
   
  /* ,    .
       ,      
     ,    .   xSemaphoreTake() 
      ,    . */
  xSemaphoreTake( Mutex_Flash_Access, portMAX_DELAY );

  /* Unlock the Flash Program Erase controller */
  FLASH_Unlock();

  if ( State_Counter >= ((PAGE_SIZE/4) - MAX_WIRE_SENSOR) )
  {
    if (FLASH_ErasePage(COUNTERS_STATE_BASE_ADDRESS)!= FLASH_COMPLETE)
      {
        /* Error occurred while sector erase.
         User can add here some code to deal with this error
        while (1)
        {
        }
        */
      }
    m=0;
    Address = COUNTERS_STATE_BASE_ADDRESS;  
  }
  else
  {
    m=1;
  }
  
  //    
  for (i=0; i<MAX_WIRE_SENSOR; i++)
  { 
    if ( (m==0) || (Counters[i]!=temp[i]) )
    {
      Data = ((uint32_t)(i<<28)) | (Counters[i] & 0x0FFFFFFF) ;
      
      if (FLASH_ProgramWord(Address, Data) == FLASH_COMPLETE)
      {
      }
      Address+=4;
    }
  }
  
  /* Lock the Flash Program Erase controller */
  FLASH_Lock();
  /*     ! */
  xSemaphoreGive( Mutex_Flash_Access );
  
}

/*******************************************************************************
* Function Name  : Save_Config
* Description    :   -    
* Input          : 
* Output         : None
* Return         : 2-    , 1- , 0 -   
*******************************************************************************/
char Save_Config(void)
{
  char i;
  uint16_t len;
  uint32_t Data, Address;
  char *Flash_pointer;
  
  if (Temp_Buffer[TEMP_BUFFER_SIZE-1]) return 0;
  
  /* ,    .
       ,      
     ,    .   xSemaphoreTake() 
      ,    . */
  xSemaphoreTake( Mutex_Flash_Access, portMAX_DELAY );

  /* Unlock the Flash Program Erase controller */
  FLASH_Unlock();

  for (i=0; i < 4; i++)
   {
      if (FLASH_ErasePage(CONFIGURATOR_BASE_ADDRESS+i*PAGE_SIZE)!= FLASH_COMPLETE)
      {
        /* Error occurred while sector erase.
         User can add here some code to deal with this error
        while (1)
        {
        }
        */
      }

    /* Program the user Flash area word by word */
    len=PAGE_SIZE;
    Address=0;

    while (len)
    {
      Data = (uint32_t) ( (0x00000000 | Temp_Buffer[i*PAGE_SIZE+Address+0])<<0 | 
			(0x00000000 | Temp_Buffer[i*PAGE_SIZE+Address+1])<<8 | 
			(0x00000000 | Temp_Buffer[i*PAGE_SIZE+Address+2])<<16 |
			(0x00000000 | Temp_Buffer[i*PAGE_SIZE+Address+3])<<24 );
    
      if (FLASH_ProgramWord(CONFIGURATOR_BASE_ADDRESS+i*PAGE_SIZE+Address, Data) == FLASH_COMPLETE)
      {
        Address = Address + 4;
        len = len-4;
      }
      else
      {
        /* Error occurred while writing data in Flash memory.
         User can add here some code to deal with this error 
        while (1)
        {
        } */
        len=0;
      }
    }

   }

  /* Lock the Flash Program Erase controller */
  FLASH_Lock(); 
  
  i=1;
  //     
  Flash_pointer= (char *) CONFIGURATOR_BASE_ADDRESS; 
  for(len = 0; len < TEMP_BUFFER_SIZE-1; len++) //4 (2 )     4 ( )  
   {
     if (Temp_Buffer[len]!= *Flash_pointer) i=2;
     Flash_pointer ++;
   } 

  /*     ! */
  xSemaphoreGive( Mutex_Flash_Access );

  //check saved data

  return i;
}

/*******************************************************************************
* Function Name  : Load_Data
* Description    :    (, )    
* Input          : *Data -    ,   ,
*		Data_len -   , Start -     
* Output         : None
* Return         : None
*******************************************************************************/

char Load_Data(u8 *Data, uint16_t Data_len, char Start)
{
  static uint16_t Pointer=0;
  static u8 crc=0;

  Load_Data_Timeout=LOAD_DATA_TIMEOUT_LEN;

  if (Start) {Pointer=0; crc=0; Data_len--; Data++;}

  while ( (Pointer<TEMP_BUFFER_SIZE) && Data_len)
  {
    Temp_Buffer[Pointer]=*Data;
    if (Pointer<(TEMP_BUFFER_SIZE-1)) crc ^=*Data;
    Data++;
    Pointer++;
    Data_len--;
  }

  if ( (USB_Mode==DownloadConfigMode) && (Pointer==TEMP_BUFFER_SIZE) ) 
  {
    USB_Mode=SaveConfigMode;
    //CRC
    Temp_Buffer[TEMP_BUFFER_SIZE-1] -=crc; //must be 0 if OK   
  }
  
  return 1;
}

void Set_Default_Settings(void)
{
     FLAG_SAVE_CONFIG_COMMAND_SET;
     vTaskDelay(20/portTICK_RATE_MS);
           //taskENTER_CRITICAL();
           //  ""   -    
           EEPROM_Default_Setting();
           //  ""   
           FLASH_Unlock(); 
           Flash_Init(0);
           FLASH_Lock();           
           //taskEXIT_CRITICAL(); 
      FLAG_SAVE_CONFIG_COMMAND_RESET;
}


//*************          STM32f10x

/**
  * @brief  Clears the USARTx's interrupt pending bits.
  * @param  USARTx: Select the USART or the UART peripheral. 
  *   This parameter can be one of the following values:
  *   USART1, USART2, USART3, UART4 or UART5.
  * @param  USART_IT: specifies the interrupt pending bit to clear.
  *   This parameter can be one of the following values:
  *     @arg USART_IT_CTS:  CTS change interrupt (not available for UART4 and UART5)
  *     @arg USART_IT_LBD:  LIN Break detection interrupt
  *     @arg USART_IT_TC:   Transmission complete interrupt. 
  *     @arg USART_IT_RXNE: Receive Data register not empty interrupt.
  *   
  * @note
  *   - PE (Parity error), FE (Framing error), NE (Noise error), ORE (OverRun 
  *     error) and IDLE (Idle line detected) pending bits are cleared by 
  *     software sequence: a read operation to USART_SR register 
  *     (USART_GetITStatus()) followed by a read operation to USART_DR register 
  *     (USART_ReceiveData()).
  *   - RXNE pending bit can be also cleared by a read to the USART_DR register 
  *     (USART_ReceiveData()).
  *   - TC pending bit can be also cleared by software sequence: a read 
  *     operation to USART_SR register (USART_GetITStatus()) followed by a write 
  *     operation to USART_DR register (USART_SendData()).
  *   - TXE pending bit is cleared only by a write to the USART_DR register 
  *     (USART_SendData()).
  * @retval None
  */
void USART_ClearITPendingBit_GSM(USART_TypeDef* USARTx, uint16_t USART_IT)
{
  uint16_t bitpos = 0x00, itmask = 0x00;

  bitpos = USART_IT >> 0x08;
  itmask = ((uint16_t)0x01 << (uint16_t)bitpos);
  USARTx->SR = (uint16_t)~itmask;
}







